SystemOrganization addCategory: #'Seaside-Core-Canvas'!
SystemOrganization addCategory: #'Seaside-Core-Canvas-Tags'!
SystemOrganization addCategory: #'Seaside-Core-Component'!
SystemOrganization addCategory: #'Seaside-Core-Components-Decorations'!
SystemOrganization addCategory: #'Seaside-Core-Components-Dialogs'!
SystemOrganization addCategory: #'Seaside-Core-Components-Frames'!
SystemOrganization addCategory: #'Seaside-Core-Components-Widgets'!
SystemOrganization addCategory: #'Seaside-Core-Configuration'!
SystemOrganization addCategory: #'Seaside-Core-Contexts'!
SystemOrganization addCategory: #'Seaside-Core-Document'!
SystemOrganization addCategory: #'Seaside-Core-Document-Elements'!
SystemOrganization addCategory: #'Seaside-Core-HTTP'!
SystemOrganization addCategory: #'Seaside-Core-Libraries'!
SystemOrganization addCategory: #'Seaside-Core-Callbacks'!
SystemOrganization addCategory: #'Seaside-Core-RenderLoop'!
SystemOrganization addCategory: #'Seaside-Core-RequestHandler'!
SystemOrganization addCategory: #'Seaside-Core-Session'!
SystemOrganization addCategory: #'Seaside-Core-Exceptions'!
SystemOrganization addCategory: #'Seaside-Core-Utilities'!
SystemOrganization addCategory: #'Seaside-Core-Continuations'!
SystemOrganization addCategory: #'Seaside-Core'!

Notification subclass: #WADeprecatedApi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Exceptions'!

!WADeprecatedApi commentStamp: 'pmm 4/17/2007 00:16' prior: 0!
WADeprecatedApi is a notification that gets signaled if someone used a deprecated Seaside method.

see #deprecatedApi!

Notification subclass: #WADynamicVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Utilities'!

!WADynamicVariable commentStamp: 'pmm 4/17/2007 00:14' prior: 0!
A WADynamicVariable is a variable that is visible only in the stackframes outgoing from this one.

Example:

WADynamicVariable
	use: 'Seaside'
	during: [ self compilcatedCalculation ]
	
Whenever
WADynamicVariable value
gets evaluated somewhere inside [ self compilcatedCalculation ] or a method invoked directly or indirectly by it, its value will be 'Seaside'. If no #use:during: handler is around the current stack frame, then the value will be the return value of #defaultValue.

Do not use WADynamicVariable directly, instead create a subclass for each variable you want to use.!

!WADynamicVariable class methodsFor: 'defaults' stamp: 'avi 3/29/2004 14:12'!
defaultValue
	^ nil! !

!WADynamicVariable class methodsFor: 'evaluating' stamp: 'lr 4/18/2007 00:25'!
use: anObject during: aBlock
	^ aBlock on: self do: [ :notification | notification resume: anObject ]! !

!WADynamicVariable class methodsFor: 'evaluating' stamp: 'avi 4/27/2004 14:25'!
value
	^ self raiseSignal! !

!WADynamicVariable methodsFor: 'defaults' stamp: 'lr 3/29/2008 19:01'!
defaultAction
	^ self class defaultValue! !

Notification subclass: #WAPageExpired
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Session'!

Notification subclass: #WARenderNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

Notification subclass: #WAReturnResponse
	instanceVariableNames: 'response'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Session'!

!WAReturnResponse methodsFor: 'accessing' stamp: 'lr 2/27/2008 15:23'!
response
	^ response! !

!WAReturnResponse methodsFor: 'accessing' stamp: 'lr 2/27/2008 15:23'!
response: anObject
	response := anObject! !

Notification subclass: #WAValidationNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Decorations'!

!WAValidationNotification commentStamp: 'cds 7/25/2005 10:17' prior: 0!
I am signaled to indicate that a validation has occurred.  See: Object>>validationError:, WAComponent>>validateWith: and WAValidationDecoration.!

!MessageSend methodsFor: '*Seaside-Core' stamp: 'pmm 4/23/2007 20:02'!
fixCallbackTemps
	"for polymorphism with BlockContext >> #fixCallbackTemps"! !

!MessageSend methodsFor: '*Seaside-Core' stamp: 'ab 3/5/2003 18:30'!
numArgs
	^ selector numArgs! !

!MessageSend methodsFor: '*Seaside-Core' stamp: 'lr 8/4/2006 09:18'!
renderOn: html
	self value: html! !

!MessageSend methodsFor: '*Seaside-Core' stamp: 'ab 7/10/2003 11:40'!
value: anObject
	^ self evaluateWithArguments: (Array with: anObject)! !

!MessageSend methodsFor: '*Seaside-Core' stamp: 'lr 10/28/2007 14:42'!
valueWithPossibleArgument: anArg

     "Evaluate the block represented by the receiver.
     If the block requires one argument, use anArg, if it requires more than one,
     fill up the rest with nils."

	self numArgs = 0
		ifTrue: [^self value].
	self numArgs = 1
		ifTrue: [^self value: anArg].
	self numArgs  > 1 ifTrue: [
		^self valueWithArguments: (Array with: anArg), (Array new: self numArgs  - 1)]! !

!String methodsFor: '*Seaside-Core' stamp: 'lr 10/28/2007 14:42'!
asCapitalizedPhrase
	|read words currentWord capitalizedWord|
	(self noneSatisfy: [:ea | ea isLowercase] ) ifTrue: [^ self].
	words := WriteStream on: String new.
	read := ReadStream on: self.
	[read atEnd] whileFalse:
		[currentWord := WriteStream on: String new.
		currentWord nextPut: read next.
		[|x| x := read peek. x isNil or: [x isUppercase]] whileFalse:
			[currentWord nextPut: read next].
		capitalizedWord := currentWord contents capitalized.
			(#(Of In At A Or To By) includes: capitalizedWord)
				ifTrue: [capitalizedWord := capitalizedWord asLowercase].
		words nextPutAll: capitalizedWord.
		words nextPutAll: ' '].
	words skip: -1.
	^ words contents! !

!String methodsFor: '*Seaside-Core' stamp: 'pmm 1/22/2008 22:05'!
asMIMEDocument
	^self asMIMEDocumentType: 'text/plain' toMimeType! !

!String methodsFor: '*Seaside-Core' stamp: 'pmm 8/29/2008 18:21'!
asMIMEDocumentType: mimeType
	^WACollectionMimeDocument
		contentType: mimeType toMimeType
		content: self! !

!String methodsFor: '*Seaside-Core' stamp: 'lr 3/26/2007 20:22'!
encodeOn: aDocument
	aDocument htmlEncoder nextPutAll: self! !

!String methodsFor: '*Seaside-Core' stamp: 'lr 6/13/2006 16:06'!
renderOn: aRenderer
	aRenderer text: self! !

!String methodsFor: '*Seaside-Core' stamp: 'pmm 11/21/2007 20:19'!
toMimeType
	^ WAMimeType fromString: self! !

!Integer methodsFor: '*Seaside-Core' stamp: 'lr 8/30/2008 16:22'!
printStringAsCents
	^ '$' , (self // 100) seasideString , '.' , (self \\ 100) asTwoCharacterString! !

!Collection methodsFor: '*Seaside-Core' stamp: 'lr 5/9/2007 08:47'!
inspectorFields
	| i |
	i := 0.
	^ self asArray collect: [ :each | i := i + 1. i -> each ]! !

!Collection methodsFor: '*Seaside-Core' stamp: 'lr 3/8/2006 08:43'!
renderOn: html
	self do: [ :each | each renderOn: html ]! !

WAProcessVariable subclass: #WACurrentRequestContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Contexts'!

!WACurrentRequestContext commentStamp: 'pmm 6/1/2008 00:38' prior: 0!
A WACurrentRequestContext is a thread local variable that points to the current WARequestContext.
!

!WACurrentRequestContext class methodsFor: 'accessing' stamp: 'jf 7/14/2008 11:11'!
application
	"returns the current WAApplication or nil if there is none"
	| context |
	context := self value.
	^ context isNil ifFalse: [ context application ]! !

!WACurrentRequestContext class methodsFor: 'accessing' stamp: 'pmm 5/9/2008 19:30'!
request
	"returns the current WARequest"
	^self value request! !

!WACurrentRequestContext class methodsFor: 'accessing' stamp: 'pmm 3/29/2008 11:16'!
requestHandlerContext
	^self value requestHandlerContext! !

!WACurrentRequestContext class methodsFor: 'accessing' stamp: 'jf 7/14/2008 11:11'!
session
	"returns the current WASession or nil if there is none"
	| context |
	context := self value.
	^ context isNil ifFalse: [ context session ]! !

!Object methodsFor: '*Seaside-Core' stamp: 'lr 3/29/2008 22:54'!
deprecatedApi: aString
	self deprecatedApi: aString in: nil! !

!Object methodsFor: '*Seaside-Core' stamp: 'lr 3/29/2008 22:53'!
deprecatedApi: aString in: aNumber
	"Deprecated the sender method in Seaside with the version aNumber."

	WADeprecatedApi raiseSignal: aString! !

!Object methodsFor: '*Seaside-Core' stamp: 'lr 8/30/2008 16:22'!
encodeOn: aDocument 
	aDocument print: self seasideString! !

!Object methodsFor: '*Seaside-Core' stamp: 'lr 3/24/2008 17:47'!
inspectorFields
	| members |
	members := Array new writeStream.
	self class allInstVarNames keysAndValuesDo: [ :index :each | members nextPut: each -> (self instVarAt: index) ].
	self class isVariable ifTrue: 
		[ 1 
			to: self size
			do: [ :index | members nextPut: index -> (self at: index) ] ].
	^ members contents! !

!Object methodsFor: '*Seaside-Core' stamp: 'avi 3/14/2005 15:19'!
labelForSelector: aSymbol
	^ aSymbol asCapitalizedPhrase! !

!Object methodsFor: '*Seaside-Core' stamp: 'pmm 4/7/2007 17:14'!
renderOn: aRenderer
	"Override this method to customize how objects (not components) are rendered when passed as an argument to #render:. The default is the return value of #displayString.
	Just remember that you can not use #callback:, #on:of:, or #call:"

	aRenderer text: self! !

!Object methodsFor: '*Seaside-Core' stamp: 'lr 10/28/2007 14:42'!
validationError: message
	^WAValidationNotification raiseSignal: message! !

Object subclass: #WAAttributeContext
	instanceVariableNames: 'key target attribute cachedValues ancestorsWithAttribute'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WAAttributeContext class methodsFor: 'instance creation' stamp: 'jf 8/4/2008 14:33'!
key: keySymbol target: targetConfiguration
	^ self basicNew initializeWithKey: keySymbol target: targetConfiguration! !

!WAAttributeContext methodsFor: 'accessing' stamp: 'jf 8/4/2008 14:49'!
at: aConfiguration ifPresent: aBlock
	^ self cache at: aConfiguration ifPresent: aBlock! !

!WAAttributeContext methodsFor: 'accessing' stamp: 'jf 8/4/2008 14:49'!
at: aConfiguration put: cachedObject
	^ self cache at: aConfiguration put: cachedObject! !

!WAAttributeContext methodsFor: 'accessing' stamp: 'jf 8/4/2008 14:38'!
attribute
	^ attribute! !

!WAAttributeContext methodsFor: 'private' stamp: 'jf 8/4/2008 14:49'!
cache
	^ cachedValues! !

!WAAttributeContext methodsFor: 'as yet unclassified' stamp: 'jf 8/4/2008 18:11'!
filterAncestors
	| stack |
	stack := OrderedCollection with: self target.! !

!WAAttributeContext methodsFor: 'private' stamp: 'jf 8/4/2008 18:37'!
findAttributeAndSelectAncestorsOf: aConfiguration
	| found |
	(ancestorsWithAttribute includes: aConfiguration) ifTrue: [ ^ true ].
			
	aConfiguration canDefineAttributes ifTrue: [
		aConfiguration localAttributeAt: self key ifPresent:
			[ :attr |
			attribute := attr.
			ancestorsWithAttribute add: aConfiguration.
			^ true ] ].
		
	found := false.
	aConfiguration parents do: [ :each | found := found | (self findAttributeAndSelectAncestorsOf: each) ].
	
	found ifTrue: [ ancestorsWithAttribute add: aConfiguration ].
	
	^ found! !

!WAAttributeContext methodsFor: 'initialization' stamp: 'jf 8/4/2008 18:39'!
initializeWithKey: keySymbol target: targetConfiguration
	key := keySymbol.
	target := targetConfiguration.
	ancestorsWithAttribute := IdentitySet new.
	cachedValues := IdentityDictionary new.
	
	self findAttributeAndSelectAncestorsOf: target.
	! !

!WAAttributeContext methodsFor: 'accessing' stamp: 'jf 8/4/2008 15:25'!
isAttributeInheritedBy: aConfiguration
	^ ancestorsWithAttribute includes: aConfiguration! !

!WAAttributeContext methodsFor: 'accessing' stamp: 'jf 8/4/2008 18:29'!
key
	^ key! !

!WAAttributeContext methodsFor: 'accessing' stamp: 'jf 8/4/2008 18:12'!
target
	^ target! !

Object subclass: #WABrush
	instanceVariableNames: 'canvas parent closed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas'!

!WABrush commentStamp: 'lr 3/27/2007 11:18' prior: 0!
I represent a brush to be used on a *WACanvas*.

Instance Variables
	canvas:		The canvas instance I am used with.
	parent:		The parent brush I am used within.
	closed:		Wether I have been closed/flushed yet.!

!WABrush class methodsFor: 'instance-creation' stamp: 'lr 3/26/2007 22:31'!
new
	^ self basicNew initialize! !

!WABrush methodsFor: 'public' stamp: 'lr 4/9/2007 16:32'!
close
	"Close and flush the receiver onto the canvas and its associated document."

	closed ifFalse: [ self with: nil ]! !

!WABrush methodsFor: 'initialize-release' stamp: 'lr 3/27/2007 11:09'!
initialize
	closed := false! !

!WABrush methodsFor: 'private' stamp: 'lr 3/27/2007 17:38'!
labelForSelector: aSymbol of: anObject
	^ anObject labelForSelector: aSymbol! !

!WABrush methodsFor: 'accessing' stamp: 'avi 6/13/2004 00:27'!
parent
	^ parent! !

!WABrush methodsFor: 'initialize-release' stamp: 'avi 6/13/2004 00:27'!
setParent: aBrush canvas: aCanvas
	parent := aBrush.
	canvas := aCanvas! !

!WABrush methodsFor: 'public' stamp: 'lr 3/27/2007 11:10'!
with: aBlock
	canvas nest: aBlock.
	closed := true! !

WABrush subclass: #WACompound
	instanceVariableNames: 'callbackBlock value id properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WACompound commentStamp: 'pmm 9/22/2007 22:22' prior: 0!
I am the superclass for stuff that is not html element but you still want to access via the canvas API.!

!WACompound methodsFor: 'callbacks' stamp: 'lr 10/28/2007 14:42'!
callback: aBlock
	callbackBlock := aBlock! !

!WACompound methodsFor: 'public' stamp: 'lr 3/27/2007 18:00'!
close
	closed ifTrue: [ ^ self ].
	closed := true.
	self with: nil! !

!WACompound methodsFor: 'testing' stamp: 'lr 3/27/2007 17:25'!
hasCallback
	^ callbackBlock notNil! !

!WACompound methodsFor: 'accessing' stamp: 'lr 3/27/2007 17:55'!
id
	^ id! !

!WACompound methodsFor: 'accessing' stamp: 'lr 3/27/2007 17:55'!
id: aString
	id := aString! !

!WACompound methodsFor: 'initialize-release' stamp: 'lr 3/27/2007 17:51'!
initialize
	super initialize.
	"do not remove properties, it is used by SeasideAsync"
	properties := Dictionary new! !

!WACompound methodsFor: 'callbacks' stamp: 'lr 3/29/2008 16:40'!
on: aSelector of: anObject
	self value: (anObject perform: aSelector).
	self callback: (MessageSend receiver: anObject selector: aSelector asMutator)! !

!WACompound methodsFor: 'accessing' stamp: 'lr 3/27/2007 17:25'!
value
	^ value! !

!WACompound methodsFor: 'accessing' stamp: 'mb 1/30/2006 18:40'!
value: aValue
	value := aValue! !

WACompound subclass: #WADateInput
	instanceVariableNames: 'options month day year'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WADateInput commentStamp: 'pmm 4/30/2007 23:41' prior: 0!
I am a composition of three input fields that allow the user to select year, month and day. #options: can be used to toggle them individually.
The argument for my callback blocks is an instance of Date.

See WADateTimeTest >> #renderDateTimeOn:!

!WADateInput methodsFor: 'private rendering' stamp: 'mb 7/6/2007 18:51'!
addCallback
	self hasCallback
		ifFalse:
			[canvas flush.
			^ self].
	canvas hiddenInput
		callback: [callbackBlock value: self setValueWithNewDate];
		 with: nil! !

!WADateInput methodsFor: 'private callbacks' stamp: 'lr 10/28/2007 14:42'!
addDayCallbackToBrush: aBrush
	self hasCallback ifFalse: [^self].
	aBrush on: #day of: self! !

!WADateInput methodsFor: 'private callbacks' stamp: 'lr 10/28/2007 14:42'!
addMonthCallbackToBrush: aBrush
	self hasCallback ifFalse: [^self].
	aBrush on: #month of: self! !

!WADateInput methodsFor: 'private callbacks' stamp: 'mb 11/3/2006 14:19'!
addYearCallbackToBrush: aBrush
	self hasCallback ifFalse: [^self].
	aBrush on: #year of: self! !

!WADateInput methodsFor: 'private callbacks' stamp: 'mb 11/4/2006 10:20'!
day
	^day! !

!WADateInput methodsFor: 'private callbacks' stamp: 'pmm 12/9/2007 12:31'!
day: anIntegerOrString
	day := [ anIntegerOrString asInteger ] on: Error do: [ :e | 1 ]! !

!WADateInput methodsFor: 'private' stamp: 'mb 11/3/2006 09:57'!
defaultOptions
	^#(month day year)! !

!WADateInput methodsFor: 'private callbacks' stamp: 'mb 11/4/2006 10:20'!
month
	^month! !

!WADateInput methodsFor: 'private callbacks' stamp: 'pmm 12/9/2007 12:31'!
month: anIntegerOrString
	month := [ anIntegerOrString asInteger ] on: Error do: [ :error | 1 ]! !

!WADateInput methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
options
	^options ifNil: [ self defaultOptions ]! !

!WADateInput methodsFor: 'accessing' stamp: 'mb 11/3/2006 09:58'!
options: anArray
	"Valid values in the array : #year #month #day
	Can be used to control what is shown and in what order
	Default #(month day year)"
	options := anArray! !

!WADateInput methodsFor: 'private rendering' stamp: 'mb 7/10/2007 09:42'!
renderDay
	| brush |
	brush := canvas textInput
				id: (self id isNil
						ifFalse: [self id , '-day']);
				 value: day;
				 yourself.
	self addDayCallbackToBrush: brush.
	brush attributeAt: 'size' put: 2;
		 attributeAt: 'maxlength' put: 2! !

!WADateInput methodsFor: 'private rendering' stamp: 'lr 10/28/2007 14:42'!
renderMonth
	| brush |
	brush := canvas select
		id: self id;
		list: (1 to: 12);
		selected: month;
		yourself.
	self addMonthCallbackToBrush: brush.
	brush
		labels: [:ea | Date nameOfMonth: ea]! !

!WADateInput methodsFor: 'private rendering' stamp: 'lr 10/28/2007 14:42'!
renderYear
	| brush |
	brush := (canvas textInput)
		id: (self id isNil ifTrue: [nil] ifFalse: [self id , '-year']);
		value: year;
		yourself.
	self addYearCallbackToBrush: brush.
	brush
		attributeAt: 'size' put: 4;
		attributeAt: 'maxlength' put: 4! !

!WADateInput methodsFor: 'private callbacks' stamp: 'dkh 3/10/2008 10:50'!
setValueWithNewDate
	^value := Date
		newDay: ((day min: (Date daysInMonthNumber: month forYear: year)) max: 1)
		monthNumber: month
		year: year! !

!WADateInput methodsFor: 'public' stamp: 'lr 10/28/2007 14:42'!
with: aBlock
	value isNil ifTrue: [value := Date today].
	day := value dayOfMonth.
	month := value monthIndex.
	year := value year.
	self options
		do: [:each | self perform: ('render' , each asLowercase capitalized) asSymbol ]
		separatedBy: [ canvas space ].
	self addCallback! !

!WADateInput methodsFor: 'private callbacks' stamp: 'mb 11/4/2006 10:20'!
year
	^year! !

!WADateInput methodsFor: 'private callbacks' stamp: 'pmm 12/9/2007 12:30'!
year: anIntegerOrString
	year := [ anIntegerOrString asInteger ] on: Error do: [ :e | 1900 ]! !

WACompound subclass: #WATimeInput
	instanceVariableNames: 'withSeconds hours minutes seconds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WATimeInput commentStamp: 'pmm 4/30/2007 23:41' prior: 0!
I am a composition of three input fields that allows the user to select hour, minute and optionally second.
#withSeconds and #withoutSeconds can be used to toggle seconds.

The argument for my callback blocks is an instance of Time.

See WADateTimeTest >> #renderDateTimeOn:!

!WATimeInput methodsFor: 'private rendering' stamp: 'mb 7/6/2007 18:52'!
addCallback
	self hasCallback
		ifFalse:
			[canvas flush.
			^ self].
	canvas hiddenInput
		callback: [callbackBlock value: self setValueWithNewTime];
		 with: nil! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'lr 10/28/2007 14:42'!
addHoursCallbackToBrush: aBrush
	self hasCallback ifFalse: [^self].
	aBrush on: #hours of: self! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'lr 10/28/2007 14:42'!
addMinutesCallbackToBrush: aBrush
	self hasCallback ifFalse: [^self].
	aBrush on: #minutes of: self! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'lr 10/28/2007 14:42'!
addSecondsCallbackToBrush: aBrush
	self hasCallback ifFalse: [^self].
	aBrush on: #seconds of: self! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'lr 10/28/2007 14:42'!
hours
	^hours! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'pmm 12/9/2007 12:29'!
hours: anIntegerOrString
	hours := [ anIntegerOrString asInteger ] on: Error do: [ :e | 0 ]! !

!WATimeInput methodsFor: 'initialize-release' stamp: 'pmm 9/12/2006 19:18'!
initialize
	super initialize.
	self withoutSeconds! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'mb 11/4/2006 10:21'!
minutes
	^minutes! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'pmm 12/9/2007 12:29'!
minutes: anIntegerOrString
	minutes := [ anIntegerOrString asInteger ] on: Error do: [ :error | 0]! !

!WATimeInput methodsFor: 'private rendering' stamp: 'lr 3/27/2007 17:28'!
renderHours
	| brush |
	brush := canvas textInput
		id: self id;
		value: hours asTwoCharacterString;
		yourself.
	self addHoursCallbackToBrush: brush.
	brush
		attributeAt: 'size' put: 2;
		attributeAt: 'maxlength' put: 2! !

!WATimeInput methodsFor: 'private rendering' stamp: 'mb 7/10/2007 09:42'!
renderMinutes
	| brush |
	brush := canvas textInput
				id: (self id isNil
						ifFalse: [self id , '-mins']);
				 value: minutes asTwoCharacterString;
				 yourself.
	self addMinutesCallbackToBrush: brush.
	brush attributeAt: 'size' put: 2;
		 attributeAt: 'maxlength' put: 2! !

!WATimeInput methodsFor: 'private rendering' stamp: 'mb 7/10/2007 09:42'!
renderSeconds
	| brush |
	brush := canvas textInput
				id: (self id isNil
						ifFalse: [self id , '-secs']);
				 value: seconds asTwoCharacterString;
				 yourself.
	self addSecondsCallbackToBrush: brush.
	brush attributeAt: 'size' put: 2;
		 attributeAt: 'maxlength' put: 2! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'mb 11/4/2006 10:21'!
seconds
	^seconds! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'lr 10/28/2007 14:42'!
seconds: anIntegerOrString
	seconds := [anIntegerOrString asNumber] on: Error do: [:e | 0]! !

!WATimeInput methodsFor: 'private callbacks' stamp: 'lr 10/28/2007 14:42'!
setValueWithNewTime
	^value := Time
				hour: hours
				minute: (minutes min: 59)
				second: (seconds min: 59)! !

!WATimeInput methodsFor: 'public' stamp: 'lr 10/28/2007 14:42'!
with: aBlock
	value isNil ifTrue: [value := Time now].
	hours := value hour.
	minutes := value minutes.
	seconds := value seconds.
	self renderHours.
	canvas space; text: ':'; space.
	self renderMinutes.
	withSeconds ifTrue:
		[canvas space; text: ':'; space.
		self renderSeconds]
	ifFalse:
		[seconds := 0].
	self addCallback! !

!WATimeInput methodsFor: 'accessing' stamp: 'mb 2/6/2006 09:55'!
withSeconds
	withSeconds := true! !

!WATimeInput methodsFor: 'accessing' stamp: 'mb 2/6/2006 09:56'!
withoutSeconds
	withSeconds := false! !

WABrush subclass: #WATagBrush
	instanceVariableNames: 'attributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas'!

!WATagBrush commentStamp: 'pmm 4/15/2007 22:14' prior: 0!
This is the superclass for all XML element classes. Its main addtions are
- element name (#tag)
- attributes (instance of WAHtmlAttributes)
- common events (onXXX), this is a hack and would better be solved with traits!

WATagBrush subclass: #WAAnchorTag
	instanceVariableNames: 'url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAAnchorTag commentStamp: 'lr 7/4/2007 20:42' prior: 0!
I'm the class responsible for adding anchors (links) to your webpage. There are multiple ways of using me.

1. In the following case, the method #doSomethingOnClick will be sent to self when the user click on the anchor 'Click here to do something':

	html anchor
		callback: [ self doSomethingOnClick ];
		with: 'Click here to do something'.
		
The following code is a shortcut to create an anchor. The executed action is #doSomethingOnClick and the text is 'Do Something On Click':

	html anchor
		on: #doSomethingOnClick of: self

2. In the following case, a link to an external resource will be generated:

	html anchor
		url: 'http://www.seaside.st';
		with: 'Visit the Seaside'!

!WAAnchorTag methodsFor: 'callbacks' stamp: 'lr 8/17/2007 15:07'!
callback: aBlock
	self url addParameter: (canvas callbacks registerActionCallback: aBlock)! !

!WAAnchorTag methodsFor: 'deprecated' stamp: 'lr 8/17/2007 15:42'!
canHaveShortcut
	^ true! !

!WAAnchorTag methodsFor: 'documents' stamp: 'lr 8/17/2007 15:08'!
document: aDocument
	self document: aDocument mimeType: nil! !

!WAAnchorTag methodsFor: 'documents' stamp: 'lr 8/17/2007 15:08'!
document: aDocument mimeType: mimeType
	self document: aDocument mimeType: mimeType fileName: nil! !

!WAAnchorTag methodsFor: 'documents' stamp: 'lr 8/17/2007 15:09'!
document: aDocument mimeType: mimeType fileName: fileName
	self url: (canvas context urlForDocument: aDocument mimeType: mimeType fileName: fileName)! !

!WAAnchorTag methodsFor: 'url' stamp: 'lr 8/17/2007 15:16'!
extraParameters: aCollection
	self url addParameter: aCollection! !

!WAAnchorTag methodsFor: 'url' stamp: 'pmm 10/7/2007 14:32'!
extraPath: aString
	self url addToPath: aString! !

!WAAnchorTag methodsFor: 'url' stamp: 'lr 8/17/2007 15:16'!
fragment: aString
	self url fragment: aString! !

!WAAnchorTag methodsFor: 'deprecated' stamp: 'lr 8/17/2007 15:43'!
ignoreURL
	"does nothing when clicked"
	^ self onClick: 'return false'! !

!WAAnchorTag methodsFor: 'deprecated' stamp: 'lr 8/17/2007 15:24'!
mailto: aString
	self deprecatedApi.
	self url: 'mailto:' , aString; with: aString! !

!WAAnchorTag methodsFor: 'attributes' stamp: 'lr 8/17/2007 15:04'!
name: aString
	self attributes at: 'name' put: aString! !

!WAAnchorTag methodsFor: 'public' stamp: 'lr 10/28/2007 14:42'!
navigation
	"Makes the receiving anchor a purely navigational link, this is it won't redirect after processing the callbacks but directly process with the render phase. Don't use this feature if you change your model in the callback'."

	self url addParameter: '_n'! !

!WAAnchorTag methodsFor: 'deprecated' stamp: 'lr 8/17/2007 15:19'!
newTarget
	self deprecatedApi.
	self target: '_new'! !

!WAAnchorTag methodsFor: 'callbacks' stamp: 'lr 3/29/2008 16:39'!
on: aSymbol of: anObject
	self callback: (MessageSend receiver: anObject selector: aSymbol).
	self with: (self labelForSelector: aSymbol of: anObject)! !

!WAAnchorTag methodsFor: 'deprecated' stamp: 'lr 8/17/2007 15:19'!
rel: aString
	self deprecatedApi.
	self relationship: aString! !

!WAAnchorTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
relationship: aString
	self attributes at: 'rel' put: aString! !

!WAAnchorTag methodsFor: 'url' stamp: 'lr 8/17/2007 15:25'!
resourceUrl: aString
	self url: (canvas context absoluteUrlForResource: aString)! !

!WAAnchorTag methodsFor: 'convenience' stamp: 'lr 10/28/2007 14:42'!
submitFormNamed: aString
	"Submits a form with the id aString."

	self onClick: 'document.forms[' , aString printString , '].submit()'! !

!WAAnchorTag methodsFor: 'accessing' stamp: 'lr 8/17/2007 15:15'!
tag
	^ 'a'! !

!WAAnchorTag methodsFor: 'deprecated' stamp: 'lr 3/24/2008 13:01'!
target: aString 
	self deprecatedApi.
	self attributes 
		at: 'target'
		put: aString! !

!WAAnchorTag methodsFor: 'deprecated' stamp: 'lr 8/17/2007 15:19'!
text: aString
	self deprecatedApi.
	self with: aString! !

!WAAnchorTag methodsFor: 'accessing' stamp: 'lr 8/17/2007 15:17'!
url
	^ url ifNil: [ url := canvas context actionUrl copy ]! !

!WAAnchorTag methodsFor: 'accessing' stamp: 'lr 8/17/2007 15:06'!
url: aString
	url := aString! !

!WAAnchorTag methodsFor: 'public' stamp: 'lr 8/17/2007 15:11'!
with: aBlock
	url isNil
		ifFalse: [ self attributes at: 'href' put: url ]
		ifTrue: [
			((self attributes includesKey: 'href') or: [ self attributes includesKey: 'name' ])
				ifFalse: [ self attributes at: 'href' put: 'javascript:void(0)' ] ].
	super with: aBlock! !

WAAnchorTag subclass: #WAImageMapTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAImageMapTag commentStamp: 'lr 8/17/2007 18:56' prior: 0!
A WAImageMapTag is supposed to be used like this:

	html map
		callback: [ :point | self click: point ];
		with: [ html image url: 'foo.gif' ]
			
An example can be found in WAScreenshot.

Technincal:
http://www.w3.org/TR/html4/struct/objects.html#include-maps

The location clicked is passed to the server as follows. The user agent derives a new URI from the URI specified by the href attribute of the A element, by appending `?' followed by the x and y coordinates, separated by a comma. The link is then followed using the new URI. For instance, in the given example, if the user clicks at the location x=10, y=27 then the derived URI is "http://www.acme.com/cgi-bin/competition?10,27".
!

!WAImageMapTag methodsFor: 'callbacks' stamp: 'lr 3/24/2008 18:32'!
callback: aBlock
	"The parameter for the image-map callback must be the last one, as the web-browser will use the same name and replace it with the coordinates."

	aBlock fixCallbackTemps.
	self url
		addParameter: (canvas callbacks registerCallback: [ :value |
			aBlock value: (self parseImageMap: value) ])
		value: ''! !

!WAImageMapTag methodsFor: 'private' stamp: 'lr 3/24/2008 18:32'!
parseImageMap: aString
	| stream x y |
	stream := aString readStream.
	stream next = $? ifFalse: [ ^ nil ].
	x := Integer readFrom: stream.
	stream next = $, ifFalse: [ ^ nil ].
	y := Integer readFrom: stream.
	^ x @ y! !

WAAnchorTag subclass: #WAPopupAnchorTag
	instanceVariableNames: 'name features'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAPopupAnchorTag commentStamp: 'lr 7/4/2007 20:46' prior: 0!
I am used to create a link that opens in a new window. A name can be specified using #name: and many features can be configured. Note, that not all features are supported on all web browser platforms. If Javascript is disabled the link will behave like any other anchor.

Most of the time a popup-anchor is created like this:

	html popupAnchor
		callback: [ WARenderLoop new call: WACounter new ];
		with: 'Open the counter within a new window'

This code creates a new render-loop and displays a new instance of WACounter within the new browser window.		
!

!WAPopupAnchorTag methodsFor: 'features' stamp: 'lr 7/4/2007 20:32'!
dependent: aBoolean
	"Specifies whether the new window is closed as well when the parent window gets closed."

	features at: #dependent put: aBoolean! !

!WAPopupAnchorTag methodsFor: 'features' stamp: 'lr 10/28/2007 14:42'!
extent: aPoint
	"Specifies the width and height of the new window."

	self width: aPoint x; height: aPoint y! !

!WAPopupAnchorTag methodsFor: 'private' stamp: 'lr 8/30/2008 16:22'!
featureString
	^ String streamContents: 
		[ :stream | 
		features associations 
			do: 
				[ :assoc | 
				stream
					nextPutAll: assoc key;
					nextPut: $=.
				stream nextPutAll: (assoc value == true 
						ifTrue: [ 'yes' ]
						ifFalse: 
							[ assoc value == false 
								ifTrue: [ 'no' ]
								ifFalse: [ assoc value seasideString ] ]) ]
			separatedBy: [ stream nextPut: $, ] ]! !

!WAPopupAnchorTag methodsFor: 'features' stamp: 'lr 10/28/2007 14:42'!
height: anInteger
	"Specifies the height of the new window."

	features at: #height put: anInteger! !

!WAPopupAnchorTag methodsFor: 'initialize-release' stamp: 'lr 7/4/2007 20:16'!
initialize
	super initialize.
	name := '_blank'.
	features := Dictionary new! !

!WAPopupAnchorTag methodsFor: 'features' stamp: 'lr 10/28/2007 14:42'!
left: anInteger
	"Specifies the x coordinate of the top left corner of the new window. "

	features at: #left put: anInteger! !

!WAPopupAnchorTag methodsFor: 'features' stamp: 'lr 7/4/2007 20:24'!
location: aBoolean
	"Specifies whether to display the address line in the new window."

	features at: #location put: aBoolean! !

!WAPopupAnchorTag methodsFor: 'features' stamp: 'lr 7/4/2007 20:25'!
menubar: aBoolean
	"Specifies whether to display the browser menu bar."

	features at: #menubar put: aBoolean! !

!WAPopupAnchorTag methodsFor: 'accessing' stamp: 'lr 7/4/2007 20:22'!
name
	^ name! !

!WAPopupAnchorTag methodsFor: 'accessing' stamp: 'lr 7/4/2007 19:56'!
name: aString
	"String specifying the name of the new window. If a window with this name already exists, then the new content will be displayed in that existing window, rather than creating a new one."

	name := aString! !

!WAPopupAnchorTag methodsFor: 'features' stamp: 'lr 10/28/2007 14:42'!
position: aPoint
	"Specifies the x and y coordinates of the top left corner of the new window."

	self left: aPoint x; top: aPoint y! !

!WAPopupAnchorTag methodsFor: 'features' stamp: 'lr 7/4/2007 20:25'!
resizable: aBoolean
	"Specifies whether the new window is resizable."

	features at: #resizable put: aBoolean! !

!WAPopupAnchorTag methodsFor: 'features' stamp: 'lr 7/4/2007 20:25'!
scrollbars: aBoolean
	"Specifies whether the new window should have scrollbars."

	features at: #scrollbars put: aBoolean! !

!WAPopupAnchorTag methodsFor: 'features' stamp: 'lr 7/4/2007 20:24'!
status: aBoolean
	"Specifies whether to display the browser status bar."

	features at: #status put: aBoolean! !

!WAPopupAnchorTag methodsFor: 'features' stamp: 'lr 7/4/2007 20:24'!
toolbar: aBoolean
	"Specifies whether to display the toolbar in the new window."

	features at: #toolbar put: aBoolean! !

!WAPopupAnchorTag methodsFor: 'features' stamp: 'lr 10/28/2007 14:42'!
top: anInteger
	"Specifies the y coordinate of the top left corner of the new window. "

	features at: #top put: anInteger! !

!WAPopupAnchorTag methodsFor: 'features' stamp: 'lr 10/28/2007 14:42'!
width: anInteger
	"Specifies the width of the new window."

	features at: #width put: anInteger! !

!WAPopupAnchorTag methodsFor: 'public' stamp: 'lr 7/4/2007 20:33'!
with: aBlock
	self onClick: 'window.open(this.href,' , self name printString , ',' , self featureString printString , ');return false'.
	super with: aBlock! !

WATagBrush subclass: #WABasicFormTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WABasicFormTag commentStamp: 'MAD 8/30/2008 15:21' prior: 0!
Acts as a basic form, with no defaultAction, and no holding of _s and _c values.
!

!WABasicFormTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
acceptCharset: aString 
	"This attribute specifies the list of character encodings for input data that is accepted by the server processing this form. The value is a space- and/or comma-delimited list of charset values. The client must interpret this list as an exclusive-or list, i.e., the server is able to accept any single character encoding per entity received.

The default value for this attribute is the reserved string 'UNKNOWN'. User agents may interpret this value as the character encoding that was used to transmit the document containing this FORM element."
	self attributes 
		at: 'accept-charset'
		put: aString! !

!WABasicFormTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
action: aString 
	"This attribute specifies a form processing agent. User agent behavior for a value other than an HTTP URI is undefined."
	self attributes 
		at: 'action'
		put: aString! !

!WABasicFormTag methodsFor: 'private' stamp: 'MAD 8/30/2008 14:55'!
defaultUrlCharset
	"the character set used for POSTs that are application/x-www-form-urlencoded
	and GETs
	There are standards that dictate this:
	http://www.w3.org/International/O-URL-code.html
	but that doesn't mean is will work with your favorite old browser"
	^ 'utf-8'! !

!WABasicFormTag methodsFor: 'attributes' stamp: 'pmm 5/9/2008 19:27'!
get
	"tells the user agent to use the HTTP POST method to submit this form"
	self method: 'get'! !

!WABasicFormTag methodsFor: 'initialize-release' stamp: 'MAD 8/30/2008 14:55'!
initialize
	super initialize.
	self acceptCharset: self defaultUrlCharset! !

!WABasicFormTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
method: aString 
	"This attribute specifies which HTTP method will be used to submit the form data set. Possible (case-insensitive) values are 'get' (the default) and 'post'."
	self attributes 
		at: 'method'
		put: aString! !

!WABasicFormTag methodsFor: 'attributes' stamp: 'pmm 5/10/2008 10:43'!
multipart
	"Sets the content type used to submit the form to the server (when the value of method is 'post') to multipart/form-data instead the default application/x-www-form-urlencoded. This should be used in combination with a WAFileUploadTag."
	self attributes 
		at: 'enctype'
		put: 'multipart/form-data'.
		
	"set the request encoding to the body encoding"
	self acceptCharset: self requestContext application charSet! !

!WABasicFormTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
multipart: aBoolean
	"Sets the content type used to submit the form to the server.
	true: sets the content type to multipart/form-data
	false: leavess the content type to default application/x-www-form-urlencoded"
	aBoolean ifTrue: [ self multipart ]! !

!WABasicFormTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
name: aString 
	self attributes 
		at: 'name'
		put: aString! !

!WABasicFormTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
noAutocomplete
	self attributes 
		at: 'autocomplete'
		put: 'off'! !

!WABasicFormTag methodsFor: 'attributes' stamp: 'pmm 5/9/2008 19:27'!
post
	"tells the user agent to use the HTTP POST method to submit this form"
	self method: 'post'! !

!WABasicFormTag methodsFor: 'initialize-release' stamp: 'pmm 6/21/2007 20:57'!
setParent: aBrush canvas: aCanvas
	super setParent: aBrush canvas: aCanvas.
	self post; action: aCanvas context actionUrl withoutParameters! !

!WABasicFormTag methodsFor: 'accessing' stamp: 'avi 6/17/2004 11:29'!
tag
	^ 'form'! !

WABasicFormTag subclass: #WAFormTag
	instanceVariableNames: 'defaultAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAFormTag commentStamp: 'pmm 9/15/2007 08:23' prior: 0!
The FORM element acts as a container for input elements and buttons.

Evaluation order:
The input fields callbacks will be evaluated in the order they
appear in the XHTML. Buttons will always be evaluated last, no matter
where they are positioned.!

!WAFormTag methodsFor: 'private' stamp: 'MAD 8/30/2008 12:24'!
after
	canvas div: [
		canvas context actionUrl parameters keysAndValuesDo: [ :k :v |
			canvas hiddenInput
				name: k;
				value: v ] ]! !

!WAFormTag methodsFor: 'private' stamp: 'MAD 8/30/2008 12:24'!
before
	"Define the default action form buttons. Some implementation notes on this feature: (1) a tab-index of -1 is not valid XHTML, but most todays browser accept it and ignore the element in the tab-order. (2) Internet Explorer requires an additional text field (without other functionality) to make the default action work. Other browser should not include this text-field, as it prevents remembering form input."

	defaultAction ifNil: [ ^ nil ].
	canvas div: [
		canvas submitButton
			tabIndex: -1;
			value: 'Default';
			callback: defaultAction;
			style: 'position: absolute; top: -100em'.
		self isInternetExplorer ifTrue: [
			canvas textInput
				tabIndex: -1;
				callback: [ :v | ];
				style: 'position: absolute; top: -100em' ] ]! !

!WAFormTag methodsFor: 'callbacks' stamp: 'MAD 8/30/2008 13:05'!
defaultAction: aBlock
	"The default action gets evaluated whenever the user presses submits
	the form by pressing enter without having the focus on a specific
	submit-button."
	defaultAction := aBlock! !

!WAFormTag methodsFor: 'private' stamp: 'pmm 8/30/2008 15:11'!
isInternetExplorer
	"Tries to find out whether the current request is made by IE. This is extremely unrelyable."
	| userAgent |
	userAgent := self requestContext request userAgent.
	^ userAgent notNil and: 
		[ (userAgent includesSubString: 'MSIE') and: [ (userAgent includesSubString: 'Opera') not ] ]! !

WATagBrush subclass: #WABreakTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WABreakTag commentStamp: 'pmm 9/22/2007 22:22' prior: 0!
The BR element forcibly breaks (ends) the current line of text. Authors are advised to use style sheets to control text flow around floating images and other objects.

Prohibiting a line break 

Sometimes authors may want to prevent a line break from occurring between two words. The &nbsp; entity (&#160; or &#xA0;) acts as a space where user agents should not cause a line break.!

!WABreakTag methodsFor: 'testing' stamp: 'lr 3/26/2007 21:10'!
isClosed
	^ true! !

!WABreakTag methodsFor: 'accessing' stamp: 'lr 3/26/2007 21:10'!
tag
	^ 'br'! !

WATagBrush subclass: #WACollectionTag
	instanceVariableNames: 'list selected callbackBlock labelBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WACollectionTag commentStamp: 'pmm 4/23/2007 20:59' prior: 0!
This element allows the use to select one (in single selection mode) or multiple (in single selection mode) elements. Multiple selection can be triggered with #beMultiple, single selection can be triggered with #beSingle .Default is single selection.

The general idea is that you pass the colletion of options to #list: and use #labels: to customize their rendering. The selected option(s) can be set with: #selected:.


This whole class is kind of an akward hack, but noone needs MI anyway. You can always get a way with composition and delegation!

!WACollectionTag methodsFor: 'adding' stamp: 'lr 6/6/2007 13:22'!
add: anObject
	self list add: anObject! !

!WACollectionTag methodsFor: 'adding' stamp: 'lr 6/6/2007 13:22'!
addAll: aCollection
	self list addAll: aCollection! !

!WACollectionTag methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
before
	super before.
	self hasList ifTrue: [
		self list do: [ :each |
			self
				renderListItem: each
				labelled: (self labelForOption: each) ] ]! !

!WACollectionTag methodsFor: 'callbacks' stamp: 'lr 6/7/2007 07:48'!
callback: aBlock
	callbackBlock := aBlock fixCallbackTemps! !

!WACollectionTag methodsFor: 'testing' stamp: 'lr 6/7/2007 07:46'!
hasCallback
	^ callbackBlock notNil! !

!WACollectionTag methodsFor: 'testing' stamp: 'lr 6/6/2007 13:30'!
hasList
	^ list notNil and: [ list notEmpty ]! !

!WACollectionTag methodsFor: 'testing' stamp: 'lr 10/28/2007 14:42'!
isSelected: anObject
	"Test if anObject is currently selected."

 	^ selected = anObject! !

!WACollectionTag methodsFor: 'private' stamp: 'lr 6/6/2007 13:53'!
labelForOption: anObject
	^ labelBlock isNil
		ifTrue: [ anObject ]
		ifFalse: [ labelBlock value: anObject ]! !

!WACollectionTag methodsFor: 'callbacks' stamp: 'lr 10/28/2007 14:42'!
labels: aBlock
	"Allows to customize the rendering of list items by passing a one argument block that converts each option to a string. If you need to do custom html rendering for the options use #with: or override #renderOn: in your objects."

	labelBlock := aBlock fixCallbackTemps! !

!WACollectionTag methodsFor: 'accessing' stamp: 'lr 6/6/2007 13:22'!
list
	^ list ifNil: [ list := OrderedCollection new ]! !

!WACollectionTag methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
list: aCollection
	"Append aCollection of items to display. The rendering can be customized using #labels:."

	aCollection ifNotNil: [ self addAll: aCollection ]! !

!WACollectionTag methodsFor: 'callbacks' stamp: 'lr 3/29/2008 16:39'!
on: aSelector of: anObject
	self selected: (anObject perform: aSelector).
	self callback: (MessageSend receiver: anObject selector: aSelector asMutator)! !

!WACollectionTag methodsFor: 'private' stamp: 'lr 6/7/2007 07:50'!
performCallback: anObject
	self hasCallback ifTrue: [ callbackBlock value: anObject ]! !

!WACollectionTag methodsFor: 'private' stamp: 'lr 6/7/2007 07:56'!
renderListItem: anObject labelled: aString
	self subclassResponsibility! !

!WACollectionTag methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
selected: anObject
	"Set anObject to be selected."

	selected := anObject! !

WACollectionTag subclass: #WAListTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAListTag commentStamp: 'pmm 6/30/2007 00:46' prior: 0!
Abstract base class for ordered and unordered list tags.

Ordered and unordered lists are rendered in an identical manner except that visual user agents number ordered list items. User agents may present those numbers in a variety of ways. Unordered list items are not numbered.

Both types of lists are made up of sequences of list items defined by the LI element (whose end tag may be omitted).

Lists may also be nested.!

!WAListTag methodsFor: 'private' stamp: 'lr 6/7/2007 08:01'!
renderListItem: anObject labelled: aString
	canvas listItem
		class: 'option-selected' if: (self isSelected: anObject);
		with: [
			self hasCallback
				ifFalse: [ canvas render: aString ]
				ifTrue: [
					canvas anchor
						callback: [ self performCallback: anObject ];
						with: aString ] ]! !

WAListTag subclass: #WAOrderedListTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAOrderedListTag commentStamp: 'pmm 6/30/2007 00:47' prior: 0!
See superclass comment.!

!WAOrderedListTag methodsFor: 'accessing' stamp: 'lr 4/9/2007 17:12'!
tag
	^ 'ol'! !

WAListTag subclass: #WAUnorderedListTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAUnorderedListTag commentStamp: 'pmm 6/30/2007 00:47' prior: 0!
See superclass comment.!

!WAUnorderedListTag methodsFor: 'accessing' stamp: 'lr 4/9/2007 17:12'!
tag
	^ 'ul'! !

WACollectionTag subclass: #WASelectTag
	instanceVariableNames: 'enabledBlock isOptional optionalLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WASelectTag commentStamp: 'pmm 4/24/2007 11:12' prior: 0!
This element allows the use to select one (in single selection mode) or multiple (in single selection mode) elements. Default is single selection. Multiple selection can be triggered with #beMultiple.

Single selection is in general a drop-down list, so make sure the list of options is not too big.
Multiple selection has in general crappy browser support and a list of checkboxes is in general the better option.

If in single selection mode and you want enable "no selection" see #beOptional.

If you absolutely need to you can render the options yourself with 'html option' inside #with:

Make sure to check the superclass for more methods.

See WAInputTest >> #renderSingleSelectionOn: and WAInputTest >> #renderMultiSelectionOn: for examples.!

WASelectTag subclass: #WAMultiSelectTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAMultiSelectTag commentStamp: 'obi 4/2/2008 22:54' prior: 0!
See superclass.!

!WAMultiSelectTag methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
closeTag
	super closeTag.
	self hasCallback ifFalse: [ ^ self ].
	canvas insert: [
		canvas hiddenInput callback: [
			self hasCallback
				ifTrue: [ callbackBlock value: selected ] ] ]! !

!WAMultiSelectTag methodsFor: 'private' stamp: 'lr 6/6/2007 16:18'!
dispatchCallback
	^ canvas callbacks registerMultiDispatchCallback! !

!WAMultiSelectTag methodsFor: 'testing' stamp: 'lr 6/6/2007 16:14'!
isSelected: anObject
	^ selected notNil and: [ selected includes: anObject ]! !

!WAMultiSelectTag methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
openTag
	self hasCallback ifTrue: [
		canvas insert: [
			canvas hiddenInput
				callback: [ selected := OrderedCollection new ] ] ].
	self attributes at: 'multiple' put: true.
	super openTag! !

!WAMultiSelectTag methodsFor: 'private' stamp: 'lr 6/6/2007 18:37'!
performCallback: anObject
	selected add: anObject! !

!WASelectTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
beOptional
	"This adds a nil item to #list: which has the semantic of no selection. #optionalLabel: is the label for nil. This only really makes sense in single selection mode."

	isOptional := true! !

!WASelectTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
beSubmitOnChange
	"Submit the form in the user selects a value."

	self onChange: 'submit()'! !

!WASelectTag methodsFor: 'private' stamp: 'lr 6/6/2007 17:44'!
before
	self isOptional ifTrue: [ self renderOptional ].
	super before! !

!WASelectTag methodsFor: 'private' stamp: 'lr 6/6/2007 16:17'!
dispatchCallback
	^ canvas callbacks registerDispatchCallback! !

!WASelectTag methodsFor: 'callbacks' stamp: 'lr 6/6/2007 13:38'!
enabled: aBlock
	"Enable only those elements for selection for whom aBlock return true."

	enabledBlock := aBlock fixCallbackTemps! !

!WASelectTag methodsFor: 'initialize-release' stamp: 'lr 6/6/2007 17:43'!
initialize
	super initialize.
	isOptional := false! !

!WASelectTag methodsFor: 'testing' stamp: 'lr 6/6/2007 16:21'!
isEnabled: anObject
	"Test if anObject is enabled."

 	^ enabledBlock isNil or: [ enabledBlock value: anObject ]! !

!WASelectTag methodsFor: 'testing' stamp: 'lr 6/6/2007 17:42'!
isOptional
	^ isOptional! !

!WASelectTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
name: aString
	"This attribute assigns the control name."

	self attributes at: 'name' put: aString! !

!WASelectTag methodsFor: 'private' stamp: 'lr 6/6/2007 16:23'!
openTag
	self attributes at: 'name' ifAbsentPut: [ self dispatchCallback ].
	super openTag! !

!WASelectTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
optionalLabel: aString
	"The label for the nil element. See #beOptional."

	optionalLabel := aString! !

!WASelectTag methodsFor: 'private' stamp: 'lr 6/7/2007 07:57'!
renderListItem: anObject labelled: aString
	| option |
	option := canvas option.
	self hasCallback
		ifTrue: [ option callback: [ self performCallback: anObject ] ].
	option
		selected: (self isSelected: anObject);
		disabled: (self isEnabled: anObject) not;
		with: aString! !

!WASelectTag methodsFor: 'private' stamp: 'lr 6/7/2007 07:58'!
renderOptional
	self renderListItem: nil labelled: optionalLabel! !

!WASelectTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
size: aNumber
	"If a SELECT element is presented as a scrolled list box, this attribute specifies the number of rows in the list that should be visible at the same time. Visual user agents are not required to present a SELECT element as a list box; they may use any other mechanism, such as a drop-down menu."

	self attributes at: 'size' put: aNumber! !

!WASelectTag methodsFor: 'accessing' stamp: 'ac 3/17/2005 16:44'!
tag
	^ 'select'! !

WATagBrush subclass: #WADivTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WADivTag commentStamp: 'obi 4/2/2008 22:48' prior: 0!
The <div> tag defines a division/section in a document.

Use the <div> tag to group block-elements to format them with styles.
!

!WADivTag methodsFor: 'public' stamp: 'avi 6/3/2005 15:40'!
clear
	self class: 'clear'.
	self with: [canvas space]! !

!WADivTag methodsFor: 'accessing' stamp: 'avi 6/3/2005 15:39'!
tag
	^ 'div'! !

WATagBrush subclass: #WAFieldSetTag
	instanceVariableNames: 'legend'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAFieldSetTag commentStamp: 'pmm 5/10/2007 10:12' prior: 0!
The FIELDSET element allows authors to group thematically related controls and labels. Grouping controls makes it easier for users to understand their purpose while simultaneously facilitating tabbing navigation for visual user agents and speech navigation for speech-oriented user agents. The proper use of this element makes documents more accessible.

The LEGEND element allows authors to assign a caption to a FIELDSET. The legend improves accessibility when the FIELDSET is rendered non-visually.!

!WAFieldSetTag methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
before
	legend ifNotNil: [canvas legend: legend]! !

!WAFieldSetTag methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
legend: aString
	legend := aString! !

!WAFieldSetTag methodsFor: 'accessing' stamp: 'mb 3/8/2006 17:44'!
tag
	^ 'fieldset'! !

WATagBrush subclass: #WAFormInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAFormInputTag commentStamp: 'obi 4/2/2008 22:49' prior: 0!
The <input> tag defines the start of an input field where the user can enter data.!

WAFormInputTag subclass: #WAAbstractTextAreaTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAAbstractTextAreaTag commentStamp: 'pmm 4/23/2007 21:10' prior: 0!
An abstract class to describe the HTML elements that allow the user to enter text.!

!WAAbstractTextAreaTag methodsFor: 'callbacks' stamp: 'lr 2/25/2007 23:11'!
callback: aBlock
	self name: (canvas callbacks registerCallback: aBlock).
	self value: self value! !

!WAAbstractTextAreaTag methodsFor: 'javascript' stamp: 'lr 6/24/2007 10:03'!
exampleText: aString
	(self value isEmptyOrNil or: [ self value = aString ]) ifFalse: [ ^ self ].
	self onFocus: 'if(value==' , aString printString , '){value='''';style.color=null}'.
	self style: 'color: #aaa'; value: aString! !

!WAAbstractTextAreaTag methodsFor: 'javascript' stamp: 'lr 10/28/2007 14:42'!
setCursorPosition: anInteger
	self setSelectionFrom: anInteger to: anInteger! !

!WAAbstractTextAreaTag methodsFor: 'javascript' stamp: 'lr 4/9/2008 10:49'!
setSelectionFrom: aStartInteger to: aStopInteger
	"Insert the javascript for setting the selection"
	| aStream |
	self ensureId.
	aStream := (String new: 30) writeStream.
	aStream
		nextPutAll: 'setSelection(''';
		nextPutAll: self id;
		nextPutAll: ''''.
	aStartInteger isNumber
		ifTrue: [aStream nextPut: $,; print: aStartInteger]
		ifFalse: [aStream nextPutAll: ',1'].
	aStopInteger isNumber
		ifTrue: [aStream nextPut: $,; print: aStopInteger ].
	aStream nextPut: $).
	self requestContext addLoadScript: aStream contents! !

WAAbstractTextAreaTag subclass: #WATextAreaTag
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WATextAreaTag commentStamp: 'pmm 4/24/2007 11:13' prior: 0!
I am a multi line text input widget. See WAInputTest >> #renderTextAreaWithExampleOn: for examples.!

!WATextAreaTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
columns: anInteger 
	"This attribute specifies the visible width in average character widths. User agents may wrap visible text lines to keep long lines visible without the need for scrolling."
	self attributes 
		at: 'cols'
		put: anInteger! !

!WATextAreaTag methodsFor: 'initialize-release' stamp: 'lr 2/16/2008 18:42'!
initialize
	super initialize.
	self rows: 'auto'; columns: 'auto'! !

!WATextAreaTag methodsFor: 'testing' stamp: 'lr 3/26/2007 21:12'!
isClosed
	^ false! !

!WATextAreaTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
rows: anInteger 
	"This attribute specifies the number of visible text lines. If more are entered, the widget scrolls."
	self attributes 
		at: 'rows'
		put: anInteger! !

!WATextAreaTag methodsFor: 'accessing' stamp: 'ac 4/13/2005 01:51'!
tag
	^ 'textarea'! !

!WATextAreaTag methodsFor: 'accessing' stamp: 'lr 9/4/2007 15:53'!
value
	^ value! !

!WATextAreaTag methodsFor: 'accessing' stamp: 'ac 8/30/2005 16:26'!
value: aString
	value := aString! !

!WATextAreaTag methodsFor: 'public' stamp: 'lr 9/4/2007 15:57'!
with: aBlock
	super with: (value ifNil: [ aBlock ])! !

WAAbstractTextAreaTag subclass: #WATextInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WATextInputTag commentStamp: 'pmm 4/24/2007 11:13' prior: 0!
I am a single line text input widget. See WAInputTest >> #renderTextInputWithExampleOn: for examples.!

WATextInputTag subclass: #WAPasswordInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAPasswordInputTag commentStamp: 'pmm 4/23/2007 21:12' prior: 0!
I am a password input widget that does not display the entered text.!

!WAPasswordInputTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 17:33'!
type
	^ 'password'! !

!WATextInputTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
maxLength: aNumber 
	"This attribute specifies the maximum number of characters the user may enter. This number may exceed the specified #size:, in which case the user agent should offer a scrolling mechanism. The default value for this attribute is an unlimited number."
	self attributes 
		at: 'maxlength'
		put: aNumber! !

!WATextInputTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
size: aNumber 
	"This attribute tells the user agent the initial width of the widget. The width is given in number of characters."
	self attributes 
		at: 'size'
		put: aNumber! !

!WATextInputTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:50'!
type
	^ 'text'! !

!WATextInputTag methodsFor: 'public' stamp: 'lr 8/30/2008 16:22'!
with: anObject 
	anObject isNil ifFalse: [ self value: anObject seasideString ].
	super with: nil! !

WAFormInputTag subclass: #WAButtonTag
	instanceVariableNames: 'type value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAButtonTag commentStamp: 'pmm 7/28/2007 08:54' prior: 0!
Buttons created with the BUTTON element function just like buttons created with the INPUT element, but they offer richer rendering possibilities: the BUTTON element may have content. For example, a BUTTON element that contains an image functions like and may resemble an INPUT element whose type is set to "image", but the BUTTON element type allows content.!

!WAButtonTag methodsFor: 'accessing' stamp: 'pmm 7/28/2007 08:40'!
bePush
	"Creates a push button. Push buttons have no default behavior. Each push button may have client-side scripts associated with the element's event attributes. When an event occurs (e.g., the user presses the button, releases it, etc.), the associated script is triggered."
	type := 'button'! !

!WAButtonTag methodsFor: 'accessing' stamp: 'pmm 7/28/2007 08:34'!
beReset
	"Creates a reset button. When activated it resets all controls to their initial values."
	type := 'reset'! !

!WAButtonTag methodsFor: 'accessing' stamp: 'pmm 7/28/2007 08:33'!
beSubmit
	"Creates a submit button. When activated, a submit button submits a form. A form may contain more than one submit button. This is the default."
	type := 'submit'! !

!WAButtonTag methodsFor: 'callbacks' stamp: 'lr 4/11/2008 08:46'!
callback: aBlock
	self name: (canvas callbacks registerActionCallback: aBlock)! !

!WAButtonTag methodsFor: 'testing' stamp: 'lr 4/11/2008 08:48'!
canHaveShortcut
	^ true! !

!WAButtonTag methodsFor: 'initialize-release' stamp: 'pmm 7/28/2007 08:34'!
initialize
	super initialize.
	self beSubmit! !

!WAButtonTag methodsFor: 'testing' stamp: 'lr 6/13/2007 21:13'!
isClosed
	^ false! !

!WAButtonTag methodsFor: 'callbacks' stamp: 'lr 4/11/2008 08:46'!
on: aSymbol of: anObject
	self value: (self labelForSelector: aSymbol of: anObject).
	self callback: (MessageSend receiver: anObject selector: aSymbol)! !

!WAButtonTag methodsFor: 'accessing' stamp: 'lr 6/13/2007 21:13'!
tag
	^ 'button'! !

!WAButtonTag methodsFor: 'accessing' stamp: 'lr 8/8/2007 14:48'!
type
	^ type! !

!WAButtonTag methodsFor: 'accessing' stamp: 'lr 9/18/2007 08:18'!
value
	^ value! !

!WAButtonTag methodsFor: 'accessing' stamp: 'lr 9/18/2007 08:19'!
value: aString
	value := aString! !

!WAButtonTag methodsFor: 'public' stamp: 'lr 9/18/2007 08:19'!
with: aBlock
	super with: (value ifNil: [ aBlock ])! !

WAFormInputTag subclass: #WACheckboxTag
	instanceVariableNames: 'value callback'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WACheckboxTag commentStamp: 'pmm 6/29/2008 17:06' prior: 0!
The checkbox element is used with an associated property of typ boolean. It renders a HTML <input> element of type checkbox.

If this input element is disabled then the callback will still be evaluted but with an argument that is false. See method comment of #callback: for more information.

!

!WACheckboxTag methodsFor: 'private' stamp: 'jf 7/20/2008 09:53'!
after
	callback ifNotNil: [
		canvas hiddenInput callback: [
			callback value: value.
			value := false ] ]! !

!WACheckboxTag methodsFor: 'callbacks' stamp: 'pmm 6/2/2008 08:26'!
callback: aBlock
	"Compared to other form elements this input element is disabled then the callback will still be evaluted but with an argument that is false. So either don't assign a callback to disabled checkboxes or make the callback code aware that he might be invoked in a disabled state.
	
	However if you enable a disabled checkbox with JavaScript then the callback is invoked with the correct argument.
	
	http://code.google.com/p/seaside/issues/detail?id=18"
	value := false.
	callback := aBlock fixCallbackTemps.
	super callback: [value := true]! !

!WACheckboxTag methodsFor: 'testing' stamp: 'lr 4/11/2008 08:48'!
canHaveShortcut
	^ true! !

!WACheckboxTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
onTrue: trueBlock onFalse: falseBlock
	trueBlock fixCallbackTemps. falseBlock fixCallbackTemps.
	self callback: [ :v | v ifTrue: [ trueBlock value ] ifFalse: [ falseBlock value ] ]! !

!WACheckboxTag methodsFor: 'convenience' stamp: 'lr 8/30/2008 16:22'!
submitFormNamed: formName 
	self onClick: 'submitForm(''' , formName seasideString , '''); return false;'! !

!WACheckboxTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:44'!
type
	^ 'checkbox'! !

!WACheckboxTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
value: aBoolean 
	self attributes 
		at: 'checked'
		put: aBoolean! !

WAFormInputTag subclass: #WAFileUploadTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAFileUploadTag commentStamp: 'pmm 4/15/2007 22:22' prior: 0!
I represent a file input element (<input type="file"). My callbacks will be evaluated with an instance of WAFile as an argument.!

!WAFileUploadTag methodsFor: 'attributes' stamp: 'pmm 5/2/2007 21:50'!
accept: aString
	"This attribute specifies a comma-separated list of content types that a server processing this form will handle correctly. User agents may use this information to filter out non-conforming files when prompting a user to select files to be sent to the server"
	self attributes at: 'accept' put: aString! !

!WAFileUploadTag methodsFor: 'callbacks' stamp: 'lr 10/28/2007 14:42'!
callback: aBlock
	aBlock fixCallbackTemps.
	super callback: [ :file | aBlock value: (file = '' ifFalse: [ file ]) ]! !

!WAFileUploadTag methodsFor: 'callbacks' stamp: 'lr 3/29/2008 16:41'!
on: aSelector of: anObject
	self callback: (MessageSend receiver: anObject selector: aSelector asMutator)! !

!WAFileUploadTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:45'!
type
	^ 'file'! !

!WAFormInputTag methodsFor: 'callbacks' stamp: 'lr 1/4/2007 09:35'!
callback: aBlock
	self name: (canvas callbacks registerCallback: aBlock)! !

!WAFormInputTag methodsFor: 'testing' stamp: 'lr 3/26/2007 21:12'!
isClosed
	^ true! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'lr 1/4/2007 09:34'!
name: aString
	self attributes at: 'name' put: aString! !

!WAFormInputTag methodsFor: 'callbacks' stamp: 'lr 3/29/2008 16:41'!
on: aSelector of: anObject
	self value: (anObject perform: aSelector).
	self callback: (MessageSend receiver: anObject selector: aSelector asMutator)! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'pmm 4/23/2007 21:24'!
readonly: aBoolean
	"When set to true, this boolean attribute prohibits changes to the widget."
	self attributes at: 'readonly' put: aBoolean! !

!WAFormInputTag methodsFor: 'javascript' stamp: 'lr 4/9/2008 10:51'!
setFocus
	"Makes this element have the initial focus once the page is loaded aka autofocus."
	self ensureId.
	self requestContext addLoadScript: 'setFocus(' , self id printString , ')'! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'lr 1/4/2007 09:34'!
submitOnClick
	self onClick: 'submit()'! !

!WAFormInputTag methodsFor: 'accessing' stamp: 'ac 3/16/2005 12:08'!
tag
	^ 'input'! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'lr 1/4/2007 09:37'!
text: aString
	self value: aString! !

!WAFormInputTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:43'!
type
	^ nil! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'lr 1/4/2007 09:34'!
type: aString
	self attributes at: 'type' put: aString! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'lr 1/4/2007 09:34'!
value
	^ self attributes at: 'value'! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'lr 1/4/2007 09:34'!
value: anObject
	anObject ifNotNil: [ self attributes at: 'value' put: anObject ]! !

!WAFormInputTag methodsFor: 'public' stamp: 'lr 11/16/2006 15:31'!
with: aBlock
	self type isNil ifFalse: [
		self attributes at: 'type' ifAbsentPut: [ self type ].
		self class: self type ].
	super with: aBlock! !

WAFormInputTag subclass: #WAHiddenInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAHiddenInputTag commentStamp: 'pmm 9/22/2007 22:23' prior: 0!
Authors may create controls that are not rendered but whose values are submitted with a form. Authors generally use this control type to store information between client/server exchanges that would otherwise be lost due to the stateless nature of HTTP (see [RFC2616]). The INPUT element is used to create a hidden control.!

!WAHiddenInputTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 17:45'!
type
	^ 'hidden'! !

WAFormInputTag subclass: #WARadioButtonTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WARadioButtonTag commentStamp: 'pmm 6/1/2008 00:45' prior: 0!
Radio buttons works like checkboxes. The difference is that radio buttons, when sharing a single control name, are exclusive. This means that only one of those radio buttons can be checked, and when it's checked, the rest are automatically unchecked.

Radio buttons must be created through a radio group.

Example:
| group |
group := html radioGroup.
group radioButton
	selected: aBoolean;
	callback: [ self someThing ].!

!WARadioButtonTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
beChecked
	self attributes 
		at: 'checked'
		put: true! !

!WARadioButtonTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
beUnchecked
	self attributes 
		at: 'checked'
		put: false! !

!WARadioButtonTag methodsFor: 'callbacks' stamp: 'pmm 1/8/2007 12:14'!
callback: aBlock
	self value: (canvas callbacks registerCallback: aBlock)! !

!WARadioButtonTag methodsFor: 'testing' stamp: 'lr 4/11/2008 08:48'!
canHaveShortcut
	^ true! !

!WARadioButtonTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
group: aRadioGroup
	self name: aRadioGroup key! !

!WARadioButtonTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
selected: aBoolean 
	self attributes 
		at: 'checked'
		put: aBoolean! !

!WARadioButtonTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:46'!
type
	^ 'radio'! !

WAFormInputTag subclass: #WASubmitButtonTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WASubmitButtonTag commentStamp: 'obi 4/2/2008 22:58' prior: 0!
The submit type creates a button. When a submit button is pressed it automatically submits the form.!

WASubmitButtonTag subclass: #WACancelButtonTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WACancelButtonTag methodsFor: 'callbacks' stamp: 'lr 1/4/2007 09:33'!
callback: aBlock
	self name: (canvas callbacks registerCancelActionCallback: aBlock)! !

WASubmitButtonTag subclass: #WAImageButtonTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAImageButtonTag commentStamp: 'pmm 7/28/2007 08:56' prior: 0!
Creates a graphical submit button. The value of the src attribute specifies the URI of the image that will decorate the button. For accessibility reasons, authors should provide alternate text for the image via the alt attribute. 

When a pointing device is used to click on the image, the form is submitted and the click coordinates passed to the server. The x value is measured in pixels from the left of the image, and the y value in pixels from the top of the image. The submitted data includes name.x=x-value and name.y=y-value where "name" is the value of the name attribute, and x-value and y-value are the x and y coordinate values, respectively.!

!WAImageButtonTag methodsFor: 'callbacks' stamp: 'lr 1/4/2007 09:33'!
callback: aBlock
	self name: (canvas callbacks registerImageCallback: aBlock)! !

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 1/4/2007 09:33'!
extent: aPoint
	self width: aPoint x; height: aPoint y! !

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 1/4/2007 09:33'!
form: aForm
	self extent: aForm extent.
	self url: (canvas context urlForDocument: aForm)! !

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 8/3/2006 08:43'!
height: aNumber
	self attributes at: 'height' put: aNumber! !

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 4/10/2007 09:55'!
resourceUrl: aString
	self url: (canvas context absoluteUrlForResource: aString)! !

!WAImageButtonTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:49'!
type
	^ 'image'! !

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 1/4/2007 09:33'!
url: aString
	self attributes at: 'src' put: aString! !

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 8/3/2006 08:43'!
width: aNumber
	self attributes at: 'width' put: aNumber! !

!WASubmitButtonTag methodsFor: 'callbacks' stamp: 'lr 1/4/2007 09:32'!
callback: aBlock
	self name: (canvas callbacks registerActionCallback: aBlock)! !

!WASubmitButtonTag methodsFor: 'testing' stamp: 'lr 4/11/2008 08:48'!
canHaveShortcut
	^ true! !

!WASubmitButtonTag methodsFor: 'callbacks' stamp: 'lr 3/29/2008 16:41'!
on: aSymbol of: anObject
	self value: (self labelForSelector: aSymbol of: anObject).
	self callback: (MessageSend receiver: anObject selector: aSymbol)! !

!WASubmitButtonTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:49'!
type
	^ 'submit'! !

!WASubmitButtonTag methodsFor: 'public' stamp: 'lr 8/30/2008 16:22'!
with: anObject 
	anObject isNil ifFalse: [ self value: anObject seasideString ].
	super with: nil! !

WATagBrush subclass: #WAGenericTag
	instanceVariableNames: 'tag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas'!

!WAGenericTag commentStamp: 'pmm 6/1/2008 00:40' prior: 0!
A WAGenericTag is the class for all tags that do not have a class of their own.

Instance Variables
	tag:		<String>

tag
	- the name of the tag
!

WAGenericTag subclass: #WAEditTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAEditTag commentStamp: 'pmm 3/28/2007 10:40' prior: 0!
INS and DEL are used to markup sections of the document that have been inserted or deleted with respect to a different version of a document (e.g., in draft legislation where lawmakers need to view the changes).

These two elements are unusual for HTML in that they may serve as either block-level or inline elements (but not both). They may contain one or more words within a paragraph or contain one or more block-level elements such as paragraphs, lists and tables.

This example could be from a bill to change the legislation for how many deputies a County Sheriff can employ from 3 to 5.

<P>
  A Sheriff can employ <DEL>3</DEL><INS>5</INS> deputies.
</P>

The INS and DEL elements must not contain block-level content when these elements behave as inline elements.!

!WAEditTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
cite: aUrl 
	"The value of this attribute is a URI that designates a source document or message. This attribute is intended to point to information explaining why a document was changed."
	self attributes 
		at: 'cite'
		put: aUrl! !

!WAEditTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
datetime: anObject 
	"The value of this attribute specifies the date and time when the change was made.
	ISO date format"
	self attributes 
		at: 'datetime'
		put: anObject! !

!WAGenericTag class methodsFor: 'instance-creation' stamp: 'pmm 1/26/2007 23:05'!
tag: aString
	^ self new initializeWithTag: aString! !

!WAGenericTag methodsFor: 'initialize-release' stamp: 'avi 6/13/2004 00:40'!
initializeWithTag: aString
	tag := aString! !

!WAGenericTag methodsFor: 'accessing' stamp: 'avi 6/13/2004 00:40'!
tag
	^ tag! !

WATagBrush subclass: #WAHeadingTag
	instanceVariableNames: 'level'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAHeadingTag commentStamp: 'pmm 6/30/2007 00:44' prior: 0!
A heading element briefly describes the topic of the section it introduces. Heading information may be used by user agents, for example, to construct a table of contents for a document automatically.

There are six levels of headings in HTML with H1 as the most important and H6 as the least. Visual browsers usually render more important headings in larger fonts than less important ones.!

!WAHeadingTag methodsFor: 'initialization' stamp: 'lr 6/6/2007 14:02'!
initialize
	super initialize.
	self level1! !

!WAHeadingTag methodsFor: 'accessing' stamp: 'lr 4/9/2007 18:26'!
level
	^ level! !

!WAHeadingTag methodsFor: 'conveniance' stamp: 'lr 6/6/2007 14:02'!
level1
	level := 1! !

!WAHeadingTag methodsFor: 'conveniance' stamp: 'lr 6/6/2007 14:02'!
level2
	level := 2! !

!WAHeadingTag methodsFor: 'conveniance' stamp: 'lr 6/6/2007 14:02'!
level3
	level := 3! !

!WAHeadingTag methodsFor: 'conveniance' stamp: 'lr 6/6/2007 14:02'!
level4
	level := 4! !

!WAHeadingTag methodsFor: 'conveniance' stamp: 'lr 6/6/2007 14:02'!
level5
	level := 5! !

!WAHeadingTag methodsFor: 'conveniance' stamp: 'lr 6/6/2007 14:02'!
level6
	level := 6! !

!WAHeadingTag methodsFor: 'accessing' stamp: 'lr 6/6/2007 14:01'!
level: anInteger
	level := (anInteger max: 1) min: 6! !

!WAHeadingTag methodsFor: 'accessing' stamp: 'lr 8/30/2008 16:22'!
tag
	^ 'h' , self level seasideString! !

WATagBrush subclass: #WAHorizontalRuleTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAHorizontalRuleTag commentStamp: 'pmm 9/22/2007 22:24' prior: 0!
The HR element causes a horizontal rule to be rendered by visual user agents.

The amount of vertical space inserted between a rule and the content that surrounds it depends on the user agent.!

!WAHorizontalRuleTag methodsFor: 'testing' stamp: 'lr 3/26/2007 21:10'!
isClosed
	^ true! !

!WAHorizontalRuleTag methodsFor: 'accessing' stamp: 'lr 3/26/2007 21:08'!
tag
	^ 'hr'! !

WATagBrush subclass: #WAIframeTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAIframeTag commentStamp: 'pmm 9/22/2007 22:25' prior: 0!
The IFRAME element allows authors to insert a frame within a block of text. Inserting an inline frame within a section of text is much like inserting an object via the OBJECT element: they both allow you to insert an HTML document in the middle of another, they may both be aligned with surrounding text, etc. 

The information to be inserted inline is designated by the src attribute of this element. The contents of the IFRAME element, on the other hand, should only be displayed by user agents that do not support frames or are configured not to display frames.

Inline frames may not be resized.!

!WAIframeTag methodsFor: 'convenience' stamp: 'pmm 5/23/2007 19:05'!
contents: anObject
	self url: (canvas urlForAction: [ self performRendering: anObject ])! !

!WAIframeTag methodsFor: 'convenience' stamp: 'lr 8/9/2006 08:34'!
document: anObject
	self document: anObject mimeType: nil! !

!WAIframeTag methodsFor: 'convenience' stamp: 'lr 8/9/2006 08:31'!
document: anObject mimeType: aMimeString
	self document: anObject mimeType: aMimeString fileName: nil! !

!WAIframeTag methodsFor: 'convenience' stamp: 'lr 10/28/2007 14:42'!
document: anObject mimeType: aMimeString fileName: aFileNameString
	self url: (canvas context
		urlForDocument: anObject
		mimeType: aMimeString
		fileName: aFileNameString)! !

!WAIframeTag methodsFor: 'attributes' stamp: 'pmm 9/22/2007 22:26'!
height: anInteger
	"The height of the inline frame."
	self attributes at: 'height' put: anInteger! !

!WAIframeTag methodsFor: 'attributes' stamp: 'pmm 9/22/2007 22:26'!
name: aString
	"This attribute assigns a name to the current frame. This name may be used as the target of subsequent links."
	self attributes at: 'name' put: aString! !

!WAIframeTag methodsFor: 'private' stamp: 'jf 7/16/2008 10:08'!
performRendering: anObject
	| innerContext docRoot document response renderer |
	innerContext := canvas context copy.
	docRoot := WAHtmlRoot context: innerContext.
	docRoot base target: '_top'.
	response := WAResponse new.
	response doNotCache.
	document := self requestContext application newDocumentOn: response stream.
	canvas context document: document.
	docRoot open: document.
	renderer := canvas species context: canvas context callbacks: canvas callbacks.
	renderer render: anObject;
		 flush.
	docRoot close: document.
	self requestContext returnResponse: response! !

!WAIframeTag methodsFor: 'accessing' stamp: 'lr 3/8/2006 23:25'!
tag
	^ 'iframe'! !

!WAIframeTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
url: aString 
	self attributes 
		at: 'src'
		put: aString! !

!WAIframeTag methodsFor: 'attributes' stamp: 'pmm 9/22/2007 22:26'!
width: anInteger
	"The width of the inline frame."
	self attributes at: 'width' put: anInteger! !

WATagBrush subclass: #WAImageTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAImageTag commentStamp: 'pmm 9/22/2007 22:28' prior: 0!
The IMG element embeds an image in the current document at the location of the element's definition. The IMG element has no content; it is usually replaced inline by the image designated by the src attribute, the exception being for left or right-aligned images that are "floated" out of line.

The alt attribute specifies alternate text that is rendered when the image cannot be displayed (see below for information on how to specify alternate text ). User agents must render alternate text when they cannot support images, they cannot support a certain image type or when they are configured not to display images.

Seaside per default sets the alternate text to an empty string. This helps validation of the page.!

!WAImageTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
altText: aString
	"The alt attribute provides a short description of the image."
	self attributes at: 'alt' put: aString! !

!WAImageTag methodsFor: 'accessing' stamp: 'lr 6/20/2007 10:52'!
document: aDocument
	self document: aDocument mimeType: nil! !

!WAImageTag methodsFor: 'accessing' stamp: 'lr 6/20/2007 10:52'!
document: aDocument mimeType: mimeType
	self document: aDocument mimeType: mimeType fileName: nil! !

!WAImageTag methodsFor: 'accessing' stamp: 'lr 6/20/2007 10:52'!
document: aDocument mimeType: mimeType fileName: fileName
	self url: (canvas context urlForDocument: aDocument mimeType: mimeType fileName: fileName)! !

!WAImageTag methodsFor: 'accessing' stamp: 'lr 3/20/2007 14:26'!
form: aForm
	self document: aForm! !

!WAImageTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
height: anInteger
	self attributes at: 'height' put: anInteger! !

!WAImageTag methodsFor: 'initialize-release' stamp: 'lr 6/20/2007 10:53'!
initialize
	super initialize.
	self altText: ''! !

!WAImageTag methodsFor: 'testing' stamp: 'lr 3/27/2007 11:06'!
isClosed
	^ true! !

!WAImageTag methodsFor: 'accessing' stamp: 'lr 4/10/2007 09:56'!
resourceUrl: aString
	self url: (canvas context absoluteUrlForResource: aString)! !

!WAImageTag methodsFor: 'initialize-release' stamp: 'lr 3/24/2008 13:01'!
setParent: aBrush canvas: aCanvas 
	super 
		setParent: aBrush
		canvas: aCanvas.
	(aBrush isKindOf: WAImageMapTag) ifTrue: [ 
		"in case the parent is an image map we need to set this attribute"
		self attributes 
			at: 'ismap'
			put: true ]! !

!WAImageTag methodsFor: 'deprecated' stamp: 'lr 10/28/2007 14:42'!
src: aString
	self deprecatedApi.
	self url: aString! !

!WAImageTag methodsFor: 'accessing' stamp: 'ac 3/16/2005 12:00'!
tag
	^ 'img'! !

!WAImageTag methodsFor: 'attributes' stamp: 'lr 6/20/2007 10:53'!
url: aString
	self attributes at: 'src' put: aString! !

!WAImageTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
width: anInteger
	self attributes at: 'width' put: anInteger! !

WATagBrush subclass: #WALabelTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WALabelTag commentStamp: 'obi 4/2/2008 22:38' prior: 0!
Defines a label to a control. If you click the text within the label element,  it is supposed to toggle the control.!

!WALabelTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
for: aString 
	self attributes 
		at: 'for'
		put: aString! !

!WALabelTag methodsFor: 'accessing' stamp: 'ac 7/9/2005 04:36'!
tag
	^ 'label'! !

WATagBrush subclass: #WAObjectTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAObjectTag commentStamp: 'obi 4/2/2008 22:46' prior: 0!
Defines an embedded object. Use this element to add multimedia to your XHTML page.
This element allows you to specify the data and parameters for objects inserted into HTML documents, and the code that can be used to display/manipulate that data.!

!WAObjectTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
archive: aUrl 
	self attributes 
		at: 'archive'
		put: aUrl! !

!WAObjectTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
classId: aUrl 
	self attributes 
		at: 'classid'
		put: aUrl! !

!WAObjectTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
codebase: aUrl 
	self attributes 
		at: 'codebase'
		put: aUrl! !

!WAObjectTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
codetype: aString 
	self attributes 
		at: 'codetype'
		put: aString! !

!WAObjectTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
declare: aBoolean 
	self attributes 
		at: 'declare'
		put: aBoolean! !

!WAObjectTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
height: anInteger 
	self attributes 
		at: 'height'
		put: anInteger! !

!WAObjectTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
standby: aString 
	self attributes 
		at: 'standby'
		put: aString! !

!WAObjectTag methodsFor: 'accessing' stamp: 'pmm 2/11/2007 19:24'!
tag
	^ 'object'! !

!WAObjectTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
type: aString 
	self attributes 
		at: 'type'
		put: aString! !

!WAObjectTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
url: aUrl 
	self attributes 
		at: 'data'
		put: aUrl! !

!WAObjectTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
width: anInteger 
	self attributes 
		at: 'width'
		put: anInteger! !

WATagBrush subclass: #WAOptionGroupTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAOptionGroupTag commentStamp: 'pmm 4/24/2007 10:53' prior: 0!
The OPTGROUP element allows authors to group choices logically. This is particularly helpful when the user must choose from a long list of options; groups of related choices are easier to grasp and remember than a single long list of options.

It has crappy browser support and noone as ever used it. See WAInputTest >> #renderOptionGroupOn: for examples.!

!WAOptionGroupTag methodsFor: 'initialize-release' stamp: 'lr 2/16/2008 18:14'!
initialize
	super initialize.
	self label: ''! !

!WAOptionGroupTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
label: aString
	"This attribute specifies the label for the option group."

	self attributes at: 'label' put: aString! !

!WAOptionGroupTag methodsFor: 'accessing' stamp: 'pmm 4/24/2007 10:49'!
tag
	^ 'optgroup'! !

WATagBrush subclass: #WAOptionTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAOptionTag commentStamp: 'obi 4/2/2008 22:45' prior: 0!
The option element defines an option in a drop-down list. !

!WAOptionTag methodsFor: 'callbacks' stamp: 'lr 6/6/2007 19:42'!
callback: aBlock
	self value: (canvas callbacks registerCallback: aBlock)! !

!WAOptionTag methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
label: aString
	"This attribute allows authors to specify a shorter label for an option than the content of the OPTION element. When specified, user agents should use the value of this attribute rather than the content of the OPTION element as the option label."

	self attributes at: 'label' put: aString! !

!WAOptionTag methodsFor: 'attributes' stamp: 'lr 6/6/2007 19:42'!
selected: aBoolean
	self attributes at: 'selected' put: aBoolean! !

!WAOptionTag methodsFor: 'accessing' stamp: 'ac 3/17/2005 17:13'!
tag
	^ 'option'! !

!WAOptionTag methodsFor: 'attributes' stamp: 'lr 6/6/2007 19:42'!
value: aString
	self attributes at: 'value' put: aString! !

WATagBrush subclass: #WAParameterTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAParameterTag commentStamp: 'obi 4/2/2008 22:45' prior: 0!
The param element allows you to specify the run-time settings for an object inserted into XHTML documents.!

!WAParameterTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
name: aString 
	self attributes 
		at: 'name'
		put: aString! !

!WAParameterTag methodsFor: 'accessing' stamp: 'pmm 2/11/2007 20:12'!
tag
	^ 'param'! !

!WAParameterTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
type: aString 
	self attributes 
		at: 'type'
		put: aString! !

!WAParameterTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
value: aString 
	self attributes 
		at: 'value'
		put: aString! !

WATagBrush subclass: #WARubyTextTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WARubyTextTag commentStamp: 'obi 4/2/2008 22:50' prior: 0!
This element works with the <ruby> element. 
The text following <rt> appears as a note to the base text displayed by the 
<ruby> element.!

!WARubyTextTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
span: anInteger 
	self attributes 
		at: 'rbspan'
		put: anInteger! !

!WARubyTextTag methodsFor: 'accessing' stamp: 'pmm 9/18/2006 19:00'!
tag
	^ 'rt'! !

WATagBrush subclass: #WAScriptTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WAScriptTag commentStamp: 'obi 4/2/2008 22:51' prior: 0!
Defines a script, such as a JavaScript.!

!WAScriptTag methodsFor: 'private' stamp: 'lr 3/27/2007 11:57'!
after
	self document nextPutAll: '/*]]>*/'! !

!WAScriptTag methodsFor: 'private' stamp: 'lr 3/27/2007 11:56'!
before
	self document nextPutAll: '/*<!![CDATA[*/'! !

!WAScriptTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:01'!
defer
	"When set, this boolean attribute provides a hint to the user agent that the script is not going to generate any document content (e.g., no 'document.write' in javascript) and thus, the user agent can continue parsing and rendering."
	self attributes 
		at: 'defer'
		put: true! !

!WAScriptTag methodsFor: 'attributes' stamp: 'lr 4/10/2007 09:55'!
resourceUrl: aString
	self url: (canvas context absoluteUrlForResource: aString)! !

!WAScriptTag methodsFor: 'accessing' stamp: 'dwj 6/10/2005 13:10'!
tag
	^ 'script'! !

!WAScriptTag methodsFor: 'attributes' stamp: 'pmm 8/26/2006 00:05'!
url: aString
	self attributes at: 'src' put: aString! !

!WAScriptTag methodsFor: 'public' stamp: 'lr 8/30/2008 16:22'!
with: aString 
	self attributes 
		at: 'type'
		ifAbsentPut: [ 'text/javascript' ].
	super with: 
		[ aString isNil ifFalse: [ self document nextPutAll: aString seasideString ] ]! !

WATagBrush subclass: #WATableCellTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WATableCellTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:44'!
align: aString
	"This attribute specifies the alignment of data and the justification of text in a cell. Possible values:
	
- left: Left-flush data/Left-justify text. This is the default value for table data.
- center: Center data/Center-justify text. This is the default value for table headers.
- right: Right-flush data/Right-justify text.
- justify: Double-justify text.
- char: Align text around a specific character. If a user agent doesn't support character alignment, behavior in - the presence of this value is unspecified."

	self attributes at: 'align' put: aString! !

!WATableCellTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:45'!
character: aString
	"This attribute specifies a single character within a text fragment to act as an axis for alignment. The default value for this attribute is the decimal point character for the current language as set by the lang attribute. User agents are not required to support this attribute."
	
	self attributes at: 'char' put: aString! !

!WATableCellTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:45'!
characterOffset: anInteger
	"When present, this attribute specifies the offset to the first occurrence of the alignment character on each line. If a line doesn't include the alignment character, it should be horizontally shifted to end at the alignment position."

	self attributes at: 'charoff' put: anInteger! !

!WATableCellTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:44'!
verticalAlign: aString
	"This attribute specifies the vertical position of data within a cell. Possible values:

- top: Cell data is flush with the top of the cell.
- middle: Cell data is centered vertically within the cell. This is the default value.
- bottom: Cell data is flush with the bottom of the cell.
- baseline: All cells in the same row as a cell whose valign attribute has this value should have their textual data positioned so that the first text line occurs on a baseline common to all cells in the row. This constraint does not apply to subsequent text lines in these cells."
		
	self attributes at: 'valign' put: aString! !

WATableCellTag subclass: #WATableColumnGroupTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WATableColumnGroupTag commentStamp: 'lr 3/24/2008 13:19' prior: 0!
WATableColumnGroupTag groups a set of col elements. It allows you to group several semantically related columns together.!

!WATableColumnGroupTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:37'!
span: anInteger
	"This attribute must be an integer > 0; the default value is 1. This specifies the number of columns in a colgroup, or specifies the number of columns spanned by the col element."
	
	self attributes at: 'span' put: anInteger! !

!WATableColumnGroupTag methodsFor: 'accessing' stamp: 'mb 12/8/2006 15:51'!
tag
	^ 'colgroup'! !

!WATableColumnGroupTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:38'!
width: anInteger
	"The width attribute specifies the width of the columns"
	
	self attributes at: 'width' put: anInteger! !

WATableColumnGroupTag subclass: #WATableColumnTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WATableColumnTag commentStamp: 'lr 3/24/2008 13:48' prior: 0!
WATableColumnTag elements define the alignment properties for cells in one or more columns.!

!WATableColumnTag methodsFor: 'testing' stamp: 'lr 3/27/2007 11:06'!
isClosed
	^ true! !

!WATableColumnTag methodsFor: 'accessing' stamp: 'mb 12/8/2006 15:51'!
tag
	^ 'col'! !

WATableCellTag subclass: #WATableDataTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WATableDataTag commentStamp: 'obi 4/2/2008 22:41' prior: 0!
The WATableDataTag defines a cell in a table.

!

!WATableDataTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 17:01'!
abbreviation: aString
	"This attribute should be used to provide an abbreviated form of the cell's content, and may be rendered by user agents when appropriate in place of the cell's content. Abbreviated names should be short since user agents may render them repeatedly. For instance, speech synthesizers may render the abbreviated headers relating to a particular cell before rendering that cell's content."
	
	self attributes at: 'abbr' put: aString! !

!WATableDataTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 17:01'!
axis: aString
	"This attribute may be used to place a cell into conceptual categories that can be considered to form axes in an n-dimensional space. User agents may give users access to these categories (e.g., the user may query the user agent for all cells that belong to certain categories, the user agent may present a table in the form of a table of contents, etc.). Please consult the section on categorizing cells for more information. The value of this attribute is a comma-separated list of category names."
	
	self attributes at: 'axis' put: aString! !

!WATableDataTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:35'!
colSpan: anInteger
	"This attribute specifies the number of columns spanned by the current cell. The default value of this attribute is one. The value zero means that the cell spans all columns from the current column to the last column of the column group (colgroup) in which the cell is defined."
	
	self attributes at: 'colspan' put: anInteger! !

!WATableDataTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:36'!
headers: aString
	"This attribute specifies the list of header cells that provide header information for the current data cell. The value of this attribute is a space-separated list of cell names; those cells must be named by setting their id attribute. Authors generally use the headers attribute to help non-visual user agents render header information about data cells (e.g., header information is spoken prior to the cell data), but the attribute may also be used in conjunction with style sheets. See also the scope attribute."
	
	self attributes at: 'headers' put: aString! !

!WATableDataTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:35'!
rowSpan: anInteger
	"This attribute specifies the number of rows spanned by the current cell. The default value of this attribute is one. The value zero means that the cell spans all rows from the current row to the last row of the current table section (rowgroup) in which the cell is defined. thead, tbody, and tfoot elements are rowgroups."
	
	self attributes at: 'rowspan' put: anInteger! !

!WATableDataTag methodsFor: 'attributes' stamp: 'lr 3/24/2008 13:35'!
scope: aString
	"This attribute specifies the set of data cells for which the current header cell provides header information. This attribute may be used in place of the headers attribute, particularly for simple tables. When specified, this attribute must have one of the following values:

- row: The current cell provides header information for the rest of the row that contains it (see also the section on table directionality).
- col: The current cell provides header information for the rest of the column that contains it.
- rowgroup: The header cell provides header information for the rest of the row group that contains it.
- colgroup: The header cell provides header information for the rest of the column group that contains it."

	self attributes at: 'scope' put: aString! !

!WATableDataTag methodsFor: 'accessing' stamp: 'ac 3/17/2005 22:09'!
tag
	^ 'td'! !

WATableDataTag subclass: #WATableHeadingTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WATableHeadingTag commentStamp: 'obi 4/2/2008 22:42' prior: 0!
The WATableHeadingTag defines a table header cell in a table. The text within the th element usually renders in bold.!

!WATableHeadingTag methodsFor: 'accessing' stamp: 'ac 3/17/2005 22:10'!
tag
	^ 'th'! !

WATagBrush subclass: #WATableTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas-Tags'!

!WATableTag commentStamp: 'obi 4/2/2008 22:42' prior: 0!
The <table> tag defines a table. Inside a <table> tag you can put table headers, table rows, table cells, and other tables.!

!WATableTag methodsFor: 'deprecated' stamp: 'lr 10/28/2007 14:42'!
align: aString
	self deprecatedApi.
	self attributes at: 'align' put: aString! !

!WATableTag methodsFor: 'deprecated' stamp: 'lr 11/16/2006 15:33'!
border: anInteger
	self deprecatedApi.
	self attributes at: 'border' put: anInteger! !

!WATableTag methodsFor: 'attributes' stamp: 'lr 12/30/2006 00:11'!
cellpadding: anInteger
	self attributes at: 'cellpadding' put: anInteger! !

!WATableTag methodsFor: 'attributes' stamp: 'lr 12/30/2006 00:11'!
cellspacing: anInteger
	self attributes at: 'cellspacing' put: anInteger! !

!WATableTag methodsFor: 'attributes' stamp: 'pmm 4/8/2007 00:07'!
frame: aString
	"frame = void|above|below|hsides|lhs|rhs|vsides|box|border [CI]
    This attribute specifies which sides of the frame surrounding a table will be visible. Possible values:

        * void: No sides. This is the default value.
        * above: The top side only.
        * below: The bottom side only.
        * hsides: The top and bottom sides only.
        * vsides: The right and left sides only.
        * lhs: The left-hand side only.
        * rhs: The right-hand side only.
        * box: All four sides.
        * border: All four sides."

	self attributes at: 'frame' put: aString! !

!WATableTag methodsFor: 'attributes' stamp: 'pmm 4/8/2007 00:06'!
rules: aString
	"rules = none|groups|rows|cols|all [CI]
    This attribute specifies which rules will appear between cells within a table. The rendering of rules is user agent dependent. Possible values:

        * none: No rules. This is the default value.
        * groups: Rules will appear between row groups (see THEAD, TFOOT, and TBODY) and column groups (see COLGROUP and COL) only.
        * rows: Rules will appear between rows only.
        * cols: Rules will appear between columns only.
        * all: Rules will appear between all rows and columns."
	self attributes at: 'rules' put: aString! !

!WATableTag methodsFor: 'attributes' stamp: 'mb 12/8/2006 15:03'!
summary: aString
	self attributes at: 'summary' put: aString! !

!WATableTag methodsFor: 'accessing' stamp: 'ac 3/16/2005 15:22'!
tag
	^ 'table'! !

!WATagBrush class methodsFor: 'code generation' stamp: 'pmm 9/12/2006 19:28'!
tag
	"WASelectTag tag"
	"WAGenericTag tag"
	^(self selectors includes: #tag)
		ifTrue: [ self new tag ]
		ifFalse: [ nil ]! !

!WATagBrush methodsFor: 'attributes-keyboard' stamp: 'lr 10/28/2007 14:42'!
accessKey: aString
	"Set a keyboard shortcut to access an element. An access key is a single character from the document character set.

	Pressing an access key assigned to an element gives focus to the element. The action that occurs when an element receives focus depends on the element. For example, when a user activates a link defined by the A element, the user agent generally follows the link. When a user activates a radio button, the user agent changes the value of the radio button. When the user activates a text field, it allows input, etc.

The following elements support the accesskey attribute: A, AREA, BUTTON, INPUT, LABEL, and LEGEND, and TEXTAREA.

	The invocation of access keys depends on the underlying system. For instance, on machines running MS Windows, one generally has to press the 'alt' key in addition to the access key. On Apple systems, one generally has to press the 'cmd' key in addition to the access key."

	self attributes at: 'accesskey' put: aString! !

!WATagBrush methodsFor: 'convenience' stamp: 'lr 4/9/2008 10:51'!
addShortcut: aString 
	self canHaveShortcut ifFalse: 
		[ self error: 'May not assign shortcut on items that are not clickable' ].
	self ensureId.
	self requestContext addLoadScript: (String streamContents: 
			[ :stream | 
			stream
				nextPutAll: 'addShortcut(''';
				nextPutAll: aString;
				nextPutAll: ''', ''';
				nextPutAll: self id;
				nextPutAll: ''')' ])! !

!WATagBrush methodsFor: 'private' stamp: 'lr 4/9/2007 13:18'!
after
	"This template method is called directly after rendering the content of the receiver."! !

!WATagBrush methodsFor: 'accessing-attributes' stamp: 'lr 3/23/2007 20:57'!
attributeAt: aKey
	^ self attributes at: aKey! !

!WATagBrush methodsFor: 'accessing-attributes' stamp: 'lr 3/23/2007 20:58'!
attributeAt: aKey ifAbsent: aBlock
	^ self attributes at: aKey ifAbsent: aBlock! !

!WATagBrush methodsFor: 'accessing-attributes' stamp: 'lr 3/23/2007 20:58'!
attributeAt: aKey ifAbsentPut: aBlock
	^ self attributes at: aKey ifAbsentPut: aBlock! !

!WATagBrush methodsFor: 'accessing-attributes' stamp: 'lr 3/23/2007 20:58'!
attributeAt: aKey ifPresent: aBlock
	^ self attributes at: aKey ifPresent: aBlock! !

!WATagBrush methodsFor: 'accessing-attributes' stamp: 'lr 3/23/2007 20:57'!
attributeAt: aKey put: aValue
	^ self attributes at: aKey put: aValue! !

!WATagBrush methodsFor: 'accessing' stamp: 'lr 3/23/2007 20:08'!
attributes
	^ attributes ifNil: [ attributes := WAHtmlAttributes new ]! !

!WATagBrush methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
attributes: anHtmlAttributes
	attributes := anHtmlAttributes! !

!WATagBrush methodsFor: 'private' stamp: 'lr 4/9/2007 13:18'!
before
	"This template method is called directly before rendering the content of the receiver."! !

!WATagBrush methodsFor: 'testing' stamp: 'lr 4/11/2008 08:48'!
canHaveShortcut
	^ false! !

!WATagBrush methodsFor: 'attributes-core' stamp: 'lr 10/28/2007 14:42'!
class: aString
	"This attribute assigns one or more class names to an element; the element may be said to belong to these classes. A class name may be shared by several element instances. Multiple classes might be added to one brush."

	self attributes addClass: aString! !

!WATagBrush methodsFor: 'convenience' stamp: 'lr 10/28/2007 14:42'!
class: aString if: aBoolean
	"Adds the class aString aString to this element if aBoolean is true,

	Example

	html div
		class: 'important' if: self isImportant;
		with: self message"

	aBoolean
		ifTrue: [self class: aString]! !

!WATagBrush methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
closeTag
	"Close the receiving tag onto the document."

	self isClosed ifFalse: [ self document closeTag: self tag ]! !

!WATagBrush methodsFor: 'convenience' stamp: 'avi 3/9/2006 17:41'!
confirm: aString
	self onClick: 'return confirm("', aString, '")'! !

!WATagBrush methodsFor: 'attributes-language' stamp: 'lr 10/28/2007 14:42'!
direction: aString
	"Set the text direction ltr (left-to-right) or right-to-left (rtl).

	Not supported on:
	APPLET, BASE, BASEFONT, BR, FRAME, FRAMESET, IFRAME, PARAM, SCRIPT"

	self attributes at: 'dir' put: aString! !

!WATagBrush methodsFor: 'convenience' stamp: 'lr 10/28/2007 14:42'!
disableEnter
	"pressing the 'enter' key in the form input element does not submit the form"
	self onEnter: ''! !

!WATagBrush methodsFor: 'attributes' stamp: 'pmm 5/17/2008 23:21'!
disabled
	"When set for a form control, this boolean attribute disables the control for user input.
When set, the disabled attribute has the following effects on an element:
	-	Disabled controls do not receive focus.
	-	Disabled controls are skipped in tabbing navigation.
	-	Disabled controls cannot be successful (= will not be submitted).
		
	The following elements support the disabled attribute: BUTTON, INPUT, OPTGROUP, OPTION, SELECT, and TEXTAREA. This one other example of functionality implemented way too high in the class hierarchy because we don't have traits."
	self disabled: true! !

!WATagBrush methodsFor: 'attributes' stamp: 'lr 6/6/2007 16:20'!
disabled: aBoolean
	self attributes at: 'disabled' put: aBoolean! !

!WATagBrush methodsFor: 'private' stamp: 'avi 6/13/2004 00:39'!
document
	^ canvas document! !

!WATagBrush methodsFor: 'public' stamp: 'lr 4/9/2007 16:31'!
ensureId
	"Answer the id of the receiving attribute. In case the receiver doesn't have an id yet, generate a new one."

	^ self attributes at: 'id' ifAbsentPut: [ canvas nextId ]! !

!WATagBrush methodsFor: 'accessing' stamp: 'pmm 11/21/2007 14:24'!
id
	^ self attributes at: 'id'! !

!WATagBrush methodsFor: 'attributes-core' stamp: 'lr 10/28/2007 14:42'!
id: aString
	"The id attribute assigns a identifier to an element. The id of an element must be unique within a document."

	self attributes at: 'id' put: aString! !

!WATagBrush methodsFor: 'testing' stamp: 'lr 10/28/2007 14:42'!
isClosed
	"Answer true if this tag should be closed immediately, such as <br />."

	^ false! !

!WATagBrush methodsFor: 'attributes' stamp: 'pmm 5/17/2008 23:19'!
isDisabled
	"answers whether the receiver is disabled"
	^self attributes
		at: 'disabled'
		ifAbsent: [ false ]! !

!WATagBrush methodsFor: 'attributes-language' stamp: 'lr 10/28/2007 14:42'!
language: aString
	"Set the language code."

	self attributes
		at: 'lang' put: aString;
		at: 'xml:lang' put: aString! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 4/9/2007 14:08'!
onBlur: aString
	"The onblurs event occurs when the element that is in focus, loses that focus."

	self attributes at: 'onblur' append: aString separator: ';'! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 4/9/2007 14:09'!
onChange: aString
	"The onchange event occurs when a select input element has a selection made or when a text input element has a change in the text."

	self attributes at: 'onchange' append: aString separator: ';'! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 6/7/2006 13:48'!
onClick: aString
	"The onclick event occurs when the pointing device button is clicked over an element."

	self attributes at: 'onclick' append: aString separator: ';'! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 6/7/2006 13:48'!
onDoubleClick: aString
	"The ondblclick event occurs when the pointing device button is double clicked over an element."

	self attributes at: 'ondblclick' append: aString separator: ';'! !

!WATagBrush methodsFor: 'convenience' stamp: 'lr 8/30/2008 16:22'!
onEnter: aString 
	"If 'enter' is pressed"
	self onKeyPress: 'if((window.event ? window.event.keyCode : event.which) == 13){' , aString seasideString , '; return false}; return true'! !

!WATagBrush methodsFor: 'convenience' stamp: 'lr 6/7/2006 13:48'!
onError: aString
	self attributes at: 'onerror' append: aString separator: ';'! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 6/7/2006 13:48'!
onFocus: aString
	"The onfocus event occurs when an element receives focus either by the pointing device or by tabbing navigation."

	self attributes at: 'onfocus' append: aString separator: ';'! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 6/7/2006 13:48'!
onKeyDown: aString
	"The onkeydown event occurs when a key is pressed down over an element."

	self attributes at: 'onkeydown' append: aString separator: ';'! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 6/7/2006 13:48'!
onKeyPress: aString
	"The onkeypress event occurs when a key is pressed and released over an element."

	self attributes at: 'onkeypress' append: aString separator: ';'! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 6/7/2006 13:48'!
onKeyUp: aString
	"The onkeyup event occurs when a key is released over an element."

	self attributes at: 'onkeyup' append: aString separator: ';'! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'mb 6/21/2006 18:28'!
onLoad: aString
	"The onload event occurs when the user agent finishes loading a window."

	self attributes at: 'onload' append: aString separator: ';'! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 6/7/2006 13:48'!
onMouseDown: aString
	"The onmousedown event occurs when the pointing device button is pressed over an element."

	self attributes at: 'onmousedown' append: aString separator: ';'! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 6/7/2006 13:48'!
onMouseMove: aString
	"The onmousemove event occurs when the pointing device is moved while it is over an element."

	self attributes at: 'onmousemove' append: aString separator: ';'! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 6/7/2006 13:48'!
onMouseOut: aString
	"The onmouseout event occurs when the pointing device is moved away from an element."

	self attributes at: 'onmouseout' append: aString separator: ';'! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 6/7/2006 13:48'!
onMouseOver: aString
	"The onmouseover event occurs when the pointing device is moved onto an element."

	self attributes at: 'onmouseover' append: aString separator: ';'! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 6/7/2006 13:48'!
onMouseUp: aString
	"The onmouseup event occurs when the pointing device button is released over an element."

	self attributes at: 'onmouseup' append: aString separator: ';'! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 6/7/2006 13:49'!
onReset: aString
	"The onreset event occurs when a form is reset."

	self attributes at: 'onreset' append: aString separator: ';'! !

!WATagBrush methodsFor: 'convenience' stamp: 'lr 6/7/2006 13:49'!
onResize: aString
	self attributes at: 'onresize' append: aString separator: ';'! !

!WATagBrush methodsFor: 'convenience' stamp: 'lr 6/7/2006 13:49'!
onScroll: aString
	self attributes at: 'onscroll' append: aString separator: ';'! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 6/7/2006 13:49'!
onSelect: aString
	"The onselect event occurs when a user selects some text in a text field."

	self attributes at: 'onselect' append: aString separator: ';'! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 6/7/2006 13:49'!
onSubmit: aString
	"The onsubmit event occurs when a form is submitted."

	self attributes at: 'onsubmit' append: aString separator: ';'! !

!WATagBrush methodsFor: 'attributes-events' stamp: 'lr 6/7/2006 13:49'!
onUnload: aString
	"The onunload event occurs when the user agent removes a document from a window."

	self attributes at: 'onunload' append: aString separator: ';'! !

!WATagBrush methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
openTag
	"Open the receiving and all associated attributes onto the document."

	self document openTag: self tag attributes: attributes closed: self isClosed! !

!WATagBrush methodsFor: 'accessing' stamp: 'lr 4/9/2008 10:53'!
requestContext
	"Answer the current request context."

	^ WACurrentRequestContext value! !

!WATagBrush methodsFor: 'attributes-core' stamp: 'lr 4/9/2007 16:13'!
style: aString
	"This attribute offers optional CSS style information. The attribute is deprecated and should be avoided in favor of an external stylesheet. Multiple styles might be added to one brush."

	self attributes addStyle: aString! !

!WATagBrush methodsFor: 'attributes-keyboard' stamp: 'lr 10/28/2007 14:42'!
tabIndex: aString
	"This attribute specifies the position of the current element in the tabbing order for the current document. This value must be a number between 0 and 32767.

	The tabbing order defines the order in which elements will receive focus when navigated by the user via the keyboard. The tabbing order may include elements nested within other elements.

	The following elements support the tabindex attribute: A, AREA, BUTTON, INPUT, OBJECT, SELECT, and TEXTAREA."

	self attributes at: 'tabindex' put: aString! !

!WATagBrush methodsFor: 'accessing' stamp: 'avi 6/13/2004 00:30'!
tag
	self subclassResponsibility! !

!WATagBrush methodsFor: 'attributes-core' stamp: 'lr 10/28/2007 14:42'!
title: aString
	"This attribute offers advisory information about the element for which it is set. Visual browsers frequently display the title as a 'tool tip'."

	self attributes at: 'title' put: aString! !

!WATagBrush methodsFor: 'public' stamp: 'lr 10/28/2007 14:42'!
with: anObject
	"Render anObject into the receiver. Make sure that you call #with: last in the cascade, as this method will serialize the tag onto the output document."

	self openTag.
	super with: [
		self before.
		anObject renderOn: canvas.
		self after ].
	self closeTag! !

!WATagBrush methodsFor: 'convenience' stamp: 'pmm 5/10/2007 10:16'!
withLineBreaks: aString
	"Renders text preserving line breaks."
	self with: [canvas withLineBreaks: aString]! !

Object subclass: #WACallback
	instanceVariableNames: 'owner key renderContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

WACallback subclass: #WAActionCallback
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

!WAActionCallback methodsFor: 'accessing' stamp: 'jf 7/14/2008 02:11'!
block: aZeroOrOneArgBlock
	block := aZeroOrOneArgBlock fixCallbackTemps! !

!WAActionCallback methodsFor: 'evaluation' stamp: 'jf 7/14/2008 02:22'!
evaluateWithArgument: anObject
	block valueWithPossibleArgument: anObject.
	self signalRenderNotification! !

!WAActionCallback methodsFor: 'testing' stamp: 'lr 4/9/2008 10:45'!
isEnabled
	^ self requestContext request isXmlHttpRequest not! !

!WAActionCallback methodsFor: 'accessing' stamp: 'avi 6/7/2004 22:37'!
priority
	^ 8! !

!WAActionCallback methodsFor: 'evaluation' stamp: 'lr 10/28/2007 14:42'!
signalRenderNotification
	WARenderNotification raiseSignal! !

WAActionCallback subclass: #WACancelActionCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

!WACancelActionCallback methodsFor: 'accessing' stamp: 'avi 6/7/2004 22:37'!
priority
	^ 3! !

WAActionCallback subclass: #WADefaultActionCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

!WADefaultActionCallback methodsFor: 'accessing' stamp: 'avi 6/7/2004 22:37'!
priority
	^ 10! !

WAActionCallback subclass: #WAImageCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

!WAImageCallback methodsFor: 'converting' stamp: 'avi 9/2/2004 14:46'!
convertKey: aString
	^ aString, '.x'! !

!WACallback methodsFor: 'comparing' stamp: 'avi 6/7/2004 22:38'!
<= other
	^ self priority < other priority or: [self priority = other priority and: [self key asNumber <= other key asNumber]]! !

!WACallback methodsFor: 'converting' stamp: 'avi 9/2/2004 14:46'!
convertKey: aString
	^ aString! !

!WACallback methodsFor: 'evaluation' stamp: 'avi 6/7/2004 21:49'!
evaluateWithArgument: anObject
	self subclassResponsibility! !

!WACallback methodsFor: 'evaluation' stamp: 'lr 8/8/2007 17:55'!
evaluateWithField: anObject
	self isEnabled ifFalse: [ ^ self ].
	self evaluateWithArgument: (self valueForField: anObject)! !

!WACallback methodsFor: 'testing' stamp: 'lr 8/8/2007 17:56'!
isEnabled
	^ true! !

!WACallback methodsFor: 'accessing' stamp: 'lr 8/8/2007 17:54'!
key
	^ self convertKey: key! !

!WACallback methodsFor: 'accessing' stamp: 'avi 6/7/2004 21:48'!
owner
	^ owner! !

!WACallback methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
priority
	self subclassResponsibility! !

!WACallback methodsFor: 'accessing' stamp: 'lr 4/9/2008 10:45'!
requestContext
	"Answer the current request context."

	^ WACurrentRequestContext value! !

!WACallback methodsFor: 'accessing' stamp: 'lr 4/9/2008 10:46'!
session
	^ self requestContext session! !

!WACallback methodsFor: 'initialization' stamp: 'lr 3/29/2008 22:47'!
setContext: aRenderingContext owner: anObject key: aString 
	renderContext := aRenderingContext.
	owner := anObject.
	key := aString! !

!WACallback methodsFor: 'converting' stamp: 'avi 6/7/2004 21:51'!
valueForField: anObject
	^ anObject
		ifNil: ['']
		ifNotNil:
			[(anObject isCollection and: [anObject isString not])
					ifTrue: [anObject isEmpty
								ifTrue: ['']
								ifFalse: [anObject first]]
					ifFalse: [anObject]]! !

WACallback subclass: #WADispatchCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

!WADispatchCallback methodsFor: 'evaluation' stamp: 'lr 3/29/2008 22:47'!
evaluateWithArgument: anObject 
	| callback |
	callback := renderContext callbackAt: anObject.
	callback isNil ifFalse: [ callback evaluateWithArgument: nil ]! !

!WADispatchCallback methodsFor: 'accessing' stamp: 'avi 6/7/2004 22:42'!
priority
	^ 5! !

WADispatchCallback subclass: #WAMultiDispatchCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

!WAMultiDispatchCallback methodsFor: 'evaluation' stamp: 'lr 10/28/2007 14:42'!
evaluateWithField: anObject
	(anObject isCollection and: [ anObject isString not ])
		ifFalse: [ ^ super evaluateWithField: anObject ].
	anObject do: [ :each |
		self evaluateWithArgument: (self valueForField: each) ]! !

WACallback subclass: #WAValueCallback
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

!WAValueCallback methodsFor: 'accessing' stamp: 'avi 9/19/2006 14:29'!
block: aOneArgBlock
	block := aOneArgBlock fixCallbackTemps! !

!WAValueCallback methodsFor: 'evaluation' stamp: 'pmm 2/27/2007 06:30'!
evaluateWithArgument: anObject
	block valueWithPossibleArgument: anObject! !

!WAValueCallback methodsFor: 'accessing' stamp: 'avi 6/7/2004 22:41'!
priority
	^ 5! !

Object subclass: #WACallbackRegistry
	instanceVariableNames: 'context owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

!WACallbackRegistry class methodsFor: 'instance-creation' stamp: 'lr 1/11/2008 19:06'!
context: aContext
	^ self context: aContext owner: nil! !

!WACallbackRegistry class methodsFor: 'instance-creation' stamp: 'avi 6/7/2004 22:04'!
context: aContext owner: anObject
	^ self basicNew initializeWithContext: aContext owner: anObject! !

!WACallbackRegistry methodsFor: 'initialization' stamp: 'avi 6/7/2004 22:04'!
initializeWithContext: aContext owner: anObject
	context := aContext.
	owner := anObject! !

!WACallbackRegistry methodsFor: 'accessing' stamp: 'lr 5/1/2007 08:20'!
owner
	^ owner! !

!WACallbackRegistry methodsFor: 'registration' stamp: 'avi 6/7/2004 22:10'!
registerActionCallback: aBlock
	^ self storeCallback: (WAActionCallback new block: aBlock)! !

!WACallbackRegistry methodsFor: 'registration' stamp: 'avi 6/7/2004 22:10'!
registerCallback: aBlock
	^ self storeCallback: (WAValueCallback new block: aBlock)! !

!WACallbackRegistry methodsFor: 'registration' stamp: 'avi 6/7/2004 22:41'!
registerCancelActionCallback: aBlock
	^ self storeCallback: (WACancelActionCallback new block: aBlock)! !

!WACallbackRegistry methodsFor: 'registration' stamp: 'avi 6/7/2004 22:41'!
registerDefaultActionCallback: aBlock
	^ self storeCallback: (WADefaultActionCallback new block: aBlock)! !

!WACallbackRegistry methodsFor: 'registration' stamp: 'avi 6/7/2004 22:10'!
registerDispatchCallback
	^ self storeCallback: WADispatchCallback new! !

!WACallbackRegistry methodsFor: 'registration' stamp: 'avi 9/2/2004 14:42'!
registerImageCallback: aBlock
	^ self storeCallback: (WAImageCallback new block: aBlock)! !

!WACallbackRegistry methodsFor: 'registration' stamp: 'lr 10/10/2005 20:00'!
registerMultiDispatchCallback
	^ self storeCallback: WAMultiDispatchCallback new! !

!WACallbackRegistry methodsFor: 'callbacks' stamp: 'lr 10/28/2007 14:42'!
storeCallback: aCallback
	| key |
	key := context storeCallback: aCallback.
	aCallback setContext: context owner: owner key: key.
	^ key! !

Object subclass: #WACallbackStream
	instanceVariableNames: 'callbacks request'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

!WACallbackStream class methodsFor: 'instance-creation' stamp: 'avi 6/8/2004 01:58'!
callbacks: aDictionary request: aRequest
	^ self basicNew initializeWithCallbacks: aDictionary request: aRequest! !

!WACallbackStream methodsFor: 'testing' stamp: 'avi 6/8/2004 01:59'!
atEnd
	^ callbacks atEnd! !

!WACallbackStream methodsFor: 'testing' stamp: 'lr 1/11/2008 19:21'!
hasCallbacksForOwner: anObject
	"Answer true if the receiving stream has more callbacks for the owner anObject. This method considers callbacks without owner to be valid as well."

	| owner |
	callbacks atEnd ifTrue: [ ^ false ].
	owner := callbacks peek owner.
	^ owner == anObject or: [ owner isNil ]! !

!WACallbackStream methodsFor: 'initialization' stamp: 'lr 1/11/2008 19:22'!
initializeWithCallbacks: aDictionary request: aRequest
	| collection |
	collection := SortedCollection new.
	aRequest fields keys do: [ :each |
		aDictionary
			at: each 
			ifPresent: [ :callback | collection add: callback ] ].
	callbacks := ReadStream on: collection asArray.
	request := aRequest! !

!WACallbackStream methodsFor: 'accessing' stamp: 'avi 6/8/2004 01:59'!
position
	^ callbacks position! !

!WACallbackStream methodsFor: 'processing' stamp: 'lr 1/11/2008 19:22'!
processCallbacksWithOwner: anObject 
	| callback |
	[ self hasCallbacksForOwner: anObject ] whileTrue: [
		callback := callbacks next.
		callback evaluateWithField: (request fields at: callback key) ]! !

!WACallbackStream methodsFor: 'accessing' stamp: 'avi 6/12/2004 00:25'!
upToEnd
	^ callbacks upToEnd! !

Object subclass: #WACanvas
	instanceVariableNames: 'currentBrush parentBrush'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas'!

!WACanvas commentStamp: 'pmm 4/15/2007 22:05' prior: 0!
This is the superclass of all canvas. It's a rendering interfact that generates brushes (see WABrush).

Subclass this class, if you want to generate an XML dialect.!

!WACanvas class methodsFor: 'instance creation' stamp: 'pmm 8/12/2007 11:59'!
builder
	^WAHtmlBuilder on: self! !

!WACanvas methodsFor: 'public' stamp: 'avi 6/17/2004 12:36'!
brush: aBrush
	self flush.
	currentBrush := aBrush.
	aBrush setParent: parentBrush canvas: self.
	^ aBrush! !

!WACanvas methodsFor: 'private' stamp: 'avi 6/17/2004 12:12'!
flush
	currentBrush ifNotNil:
		[currentBrush close.
		currentBrush := nil]! !

!WACanvas methodsFor: 'private' stamp: 'lr 6/6/2007 10:32'!
insert: aBlock
	| oldBrush |
	oldBrush := currentBrush.
	currentBrush := nil.
	aBlock value.
	self flush.
	currentBrush := oldBrush! !

!WACanvas methodsFor: 'private' stamp: 'lr 4/9/2007 17:54'!
nest: aBlock
	parentBrush := currentBrush.
	currentBrush := nil.
	aBlock renderOn: self.
	self flush.
	parentBrush := parentBrush parent! !

!WACanvas methodsFor: 'public' stamp: 'pmm 10/15/2006 11:33'!
render: anObject
	self flush.
	anObject renderOn: self! !

WACanvas subclass: #WAHtmlCanvas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas'!

!WAHtmlCanvas commentStamp: 'jf 7/16/2008 12:16' prior: 0!
This is an abstract canvas that knows about HTML but nothing about callbacks. Subclasses must implement #document.!

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'lr 4/9/2007 17:01'!
abbreviated
	"Defines an abbreviation, such as 'M.', 'Inc.', 'et al.', 'etc.'"

	^ self tag: 'abbr'! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'pmm 9/30/2006 20:06'!
abbreviated: aBlock
	self abbreviated with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'lr 10/28/2007 14:42'!
acronym
	"Defines an acronym, such as 'GmbH', 'NATO', and 'F.B.I.'"

	^ self tag: 'acronym'! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'mb 3/24/2006 13:42'!
acronym: aBlock
	self acronym with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'lr 10/28/2007 14:42'!
address
	"Defines an address element."

	^ self tag: 'address'! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'pmm 12/24/2005 17:44'!
address: aBlock
	self address with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'lr 10/28/2007 14:42'!
anchor
	"Defines an anchor."

	^ self brush: WAAnchorTag new! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'lr 4/9/2007 17:23'!
anchor: aBlock
	self anchor with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-format' stamp: 'lr 10/28/2007 14:42'!
big
	"Defines big text."

	^ self tag: 'big'! !

!WAHtmlCanvas methodsFor: 'tags-format' stamp: 'ac 2/21/2006 14:36'!
big: aBlock
	self big with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'lr 4/9/2007 17:02'!
blockquote
	"Defines a long quotation."

	^ self tag: 'blockquote'! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'avi 6/3/2005 15:40'!
blockquote: aBlock
	self blockquote with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'lr 10/28/2007 14:42'!
break
	"Inserts a single line break."

	^ self brush: WABreakTag new! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'lr 10/28/2007 14:42'!
citation
	"Defines a citation."

	^ self tag: 'cite'! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'pmm 9/30/2006 20:06'!
citation: aBlock
	self citation with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'lr 10/28/2007 14:42'!
code
	"Defines computer code text."

	^ self tag: 'code'! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'avi 6/3/2005 15:40'!
code: aBlock
	self code with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'lr 10/28/2007 14:42'!
definition
	"Defines a definition term."

	^ self tag: 'dfn'! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'pmm 9/30/2006 20:06'!
definition: aBlock
	self definition with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-lists' stamp: 'lr 10/28/2007 14:42'!
definitionData
	"Defines a definition description."

	^ self tag: 'dd'! !

!WAHtmlCanvas methodsFor: 'tags-lists' stamp: 'pmm 5/31/2006 20:26'!
definitionData: aBlock
	self definitionData with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-lists' stamp: 'lr 10/28/2007 14:42'!
definitionList
	"Defines a definition list."

	^ self tag: 'dl'! !

!WAHtmlCanvas methodsFor: 'tags-lists' stamp: 'pmm 12/24/2005 17:42'!
definitionList: aBlock
	self definitionList with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-lists' stamp: 'lr 10/28/2007 14:42'!
definitionTerm
	"Defines a definition term."

	^ self tag: 'dt'! !

!WAHtmlCanvas methodsFor: 'tags-lists' stamp: 'pmm 12/24/2005 17:42'!
definitionTerm: aBlock
	self definitionTerm with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'lr 10/28/2007 14:42'!
deleted
	"Defines deleted text."

	^ self brush: (WAEditTag tag: 'del')! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'pmm 3/28/2007 10:42'!
deleted: aBlock
	self deleted with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-styles' stamp: 'lr 10/28/2007 14:42'!
div
	"Defines a section in a document."

	^ self brush: WADivTag new! !

!WAHtmlCanvas methodsFor: 'tags-styles' stamp: 'avi 6/3/2005 15:40'!
div: aBlock
	self div with: aBlock! !

!WAHtmlCanvas methodsFor: 'accessing' stamp: 'avi 6/13/2004 00:57'!
document
	self subclassResponsibility! !

!WAHtmlCanvas methodsFor: 'tags-format' stamp: 'lr 4/9/2007 16:53'!
emphasis
	"Defines emphasized text."

	^ self tag: 'em'! !

!WAHtmlCanvas methodsFor: 'tags-format' stamp: 'mb 3/8/2006 17:14'!
emphasis: aBlock
	self emphasis with: aBlock! !

!WAHtmlCanvas methodsFor: 'convenience' stamp: 'lr 8/30/2008 16:22'!
encodeCharacter: aCharacter 
	self html: '&#' , aCharacter asInteger seasideString , ';'! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'lr 10/28/2007 14:42'!
fieldSet
	"Defines a fieldset."

	^ self brush: WAFieldSetTag new! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'mb 3/24/2006 13:45'!
fieldSet: aBlock
	self fieldSet with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'lr 10/28/2007 14:42'!
form
	"Defines a form."

	^ self tag: 'form'! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'avi 6/3/2005 15:40'!
form: aBlock
	self form with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'lr 10/28/2007 14:42'!
heading
	"Defines header 1 to header 6."

	^ self brush: WAHeadingTag new! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'ac 3/16/2005 14:14'!
heading: aBlock
	self heading with: aBlock! !

!WAHtmlCanvas methodsFor: 'deprecated' stamp: 'lr 7/10/2007 12:17'!
heading: anObject level: anInteger
	self deprecatedApi.
	self heading level: anInteger; with: anObject! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'lr 10/28/2007 14:42'!
horizontalRule
	"Defines a horizontal rule."

	^ self brush: WAHorizontalRuleTag new! !

!WAHtmlCanvas methodsFor: 'public' stamp: 'lr 8/30/2008 16:22'!
html: aString 
	"Emit aString unescaped onto the target document."
	self flush.
	self document nextPutAll: aString seasideString! !

!WAHtmlCanvas methodsFor: 'deprecated' stamp: 'pmm 1/3/2008 16:59'!
iframe
	^ self brush: WAIframeTag new! !

!WAHtmlCanvas methodsFor: 'tags-images' stamp: 'lr 10/28/2007 14:42'!
image
	"Defines an image."

	^ self brush: WAImageTag new! !

!WAHtmlCanvas methodsFor: 'tags-images' stamp: 'mb 3/24/2006 13:51'!
image: aBlock
	self image with: aBlock! !

!WAHtmlCanvas methodsFor: 'deprecated' stamp: 'lr 10/28/2007 14:42'!
imageForm: aForm
	self deprecatedApi.
	self image form: aForm! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'lr 4/9/2007 17:02'!
inserted
	"Defines inserted text."

	^ self brush: (WAEditTag tag: 'ins')! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'pmm 3/28/2007 10:41'!
inserted: aBlock
	self inserted with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'lr 10/28/2007 14:42'!
keyboard
	"Defines keyboard text."

	^ self tag: 'kbd'! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'lr 4/9/2007 17:23'!
keyboard: aBlock
	self keyboard with: aBlock! !

!WAHtmlCanvas methodsFor: 'deprecated' stamp: 'pmm 12/18/2007 20:41'!
keyboardInput
	"Keyboard, text to be entered by the user.
	This selector has been renamed"

	self deprecatedApi.
	^ self keyboard! !

!WAHtmlCanvas methodsFor: 'deprecated' stamp: 'pmm 12/18/2007 20:46'!
keyboardInput: aBlock
	self deprecatedApi.
	self keyboard: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'lr 10/28/2007 14:42'!
label
	"Defines a label for a form control."

	^ self brush: WALabelTag new! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'avi 6/3/2005 15:40'!
label: aBlock
	self label with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'lr 10/28/2007 14:42'!
legend
	"Defines a title in a fieldset."

	^ self tag: 'legend'! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'mb 3/8/2006 18:00'!
legend: aBlock
	self legend with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-lists' stamp: 'lr 10/28/2007 14:42'!
listItem
	"Defines a list item."

	^ self tag: 'li'! !

!WAHtmlCanvas methodsFor: 'tags-lists' stamp: 'avi 6/3/2005 15:40'!
listItem: aBlock
	self listItem with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-images' stamp: 'lr 10/28/2007 14:42'!
map
	"Defines an anchor to be used around an image."

	^ self brush: WAImageMapTag new! !

!WAHtmlCanvas methodsFor: 'tags-images' stamp: 'lr 4/9/2007 17:47'!
map: aBlock
	self map with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-program' stamp: 'lr 10/28/2007 14:42'!
object
	"Defines an embedded object."

	^ self brush: WAObjectTag new! !

!WAHtmlCanvas methodsFor: 'tags-program' stamp: 'pmm 2/11/2007 19:31'!
object: aBlock
	self object with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-lists' stamp: 'lr 10/28/2007 14:42'!
orderedList
	"Defines an ordered list."

	^ self brush: WAOrderedListTag new! !

!WAHtmlCanvas methodsFor: 'tags-lists' stamp: 'lr 9/25/2005 11:52'!
orderedList: aBlock
	self orderedList with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'lr 10/28/2007 14:42'!
paragraph
	"Defines a paragraph."

	^ self tag: 'p'! !

!WAHtmlCanvas methodsFor: 'tags' stamp: 'avi 6/3/2005 15:40'!
paragraph: aBlock
	self paragraph with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-program' stamp: 'lr 10/28/2007 14:42'!
parameter
	"Defines a parameter for an object."

	^ self brush: WAParameterTag new! !

!WAHtmlCanvas methodsFor: 'tags-program' stamp: 'lr 2/13/2007 00:12'!
parameter: aBlock
	self parameter! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'ac 7/3/2005 15:46'!
popupAnchor
	^ self brush: WAPopupAnchorTag new! !

!WAHtmlCanvas methodsFor: 'tags-input' stamp: 'lr 7/10/2007 12:12'!
popupAnchor: aBlock
	self popupAnchor with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'lr 10/28/2007 14:42'!
preformatted
	"Defines preformatted text."

	^ self tag: 'pre'! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'avi 6/3/2005 15:40'!
preformatted: aBlock
	self preformatted with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'lr 10/28/2007 14:42'!
quote
	"Defines a short quotation."

	^ self tag: 'q'! !

!WAHtmlCanvas methodsFor: 'tags-block' stamp: 'pmm 9/30/2006 20:06'!
quote: aBlock
	self quote with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-ruby' stamp: 'mb 9/21/2006 16:26'!
ruby
	^ self tag: 'ruby'! !

!WAHtmlCanvas methodsFor: 'tags-ruby' stamp: 'mb 9/21/2006 16:26'!
ruby: aBlock
	self ruby with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-ruby' stamp: 'mb 9/21/2006 16:26'!
rubyBase
	^ self tag: 'rb'! !

!WAHtmlCanvas methodsFor: 'tags-ruby' stamp: 'mb 9/21/2006 16:26'!
rubyBase: aBlock
	self rubyBase with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-ruby' stamp: 'mb 9/21/2006 16:26'!
rubyBaseContainer
	^ self tag: 'rbc'! !

!WAHtmlCanvas methodsFor: 'tags-ruby' stamp: 'mb 9/21/2006 16:26'!
rubyBaseContainer: aBlock
	self rubyBaseContainer with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-ruby' stamp: 'mb 9/21/2006 16:26'!
rubyParentheses
	^ self tag: 'rp'! !

!WAHtmlCanvas methodsFor: 'tags-ruby' stamp: 'mb 9/21/2006 16:26'!
rubyParentheses: aBlock
	self rubyParentheses with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-ruby' stamp: 'mb 9/21/2006 16:26'!
rubyText
	^ self brush: WARubyTextTag new! !

!WAHtmlCanvas methodsFor: 'tags-ruby' stamp: 'mb 9/21/2006 16:26'!
rubyText: aBlock
	self rubyText with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-ruby' stamp: 'mb 9/21/2006 16:26'!
rubyTextContainer
	^ self tag: 'rtc'! !

!WAHtmlCanvas methodsFor: 'tags-ruby' stamp: 'mb 9/21/2006 16:26'!
rubyTextContainer: aBlock
	self rubyTextContainer with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'lr 10/28/2007 14:42'!
sample
	"Defines sample computer code."

	^ self tag: 'samp'! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'lr 4/9/2007 17:23'!
sample: aBlock
	self sample with: aBlock! !

!WAHtmlCanvas methodsFor: 'deprecated' stamp: 'pmm 12/18/2007 20:41'!
sampleOutput
	"Sample output, from a program or script.
	This selector has been renamed."

	self deprecatedApi.
	^ self sample! !

!WAHtmlCanvas methodsFor: 'deprecated' stamp: 'lr 7/10/2007 12:13'!
sampleOutput: aBlock
	self deprecatedApi.
	self sampleOutput with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-program' stamp: 'lr 10/28/2007 14:42'!
script
	"Defines a script."

	^ self brush: WAScriptTag new! !

!WAHtmlCanvas methodsFor: 'tags-program' stamp: 'avi 6/3/2005 15:40'!
script: aBlock
	self script with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-format' stamp: 'lr 10/28/2007 14:42'!
small
	"Defines small text."

	^ self tag: 'small'! !

!WAHtmlCanvas methodsFor: 'tags-format' stamp: 'avi 6/3/2005 15:40'!
small: aBlock
	self small with: aBlock! !

!WAHtmlCanvas methodsFor: 'convenience' stamp: 'mb 10/31/2006 16:13'!
space
	self html: self spaceEntity! !

!WAHtmlCanvas methodsFor: 'convenience' stamp: 'lr 8/20/2007 21:34'!
space: anInteger
	anInteger timesRepeat: [ self space ]! !

!WAHtmlCanvas methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
spaceEntity
	"The HTML entity representing a space. To be subclassed as needed."

	^ '&nbsp;'! !

!WAHtmlCanvas methodsFor: 'tags-styles' stamp: 'lr 10/28/2007 14:42'!
span
	"Defines a section in a document."

	^ self tag: 'span'! !

!WAHtmlCanvas methodsFor: 'tags-styles' stamp: 'avi 6/3/2005 15:40'!
span: aBlock
	self span with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-format' stamp: 'lr 10/28/2007 14:42'!
strong
	"Defines strong text."

	^ self tag: 'strong'! !

!WAHtmlCanvas methodsFor: 'tags-format' stamp: 'ac 3/20/2005 01:24'!
strong: aBlock
	self strong with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-format' stamp: 'lr 10/28/2007 14:42'!
subscript
	"Defines subscripted text."

	^ self tag: 'sub'! !

!WAHtmlCanvas methodsFor: 'tags-format' stamp: 'lr 4/9/2007 16:46'!
subscript: aBlock
	self subscript with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-format' stamp: 'lr 10/28/2007 14:42'!
superscript
	"Defines superscripted text."

	^ self tag: 'sup'! !

!WAHtmlCanvas methodsFor: 'tags-format' stamp: 'lr 4/9/2007 16:46'!
superscript: aBlock
	self superscript with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'lr 10/28/2007 14:42'!
table
	"Defines a table."

	^ self brush: WATableTag new! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'lr 4/9/2007 17:05'!
table: aBlock
	self table with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'lr 10/28/2007 14:42'!
tableBody
	"Defines a table body."

	^ self tag: 'tbody'! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'avi 6/3/2005 15:40'!
tableBody: aBlock
	self tableBody with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'lr 10/28/2007 14:42'!
tableCaption
	"Defines a table caption."

	^ self tag: 'caption'! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'mb 12/8/2006 16:17'!
tableCaption: aBlock
	self tableCaption with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'lr 10/28/2007 14:42'!
tableColumn
	"Defines attributes for table columns."

	^ self brush: WATableColumnTag new! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'mb 12/7/2006 20:27'!
tableColumn: aBlock
	self tableColumn with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'lr 10/28/2007 14:42'!
tableColumnGroup
	"Defines groups of table columns."

	^ self brush: WATableColumnGroupTag new! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'mb 12/7/2006 20:27'!
tableColumnGroup: aBlock
	self tableColumnGroup with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'lr 10/28/2007 14:42'!
tableData
	"Defines a table cell."

	^ self brush: WATableDataTag new! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'avi 6/3/2005 15:40'!
tableData: aBlock
	self tableData with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'lr 10/28/2007 14:42'!
tableFoot
	"Defines a table footer."

	^ self tag: 'tfoot'! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'lr 4/9/2007 17:06'!
tableFoot: aBlock
	^ self tableFoot with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'lr 10/28/2007 14:42'!
tableHead
	"Defines a table header."

	^ self tag: 'thead'! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'avi 6/3/2005 15:40'!
tableHead: aBlock
	self tableHead with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'lr 10/28/2007 14:42'!
tableHeading
	"Defines a table header."

	^ self brush: WATableHeadingTag new! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'ac 3/16/2005 16:15'!
tableHeading: aBlock
	self tableHeading with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'lr 10/28/2007 14:42'!
tableRow
	"Defines a table row."

	^ self tag: 'tr'! !

!WAHtmlCanvas methodsFor: 'tags-tables' stamp: 'avi 6/3/2005 15:40'!
tableRow: aBlock
	self tableRow with: aBlock! !

!WAHtmlCanvas methodsFor: 'public' stamp: 'lr 10/28/2007 14:42'!
tag: aString
	"Defines a generic tag with the name aString."

	^ self brush: (WAGenericTag tag: aString)! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'lr 10/28/2007 14:42'!
teletype
	"Defines teletype text."

	^ self tag: 'tt'! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'lr 4/9/2007 17:23'!
teletype: aBlock
	self teletype with: aBlock! !

!WAHtmlCanvas methodsFor: 'public' stamp: 'lr 10/28/2007 14:42'!
text: anObject
	"Emit anObject onto the target document."

	self flush.
	self document print: anObject! !

!WAHtmlCanvas methodsFor: 'tags-lists' stamp: 'lr 10/28/2007 14:42'!
unorderedList
	"Defines an unordered list."

	^ self brush: WAUnorderedListTag new! !

!WAHtmlCanvas methodsFor: 'tags-lists' stamp: 'avi 6/3/2005 15:40'!
unorderedList: aBlock
	self unorderedList with: aBlock! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'lr 10/28/2007 14:42'!
variable
	"Defines a variable."

	^ self tag: 'var'! !

!WAHtmlCanvas methodsFor: 'tags-output' stamp: 'pmm 9/30/2006 20:06'!
variable: aBlock
	self variable with: aBlock! !

!WAHtmlCanvas methodsFor: 'convenience' stamp: 'pmm 5/10/2007 10:16'!
withLineBreaks: aString
	"Renders text preserving line breaks."
	| stream |
	stream := aString readStream.
	[ stream atEnd ] whileFalse: [
		self text: stream nextLine.
		stream atEnd ifFalse: [ self break ] ]! !

!WAHtmlCanvas methodsFor: 'convenience' stamp: 'avi 6/23/2006 10:16'!
withLineBreaksAndUrls: aString
	| stream |
	aString ifNil: [^ self].
	stream := aString readStream.
	[stream atEnd] whileFalse:
		[self withUrls: stream nextLine.
		stream atEnd ifFalse: [self break]]! !

!WAHtmlCanvas methodsFor: 'convenience' stamp: 'lr 10/28/2007 14:42'!
withUrls: aString
	| stream url |
	stream := aString readStream.
	[ stream atEnd ] whileFalse: [
		self text: (stream upToAndSkipThroughAll: 'http://').
			stream atEnd ifFalse: [
				url := 'http://', (stream upTo: Character space).
				self anchor
					url: url;
					with: url.
				self text: ' '] ]! !

WAHtmlCanvas subclass: #WARenderCanvas
	instanceVariableNames: 'context callbacks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas'!

!WARenderCanvas commentStamp: 'pmm 4/20/2007 11:35' prior: 0!
This canvas knows about callbacks and is intertwined with the rest of the framework.!

!WARenderCanvas class methodsFor: 'instance creation' stamp: 'avi 6/13/2004 00:59'!
context: aRenderingContext callbacks: aCallbackStore
	^ self basicNew initializeWithContext: aRenderingContext callbacks: aCallbackStore! !

!WARenderCanvas methodsFor: 'form' stamp: 'MAD 8/30/2008 12:35'!
basicForm
	^ self brush: WABasicFormTag new! !

!WARenderCanvas methodsFor: 'form-buttons' stamp: 'lr 10/28/2007 14:42'!
button
	^ self brush: WAButtonTag new! !

!WARenderCanvas methodsFor: 'form-buttons' stamp: 'lr 4/11/2008 09:03'!
button: anObject
	^ self button with: anObject! !

!WARenderCanvas methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
callbacks
	"Answer the callback registry."

	^ callbacks! !

!WARenderCanvas methodsFor: 'form-buttons' stamp: 'lr 10/28/2007 14:42'!
cancelButton
	^ self brush: WACancelButtonTag new! !

!WARenderCanvas methodsFor: 'form-buttons' stamp: 'lr 4/11/2008 09:04'!
cancelButton: anObject
	^ self cancelButton with: anObject! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'lr 10/28/2007 14:42'!
checkbox
	^ self brush: WACheckboxTag new! !

!WARenderCanvas methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
context
	"Answer the rendering context."

	^ context! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'mb 2/6/2006 10:09'!
dateInput
	^ self brush: WADateInput new! !

!WARenderCanvas methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
document
	"Answer the XHTML document."

	^ self context document! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'lr 10/28/2007 14:42'!
fileUpload
	^ self brush: WAFileUploadTag new! !

!WARenderCanvas methodsFor: 'form' stamp: 'MAD 8/30/2008 12:30'!
form
	^ self brush: WAFormTag new! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'lr 10/28/2007 14:42'!
hiddenInput
	^ self brush: WAHiddenInputTag new! !

!WARenderCanvas methodsFor: 'form-buttons' stamp: 'lr 10/28/2007 14:42'!
imageButton
	^ self brush: WAImageButtonTag new! !

!WARenderCanvas methodsFor: 'form-buttons' stamp: 'lr 4/11/2008 09:04'!
imageButton: anObject
	^ self imageButton with: anObject! !

!WARenderCanvas methodsFor: 'initialize-release' stamp: 'avi 6/13/2004 01:01'!
initializeWithContext: aRenderingContext callbacks: aCallbackStore
	context := aRenderingContext.
	callbacks := aCallbackStore! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'lr 10/28/2007 14:42'!
multiSelect
	^ self brush: WAMultiSelectTag new! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'lr 6/6/2007 18:00'!
multiSelect: aBlock
	^ self multiSelect with: aBlock! !

!WARenderCanvas methodsFor: 'public' stamp: 'lr 3/28/2006 20:16'!
nextId
	^ 'id' , context advanceKey! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'lr 10/28/2007 14:42'!
option
	^ self brush: WAOptionTag new! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'ac 3/17/2005 17:14'!
option: aBlock
	^ self option with: aBlock! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'lr 10/28/2007 14:42'!
optionGroup
	^ self brush: WAOptionGroupTag new! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'pmm 4/24/2007 10:52'!
optionGroup: aBlock
	^ self optionGroup with: aBlock! !

!WARenderCanvas methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
painter
	"Answer the component that is supposed to paint this canvas."

	^ callbacks owner! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'lr 10/28/2007 14:42'!
passwordInput
	^ self brush: WAPasswordInputTag new! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'lr 4/11/2008 09:16'!
passwordInput: anObject
	^ self passwordInput with: anObject! !

!WARenderCanvas methodsFor: 'public' stamp: 'mb 3/31/2006 11:38'!
peekNextId
	^ 'id' , context nextKey! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'lr 10/28/2007 14:42'!
radioButton
	^ self brush: WARadioButtonTag new! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'ac 7/6/2005 10:46'!
radioButton: aBlock
	^ self radioButton with: aBlock! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'ac 7/6/2005 11:29'!
radioGroup
	^ WARadioGroup canvas: self! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'ac 7/6/2005 10:44'!
radioGroup: aBlock
	^ aBlock value: self radioGroup! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'lr 10/28/2007 14:42'!
select
	^ self brush: WASelectTag new! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'pmm 4/24/2007 11:07'!
select: aBlock
	^ self select with: aBlock! !

!WARenderCanvas methodsFor: 'form-buttons' stamp: 'lr 10/28/2007 14:42'!
submitButton
	^ self brush: WASubmitButtonTag new! !

!WARenderCanvas methodsFor: 'form-buttons' stamp: 'lr 4/11/2008 09:05'!
submitButton: anObject
	^ self submitButton with: anObject! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'ac 3/22/2005 17:50'!
textArea
	^ self brush: WATextAreaTag new! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'lr 4/11/2008 09:05'!
textArea: anObject
	^ self textArea with: anObject! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'lr 4/9/2007 17:20'!
textInput
	^ self brush: WATextInputTag new! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'lr 4/11/2008 09:06'!
textInput: anObject
	^ self textInput with: anObject! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'mb 2/6/2006 10:10'!
timeInput
	^ self brush: WATimeInput new! !

!WARenderCanvas methodsFor: 'public' stamp: 'lr 5/23/2007 19:57'!
urlForAction: aBlock
	"Answer an action URL that will evaluate aBlock when beeing requested."

	^ self context actionUrl withParameter: (self callbacks registerActionCallback: aBlock)! !

WAHtmlCanvas subclass: #WAStaticHtmlCanvas
	instanceVariableNames: 'document'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas'!

!WAStaticHtmlCanvas commentStamp: 'pmm 4/15/2007 22:10' prior: 0!
This canvas can be used to generate static/RESTful HTML pages.!

!WAStaticHtmlCanvas methodsFor: 'accessing' stamp: 'avi 9/10/2005 17:20'!
document
	^ document! !

!WAStaticHtmlCanvas methodsFor: 'accessing' stamp: 'ac 6/9/2006 12:42'!
document: aDocument
	document := aDocument! !

!WAStaticHtmlCanvas methodsFor: 'initialize-release' stamp: 'avi 9/10/2005 17:20'!
initializeWithDocument: aDocument
	document := aDocument! !

!WAStaticHtmlCanvas methodsFor: 'form-elements' stamp: 'ac 6/10/2006 18:52'!
textArea
	^ self brush: WATextAreaTag new! !

Object subclass: #WAClosingConditionalComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WAClosingConditionalComment commentStamp: 'pmm 1/28/2008 07:07' prior: 0!
Closes a WAConditionalComment.!

!WAClosingConditionalComment methodsFor: 'printing' stamp: 'lr 3/27/2007 11:37'!
encodeOn: aDocument
	aDocument nextPutAll: '<!![endif]-->'! !

Object subclass: #WAClosingRevealedConditionalComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WAClosingRevealedConditionalComment commentStamp: 'pmm 1/28/2008 07:07' prior: 0!
Closes a WARevealedConditionalComment.!

!WAClosingRevealedConditionalComment methodsFor: 'printing' stamp: 'pmm 11/25/2007 21:55'!
encodeOn: aDocument
	aDocument nextPutAll: '<!!--<!![endif]-->'! !

Object subclass: #WACodec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document'!

!WACodec commentStamp: 'pmm 5/9/2008 19:40' prior: 0!
A WACodec is the abstract base class for all codecs. Codecs convert strings from and to a given encoding.
!

!WACodec class methodsFor: 'instance creation' stamp: 'pmm 8/5/2008 22:59'!
forEncoding: aStringOrNil
	"valid values for aStringOrNil are:
	nil
		switches off all encoding, like WAKom
	aString
		any other encoding supported by the dialect"
	aStringOrNil isNil ifTrue: [
		^WANullCodec new ].
	^SeasidePlatformSupport genericCodecClass newForEncoding: aStringOrNil! !

!WACodec methodsFor: 'decoding' stamp: 'pmm 8/5/2008 22:56'!
decode: aString
	"decodes aString in the encoding of the receiver to the native encoding of this dialect"
	self subclassResponsibility! !

!WACodec methodsFor: 'decoding' stamp: 'pmm 5/10/2008 10:51'!
decodeUrl: aString
	"decodes an URL encoded string, percend decoding was already happened
	in general will do only utf-8 decoding
	http://www.w3.org/International/O-URL-code.html"
	self subclassResponsibility! !

!WACodec methodsFor: 'encoding' stamp: 'pmm 8/5/2008 22:56'!
encode: aString
	"decodes aString in the native encoding of this dialect to the encoding of the receiver"
	self subclassResponsibility! !

!WACodec methodsFor: 'encoding' stamp: 'pmm 5/10/2008 11:19'!
encodeUrl: aString
	"encodes a string to URL encoding, percend encoding will happen later
	in general will do only utf-8 encoding
	http://www.w3.org/International/O-URL-code.html"
	self subclassResponsibility! !

!WACodec methodsFor: 'testing' stamp: 'pmm 5/9/2008 19:38'!
usesSmalltalkEncoding
	"see WARequestContext >> #usesSmalltalkEncoding"
	^true! !

WACodec subclass: #WANullCodec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document'!

!WANullCodec commentStamp: 'pmm 5/9/2008 19:39' prior: 0!
A WANullCodec does not do any encoding at all.!

!WANullCodec methodsFor: 'decoding' stamp: 'pmm 9/30/2007 01:07'!
decode: aString
	^aString! !

!WANullCodec methodsFor: 'decoding' stamp: 'pmm 11/20/2007 10:17'!
decodeUrl: aString
	^aString! !

!WANullCodec methodsFor: 'encoding' stamp: 'pmm 9/30/2007 01:07'!
encode: aString
	^aString! !

!WANullCodec methodsFor: 'encoding' stamp: 'obi 5/27/2008 20:21'!
encodeUrl: aString
	^aString! !

!WANullCodec methodsFor: 'testing' stamp: 'pmm 5/9/2008 19:38'!
usesSmalltalkEncoding
	"see WARequestContext >> #usesSmalltalkEncoding"
	^false! !

Object subclass: #WAConditionalComment
	instanceVariableNames: 'condition root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WAConditionalComment commentStamp: 'pmm 1/28/2008 07:06' prior: 0!
A WAConditionalComment is an implementation of Downlevel-hidden Conditional Comments:
http://msdn2.microsoft.com/en-us/library/ms537512.aspx
These are only visible for the IE family of browsers.

See also WAOpeningConditionalComment and WAClosingConditionalComment.!

!WAConditionalComment class methodsFor: 'instance creation' stamp: 'pmm 10/11/2006 17:37'!
root: anHtmlRoot
	^self new initializeWithRoot: anHtmlRoot! !

!WAConditionalComment methodsFor: 'private' stamp: 'lr 3/27/2007 11:36'!
addToCondition: aString
	condition := condition , aString! !

!WAConditionalComment methodsFor: 'private' stamp: 'pmm 11/25/2007 21:51'!
closingConditionClass
	^WAClosingConditionalComment! !

!WAConditionalComment methodsFor: 'public' stamp: 'pmm 11/25/2007 21:51'!
do: aBlock
	root add: (self openingConditionClass condition: condition).
	aBlock value.
	root add: (self closingConditionClass new)! !

!WAConditionalComment methodsFor: 'operators' stamp: 'pmm 10/11/2006 17:19'!
equal
	"implicit of nothing else"! !

!WAConditionalComment methodsFor: 'operators' stamp: 'pmm 10/11/2006 17:14'!
greaterThan
	self addToCondition: ' gt'! !

!WAConditionalComment methodsFor: 'features' stamp: 'pmm 10/11/2006 17:16'!
ie
	self addToCondition: ' IE'! !

!WAConditionalComment methodsFor: 'features' stamp: 'pmm 10/11/2006 17:16'!
ie5
	self addToCondition: ' IE 5'! !

!WAConditionalComment methodsFor: 'features' stamp: 'pmm 10/11/2006 17:16'!
ie50
	self addToCondition: ' IE 5.0'! !

!WAConditionalComment methodsFor: 'features' stamp: 'pmm 10/11/2006 17:16'!
ie55
	self addToCondition: ' IE 5.5'! !

!WAConditionalComment methodsFor: 'features' stamp: 'pmm 10/11/2006 17:16'!
ie6
	self addToCondition: ' IE 6'! !

!WAConditionalComment methodsFor: 'features' stamp: 'pmm 10/11/2006 17:16'!
ie7
	self addToCondition: ' IE 7'! !

!WAConditionalComment methodsFor: 'initialization' stamp: 'pmm 10/11/2006 17:36'!
initializeWithRoot: anHtmlRoot
	root := anHtmlRoot.
	condition := 'if'! !

!WAConditionalComment methodsFor: 'operators' stamp: 'pmm 10/11/2006 17:15'!
lessThan
	self addToCondition: ' lt'! !

!WAConditionalComment methodsFor: 'operators' stamp: 'tbn 11/21/2007 12:41'!
not
	self addToCondition: ' !!'! !

!WAConditionalComment methodsFor: 'private' stamp: 'pmm 11/25/2007 21:51'!
openingConditionClass
	^WAOpeningConditionalComment! !

!WAConditionalComment methodsFor: 'operators' stamp: 'pmm 10/19/2006 20:19'!
orEqual
	self addToCondition: 'e'! !

WAConditionalComment subclass: #WARevealedConditionalComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WARevealedConditionalComment commentStamp: 'pmm 1/28/2008 07:07' prior: 0!
A WAConditionalComment is an implementation of Downlevel-revealed Conditional Comments:
http://msdn2.microsoft.com/en-us/library/ms537512.aspx
Non-IE family browsers see them always.

See also WAOpeningRevealedConditionalComment and WARevealedConditionalComment.!

!WARevealedConditionalComment methodsFor: 'private' stamp: 'pmm 11/25/2007 21:55'!
closingConditionClass
	^WAClosingRevealedConditionalComment! !

!WARevealedConditionalComment methodsFor: 'private' stamp: 'pmm 11/25/2007 21:55'!
openingConditionClass
	^WAOpeningRevealedConditionalComment! !

Object subclass: #WAConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WAConfiguration commentStamp: 'jf 7/24/2008 19:44' prior: 0!
A configuration for a Seaside application contains attributes which can be used by Seaside and the application. WAConfiguration hierarchy uses the composite pattern.

Subclasses of WASystemConfiguration define and configure related groups of attributes. See WASystemConfiguration class comment for information on defining your own attributes.

WAUserConfiguration is a composite of configurations. The set of configurations contained in WAUserConfiguration is called the ancestors. Attribute values in a configuration override the attribute values in the ancestors. WAUserConfiguration also holds the non-default values of attributes.

Seaside applications start with a WAUserConfiguration (see WAApplication>>configuration) a single parent: WARenderLoopConfiguration. The full ancestry also includes WASessionConfiguration WAGlobalConfiguration. Other configurations can be added to an application on the Seaside configuration page for the application or in your application. Values for the attributes can be given in either location. 

See Seaside documentation (http://www.seaside.st/documentation) on configuration and preferences (http://www.seaside.st/documentation/Configuration%20and%20Preferences) for more information.

Example of setting attributes and adding configurations in code
ASubclassOfWAComponent class>>initialize
	"self initialize"
	| application |
	application := self registerAsApplication: 'GlorpExample'.
	"set a standard attribute"
	application preferenceAt: #sessionClass put: Glorp.WAGlorpSession. 

	"add a configuration"
	application configuration addParent: GlorpConfiguration new.
	application preferenceAt: #databaseLogin put: 'foo'. "set attribute defined in GlorpConfiguration"

Subclasses must implement the following messages:
	name
		return the name of the configuration

	localValueAt:ifAbsent:
		return the value of the attribute given as first argument!

!WAConfiguration class methodsFor: 'instance creation' stamp: 'avi 1/30/2004 16:39'!
new
	^ self basicNew initialize! !

!WAConfiguration methodsFor: 'attributes' stamp: 'jf 7/29/2008 18:39'!
allAttributes
	| attributes |
	attributes := IdentityDictionary new.
	
	self ancestorsDo: 
		[ :each |
		each canDefineAttributes ifTrue: [ attributes addAll: each attributes ] ].
	
	^ attributes! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'jf 7/24/2008 19:22'!
ancestors
	"As it happens, the 'seen' set gives us the result we need"
	| set |
	set := IdentitySet new.
	self 
		ancestorsDo: 
			[ :each | 
			"nothing"
			 ]
		seen: set.
	^ set! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'jf 7/24/2008 19:22'!
ancestorsDo: aBlock 
	| set |
	set := IdentitySet new.
	self 
		ancestorsDo: aBlock
		seen: set.
	^ set! !

!WAConfiguration methodsFor: 'ancestry-private' stamp: 'jf 7/24/2008 19:22'!
ancestorsDo: aBlock seen: seenSet 
	self parents do: 
		[ :each | 
		(seenSet includes: each) ifFalse: 
			[ aBlock value: each.
			seenSet add: each.
			each 
				ancestorsDo: aBlock
				seen: seenSet ] ]! !

!WAConfiguration methodsFor: 'attributes' stamp: 'jf 7/19/2008 14:47'!
attributeAt: aSymbol
	^ self attributeAt: aSymbol ifAbsent: [ self error: 'No attribute named ', aSymbol printString ]! !

!WAConfiguration methodsFor: 'attributes' stamp: 'jf 7/29/2008 18:40'!
attributeAt: aSymbol ifAbsent: aBlock
	^ self allAttributes at: aSymbol ifAbsent: aBlock! !

!WAConfiguration methodsFor: 'attributes' stamp: 'jf 7/19/2008 15:26'!
canDefineAttributes
	^ false! !

!WAConfiguration methodsFor: 'values' stamp: 'jf 8/4/2008 16:07'!
expressionAt: aSymbol ifAbsent: absentBlock
	self subclassResponsibility! !

!WAConfiguration methodsFor: 'values' stamp: 'jf 8/4/2008 16:09'!
expressionAt: aSymbol ifPresent: aBlock
	| expression |
	expression := self expressionAt: aSymbol ifAbsent: [ ^ nil ].
	^ aBlock value: expression! !

!WAConfiguration methodsFor: 'values-private' stamp: 'jf 8/4/2008 15:26'!
inheritedValueAt: aSymbol context: aContext
	| value |
	(self parents select: [ :each | aContext isAttributeInheritedBy: each ]) reverseDo:
		[ :each |
		value := each valueAt: aSymbol context: aContext.
		value notNil ifTrue: [ ^ value ] ].
	
	^ nil! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'jf 7/24/2008 19:16'!
inheritsFrom: aConfiguration 
	^ self ancestors includes: aConfiguration! !

!WAConfiguration methodsFor: 'initializing' stamp: 'lr 10/28/2007 14:42'!
initialize! !

!WAConfiguration methodsFor: 'accessing' stamp: 'dkh 2/29/2008 10:48'!
name

	^self class name! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'jf 7/24/2008 19:10'!
parents
	^ #()! !

!WAConfiguration methodsFor: 'values' stamp: 'jf 8/26/2008 14:57'!
valueAt: aSymbol 
	| value context |
	context := WAAttributeContext key: aSymbol target: self.

	context attribute isNil ifTrue: [ ^ WAAttributeNotFound new key: aSymbol; signal ].

	value := self valueAt: aSymbol context: context.
	
	^ value isNil
		ifTrue: [ context attribute default ]
		ifFalse: [ value ]! !

!WAConfiguration methodsFor: 'values-private' stamp: 'jf 8/4/2008 16:10'!
valueAt: aSymbol context: aContext
	aContext at: self ifPresent: [ :v | ^ v ].
	
	(aContext attribute configuration == self) ifTrue: [ ^ aContext at: self put: nil ].
	
	self expressionAt: aContext key ifPresent:
		[ :expression |
		^ aContext
			at: self
			put: (expression determineValueWithContext: aContext) ].
		
	^ aContext at: self put: (self inheritedValueAt: aSymbol context: aContext)! !

WAConfiguration subclass: #WASystemConfiguration
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

WASystemConfiguration class
	instanceVariableNames: 'instance'!

!WASystemConfiguration commentStamp: 'jf 7/24/2008 19:44' prior: 0!
You should subclass WASystemConfiguration to define new attributes. The method #addAttributes is passed an instance of WAAttributes which can be used to create new attributes. The attributes can be configured to specify their default value, label, and so on. See the methods on WAConfigurationAttribute and its subclasses to see what options are available.

If a configuration needs to override the value of another WASystemConfiguration or depends on its attributes, implement the method "parents", returning a collection of configuration objects.

WASystemConfiguration subclasses are "read-only" in that their attributes, parents, and default values are all specified in code. Users and applications that want to configure values for attributes should create a WAUserConfiguration and specify the WASystemConfiguration in its ancestry.

WASystemConfiguration classes are singleton. You should use #instance on the class side to get the current instance. You cannot call #copy on a WASystemConfiguration.

Subclasses should implement the following messages:
	addAttributes:
		
They may also want to implement:
	addOverrides:
	parents!

WASystemConfiguration class
	instanceVariableNames: 'instance'!

WASystemConfiguration subclass: #WAApplicationConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Session'!

!WAApplicationConfiguration commentStamp: 'jf 7/22/2008 12:40' prior: 0!
WAApplicationConfiguration defines attributes required by WAApplication. All applications should include this configuration (this is done by default for new applications).

See #addAttributes: for details on provided attributes.!

!WAApplicationConfiguration methodsFor: 'description' stamp: 'jf 7/31/2008 12:23'!
describeOn: config
	(config string: #charSet)
		comment: 'The character set reported to the browser. You may additionally need to configure your server that this is also the character set used by your server.';
		default: WAResponse defaultValueForCharSet.
	(config collection: #libraries)
		options: [self libraryClasses];
		default: (Set with: WAStandardFiles).
	(config string: #mimeType)
		comment: 'the Internet media type of HTML documents reported to the browser';
		default: WAResponse defaultValueForMimeType.
	(config string: #resourceBaseUrl)
		group: #server;
		comment: 'Sets the base URL for URLS generated with #resourceUrl:'.
	(config list: #sessionClass)
		comment: 'Sessions in this application will be instances of this class.';
		options: [self sessionClasses];
		default: WASession.
! !

!WAApplicationConfiguration methodsFor: 'description' stamp: 'jf 7/22/2008 12:00'!
libraryClasses
	^ WALibrary allSubclasses asSortedCollection: [ :a :b | a name <= b name ]! !

!WAApplicationConfiguration methodsFor: 'ancestry' stamp: 'jf 7/29/2008 12:28'!
parents
	^ Array with: WARequestHandlingConfiguration instance! !

!WAApplicationConfiguration methodsFor: 'description' stamp: 'jf 7/22/2008 12:00'!
sessionClasses
	^ WASession withAllSubclasses asSortedCollection: [ :a :b | a name <= b name ]! !

WASystemConfiguration subclass: #WAAuthConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RenderLoop'!

!WAAuthConfiguration commentStamp: 'jf 7/22/2008 12:39' prior: 0!
WAAuthConfiguration defines attributes to store a username and password for an application. It is used by WAApplication to provide a basic single-account authentication mechanism for applications like the Seaside Configuration application. It changes to mainClass for the session to WAAuthMain, which adds a Decoration to check for authentication before displaying the root component.

You can implement your own authentication mechanism without using this configuration by subclassing WAApplication and implementing #verifyPassword:forUser: to lookup account details from a database or similar. You can then manually set WAAuthMain as your main class.
!

!WAAuthConfiguration methodsFor: 'description' stamp: 'jf 7/29/2008 18:01'!
describeOn: config
	(config string: #login)
		group: #authentication;
		comment: 'The username for this application.'.
	(config password: #passwordHash)
		group: #authentication;
		comment: 'The password for this application.';
		label: 'Password'.
	config at: #mainClass put: WAAuthMain.! !

!WAAuthConfiguration methodsFor: 'ancestry' stamp: 'jf 7/24/2008 19:10'!
parents
	"Our configuration only depends on attributes from WASessionConfiguration. Currently, however, the only thing that drive WAApplication to use our attributes is WAAuthMain, which is a subclass of WARenderLoopMain. Therefore, we require the renderloop configuration for convenience. This could be changed at some point if authentication was made more pluggable so it did not depend on the render loop."
	^ Array with: WARenderLoopConfiguration instance! !

WASystemConfiguration subclass: #WARenderLoopConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RenderLoop'!

!WARenderLoopConfiguration commentStamp: 'jf 7/22/2008 12:32' prior: 0!
WARenderLoopConfiguration defines attributes required by the Render Loop classes (see the Seaside-Core-RenderLoop category). Any application using these classes (e.g. WARenderLoopMain) should include this configuration (this is done by default for new applications).

See #addAttributes: for details on provided attributes.!

!WARenderLoopConfiguration methodsFor: 'description' stamp: 'jf 7/22/2008 12:00'!
allDecorationClasses
	^ WADecoration allSubclasses asSortedCollection: [ :a :b | a name < b name ]! !

!WARenderLoopConfiguration methodsFor: 'description' stamp: 'jf 7/31/2008 12:23'!
describeOn: config
	(config collection: #decorationClasses)
		options: [self allDecorationClasses].
	(config list: #redirectContinuationClass)
		options: [self redirectContinuationClasses];
		default: WARedirectContinuation.
	(config list: #renderContinuationClass)
		options: [self renderContinuationClasses];
		default: WARenderContinuation.
	(config list: #rootClass)
		comment: 'The root component of this seaside application.';
		options: [self rootClasses].
		
	config
		at: #mainClass put: WARenderLoopMain;
		at: #errorHandler put: WASimpleErrorHandler.
! !

!WARenderLoopConfiguration methodsFor: 'ancestry' stamp: 'jf 7/24/2008 19:10'!
parents
	"We override several attributes of the session configuration."
	^ Array with: WASessionConfiguration instance! !

!WARenderLoopConfiguration methodsFor: 'description' stamp: 'pmm 8/1/2008 12:09'!
redirectContinuationClasses
	^ WARedirectContinuation withAllSubclasses asSortedCollection: [ :a :b | a name <= b name ]! !

!WARenderLoopConfiguration methodsFor: 'description' stamp: 'pmm 8/1/2008 12:09'!
renderContinuationClasses
	^ WARenderContinuation withAllSubclasses asSortedCollection: [ :a :b | a name <= b name ]! !

!WARenderLoopConfiguration methodsFor: 'description' stamp: 'jf 7/29/2008 14:30'!
rootClasses
	^ (WAComponent allSubclasses select: [ :each | each canBeRoot ])
		asSortedCollection: [ :a :b | a name <= b name ]! !

WASystemConfiguration subclass: #WARequestHandlingConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandler'!

!WARequestHandlingConfiguration commentStamp: 'jf 7/24/2008 22:37' prior: 0!
This configuration class holds attributes needed by classes in the Request Handling layer.!

!WARequestHandlingConfiguration methodsFor: 'description' stamp: 'jf 8/5/2008 11:23'!
describeOn: config
	(config list: #documentClass)
		options: [self documentClasses];
		default: WAHtmlStreamDocument.
	(config list: #expiredKeyHandlerClass)
		options: [self expiredKeyHandlerClasses];
		default: WAExpiredKeyHandler.
	(config list: #notFoundHandlerClass)
		options: [self notFoundHandlerClasses];
		default: WANotFoundHandler.
	(config list: #redirectHandlerClass)
		options: [self redirectHandlerClasses];
		default: WARedirectHandler.
	(config list: #serverProtocol)
		group: #server;
		comment: 'The protocol in URLs generated by Seaside.';
		options: [#(http https)].
	(config string: #serverHostname)
		group: #server;
		comment: 'The hostname in URLs generated by Seaside.'.
	(config number: #serverPort)
		group: #server;
		comment: 'The port in URLs generated by Seaside.'.
	(config string: #serverPath)
		group: #server;
		comment: 'The path in URLs generated by Seaside.'.! !

!WARequestHandlingConfiguration methodsFor: 'description' stamp: 'jf 8/5/2008 10:33'!
documentClasses
	^ WAHtmlStreamDocument withAllSubclasses asSortedCollection: [ :a :b | a name <= b name ]! !

!WARequestHandlingConfiguration methodsFor: 'description' stamp: 'jf 8/5/2008 11:24'!
expiredKeyHandlerClasses
	^ WAExpiredKeyHandler withAllSubclasses asSortedCollection: [ :a :b | a name <= b name ]! !

!WARequestHandlingConfiguration methodsFor: 'description' stamp: 'pmm 8/1/2008 12:10'!
notFoundHandlerClasses
	^ WANotFoundHandler withAllSubclasses asSortedCollection: [ :a :b | a name <= b name ]! !

!WARequestHandlingConfiguration methodsFor: 'description' stamp: 'pmm 8/1/2008 12:10'!
redirectHandlerClasses
	^ WARedirectHandler withAllSubclasses asSortedCollection: [ :a :b | a name <= b name ]! !

WASystemConfiguration subclass: #WASessionConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Session'!

!WASessionConfiguration commentStamp: 'jf 7/22/2008 12:30' prior: 0!
WASessionConfiguration defines attributes required by WASession and its subclasses. Any application using a WASession should include this configuration (this is done by default for new applications).

See #addAttributes: for details on provided attributes.!

!WASessionConfiguration methodsFor: 'description' stamp: 'jf 8/5/2008 11:36'!
describeOn: config
	(config list: #errorHandler)
		options: [self errorHandlerClasses];
		default: WASimpleErrorHandler.
	(config list: #mainClass)
		options: [self mainClasses].
	(config number: #sessionContinuationCacheSize)
		comment: 'The number of continuations to keep cached for each session. Once a continuation has expired, users of the application will be unable to click links, submit forms, or trigger actions on that page.';
		default: 20.
	(config number: #sessionExpirySeconds)
		comment: 'The number of seconds after which inactive sessions are expired.';
		default: 600.
	(config boolean: #useSessionCookie)
		comment: 'Whether the session identifier should be stored in a cookie instead of the URL. Will fall back to URL if the client does not support cookies.';
		default: false.
	(config boolean: #sessionAllowTermination)
		comment: 'Whether sessions allows a special HTTP request to terminate the process currently running in the session. This is used during development and should be disabled for deployment.';
		default: false.
		
	config at: #expiredKeyHandlerClass put: WAExpiredSessionKeyHandler.! !

!WASessionConfiguration methodsFor: 'description' stamp: 'lr 11/18/2007 15:18'!
errorHandlerClasses
	^ WAErrorHandler withAllSubclasses asSortedCollection: [ :a :b | a name <= b name ]! !

!WASessionConfiguration methodsFor: 'description' stamp: 'lr 11/18/2007 15:18'!
mainClasses
	^ WAMain allSubclasses asSortedCollection: [ :a :b | a name <= b name ]! !

!WASessionConfiguration methodsFor: 'ancestry' stamp: 'jf 8/5/2008 08:49'!
parents
	^ Array with: WARequestHandlingConfiguration instance! !

!WASystemConfiguration class methodsFor: 'as yet unclassified' stamp: 'jf 7/29/2008 18:48'!
clearAllDescriptions
	self allSubInstances do: [ :each | each clearDescription ]! !

!WASystemConfiguration class methodsFor: 'accessing' stamp: 'lr 5/3/2006 09:44'!
instance
	^ instance ifNil: [ instance := self basicNew initialize ]! !

!WASystemConfiguration class methodsFor: 'instance creation' stamp: 'jf 7/18/2008 17:10'!
new
	^ self error: 'SystemConfigurations are singletons. Use #instance.'! !

!WASystemConfiguration methodsFor: 'attributes' stamp: 'jf 7/29/2008 18:36'!
attributes
	^ self description attributes! !

!WASystemConfiguration methodsFor: 'description' stamp: 'jf 7/29/2008 18:57'!
buildDescription
	| d |
	d := WAConfigurationDescription new.
	d configuration: self.
	self describeOn: d.
	^ description := d! !

!WASystemConfiguration methodsFor: 'attributes' stamp: 'jf 7/19/2008 15:26'!
canDefineAttributes
	^ true! !

!WASystemConfiguration methodsFor: 'description' stamp: 'jf 7/29/2008 18:56'!
clearDescription
	description := nil! !

!WASystemConfiguration methodsFor: 'copying' stamp: 'jf 7/18/2008 17:10'!
copy
	^ self error: 'SystemConfigurations are singletons and should not be copied.'! !

!WASystemConfiguration methodsFor: 'description' stamp: 'jf 7/29/2008 17:55'!
describeOn: conf
	"Should be implemented by subclasses to add attributes and value overrides to the configuration"! !

!WASystemConfiguration methodsFor: 'accessing' stamp: 'jf 7/29/2008 18:56'!
description
	^ description isNil 
		ifFalse: [ description ]
		ifTrue: [ self buildDescription ]! !

!WASystemConfiguration methodsFor: 'values' stamp: 'jf 8/4/2008 16:08'!
expressionAt: aSymbol ifAbsent: absentBlock
	^ self description values at: aSymbol ifAbsent: absentBlock.! !

!WASystemConfiguration methodsFor: 'attributes' stamp: 'jf 7/29/2008 18:37'!
localAttributeAt: aSymbol ifPresent: absentBlock
	^ self attributes at: aSymbol ifPresent: absentBlock! !

WAConfiguration subclass: #WAUserConfiguration
	instanceVariableNames: 'expressions parents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WAUserConfiguration commentStamp: 'jf 7/24/2008 19:45' prior: 0!
WAUserConfiguration is a composite of configurations.  This composite of configurations is stored in the field "parents". WAUserConfiguration provides methods to dynamically provide non-default values for attributes. WAUserConfiguration inherits attributes and values defined in its ancestors. If WAUserConfiguration does not have a value for an attribute it will search its ancestors for a value, stopping when it finds a value.

An instance of WAUserConfiguration is the first configuration added to a Seaside application (WAApplication). All other configurations added to the application are added as ancestors of this instance. When a value for an attribute is set either by the standard Seaside component configuration page or in code the value is added to the "values" dictionary in WAUserConfiguration.

Instance Variables:
	parents	<Collection of: WAConfiguration>	 hierarchy of configurations defining all attributes for this instance of WAUserConfiguration
	values	<Dictionary>	the dictionary key is an attribute key, dictionary value is value of that attribute 
!

WAUserConfiguration subclass: #WASharedConfiguration
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

WASharedConfiguration class
	instanceVariableNames: 'instances'!

WASharedConfiguration class
	instanceVariableNames: 'instances'!

!WASharedConfiguration class methodsFor: 'accessing' stamp: 'jf 7/31/2008 14:37'!
add: aSharedConfiguration
	^ instances add: aSharedConfiguration! !

!WASharedConfiguration class methodsFor: 'accessing' stamp: 'jf 7/31/2008 14:38'!
configurations
	^ instances copy! !

!WASharedConfiguration class methodsFor: 'class initialization' stamp: 'jf 7/31/2008 14:37'!
initialize
	instances := IdentitySet new.! !

!WASharedConfiguration class methodsFor: 'instance creation' stamp: 'jf 7/31/2008 14:39'!
named: aString
	^ self add: (self new name: aString; yourself)! !

!WASharedConfiguration class methodsFor: 'accessing' stamp: 'jf 7/31/2008 14:37'!
remove: aSharedConfiguration
	^ instances remove: aSharedConfiguration! !

!WASharedConfiguration methodsFor: 'accessing' stamp: 'jf 7/31/2008 14:15'!
name
	^ name! !

!WASharedConfiguration methodsFor: 'accessing' stamp: 'jf 7/31/2008 14:15'!
name: anObject
	name := anObject! !

!WAUserConfiguration methodsFor: 'ancestry' stamp: 'jf 7/24/2008 19:47'!
addParent: aConfiguration 
	(self canAddParent: aConfiguration) 
		ifTrue: [ parents add: aConfiguration ]
		ifFalse: 
			[ self error: 'Cannot add this configuration as a parent. Would this cause a circular ancestry graph?' ]! !

!WAUserConfiguration methodsFor: 'ancestry' stamp: 'jf 7/24/2008 19:42'!
canAddParent: aConfiguration 
	^ (aConfiguration = self or: [ aConfiguration inheritsFrom: self ]) not! !

!WAUserConfiguration methodsFor: 'values' stamp: 'jf 8/4/2008 16:17'!
expressionAt: aSymbol ifAbsent: errorBlock
	^ expressions at: aSymbol ifAbsent: errorBlock! !

!WAUserConfiguration methodsFor: 'initialization' stamp: 'jf 8/4/2008 16:17'!
initialize
	super initialize.
	expressions := Dictionary new.
	parents := OrderedCollection new! !

!WAUserConfiguration methodsFor: 'ancestry' stamp: 'lr 8/30/2008 15:36'!
moveParentDown: aConfiguration 
	| index |
	index := parents indexOf: aConfiguration ifAbsent: [ ^ self ].
	index < parents size ifTrue: [ parents swap: index with: index + 1 ]! !

!WAUserConfiguration methodsFor: 'ancestry' stamp: 'lr 8/30/2008 15:36'!
moveParentUp: aConfiguration 
	| index |
	index := parents indexOf: aConfiguration ifAbsent: [ ^ self ].
	index > 1 ifTrue: [ parents swap: index with: index - 1 ]! !

!WAUserConfiguration methodsFor: 'ancestry' stamp: 'jf 7/24/2008 19:47'!
parents
	^ parents! !

!WAUserConfiguration methodsFor: 'copying' stamp: 'jf 8/4/2008 16:18'!
postCopy
	super postCopy.
	expressions := expressions copy.
	parents := parents copy.! !

!WAUserConfiguration methodsFor: 'ancestry' stamp: 'lr 8/30/2008 15:34'!
removeParent: aConfiguration 
	parents 
		remove: aConfiguration
		ifAbsent: [ ]! !

!WAUserConfiguration methodsFor: 'values' stamp: 'jf 8/4/2008 16:17'!
storeExpression: anAttributeExpression forAttribute: anAttribute
	^ expressions at: anAttribute key put: (anAttributeExpression configuration: self; yourself)! !

!WAUserConfiguration methodsFor: 'values' stamp: 'jf 8/4/2008 16:02'!
takeValue: anObject forAttribute: anAttribute
	^ anObject isNil ifFalse: [
		self
			storeExpression:
				((WAValueExpression key: anAttribute key)
					configuration: self;
					value: anObject;
					yourself)
			forAttribute: anAttribute ]! !

!WAUserConfiguration methodsFor: 'values' stamp: 'jf 7/19/2008 20:40'!
takeValueFromString: aString forAttribute: anAttribute
	^ self takeValue: (anAttribute valueFromString: aString) forAttribute: anAttribute! !

!WAUserConfiguration methodsFor: 'values' stamp: 'jf 7/31/2008 13:10'!
valueAt: aSymbol addAll: aCollection
	^ self valueAt: aSymbol addAll: aCollection removeAll: #()! !

!WAUserConfiguration methodsFor: 'values' stamp: 'jf 8/4/2008 16:00'!
valueAt: aSymbol addAll: additions removeAll: removals
	^ self
		storeExpression:
			((WAAddRemoveExpression key: aSymbol)
				additions: additions;
				removals: removals;
				yourself)
		forAttribute: (self attributeAt: aSymbol)! !

!WAUserConfiguration methodsFor: 'values' stamp: 'jf 7/21/2008 09:27'!
valueAt: aSymbol put: anObject
	"It would be faster to simply add the value to the dictionary and
	implement #takeValue:forAttribute: in terms of this method, but
	config options are set only rarely and this ensures you are setting
	a value for an attribute that actually exists."

	^ self takeValue: anObject forAttribute: (self attributeAt: aSymbol)! !

Object subclass: #WAConfigurationDescription
	instanceVariableNames: 'configuration attributes values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WAConfigurationDescription commentStamp: 'jf 7/19/2008 13:33' prior: 0!
I hold a collection of attributes and present methods to construct new methods, providing an interface a bit like WACanvs and #renderContentOn: to WASystemConfiguration>>addAttributes:.

I can use any kind of collection class and handle setting the #configuration: parameter of the attribute appropriately on addition. If my collection is a Dictionary, I will store the attributes by their keys.
!

!WAConfigurationDescription class methodsFor: 'as yet unclassified' stamp: 'jf 7/29/2008 16:51'!
new
	^ self basicNew initialize! !

!WAConfigurationDescription methodsFor: 'private' stamp: 'jf 7/29/2008 16:57'!
add: aDescriptor to: aDictionary
	configuration isNil ifFalse: [ aDescriptor configuration: configuration ].
	^ aDictionary at: aDescriptor key put: aDescriptor! !

!WAConfigurationDescription methodsFor: 'attribute creation' stamp: 'jf 7/29/2008 16:57'!
addAttribute: anAttribute
	^ self add: anAttribute to: attributes! !

!WAConfigurationDescription methodsFor: 'values' stamp: 'jf 7/29/2008 16:58'!
addValue: aValue
	^ self add: aValue to: values! !

!WAConfigurationDescription methodsFor: 'values' stamp: 'jf 7/31/2008 13:11'!
at: aSymbol addAll: aCollection
	self at: aSymbol addAll: aCollection removeAll: #()! !

!WAConfigurationDescription methodsFor: 'values' stamp: 'jf 8/4/2008 14:21'!
at: aSymbol addAll: additions removeAll: removals
	self addValue: ((WAAddRemoveExpression key: aSymbol)
			additions: additions;
			removals: removals;
			yourself)! !

!WAConfigurationDescription methodsFor: 'values' stamp: 'jf 8/4/2008 14:22'!
at: aSymbol put: anObject 
	self addValue: ((WAValueExpression key: aSymbol)
			value: anObject;
			yourself)! !

!WAConfigurationDescription methodsFor: 'accessing' stamp: 'jf 7/29/2008 17:02'!
attributes
	^ attributes! !

!WAConfigurationDescription methodsFor: 'attribute creation' stamp: 'jf 7/29/2008 16:59'!
boolean: aSymbol
	^ self addAttribute: (WABooleanAttribute key: aSymbol)! !

!WAConfigurationDescription methodsFor: 'attribute creation' stamp: 'jf 7/29/2008 17:00'!
collection: aSymbol
	^ self addAttribute: (WACollectionAttribute key: aSymbol)! !

!WAConfigurationDescription methodsFor: 'accessing' stamp: 'jf 7/19/2008 15:40'!
configuration: aConfiguration
	configuration := aConfiguration! !

!WAConfigurationDescription methodsFor: 'initialization' stamp: 'jf 7/29/2008 16:49'!
initialize
	attributes := IdentityDictionary new.
	values := IdentityDictionary new.! !

!WAConfigurationDescription methodsFor: 'attribute creation' stamp: 'jf 7/29/2008 17:00'!
list: aSymbol
	^ self addAttribute: (WAListAttribute key: aSymbol)! !

!WAConfigurationDescription methodsFor: 'attribute creation' stamp: 'jf 7/29/2008 17:00'!
number: aSymbol
	^ self addAttribute: (WANumberAttribute key: aSymbol)! !

!WAConfigurationDescription methodsFor: 'attribute creation' stamp: 'jf 7/29/2008 17:00'!
password: aSymbol
	^ self addAttribute: (WAPasswordAttribute key: aSymbol)! !

!WAConfigurationDescription methodsFor: 'attribute creation' stamp: 'jf 7/29/2008 17:00'!
string: aSymbol
	^ self addAttribute: (WAStringAttribute key: aSymbol)! !

!WAConfigurationDescription methodsFor: 'accessing' stamp: 'jf 7/29/2008 17:19'!
values
	^ values! !

Object subclass: #WAConfigurationElement
	instanceVariableNames: 'configuration key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

WAConfigurationElement subclass: #WAAttributeDescription
	instanceVariableNames: 'group comment label default'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WAAttributeDescription commentStamp: 'jf 7/19/2008 13:54' prior: 0!
WAConfigurationAttribute represents a value of a specified type in a Seaside configuration. Some attributes are needed by Seaside for application parameters like deployment Mode and session timeout. Optional attributes like a database login may be used internally by the application.

Each subclass of WAConfigurationAttribute handles one type (Number, Boolean, etc) of attribute. The "group" of the attribute is used to place all attributes in the same group together on the Seaside configuration page. The "key" of the attribute identifies the attribute. Attribute keys must be globally unique so use namespacing where required to ensure uniqueness. See WAConfiguration for example of accessing a configuration attribute. 

Subclasses may implement their own configuration options depending on their needs.

Subclasses must implement the following messages:
	valueFromString: aString
		convert "aString" into type represented by the class, return result of the conversion
	
	accept: aVisitor with: anObject
		Typical implementation is:
			aVisitor visitXXXAttribute: self with: anObject

		where XXX is the type of this attribute. The method visitXXXAttribute:with: must be implemented in all visitors, in particular WAConfigurationEditor which creates the configuration page for Seaside applications.

Instance Variables:
	configuration	<WAConfiguration>	The configuration object that defined the attribute
	group	<Symbol>	name of the group the attribute belongs to
	key	<Symbol>	key or name of the attribute, used to look up the attribute
	comment	<String> a full length description of the attribute for displaying in the configuration interface
	label	<String>	a short field label used in the user interface. If not specified, a label is constructed from the key.
	default	<Object>	The default value for the attribute.!

!WAAttributeDescription methodsFor: 'visiting' stamp: 'lr 10/28/2007 14:42'!
accept: aVisitor with: anObject
	self subclassResponsibility! !

!WAAttributeDescription methodsFor: 'accessing' stamp: 'pmm 12/9/2007 12:10'!
comment
	^ comment! !

!WAAttributeDescription methodsFor: 'accessing' stamp: 'jf 7/16/2008 16:46'!
comment: aString
	comment := aString! !

!WAAttributeDescription methodsFor: 'accessing' stamp: 'jf 7/18/2008 15:33'!
default
	^ default! !

!WAAttributeDescription methodsFor: 'accessing' stamp: 'jf 7/18/2008 15:32'!
default: anObject
	default := anObject! !

!WAAttributeDescription methodsFor: 'accessing' stamp: 'avi 2/5/2004 13:21'!
group
	^ group ifNil: [#general]! !

!WAAttributeDescription methodsFor: 'accessing' stamp: 'jf 7/16/2008 16:46'!
group: aSymbol
	group := aSymbol! !

!WAAttributeDescription methodsFor: 'accessing' stamp: 'jf 7/18/2008 18:11'!
label
	^ label ifNil: [self labelForSelector: self key] ! !

!WAAttributeDescription methodsFor: 'accessing' stamp: 'jf 7/18/2008 18:10'!
label: aString
	label := aString! !

!WAAttributeDescription methodsFor: 'converting' stamp: 'lr 8/30/2008 16:22'!
stringForValue: anObject 
	^ anObject seasideString! !

!WAAttributeDescription methodsFor: 'converting' stamp: 'lr 10/28/2007 14:42'!
valueFromString: aString
	self subclassResponsibility! !

WAAttributeDescription subclass: #WABooleanAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WABooleanAttribute commentStamp: 'rew 10/7/2007 12:49' prior: 0!
WABooleanAttribute  represents a boolean attribute. It converts between text entered on the configuration page and boolean values.!

!WABooleanAttribute methodsFor: 'visiting' stamp: 'lr 1/3/2008 17:22'!
accept: aVisitor with: anObject
	aVisitor visitBooleanAttribute: self with: anObject! !

!WABooleanAttribute methodsFor: 'converting' stamp: 'lr 10/28/2007 14:42'!
valueFromString: aString
	^ aString = 'true'
		ifTrue: [true]
		ifFalse: [aString = 'false'
				 ifTrue: [false]
				 ifFalse: [self error: 'Invalid value for boolean attribute']]! !

WAAttributeDescription subclass: #WAListAttribute
	instanceVariableNames: 'optionsBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WAListAttribute commentStamp: 'jf 7/19/2008 13:55' prior: 0!
WAListAttribute is an attribute that is restricted to a list of values. 

Instance Variables:
	options	<Block>	A block returning a list of possible values for the attribute!

WAListAttribute subclass: #WACollectionAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WACollectionAttribute methodsFor: 'visiting' stamp: 'lr 1/3/2008 17:22'!
accept: aVisitor with: anObject
	aVisitor visitCollectionAttribute: self with: anObject! !

!WACollectionAttribute methodsFor: 'initialization' stamp: 'jf 7/31/2008 11:40'!
initializeWithKey: aSymbol
	super initializeWithKey: aSymbol.
	default := Set new.! !

!WAListAttribute methodsFor: 'visiting' stamp: 'lr 1/3/2008 17:22'!
accept: aVisitor with: anObject
	aVisitor visitListAttribute: self with: anObject! !

!WAListAttribute methodsFor: 'accessing' stamp: 'jf 7/18/2008 20:16'!
options
	^ optionsBlock isNil
		ifTrue: [#()]
		ifFalse: optionsBlock! !

!WAListAttribute methodsFor: 'accessing' stamp: 'jf 7/18/2008 20:19'!
options: aBlock
	optionsBlock := aBlock! !

!WAListAttribute methodsFor: 'converting' stamp: 'lr 8/30/2008 16:22'!
valueFromString: aString 
	^ self options 
		detect: [ :each | each seasideString = aString ]
		ifNone: [ self error: 'No matching list option' ]! !

WAAttributeDescription subclass: #WANumberAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WANumberAttribute commentStamp: 'rew 10/7/2007 12:51' prior: 0!
WANumberAttribute represents a number attribute. It converts between text entered on the configuration page and numbers.
!

!WANumberAttribute methodsFor: 'visiting' stamp: 'lr 1/3/2008 17:22'!
accept: aVisitor with: anObject
	aVisitor visitNumberAttribute: self with: anObject! !

!WANumberAttribute methodsFor: 'converting' stamp: 'jf 7/31/2008 16:43'!
valueFromString: aString
	^ aString isEmptyOrNil ifFalse: [ Number readFrom: aString ]! !

WAAttributeDescription subclass: #WAPasswordAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WAPasswordAttribute commentStamp: 'jf 7/10/2008 14:06' prior: 0!
WAPasswordAttribute represents a password attribute. When set from a string, it records a hashed value. On the Seaside configuration page it does not display its current value.
!

!WAPasswordAttribute methodsFor: 'visiting' stamp: 'lr 1/3/2008 17:22'!
accept: aVisitor with: anObject
	aVisitor visitPasswordAttribute: self with: anObject! !

!WAPasswordAttribute methodsFor: 'converting' stamp: 'pmm 7/14/2008 20:32'!
valueFromString: aString
	^ aString isEmptyOrNil ifFalse: [
		SeasidePlatformSupport secureHashFor: aString ]! !

WAAttributeDescription subclass: #WAStringAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WAStringAttribute commentStamp: 'rew 10/7/2007 12:52' prior: 0!
WAStringAttribute represents a string attribute. It does the trivial conversion between text entered on the Seaside configuration page and a string.!

!WAStringAttribute methodsFor: 'visiting' stamp: 'lr 1/3/2008 17:22'!
accept: aVisitor with: anObject
	aVisitor visitStringAttribute: self with: anObject! !

!WAStringAttribute methodsFor: 'converting' stamp: 'lr 5/3/2006 09:56'!
valueFromString: aString
	^ aString isEmptyOrNil ifFalse: [ aString ]! !

WAConfigurationElement subclass: #WAAttributeExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

WAAttributeExpression subclass: #WAAddRemoveExpression
	instanceVariableNames: 'additions removals'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WAAddRemoveExpression methodsFor: 'accessing' stamp: 'jf 7/31/2008 11:42'!
additions
	^ additions! !

!WAAddRemoveExpression methodsFor: 'accessing' stamp: 'jf 7/31/2008 11:43'!
additions: aCollection
	additions := aCollection! !

!WAAddRemoveExpression methodsFor: 'values' stamp: 'jf 8/4/2008 15:30'!
determineValueWithContext: aContext
	| collection set |
	collection := self configuration inheritedValueAt: self key context: aContext.
	
	collection isNil ifTrue: [ collection := aContext attribute default ].
	collection isNil ifTrue: [ collection := Set new ].
	
	set := collection asSet.
	set addAll: self additions.
	self removals do: [ :each | set remove: each ifAbsent: [] ].
	
	^ set! !

!WAAddRemoveExpression methodsFor: 'accessing' stamp: 'jf 7/31/2008 13:09'!
removals
	^ removals! !

!WAAddRemoveExpression methodsFor: 'accessing' stamp: 'jf 7/31/2008 13:09'!
removals: anObject
	removals := anObject! !

!WAAttributeExpression methodsFor: 'values' stamp: 'jf 8/4/2008 15:28'!
determineValueWithContext: aContext
	self subclassResponsibility! !

WAAttributeExpression subclass: #WAValueExpression
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WAValueExpression methodsFor: 'values' stamp: 'jf 8/4/2008 15:28'!
determineValueWithContext: aContext
	^ self value! !

!WAValueExpression methodsFor: 'accessing' stamp: 'jf 7/29/2008 16:31'!
value
	^ value! !

!WAValueExpression methodsFor: 'accessing' stamp: 'jf 7/29/2008 16:31'!
value: anObject
	value := anObject! !

!WAConfigurationElement class methodsFor: 'instance-creation' stamp: 'jf 7/29/2008 19:02'!
key: aSymbol
	^ self basicNew initializeWithKey: aSymbol! !

!WAConfigurationElement methodsFor: 'accessing' stamp: 'jf 7/29/2008 16:53'!
configuration
	^ configuration! !

!WAConfigurationElement methodsFor: 'accessing' stamp: 'jf 7/29/2008 19:02'!
configuration: aConfiguration
	configuration := aConfiguration! !

!WAConfigurationElement methodsFor: 'initialization' stamp: 'jf 7/29/2008 19:02'!
initializeWithKey: aSymbol
	key := aSymbol! !

!WAConfigurationElement methodsFor: 'accessing' stamp: 'jf 7/29/2008 16:54'!
key
	^ key! !

Object subclass: #WACurrentSession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Session'!

!WACurrentSession commentStamp: 'jf 7/16/2008 10:20' prior: 0!
Available for backward compatibility. You should now use "WACurrentRequestContext session"!

!WACurrentSession class methodsFor: 'evaluating' stamp: 'lr 4/9/2008 09:38'!
value
	^ WACurrentRequestContext session! !

Object subclass: #WAEncoder
	instanceVariableNames: 'stream table'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document'!

WAEncoder class
	instanceVariableNames: 'table'!

!WAEncoder commentStamp: 'lr 4/8/2007 15:49' prior: 0!
I encode everything that is written to myself using #nextPut: and #nextPutAll: onto the wrapped stream. To be efficient I use an encoding table to be able to transform the most used characters from the UTF Basic Multilingual Plane as efficiently as possible. The convertion of a single character is defined in #encode:on: on the class-side of my subclasses.!

WAEncoder class
	instanceVariableNames: 'table'!

!WAEncoder class methodsFor: 'private' stamp: 'lr 4/8/2007 13:42'!
encode: aCharacter on: aStream
	self subclassResponsibility! !

!WAEncoder class methodsFor: 'initialization' stamp: 'pmm 2/13/2008 21:17'!
initializeBMP
	"Initializes the BMP, the Basic Multilingual Plane of UTF characters, using the encoding strategy of the receiver. This chaching strategy ensures that most commonly used characters can be encoded as efficient as possible."

	| stream characterLimit |
	characterLimit := self maximumCharacterValue.
	table := Array new: characterLimit.
	stream := WriteStream on: (String new: 6).
	1 to: characterLimit do: [ :index |
		self encode: (Character value: index - 1) on: stream reset.
		table at: index put: (stream position = 1
			ifTrue: [ stream contents first ]
			ifFalse: [ stream contents ]) ]! !

!WAEncoder class methodsFor: 'private' stamp: 'pmm 2/13/2008 21:17'!
maximumCharacterValue
	"find the maximum value of a character that we can instantiate, for Squeak 3.7 this is 255"
	^[ Character value: 16rFFFF.
		16rFFFF ]
			on: Error
			do: [ :error  | 16rFF ]! !

!WAEncoder class methodsFor: 'instance-creation' stamp: 'lr 3/26/2007 20:51'!
on: aStream
	^ self on: aStream table: table! !

!WAEncoder class methodsFor: 'instance-creation' stamp: 'lr 3/26/2007 20:29'!
on: aStream table: anArray
	^ self basicNew initializeOn: aStream table: anArray! !

!WAEncoder methodsFor: 'initialization' stamp: 'lr 3/26/2007 20:30'!
initializeOn: aStream table: anArray
	stream := aStream.
	table := anArray! !

!WAEncoder methodsFor: 'accessing' stamp: 'lr 4/8/2007 13:57'!
nextPut: aCharacter
	| value encoded |
	value := aCharacter asInteger.
	value < table size
		ifFalse: [ self class encode: aCharacter on: stream ]
		ifTrue: [
			encoded := table at: value + 1.
			encoded isString
				ifTrue: [ stream nextPutAll: encoded ]
				ifFalse: [ stream nextPut: encoded ] ]! !

!WAEncoder methodsFor: 'accessing' stamp: 'lr 4/8/2007 13:57'!
nextPutAll: aString
	| character value encoded |
	"uses #to:do: for speed reasons (on Squeak)
	this is not premature optimization, this is a hotspot method method
	and #to:do: shows measurable speed improvements for rendering seaside pages"
	1 to: aString size do: [ :index |
		character := aString at: index.
		value := character asInteger.
		value < table size
			ifFalse: [ self class encode: character on: stream ]
			ifTrue: [
				encoded := table at: value + 1.
				encoded isString
					ifTrue: [ stream nextPutAll: encoded ]
					ifFalse: [ stream nextPut: encoded ] ] ]! !

WAEncoder subclass: #WAHtmlEncoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document'!

!WAHtmlEncoder commentStamp: 'lr 4/6/2007 19:45' prior: 0!
I encode XHTML text.!

!WAHtmlEncoder class methodsFor: 'private' stamp: 'lr 4/8/2007 14:05'!
encode: aCharacter on: aStream
	aCharacter = $" ifTrue: [ ^ aStream nextPutAll: '&quot;' ].
	aCharacter = $< ifTrue: [ ^ aStream nextPutAll: '&lt;' ].
	aCharacter = $& ifTrue: [ ^ aStream nextPutAll: '&amp;'].
	aCharacter = $> ifTrue: [ ^ aStream nextPutAll: '&gt;' ].
	aStream nextPut: aCharacter! !

!WAHtmlEncoder class methodsFor: 'initialization' stamp: 'lr 4/8/2007 14:01'!
initialize
	self initializeBMP! !

WAEncoder subclass: #WAUrlEncoder
	instanceVariableNames: 'codec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document'!

!WAUrlEncoder commentStamp: 'pmm 5/10/2008 22:03' prior: 0!
I encode path segments and arguments of an URL.

I only do "precend encoding", I delegate the encoding from characters to bytes to a codec (provided by the server).!

!WAUrlEncoder class methodsFor: 'private' stamp: 'pmm 5/11/2008 08:58'!
encode: aCharacter on: aStream
	| value |
	('ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_.~' includes: aCharacter)
		ifTrue: [ ^ aStream nextPut: aCharacter ].
	aCharacter = Character space
		ifTrue: [ ^ aStream nextPut: $+ ].
	value := aCharacter asInteger.
	aStream nextPut: $%.
	aStream nextPutAll: ((value printStringBase: 16) padded: #left to: 2 with: $0)! !

!WAUrlEncoder class methodsFor: 'initialization' stamp: 'lr 4/8/2007 15:43'!
initialize
	self initializeBMP! !

!WAUrlEncoder class methodsFor: 'private' stamp: 'pmm 5/10/2008 21:57'!
maximumCharacterValue
	"String to bye encoding has aleady happened in the server"
	^16rFF! !

!WAUrlEncoder methodsFor: 'initialization' stamp: 'jf 7/29/2008 12:25'!
initializeOn: aStream table: anArray
	super initializeOn: aStream table: anArray.
	
	codec := WACurrentRequestContext value isNil
		ifFalse: [ WACurrentRequestContext value codec ].
	codec isNil ifTrue: [ codec := WANullCodec new ].! !

!WAUrlEncoder methodsFor: 'accessing' stamp: 'pmm 5/10/2008 22:05'!
nextPut: aCharacter
	self nextPutAll: (String with: aCharacter)! !

!WAUrlEncoder methodsFor: 'accessing' stamp: 'pmm 5/11/2008 08:48'!
nextPutAll: aString
	super nextPutAll: (codec encodeUrl: aString)! !

Object subclass: #WAErrorHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Session'!

!WAErrorHandler commentStamp: 'pmm 5/27/2007 21:46' prior: 0!
Error handlers are invoked when an error in a Seaside application occurs. They handle
- errors
- warnings
- internal errors in the Seaside core

I am the base class for all error handlers and handle only internal errors which which I display a code 500 error with a short stackframe.

See WAWalkbackErrorHandler for examples of how to do rendering with the canvas API.!

WAErrorHandler subclass: #WADefaultErrorHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Session'!

!WADefaultErrorHandler commentStamp: 'pmm 8/30/2008 10:41' prior: 0!
A WADefaultErrorHandler is a convienient superclass for all error handlers. It returns an HTTP response for #internalError:.!

!WADefaultErrorHandler methodsFor: 'actions' stamp: 'sh 8/29/2008 15:59'!
internalError: anError
	^ WAResponse internalError: anError! !

WADefaultErrorHandler subclass: #WASimpleErrorHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Session'!

!WASimpleErrorHandler commentStamp: 'pmm 5/27/2007 21:48' prior: 0!
I am like WAErrorHandler except that I display the code 500 error with a short stackframe for errors and warnings too.!

!WASimpleErrorHandler methodsFor: 'actions' stamp: 'jf 7/14/2008 17:07'!
handleError: anError
	WACurrentRequestContext value
		returnResponse: (WAResponse internalError: anError)! !

!WAErrorHandler class methodsFor: 'actions' stamp: 'avi 3/28/2004 21:22'!
handleError: anError
	^ self new handleError: anError! !

!WAErrorHandler class methodsFor: 'actions' stamp: 'avi 3/28/2004 21:23'!
handleWarning: aWarning
	^ self new handleWarning: aWarning! !

!WAErrorHandler class methodsFor: 'actions' stamp: 'pmm 2/24/2007 22:13'!
internalError: anError
	^ self new internalError: anError! !

!WAErrorHandler methodsFor: 'actions' stamp: 'lr 4/20/2007 14:41'!
handleError: anError
	anError pass! !

!WAErrorHandler methodsFor: 'actions' stamp: 'sh 8/29/2008 16:00'!
handleWarning: aWarning
	self handleError: aWarning! !

!WAErrorHandler methodsFor: 'actions' stamp: 'sh 8/29/2008 15:58'!
internalError: anError
	^ self handleError: anError! !

Object subclass: #WAEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Contexts'!

WAEvent subclass: #WAResponseEvent
	instanceVariableNames: 'response'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Contexts'!

!WAResponseEvent class methodsFor: 'instance-creation' stamp: 'lr 3/29/2008 22:35'!
on: aResponse
	^ self basicNew initializeOn: aResponse! !

!WAResponseEvent methodsFor: 'initialization' stamp: 'lr 3/29/2008 22:34'!
initializeOn: aResponse
	response := aResponse! !

!WAResponseEvent methodsFor: 'accessing' stamp: 'lr 3/29/2008 22:34'!
response
	^ response! !

Object subclass: #WAFile
	instanceVariableNames: 'contents contentType fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAFile commentStamp: 'pmm 5/31/2008 23:54' prior: 0!
I represent a file that was uploaded by the user via #fileInput.

Instance Variables
	contents:		<ByteArray>
	contentType:	<WAMimeType>
	fileName:		<String>

contents
	- the contents of the file, binary

contentType
	- the content type of the file
	
fileName
	- The name of the file the user agent uploaded. This is locale name on the machine of the client. The instance variable might include the full path on the file system, the accessor will never return the path.!

!WAFile methodsFor: 'accessing' stamp: 'avi 4/28/2004 11:13'!
contentType
	^ contentType! !

!WAFile methodsFor: 'accessing' stamp: 'pmm 11/21/2007 21:07'!
contentType: aMimeTypeOrString
	contentType := aMimeTypeOrString toMimeType! !

!WAFile methodsFor: 'accessing' stamp: 'mb 9/22/2006 12:39'!
contents
	"Answer a ByteArray"
	^ contents! !

!WAFile methodsFor: 'accessing' stamp: 'mb 9/22/2006 12:37'!
contents: aByteArray
	contents := aByteArray! !

!WAFile methodsFor: 'accessing' stamp: 'pmm 7/24/2007 22:03'!
fileName
	"compensate for windows explorer behavior"
	^ self isWindowsPath
		ifTrue: [ fileName copyAfterLast: $\ ]
		ifFalse: [ fileName ]! !

!WAFile methodsFor: 'accessing' stamp: 'mb 9/22/2006 12:21'!
fileName: aString
	fileName := aString! !

!WAFile methodsFor: 'private' stamp: 'pmm 7/24/2007 22:02'!
isWindowsPath
	"'#:\*' match: fileName is broken on Squeak for WideString arguments"
	^fileName notEmpty
		and: [ fileName first isLetter
		and: [ fileName size >= 3
		and: [ (fileName copyFrom: 2 to: 3) = ':\' ] ] ]! !

!WAFile methodsFor: 'accessing' stamp: 'pmm 4/18/2008 22:45'!
size
	"the file size in bytes"
	^self contents size! !

Object subclass: #WAHtmlBuilder
	instanceVariableNames: 'canvasClass fullDocument documentRoot rootBlock callbackOwner rootClass documentClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas'!

!WAHtmlBuilder commentStamp: 'pmm 8/18/2007 12:40' prior: 0!
A WAHtmlBuilder is a convenience class to render html. I am supposed to be used like this.

WARenderCanvas builder render: [ :html |
	html anchor
		url: 'htttp://www.seaside.st';
		with: 'Seaside Homepage' ]

See WAHtmlBuilderTest for more examples.

Instance Variables
	callbackOwner:		<Object>
	canvasClass:		<WACanvas class>
	documentRoot:		<WARoot>
	fullDocument:		<Boolean>
	rootBlock:			<BlockContext>

callbackOwner
	- optional, the owner of the callbacks

canvasClass
	- the canvas class to use, on the class side it must implement #context:callbacks: as an object construction method

documentRoot
	- for private use only, the instantiated root of the document

fullDocument
	- whether a full html document including the head section should be rendered

rootBlock
	- a one argement block to customize the document root. The argument of the block is the root
!

!WAHtmlBuilder class methodsFor: 'instance creation' stamp: 'pmm 8/31/2007 09:35'!
new
	^self basicNew initialize! !

!WAHtmlBuilder class methodsFor: 'instance creation' stamp: 'pmm 8/12/2007 11:58'!
on: aCanvasClass
	^self new
		canvasClass: aCanvasClass;
		yourself! !

!WAHtmlBuilder methodsFor: 'accessing' stamp: 'pmm 8/16/2007 22:53'!
actionUrl
	^WAUrl new! !

!WAHtmlBuilder methodsFor: 'accessing' stamp: 'pmm 8/12/2007 12:10'!
callbackOwner
	^callbackOwner! !

!WAHtmlBuilder methodsFor: 'accessing' stamp: 'pmm 8/12/2007 12:10'!
callbackOwner: anObject
	callbackOwner := anObject! !

!WAHtmlBuilder methodsFor: 'accessing' stamp: 'pmm 8/12/2007 11:58'!
canvasClass
	^canvasClass! !

!WAHtmlBuilder methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
canvasClass: aClass
	canvasClass := aClass! !

!WAHtmlBuilder methodsFor: 'private' stamp: 'lr 3/6/2008 10:03'!
closeDocument: aDocument
	self fullDocument ifTrue: [ aDocument close: documentRoot ]! !

!WAHtmlBuilder methodsFor: 'private' stamp: 'pmm 8/12/2007 12:11'!
createCallbacksFor: aContext
	^self callbackOwner isNil
		ifTrue: [ nil ]
		ifFalse: [ aContext callbacksFor: self callbackOwner ]! !

!WAHtmlBuilder methodsFor: 'accessing' stamp: 'lr 3/6/2008 09:57'!
documentClass
	^ documentClass ifNil: [ documentClass := WAHtmlStreamDocument ]! !

!WAHtmlBuilder methodsFor: 'accessing' stamp: 'lr 3/6/2008 09:57'!
documentClass: aClass
	documentClass := aClass! !

!WAHtmlBuilder methodsFor: 'accessing' stamp: 'pmm 8/12/2007 11:53'!
fullDocument
	^fullDocument! !

!WAHtmlBuilder methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
fullDocument: aBoolean
	fullDocument := aBoolean! !

!WAHtmlBuilder methodsFor: 'initialization' stamp: 'pmm 8/31/2007 09:34'!
initialize
	self fullDocument: false! !

!WAHtmlBuilder methodsFor: 'private' stamp: 'lr 3/25/2008 22:13'!
openDocumentDocument: aDocument context: aContext 
	self fullDocument ifFalse: [ ^ self ].
	documentRoot := self rootClass context: aContext.
	self rootBlock value: documentRoot.
	aDocument open: documentRoot! !

!WAHtmlBuilder methodsFor: 'rendering' stamp: 'pmm 3/29/2008 16:04'!
render: anObject
	"renders anObject and returns the resulting HTML document as a String
	anObject must understand #renderOn:
	often anObject will be a render block. That is a one argument block who will be
	evaluated with a html canvas."
	^ String streamContents: [ :stream |
		| context docRoot document html callbacks |
		document := self documentClass new stream: stream.
		context := WARenderingContext new.
		context document: document.
		context actionUrl: self actionUrl.
		callbacks := self createCallbacksFor: context.
		html := self canvasClass context: context callbacks: callbacks.
		
		self openDocumentDocument: document context: context.
		html render: anObject; flush.
		self closeDocument: document ]! !

!WAHtmlBuilder methodsFor: 'rendering' stamp: 'pmm 3/21/2008 17:36'!
renderResponse: anObject
	"renders anObject and returns the resulting document as a WAResponse
	this automatically triggers full document rendering since returning a partial
	html document to the client makes no sense
	see #render: for more discussion about anObject"
	self fullDocument: true.
	^ WAResponse new
		contentType: WAResponse defaultValueForMimeType;
		nextPutAll: (self render: anObject);
		yourself! !

!WAHtmlBuilder methodsFor: 'accessing' stamp: 'pmm 8/12/2007 12:00'!
rootBlock
	rootBlock isNil ifTrue: [
		rootBlock := [ :html | ] ].
	^rootBlock! !

!WAHtmlBuilder methodsFor: 'accessing' stamp: 'pmm 8/12/2007 12:00'!
rootBlock: anObject
	rootBlock := anObject! !

!WAHtmlBuilder methodsFor: 'accessing' stamp: 'pmm 8/16/2007 22:57'!
rootClass
	rootClass isNil ifTrue: [
		rootClass := WAHtmlRoot ].
	^rootClass! !

!WAHtmlBuilder methodsFor: 'accessing' stamp: 'pmm 8/16/2007 22:58'!
rootClass: anHtmlRootClass
	rootClass := anHtmlRootClass! !

Object subclass: #WAHtmlDocument
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document'!

!WAHtmlDocument commentStamp: 'pmm 6/1/2008 00:19' prior: 0!
A WAHtmlDocument controls how a string is created from a series of brushes.!

!WAHtmlDocument class methodsFor: 'instance-creation' stamp: 'lr 3/26/2007 21:28'!
new
	^ self basicNew initialize! !

!WAHtmlDocument methodsFor: 'writing-xhtml' stamp: 'lr 3/26/2007 22:23'!
closeTag: aString
	self subclassResponsibility! !

!WAHtmlDocument methodsFor: 'initialization' stamp: 'lr 3/26/2007 21:28'!
initialize! !

!WAHtmlDocument methodsFor: 'writing' stamp: 'lr 3/27/2007 10:36'!
nextPut: aCharacter
	self subclassResponsibility! !

!WAHtmlDocument methodsFor: 'writing' stamp: 'lr 3/27/2007 10:36'!
nextPutAll: aString
	self subclassResponsibility! !

!WAHtmlDocument methodsFor: 'writing-xhtml' stamp: 'lr 3/26/2007 21:38'!
openTag: aString
	self openTag: aString attributes: nil closed: false! !

!WAHtmlDocument methodsFor: 'writing-xhtml' stamp: 'lr 3/26/2007 21:38'!
openTag: aString attributes: anAttributes
	self openTag: aString attributes: anAttributes closed: false! !

!WAHtmlDocument methodsFor: 'writing-xhtml' stamp: 'lr 3/26/2007 22:23'!
openTag: aString attributes: anAttributes closed: aBoolean
	self subclassResponsibility! !

!WAHtmlDocument methodsFor: 'writing' stamp: 'lr 3/27/2007 10:36'!
print: anObject
	self subclassResponsibility! !

WAHtmlDocument subclass: #WAHtmlStreamDocument
	instanceVariableNames: 'stream htmlEncoder urlEncoder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document'!

!WAHtmlStreamDocument commentStamp: 'pmm 6/1/2008 00:23' prior: 0!
A WAHtmlStreamDocument is a concrete WAHtmlDocument that writes tags into a stream.

Instance Variables
	htmlEncoder:	<WAHtmlEncoder>
	stream:			<WriteStream>
	urlEncoder:		<WAUrlEncoder>

htmlEncoder
	- the encoder used to escape reserved HTML characters

stream
	- the stream on which the brushes are written

urlEncoder
	- the encoder used to escape reserved URL characters
!

!WAHtmlStreamDocument methodsFor: 'actions' stamp: 'lr 3/27/2007 11:47'!
close: aHtmlRoot
	aHtmlRoot close: self! !

!WAHtmlStreamDocument methodsFor: 'writing-xhtml' stamp: 'lr 4/9/2007 10:28'!
closeTag: aString
	stream nextPutAll: '</'.
	stream nextPutAll: aString.
	stream nextPut: $>! !

!WAHtmlStreamDocument methodsFor: 'accessing-encoders' stamp: 'lr 3/26/2007 20:22'!
htmlEncoder
	^ htmlEncoder! !

!WAHtmlStreamDocument methodsFor: 'writing' stamp: 'lr 3/26/2007 20:06'!
nextPut: aCharacter
	stream nextPut: aCharacter! !

!WAHtmlStreamDocument methodsFor: 'writing' stamp: 'lr 3/26/2007 20:07'!
nextPutAll: aString
	stream nextPutAll: aString! !

!WAHtmlStreamDocument methodsFor: 'actions' stamp: 'lr 10/28/2007 14:42'!
open: aHtmlRoot
	aHtmlRoot open: self! !

!WAHtmlStreamDocument methodsFor: 'writing-xhtml' stamp: 'lr 5/23/2007 10:49'!
openTag: aString attributes: anAttributes closed: aBoolean
	stream nextPut: $<.
	stream nextPutAll: aString.
	anAttributes encodeOn: self.
	aBoolean ifTrue: [ stream nextPut: $/ ].
	stream nextPut: $>! !

!WAHtmlStreamDocument methodsFor: 'writing' stamp: 'lr 3/26/2007 20:16'!
print: anObject
	anObject encodeOn: self! !

!WAHtmlStreamDocument methodsFor: 'accessing' stamp: 'avi 7/8/2004 00:39'!
stream
	^ stream! !

!WAHtmlStreamDocument methodsFor: 'accessing' stamp: 'lr 3/26/2007 20:42'!
stream: aStream
	stream := aStream.
	htmlEncoder := WAHtmlEncoder on: stream.
	urlEncoder := WAUrlEncoder on: stream! !

!WAHtmlStreamDocument methodsFor: 'accessing-encoders' stamp: 'lr 3/26/2007 20:22'!
urlEncoder
	^ urlEncoder! !

Object subclass: #WAHtmlElement
	instanceVariableNames: 'root attributes children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WAHtmlElement commentStamp: 'pmm 1/28/2008 07:08' prior: 0!
Root class of all elements inside a <head> section.!

WAHtmlElement subclass: #WABaseElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WABaseElement commentStamp: 'pmm 1/28/2008 07:05' prior: 0!
In HTML, links and references to external images, applets, form-processing programs, style sheets, etc. are always specified by a URI. Relative URIs are resolved according to a base URI, which may come from a variety of sources. The BASE element allows authors to specify a document's base URI explicitly.

When present, the BASE element must appear in the HEAD section of an HTML document, before any element that refers to an external source. The path information specified by the BASE element only affects URIs in the document where the element appears.

For example, given the following BASE declaration and A declaration:
updateRoot: html
	super updateRoot: html.
	html base url: 'http://www.aviary.com/products/intro.html'

renderContentOn: html
	html anchor
		url: '../cages/birds.gif';
		with: 'Bird Cages'

the relative URI "../cages/birds.gif" would resolve to:
http://www.aviary.com/cages/birds.gif!

!WABaseElement methodsFor: 'accessing' stamp: 'lr 3/27/2007 11:26'!
tag
	^ 'base'! !

!WABaseElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:43'!
target: aString
	self attributeAt: 'target' put: aString! !

!WABaseElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:43'!
url: aString
	self attributeAt: 'href' put: aString! !

WAHtmlElement subclass: #WAContentElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WAContentElement commentStamp: 'pmm 1/28/2008 07:01' prior: 0!
Common superclass of all elements inside a <head> that can have content. Either between the start and end tag or a (mime) document pointed to by an URL.!

!WAContentElement methodsFor: 'attributes' stamp: 'lr 3/27/2007 13:33'!
contents: aString
	self document: aString! !

!WAContentElement methodsFor: 'document' stamp: 'lr 3/27/2007 13:32'!
document: aString
	self document: aString mimeType: self typeOrNil! !

!WAContentElement methodsFor: 'document' stamp: 'lr 3/27/2007 13:32'!
document: aString fileName: fileName
	self document: aString mimeType: self typeOrNil fileName: fileName! !

!WAContentElement methodsFor: 'document' stamp: 'lr 3/27/2007 13:32'!
document: aString mimeType: mimeType
	self document: aString mimeType: mimeType fileName: nil! !

!WAContentElement methodsFor: 'document' stamp: 'lr 3/27/2007 13:33'!
document: aString mimeType: mimeType fileName: fileName
	self url: (root context urlForDocument: aString mimeType: mimeType fileName: fileName)! !

!WAContentElement methodsFor: 'printing' stamp: 'lr 8/30/2008 16:22'!
encodeChildrenOn: aDocument 
	children isEmptyOrNil ifTrue: [ ^ self ].
	aDocument nextPutAll: '/*<!![CDATA[*/'.
	children do: [ :each | aDocument nextPutAll: each seasideString ].
	aDocument nextPutAll: '/*]]>*/'! !

!WAContentElement methodsFor: 'testing' stamp: 'lr 11/5/2007 17:20'!
isClosed
	^ false! !

!WAContentElement methodsFor: 'attributes' stamp: 'lr 4/10/2007 09:55'!
resourceUrl: aString
	self url: (root context absoluteUrlForResource: aString)! !

!WAContentElement methodsFor: 'attributes' stamp: 'pmm 11/21/2007 20:48'!
type: aMimeTypeOrString
	self attributeAt: 'type' put: aMimeTypeOrString! !

!WAContentElement methodsFor: 'private' stamp: 'lr 3/27/2007 10:51'!
typeOrNil
	^ self attributeAt: 'type' ifAbsent:  [ nil ]! !

!WAContentElement methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
url: aString
	self subclassResponsibility! !

WAContentElement subclass: #WALinkElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WALinkElement commentStamp: 'pmm 1/29/2008 22:04' prior: 0!
Defines either a link or style sheet rules. If it has children then it defines style sheet rules, else it defines a link.

= if link =
This element defines a link. Unlike A, it may only appear in the HEAD section of a document, although it may appear any number of times. Although LINK has no content, it conveys relationship information that may be rendered by user agents in a variety of ways (e.g., a tool-bar with a drop-down menu of links).

= style sheet rules =
The STYLE element allows authors to put style sheet rules in the head of the document. HTML permits any number of STYLE elements in the HEAD section of a document.

User agents that don't support style sheets, or don't support the specific style sheet language used by a STYLE element, must hide the contents of the STYLE element. It is an error to render the content as part of the document's text. Some style sheet languages support syntax for hiding the content from non-conforming user agents.!

!WALinkElement methodsFor: 'accessing-children' stamp: 'pmm 1/29/2008 22:00'!
add: anElement
	super add: anElement.
	attributes isNil ifFalse: [
		attributes removeKey: 'rel' ifAbsent: [ "ignore" ] ]! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:36'!
addAll
	self addMedia: 'all'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:36'!
addAural
	self addMedia: 'aural'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:36'!
addBraille
	self addMedia: 'braille'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:35'!
addHandheld
	self addMedia: 'handheld'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 3/9/2008 11:19'!
addMedia: aString
	self attributes addMedia: aString! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:36'!
addPrint
	self addMedia: 'print'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:35'!
addProjection
	self addMedia: 'projection'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:35'!
addScreen
	self addMedia: 'screen'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:35'!
addTeletype
	self addMedia: 'tty'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:35'!
addTelevision
	self addMedia: 'tv'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 3/31/2007 00:54'!
beAlternate
	"Gives alternate representations of the current document."
	self relationship: 'alternate'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:14'!
beAlternateStylesheet
	self relationship: 'alternate stylesheet'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:12'!
beAppendix
	self relationship: 'appendix'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 3/31/2007 00:56'!
beArchives
	"Provides a link to a collection of records, documents, or other materials of historical interest."
	self relationship: 'archives'! !

!WALinkElement methodsFor: 'type' stamp: 'pmm 11/21/2007 20:52'!
beAtom
	self type: 'application/atom+xml' toMimeType! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:12'!
beBookmark
	self relationship: 'bookmark'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:11'!
beChapter
	self relationship: 'chapter'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:11'!
beClossary
	self relationship: 'lossary'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:11'!
beCopyright
	self relationship: 'copyright'! !

!WALinkElement methodsFor: 'type' stamp: 'pmm 11/21/2007 20:52'!
beCss
	self type: 'text/css' toMimeType! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 3/31/2007 01:05'!
beFirst
	"Indicates that the current document is a part of a series, and that the first document in the series is the referenced document."
	self relationship: 'first'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:17'!
beFontDefinition
	self relationship: 'fontdef'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 3/31/2007 00:57'!
beGlossary
	self relationship: 'glossary'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:12'!
beHelp
	self relationship: 'help'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:10'!
beIndex
	self relationship: 'index'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:18'!
beLast
	self relationship: 'last'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:58'!
beMicrosummary
	"http://wiki.mozilla.org/Microsummaries"
	self relationship: 'microsummary'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 3/31/2007 01:04'!
beNext
	"Indicates that the current document is a part of a series, and that the next document in the series is the referenced document."
	self relationship: 'next'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 3/31/2007 01:04'!
bePrevious
	"Indicates that the current document is a part of a series, and that the previous document in the series is the referenced document."
	self relationship: 'previous'! !

!WALinkElement methodsFor: 'type' stamp: 'pmm 11/21/2007 20:52'!
beRss
	self type: 'application/rss+xml' toMimeType! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 3/31/2007 01:04'!
beSearch
	"Gives a link to a resource that can be used to search through the current document and its related pages. "
	self relationship: 'search'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:11'!
beSection
	self relationship: 'section'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:16'!
beShortcutIcon
	self relationship: 'shortcut icon'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 3/31/2007 01:03'!
beStart
	"Refers to the first document in a collection of documents. This link type tells search engines which document is considered by the author to be the starting point of the collection."
	self relationship: 'start'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 3/31/2007 00:58'!
beStylesheet
	"Imports a stylesheet."
	self relationship: 'stylesheet'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:12'!
beSubsection
	self relationship: 'subsection'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:10'!
beTableOfContents
	self relationship: 'contents'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:18'!
beTop
	self relationship: 'top'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 3/31/2007 00:58'!
beUp
	"Provides a link to a document giving the context for the current document."
	self relationship: 'up'! !

!WALinkElement methodsFor: 'testing' stamp: 'lr 11/5/2007 17:20'!
isClosed
	^ children isEmptyOrNil! !

!WALinkElement methodsFor: 'attributes' stamp: 'pmm 3/31/2007 01:02'!
media: aString
	"This attribute specifies the intended destination medium for style information. It may be a single media descriptor or a comma-separated list. The default value for this attribute is 'screen'."
	self attributeAt: 'media' put: aString! !

!WALinkElement methodsFor: 'attributes' stamp: 'pmm 3/31/2007 01:01'!
relationship: aString
	"This attribute describes the relationship from the current document to the anchor specified by the href(url) attribute. The value of this attribute is a space-separated list of link types."
	self attributeAt: 'rel' put: aString! !

!WALinkElement methodsFor: 'attributes' stamp: 'pmm 3/31/2007 01:00'!
reverse: aString
	"This attribute is used to describe a reverse link from the anchor specified by the href attribute to the current document. The value of this attribute is a space-separated list of link types."
	self attributeAt: 'rev' put: aString! !

!WALinkElement methodsFor: 'accessing' stamp: 'pmm 1/29/2008 21:57'!
tag
	^ children isEmptyOrNil
		ifTrue: [ 'link' ]
		ifFalse: [ 'style' ]! !

!WALinkElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 17:09'!
title: aString
	self attributeAt: 'title' put: aString! !

!WALinkElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:10'!
url: aString
	self attributeAt: 'href' put: aString! !

WAContentElement subclass: #WAScriptElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WAScriptElement commentStamp: 'pmm 1/28/2008 06:46' prior: 0!
The SCRIPT element places a script within a document. This element may appear any number of times in the HEAD of an HTML document.

The script may be defined within the contents of the SCRIPT element or in an external file. If the src attribute is not set, user agents must interpret the contents of the element as the script. If the src has a URI value, user agents must ignore the element's contents and retrieve the script via the URI. Note that the charset attribute refers to the character encoding of the script designated by the src attribute; it does not concern the content of the SCRIPT element.!

!WAScriptElement methodsFor: 'types' stamp: 'pmm 11/25/2007 15:41'!
beJavascript
	self type: 'text/javascript' toMimeType! !

!WAScriptElement methodsFor: 'attributes' stamp: 'pmm 9/22/2007 07:36'!
defer
	"When set, this boolean attribute provides a hint to the user agent that the script is not going to generate any document content (e.g., no 'document.write' in javascript) and thus, the user agent can continue parsing and rendering."
		self attributeAt: 'defer' put: true! !

!WAScriptElement methodsFor: 'accessing' stamp: 'lr 3/27/2007 11:27'!
tag
	^ 'script'! !

!WAScriptElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:10'!
url: aString
	self attributeAt: 'src' put: aString! !

!WAHtmlElement class methodsFor: 'instance-creation' stamp: 'lr 3/27/2007 13:26'!
root: aRoot
	^ self basicNew initializeWithRoot: aRoot! !

!WAHtmlElement methodsFor: 'accessing-children' stamp: 'lr 3/27/2007 10:47'!
add: anElement
	children ifNil: [ children := OrderedCollection new ].
	children add: anElement! !

!WAHtmlElement methodsFor: 'accessing-attributes' stamp: 'lr 3/21/2007 15:59'!
attributeAt: aString
	^ self attributes at: aString! !

!WAHtmlElement methodsFor: 'accessing-attributes' stamp: 'lr 3/21/2007 15:59'!
attributeAt: aString ifAbsent: aBlock
	^ self attributes at: aString ifAbsent: aBlock! !

!WAHtmlElement methodsFor: 'accessing-attributes' stamp: 'lr 3/21/2007 15:59'!
attributeAt: aString put: anObject
	^ self attributes at: aString put: anObject! !

!WAHtmlElement methodsFor: 'accessing' stamp: 'lr 3/21/2007 15:58'!
attributes
	^ attributes ifNil: [ attributes := WAHtmlAttributes new ]! !

!WAHtmlElement methodsFor: 'accessing-children' stamp: 'lr 3/27/2007 10:47'!
childrenDo: aBlock
	children ifNotNil: [ children do: aBlock ]! !

!WAHtmlElement methodsFor: 'printing' stamp: 'lr 1/26/2008 21:08'!
encodeAfterOn: aDocument
	aDocument closeTag: self tag! !

!WAHtmlElement methodsFor: 'printing' stamp: 'lr 1/26/2008 21:08'!
encodeBeforeOn: aDocument
	aDocument openTag: self tag attributes: attributes closed: self isClosed! !

!WAHtmlElement methodsFor: 'printing' stamp: 'lr 1/26/2008 21:08'!
encodeChildrenOn: aDocument
	self childrenDo: [ :each | each encodeOn: aDocument ]! !

!WAHtmlElement methodsFor: 'printing' stamp: 'lr 1/26/2008 21:08'!
encodeOn: aDocument
	self encodeBeforeOn: aDocument.
	self isClosed ifTrue: [ ^ self ].
	self encodeChildrenOn: aDocument.
	self encodeAfterOn: aDocument! !

!WAHtmlElement methodsFor: 'initialization' stamp: 'lr 3/27/2007 13:26'!
initializeWithRoot: aRoot
	root := aRoot! !

!WAHtmlElement methodsFor: 'testing' stamp: 'lr 3/27/2007 11:24'!
isClosed
	^ true! !

!WAHtmlElement methodsFor: 'accessing' stamp: 'lr 3/27/2007 11:24'!
tag
	self subclassResponsibility! !

!WAHtmlElement methodsFor: 'public' stamp: 'lr 11/5/2007 17:22'!
with: anObject
	self add: anObject! !

WAHtmlElement subclass: #WAMetaElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WAMetaElement commentStamp: 'pmm 1/28/2008 06:58' prior: 0!
The META element can be used to identify properties of a document (e.g., author, expiration date, a list of key words, etc.) and assign values to those properties. This specification does not define a normative set of properties.

Each META element specifies a property/value pair. The name attribute identifies the property and the content attribute specifies the property's value.

For example, the following declaration sets a value for the Author property:
<META name="Author" content="Dave Raggett">

The lang attribute can be used with META to specify the language for the value of the content attribute. This enables speech synthesizers to apply language dependent pronunciation rules.

In this example, the author's name is declared to be French:

htm meta
	name: 'Author'; language: 'fr'; content: 'Arnaud Le Hors'
	
Note. The META element is a generic mechanism for specifying meta data. However, some HTML elements and attributes already handle certain pieces of meta data and may be used by authors instead of META to specify those pieces: the TITLE element, the ADDRESS element, the INS and DEL elements, the title attribute, and the cite attribute.

Note. When a property specified by a META element takes a value that is a URI, some authors prefer to specify the meta data via the LINK element. Thus, the following meta data declaration:
html meta
      name: 'DC.identifier';
      content: 'http://www.ietf.org/rfc/rfc1866.txt'

might also be written:
html link
         relationship: 'DC.identifier';
         type: 'text/plain';
         url: 'http://www.ietf.org/rfc/rfc1866.txt'

The http-equiv attribute can be used in place of the name attribute and has a special significance when documents are retrieved via the Hypertext Transfer Protocol (HTTP). HTTP servers may use the property name specified by the http-equiv attribute to create an [RFC822]-style header in the HTTP response. Please see the HTTP specification ([RFC2616]) for details on valid HTTP headers.

The following sample META declaration:
htttp meta
         responseHeaderName: 'Expires';
         content: 'Tue, 20 Aug 1996 14:25:27 GMT'

will result in the HTTP header:
Expires: Tue, 20 Aug 1996 14:25:27 GMT

This can be used by caches to determine when to fetch a fresh copy of the associated document.

Note. Some user agents support the use of META to refresh the current page after a specified number of seconds, with the option of replacing it by a different URI. Authors should not use this technique to forward users to different pages, as this makes the page inaccessible to some users. Instead, automatic page forwarding should be done using server-side redirects.

html meta
         redirectAfter: 5 to: 'http://www.google.com/'!

!WAMetaElement methodsFor: 'conveniance' stamp: 'pmm 10/7/2006 18:20'!
beLeftToRight
	self textDirection: 'LTR'! !

!WAMetaElement methodsFor: 'conveniance' stamp: 'pmm 10/7/2006 18:20'!
beRightToLeft
	self textDirection: 'RTL'! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:17'!
content: aString
	self attributeAt: 'content' put: aString! !

!WAMetaElement methodsFor: 'conveniance' stamp: 'pmm 11/21/2007 21:17'!
contentScriptType: aMimeTypeOrString
	self responseHeaderName: 'Content-Script-Type'.
	self content: aMimeTypeOrString! !

!WAMetaElement methodsFor: 'conveniance' stamp: 'pmm 11/21/2007 21:17'!
contentType: aMimeTypeOrString
	self responseHeaderName: 'Content-Type'.
	self content: aMimeTypeOrString! !

!WAMetaElement methodsFor: 'initialization' stamp: 'lr 2/16/2008 18:47'!
initialize
	super initialize.
	self content: ''! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:18'!
language: aString
	self attributeAt: 'lang' put: aString! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:17'!
name: aString
	self attributeAt: 'name' put: aString! !

!WAMetaElement methodsFor: 'conveniance' stamp: 'lr 8/30/2008 16:22'!
redirectAfter: seconds to: aString 
	self responseHeaderName: 'refresh'.
	self content: seconds seasideString , ';URL=' , aString! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:25'!
responseHeaderName: aString
	self attributeAt: 'http-equiv' put: aString! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:17'!
scheme: aString
	self attributeAt: 'scheme' put: aString! !

!WAMetaElement methodsFor: 'accessing' stamp: 'lr 3/27/2007 11:26'!
tag
	^ 'meta'! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:19'!
textDirection: aString
	self attributeAt: 'dir' put: aString! !

Object subclass: #WALRUCache
	instanceVariableNames: 'table ageTable max'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Utilities'!

!WALRUCache commentStamp: 'pmm 10/20/2007 23:23' prior: 0!
WALRUCache implements at Least Recently Used cache. Items are removed from the cache when they reach "max" age. The age of an item is the number of additions to the cache done since the item itself was added. WALRUCache does not worry about the size of the cache. The "capacity:" method is misleading, it sets how long items will remain in the cache.

Instance Variables:
	ageTable	<Dictionary>	The age each time in the cache
	max	<SmallInteger>	The age at which items are removed from the cache
	table	<Dictionary>	Items in the cache, each item has key
			
WALRUCache is used to store the last n continutations of a session.

!

!WALRUCache class methodsFor: 'instance creation' stamp: 'pmm 4/18/2006 20:17'!
new
	^ self basicNew initialize! !

!WALRUCache class methodsFor: 'instance creation' stamp: 'ab 7/15/2002 00:10'!
new: max
	^ self new capacity: max! !

!WALRUCache methodsFor: 'accessing' stamp: 'lr 3/19/2007 20:18'!
at: aKey
	^ self at: aKey ifAbsent: [ self error: 'No entry for ' , aKey ]! !

!WALRUCache methodsFor: 'accessing' stamp: 'lr 3/19/2007 20:37'!
at: aKey ifAbsent: anErrorBlock
	| result |
	result := table at: aKey ifAbsent: [ ^ anErrorBlock value ].
	ageTable at: result put: 0.
	^ result! !

!WALRUCache methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
at: aKey put: aValue
	| removals |
	table at: aKey put: aValue.
	ageTable at: aValue put: 0.
	removals := OrderedCollection new.
	ageTable associationsDo: [ :assoc |
		assoc value > max
			ifTrue: [ removals add: assoc key ]
			ifFalse: [ assoc value: assoc value + 1 ] ].
	removals do: [ :each | self remove: each ]! !

!WALRUCache methodsFor: 'initialize-release' stamp: 'ab 7/15/2002 00:10'!
capacity: aNumber
	max := aNumber! !

!WALRUCache methodsFor: 'initialize-release' stamp: 'lr 3/19/2007 20:16'!
initialize
	max := 20.
	table := Dictionary new.
	ageTable := Dictionary new! !

!WALRUCache methodsFor: 'testing' stamp: 'avi 1/31/2004 17:45'!
isEmpty
	^ table isEmpty! !

!WALRUCache methodsFor: 'callbacks' stamp: 'lr 8/30/2008 16:22'!
nextKey
	| key |
	[ table includesKey: (key := WAExternalID new seasideString) ] whileTrue.
	^ key! !

!WALRUCache methodsFor: 'removing' stamp: 'lr 10/28/2007 14:42'!
remove: anObject
	ageTable removeKey: anObject.
	table removeKey: (table keyAtValue: anObject)! !

!WALRUCache methodsFor: 'callbacks' stamp: 'lr 3/19/2007 20:43'!
store: anObject
	| key |
	key := self nextKey.
	self at: key put: anObject.
	^ key! !

Object subclass: #WALibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Libraries'!

WALibrary class
	instanceVariableNames: 'default'!

!WALibrary commentStamp: 'pmm 4/22/2007 12:56' prior: 0!
I'm the common superclass of file and string libraries.!

WALibrary class
	instanceVariableNames: 'default'!

WALibrary subclass: #WAFileLibrary
	instanceVariableNames: ''
	classVariableNames: 'MimeTypes'
	poolDictionaries: ''
	category: 'Seaside-Core-Libraries'!

!WAFileLibrary commentStamp: 'pmm 8/17/2007 06:58' prior: 0!
What does FileLibrary do
=============================
It allows to serve static files directly from seaside without the need for a standalone server like Apache or to configure Kom. These files can reference each other (say a CSS references an image) and can be distrubuted the same way as normal Smalltalk code (Monticello, SqueakMap, ...).

Each file in a file library is represented by a method. The method name is created from the file name, the dot is removed and the first letter of the suffix in capitalized. This puts certain limitations to the allowed filenames. Eg. 'main.css' becomes #mainCss.

Like Script- and StyleLibraries FileLibraries can be added to an application so that they automatically include themselves in the document root. Implement #selectorsToInclude and return the selectors you whish to be added to the document root.

How to create a FileLibrary
================================
- First create the static files and put them in some directory. From there they can reference the other files in the same directory normally with their filenames.
- Make sure you have a "Files" entry that serves your files. This is a normal entry point type that you can find in your /seaside/config application. If you don't already have one, you can create it if you select "Files" in the type field of the "add entry point" dialog. For the rest of this text we assume you chose "files" as the path.
- Create a subclass of WAFileLibrary, for the rest of this text I assume its name is MyFileLibrary.
- To add the files to your file library there are two ways.
1. Programmatically with MyFileLibrary class >> #addAllFilesIn: / #addFileNamed:. For example MyFileLibrary addAllFilesIn: '/path/to/directory/with/files' or MyFileLibrary addFileNamed: '/path/to/background.png'.
2. Via the web interface. Go to your /seaside/config application and there click configure for your "Files". Click "configure" behind MyFileLibrary. There you can add a file by uploading it (select the file, then click "Add")

Note that a "Files" can consist of several file libraries and can even have tradional script or style libraries.

How to integrate a FileLibrary into your application
=============================================================
Files from a FileLibrary are ingetrated the same way other static files are integrated. They have a constant path that is '/seaside/<Static File Library>/<FileLibrary class name>/<filename>' so for example '/seaside/files/MyFileLibrary/background.png'. These can be conveniently generated by 'MyFileLibrary / #aSelector' where #aSelector is the name of the method representing that file. For example 'MyFileLibrary / #backgroundPng'.

How to get back the files in a FileLibrary
=================================================
The contents of a file library can be written out to disk. Writing out a file library first makes a folder with the name of the file library in the folder of your Smallatlk image. Then a file for each file in the file library is created in this folder. Writing out to disk can happen in three ways
1. MyFileLibrary default deployFiles
2. Via the configuration interface of the file library. On the same page where you can add files to your file library there is also a button 'write to disk' which will write out all the files in this library.
3. Via the configuration interface of your application. In the section where you can add libraries to your application there is a a button 'write to disk' which will write out all the libraries of this application.

Examples:
==========

The following code uses WAFileLibrary to add a CSS file to a page.

updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot stylesheet 
		url: WAFileLibraryDemo / #mainCss
		
The folllowing code uses WAFileLibrary to display an image.

renderContentOn: html
	html image
		url: WAFileLibraryDemo / #mainJpg!

!WAFileLibrary class methodsFor: 'convenience' stamp: 'pmm 2/27/2007 20:35'!
/ aSymbol
	^self urlOf: aSymbol! !

!WAFileLibrary class methodsFor: 'adding-files' stamp: 'pmm 10/4/2006 20:31'!
addAllFilesIn: aPathString
	"adds all files in the directory specified by aPathString to the current file library"
	(SeasidePlatformSupport filesIn: aPathString)
		do: [ :each | self addFileAt: each ]! !

!WAFileLibrary class methodsFor: 'adding-files' stamp: 'pmm 10/5/2006 18:29'!
addFileAt: aPath
	"adds the file specified by aFilename to the current file library"
	self
		addFileAt: aPath
		contents: (SeasidePlatformSupport
			contentsOfFile: aPath
			binary: (self isBinaryAt: aPath))! !

!WAFileLibrary class methodsFor: 'private' stamp: 'pmm 10/4/2006 20:29'!
addFileAt: aPath contents: aByteArrayOrString
	self
		addFileNamed: (SeasidePlatformSupport localNameOf: aPath)
		contents: aByteArrayOrString! !

!WAFileLibrary class methodsFor: 'private' stamp: 'pmm 10/5/2006 18:37'!
addFileNamed: aFilename contents: aByteArrayOrString
	| selector |
	selector := self asSelector: aFilename.
	(self isBinary: aFilename)
		ifTrue: [ self compileBinary: aByteArrayOrString selector: selector ]
		ifFalse: [ self compileText: aByteArrayOrString selector: selector ]! !

!WAFileLibrary class methodsFor: 'vw port-squeak' stamp: 'lr 10/28/2007 14:42'!
adjustForVisualWorks
	| newSource oldSource badCode goodCode |
	badCode := 'xxxCache := #(nil).'.
	goodCode := 'xxxCache := #(nil) beMutable.'.
	self selectors do: [:selector |
		oldSource := self sourceCodeAt: selector.
		(oldSource indexOfSubCollection: badCode startingAt: 1) > 0 ifTrue:
			[newSource := oldSource copyReplaceAll: badCode with: goodCode.
			self compile: newSource classified: self methodCategory]]! !

!WAFileLibrary class methodsFor: 'private' stamp: 'pmm 2/23/2008 18:25'!
asSelector: aFilename
	| mainPart extension |
	mainPart := (aFilename copyUpToLast: $.)
		select: [ :each | each isAlphaNumeric ].
	[ mainPart first isDigit ]
		whileTrue: [ mainPart := mainPart allButFirst ].
	extension := (aFilename copyAfterLast: $.) asLowercase capitalized.
	^ (mainPart , extension) asSymbol! !

!WAFileLibrary class methodsFor: 'private' stamp: 'pmm 5/22/2007 22:08'!
compileBinary: aByteArrayOrString selector: aSymbol
	"compiles aByteArrayOrString into a method named aSymbol that returns aByteArrayOrString as a byte array"
	| code |
	code := SeasidePlatformSupport asMethodReturningByteArray: aByteArrayOrString named: aSymbol.
	SeasidePlatformSupport compile: code into: self classified: self methodCategory! !

!WAFileLibrary class methodsFor: 'private' stamp: 'lr 8/30/2008 16:22'!
compileText: aByteArrayOrString selector: aSymbol 
	"Compiles aByteArrayOrString into a method named aSymbol that returns aByteArrayOrString as a string literal.
	aSymbol
		^ aByteArrayOrString"
	| code |
	code := String streamContents: 
		[ :stream | 
		stream
			nextPutAll: aSymbol;
			cr.
		stream
			tab;
			nextPutAll: '^ '''.
		aByteArrayOrString seasideString do: 
			[ :each | 
			each = $' ifTrue: [ stream nextPut: $' ].
			stream nextPut: each ].
		stream nextPutAll: '''' ].
	SeasidePlatformSupport 
		compile: code
		into: self
		classified: self methodCategory! !

!WAFileLibrary class methodsFor: 'accessing-defaults' stamp: 'pmm 4/20/2006 20:52'!
defaultMimeType
	^ 'application/octet-stream'! !

!WAFileLibrary class methodsFor: 'accessing-defaults' stamp: 'pmm 9/6/2007 22:27'!
defaultMimeTypes
	^ #(
		'%' 'application/x-trash'
		'323' 'text/h323'
		'abw' 'application/x-abiword'
		'ai' 'application/postscript'
		'aif' 'audio/x-aiff'
		'aifc' 'audio/x-aiff'
		'aiff' 'audio/x-aiff'
		'alc' 'chemical/x-alchemy'
		'art' 'image/x-jg'
		'asc' 'text/plain'
		'asf' 'video/x-ms-asf'
		'asn' 'chemical/x-ncbi-asn1-spec'
		'aso' 'chemical/x-ncbi-asn1-binary'
		'asx' 'video/x-ms-asf'
		'au' 'audio/basic'
		'avi' 'video/x-msvideo'
		'b' 'chemical/x-molconn-Z'
		'bak' 'application/x-trash'
		'bat' 'application/x-msdos-program'
		'bcpio' 'application/x-bcpio'
		'bib' 'text/x-bibtex'
		'bin' 'application/octet-stream'
		'bmp' 'image/x-ms-bmp'
		'book' 'application/x-maker'
		'bsd' 'chemical/x-crossfire'
		'c' 'text/x-csrc'
		'c++' 'text/x-c++src'
		'c3d' 'chemical/x-chem3d'
		'cac' 'chemical/x-cache'
		'cache' 'chemical/x-cache'
		'cascii' 'chemical/x-cactvs-binary'
		'cat' 'application/vnd.ms-pki.seccat'
		'cbin' 'chemical/x-cactvs-binary'
		'cc' 'text/x-c++src'
		'cdf' 'application/x-cdf'
		'cdr' 'image/x-coreldraw'
		'cdt' 'image/x-coreldrawtemplate'
		'cdx' 'chemical/x-cdx'
		'cdy' 'application/vnd.cinderella'
		'cef' 'chemical/x-cxf'
		'cer' 'chemical/x-cerius'
		'chm' 'chemical/x-chemdraw'
		'chrt' 'application/x-kchart'
		'cif' 'chemical/x-cif'
		'class' 'application/java-vm'
		'cls' 'text/x-tex'
		'cmdf' 'chemical/x-cmdf'
		'cml' 'chemical/x-cml'
		'cod' 'application/vnd.rim.cod'
		'com' 'application/x-msdos-program'
		'cpa' 'chemical/x-compass'
		'cpio' 'application/x-cpio'
		'cpp' 'text/x-c++src'
		'cpt' 'image/x-corelphotopaint'
		'crl' 'application/x-pkcs7-crl'
		'crt' 'application/x-x509-ca-cert'
		'csf' 'chemical/x-cache-csf'
		'csh' 'text/x-csh'
		'csm' 'chemical/x-csml'
		'csml' 'chemical/x-csml'
		'css' 'text/css'
		'csv' 'text/comma-separated-values'
		'ctab' 'chemical/x-cactvs-binary'
		'ctx' 'chemical/x-ctx'
		'cu' 'application/cu-seeme'
		'cub' 'chemical/x-gaussian-cube'
		'cxf' 'chemical/x-cxf'
		'cxx' 'text/x-c++src'
		'dat' 'chemical/x-mopac-input'
		'dcr' 'application/x-director'
		'deb' 'application/x-debian-package'
		'dif' 'video/dv'
		'diff' 'text/plain'
		'dir' 'application/x-director'
		'djv' 'image/vnd.djvu'
		'djvu' 'image/vnd.djvu'
		'dl' 'video/dl'
		'dll' 'application/x-msdos-program'
		'dmg' 'application/x-apple-diskimage'
		'dms' 'application/x-dms'
		'doc' 'application/msword'
		'dot' 'application/msword'
		'dv' 'video/dv'
		'dvi' 'application/x-dvi'
		'dx' 'chemical/x-jcamp-dx'
		'dxr' 'application/x-director'
		'emb' 'chemical/x-embl-dl-nucleotide'
		'embl' 'chemical/x-embl-dl-nucleotide'
		'ent' 'chemical/x-pdb'
		'eps' 'application/postscript'
		'etx' 'text/x-setext'
		'exe' 'application/x-msdos-program'
		'ez' 'application/andrew-inset'
		'fb' 'application/x-maker'
		'fbdoc' 'application/x-maker'
		'fch' 'chemical/x-gaussian-checkpoint'
		'fchk' 'chemical/x-gaussian-checkpoint'
		'fig' 'application/x-xfig'
		'flac' 'application/x-flac'
		'fli' 'video/fli'
		'fm' 'application/x-maker'
		'frame' 'application/x-maker'
		'frm' 'application/x-maker'
		'gal' 'chemical/x-gaussian-log'
		'gam' 'chemical/x-gamess-input'
		'gamin' 'chemical/x-gamess-input'
		'gau' 'chemical/x-gaussian-input'
		'gcd' 'text/x-pcs-gcd'
		'gcf' 'application/x-graphing-calculator'
		'gcg' 'chemical/x-gcg8-sequence'
		'gen' 'chemical/x-genbank'
		'gf' 'application/x-tex-gf'
		'gif' 'image/gif'
		'gjc' 'chemical/x-gaussian-input'
		'gjf' 'chemical/x-gaussian-input'
		'gl' 'video/gl'
		'gnumeric' 'application/x-gnumeric'
		'gpt' 'chemical/x-mopac-graph'
		'gsf' 'application/x-font'
		'gsm' 'audio/x-gsm'
		'gtar' 'application/x-gtar'
		'h' 'text/x-chdr'
		'h++' 'text/x-c++hdr'
		'hdf' 'application/x-hdf'
		'hh' 'text/x-c++hdr'
		'hin' 'chemical/x-hin'
		'hpp' 'text/x-c++hdr'
		'hqx' 'application/mac-binhex40'
		'hs' 'text/x-haskell'
		'hta' 'application/hta'
		'htc' 'text/x-component'
		'htm' 'text/html'
		'html' 'text/html'
		'hxx' 'text/x-c++hdr'
		'ica' 'application/x-ica'
		'ice' 'x-conference/x-cooltalk'
		'ico' 'image/x-icon'
		'ics' 'text/calendar'
		'icz' 'text/calendar'
		'ief' 'image/ief'
		'iges' 'model/iges'
		'igs' 'model/iges'
		'iii' 'application/x-iphone'
		'inp' 'chemical/x-gamess-input'
		'ins' 'application/x-internet-signup'
		'iso' 'application/x-iso9660-image'
		'isp' 'application/x-internet-signup'
		'ist' 'chemical/x-isostar'
		'istr' 'chemical/x-isostar'
		'jad' 'text/vnd.sun.j2me.app-descriptor'
		'jar' 'application/java-archive'
		'java' 'text/x-java'
		'jdx' 'chemical/x-jcamp-dx'
		'jmz' 'application/x-jmol'
		'jng' 'image/x-jng'
		'jnlp' 'application/x-java-jnlp-file'
		'jpe' 'image/jpeg'
		'jpeg' 'image/jpeg'
		'jpg' 'image/jpeg'
		'js' 'application/x-javascript'
		'kar' 'audio/midi'
		'key' 'application/pgp-keys'
		'kil' 'application/x-killustrator'
		'kin' 'chemical/x-kinemage'
		'kpr' 'application/x-kpresenter'
		'kpt' 'application/x-kpresenter'
		'ksp' 'application/x-kspread'
		'kwd' 'application/x-kword'
		'kwt' 'application/x-kword'
		'latex' 'application/x-latex'
		'lha' 'application/x-lha'
		'lhs' 'text/x-literate-haskell'
		'lsf' 'video/x-la-asf'
		'lsx' 'video/x-la-asf'
		'ltx' 'text/x-tex'
		'lzh' 'application/x-lzh'
		'lzx' 'application/x-lzx'
		'm3u' 'audio/x-mpegurl'
		'm4a' 'audio/mpeg'
		'maker' 'application/x-maker'
		'man' 'application/x-troff-man'
		'mcif' 'chemical/x-mmcif'
		'mcm' 'chemical/x-macmolecule'
		'mdb' 'application/msaccess'
		'me' 'application/x-troff-me'
		'mesh' 'model/mesh'
		'mid' 'audio/midi'
		'midi' 'audio/midi'
		'mif' 'application/x-mif'
		'mm' 'application/x-freemind'
		'mmd' 'chemical/x-macromodel-input'
		'mmf' 'application/vnd.smaf'
		'mml' 'text/mathml'
		'mmod' 'chemical/x-macromodel-input'
		'mng' 'video/x-mng'
		'moc' 'text/x-moc'
		'mol' 'chemical/x-mdl-molfile'
		'mol2' 'chemical/x-mol2'
		'moo' 'chemical/x-mopac-out'
		'mop' 'chemical/x-mopac-input'
		'mopcrt' 'chemical/x-mopac-input'
		'mov' 'video/quicktime'
		'movie' 'video/x-sgi-movie'
		'mp2' 'audio/mpeg'
		'mp3' 'audio/mpeg'
		'mp4' 'video/mp4'
		'mpc' 'chemical/x-mopac-input'
		'mpe' 'video/mpeg'
		'mpeg' 'video/mpeg'
		'mpega' 'audio/mpeg'
		'mpg' 'video/mpeg'
		'mpga' 'audio/mpeg'
		'ms' 'application/x-troff-ms'
		'msh' 'model/mesh'
		'msi' 'application/x-msi'
		'mvb' 'chemical/x-mopac-vib'
		'mxu' 'video/vnd.mpegurl'
		'nb' 'application/mathematica'
		'nc' 'application/x-netcdf'
		'nwc' 'application/x-nwc'
		'o' 'application/x-object'
		'oda' 'application/oda'
		'odb' 'application/vnd.oasis.opendocument.database'
		'odc' 'application/vnd.oasis.opendocument.chart'
		'odf' 'application/vnd.oasis.opendocument.formula'
		'odg' 'application/vnd.oasis.opendocument.graphics'
		'odi' 'application/vnd.oasis.opendocument.image'
		'odm' 'application/vnd.oasis.opendocument.text-master'
		'odp' 'application/vnd.oasis.opendocument.presentation'
		'ods' 'application/vnd.oasis.opendocument.spreadsheet'
		'odt' 'application/vnd.oasis.opendocument.text'
		'ogg' 'application/ogg'
		'old' 'application/x-trash'
		'oth' 'application/vnd.oasis.opendocument.text-web'
		'oza' 'application/x-oz-application'
		'p' 'text/x-pascal'
		'p7r' 'application/x-pkcs7-certreqresp'
		'pac' 'application/x-ns-proxy-autoconfig'
		'pas' 'text/x-pascal'
		'pat' 'image/x-coreldrawpattern'
		'pbm' 'image/x-portable-bitmap'
		'pcf' 'application/x-font'
		'pcf.Z' 'application/x-font'
		'pcx' 'image/pcx'
		'pdb' 'chemical/x-pdb'
		'pdf' 'application/pdf'
		'pfa' 'application/x-font'
		'pfb' 'application/x-font'
		'pgm' 'image/x-portable-graymap'
		'pgn' 'application/x-chess-pgn'
		'pgp' 'application/pgp-signature'
		'pk' 'application/x-tex-pk'
		'pl' 'text/x-perl'
		'pls' 'audio/x-scpls'
		'pm' 'text/x-perl'
		'png' 'image/png'
		'pnm' 'image/x-portable-anymap'
		'pot' 'text/plain'
		'ppm' 'image/x-portable-pixmap'
		'pps' 'application/vnd.ms-powerpoint'
		'ppt' 'application/vnd.ms-powerpoint'
		'prf' 'application/pics-rules'
		'prt' 'chemical/x-ncbi-asn1-ascii'
		'ps' 'application/postscript'
		'psd' 'image/x-photoshop'
		'psp' 'text/x-psp'
		'py' 'text/x-python'
		'pyc' 'application/x-python-code'
		'pyo' 'application/x-python-code'
		'qt' 'video/quicktime'
		'qtl' 'application/x-quicktimeplayer'
		'ra' 'audio/x-realaudio'
		'ram' 'audio/x-pn-realaudio'
		'rar' 'application/rar'
		'ras' 'image/x-cmu-raster'
		'rd' 'chemical/x-mdl-rdfile'
		'rdf' 'application/rdf+xml'
		'rgb' 'image/x-rgb'
		'rm' 'audio/x-pn-realaudio'
		'roff' 'application/x-troff'
		'ros' 'chemical/x-rosdal'
		'rpm' 'application/x-redhat-package-manager'
		'rss' 'application/rss+xml'
		'rtf' 'text/rtf'
		'rtx' 'text/richtext'
		'rxn' 'chemical/x-mdl-rxnfile'
		'sct' 'text/scriptlet'
		'sd' 'chemical/x-mdl-sdfile'
		'sd2' 'audio/x-sd2'
		'sda' 'application/vnd.stardivision.draw'
		'sdc' 'application/vnd.stardivision.calc'
		'sdd' 'application/vnd.stardivision.impress'
		'sdf' 'chemical/x-mdl-sdfile'
		'sdp' 'application/vnd.stardivision.impress'
		'sdw' 'application/vnd.stardivision.writer'
		'ser' 'application/java-serialized-object'
		'sgf' 'application/x-go-sgf'
		'sgl' 'application/vnd.stardivision.writer-global'
		'sh' 'text/x-sh'
		'shar' 'application/x-shar'
		'shtml' 'text/html'
		'sid' 'audio/prs.sid'
		'sik' 'application/x-trash'
		'silo' 'model/mesh'
		'sis' 'application/vnd.symbian.install'
		'sit' 'application/x-stuffit'
		'skd' 'application/x-koan'
		'skm' 'application/x-koan'
		'skp' 'application/x-koan'
		'skt' 'application/x-koan'
		'smf' 'application/vnd.stardivision.math'
		'smi' 'application/smil'
		'smil' 'application/smil'
		'snd' 'audio/basic'
		'spc' 'chemical/x-galactic-spc'
		'spl' 'application/x-futuresplash'
		'src' 'application/x-wais-source'
		'stc' 'application/vnd.sun.xml.calc.template'
		'std' 'application/vnd.sun.xml.draw.template'
		'sti' 'application/vnd.sun.xml.impress.template'
		'stl' 'application/vnd.ms-pki.stl'
		'stw' 'application/vnd.sun.xml.writer.template'
		'sty' 'text/x-tex'
		'sv4cpio' 'application/x-sv4cpio'
		'sv4crc' 'application/x-sv4crc'
		'svg' 'image/svg+xml'
		'svgz' 'image/svg+xml'
		'sw' 'chemical/x-swissprot'
		'swf' 'application/x-shockwave-flash'
		'swfl' 'application/x-shockwave-flash'
		'sxc' 'application/vnd.sun.xml.calc'
		'sxd' 'application/vnd.sun.xml.draw'
		'sxg' 'application/vnd.sun.xml.writer.global'
		'sxi' 'application/vnd.sun.xml.impress'
		'sxm' 'application/vnd.sun.xml.math'
		'sxw' 'application/vnd.sun.xml.writer'
		't' 'application/x-troff'
		'tar' 'application/x-tar'
		'taz' 'application/x-gtar'
		'tcl' 'text/x-tcl'
		'tex' 'text/x-tex'
		'texi' 'application/x-texinfo'
		'texinfo' 'application/x-texinfo'
		'text' 'text/plain'
		'tgf' 'chemical/x-mdl-tgf'
		'tgz' 'application/x-gtar'
		'tif' 'image/tiff'
		'tiff' 'image/tiff'
		'tk' 'text/x-tcl'
		'tm' 'text/texmacs'
		'torrent' 'application/x-bittorrent'
		'tr' 'application/x-troff'
		'ts' 'text/texmacs'
		'tsp' 'application/dsptype'
		'tsv' 'text/tab-separated-values'
		'txt' 'text/plain'
		'udeb' 'application/x-debian-package'
		'uls' 'text/iuls'
		'ustar' 'application/x-ustar'
		'val' 'chemical/x-ncbi-asn1-binary'
		'vcd' 'application/x-cdlink'
		'vcf' 'text/x-vcard'
		'vcs' 'text/x-vcalendar'
		'vmd' 'chemical/x-vmd'
		'vms' 'chemical/x-vamas-iso14976'
		'vor' 'application/vnd.stardivision.writer'
		'vrm' 'x-world/x-vrml'
		'vrml' 'x-world/x-vrml'
		'vsd' 'application/vnd.visio'
		'wad' 'application/x-doom'
		'wav' 'audio/x-wav'
		'wax' 'audio/x-ms-wax'
		'wbmp' 'image/vnd.wap.wbmp'
		'wbxml' 'application/vnd.wap.wbxml'
		'wk' 'application/x-123'
		'wm' 'video/x-ms-wm'
		'wma' 'audio/x-ms-wma'
		'wmd' 'application/x-ms-wmd'
		'wml' 'text/vnd.wap.wml'
		'wmlc' 'application/vnd.wap.wmlc'
		'wmls' 'text/vnd.wap.wmlscript'
		'wmlsc' 'application/vnd.wap.wmlscriptc'
		'wmv' 'video/x-ms-wmv'
		'wmx' 'video/x-ms-wmx'
		'wmz' 'application/x-ms-wmz'
		'wp5' 'application/wordperfect5.1'
		'wpd' 'application/wordperfect'
		'wrl' 'x-world/x-vrml'
		'wsc' 'text/scriptlet'
		'wvx' 'video/x-ms-wvx'
		'wz' 'application/x-wingz'
		'xbm' 'image/x-xbitmap'
		'xcf' 'application/x-xcf'
		'xht' 'application/xhtml+xml'
		'xhtml' 'application/xhtml+xml'
		'xlb' 'application/vnd.ms-excel'
		'xls' 'application/vnd.ms-excel'
		'xlt' 'application/vnd.ms-excel'
		'xml' 'application/xml'
		'xpi' 'application/x-xpinstall'
		'xpm' 'image/x-xpixmap'
		'xsl' 'application/xml'
		'xtel' 'chemical/x-xtel'
		'xul' 'application/vnd.mozilla.xul+xml'
		'xwd' 'image/x-xwindowdump'
		'xyz' 'chemical/x-xyz'
		'zip' 'application/zip'
		'zmt' 'chemical/x-mopac-input'
		'~' 'application/x-trash'

	)! !

!WAFileLibrary class methodsFor: 'class initialization' stamp: 'pmm 9/6/2007 22:28'!
initialize
	MimeTypes := Dictionary new.
	1 to: self defaultMimeTypes size by: 2 do: [ :index |
		MimeTypes
			at: (self defaultMimeTypes at: index)
			put: (self defaultMimeTypes at: index + 1) ]! !

!WAFileLibrary class methodsFor: 'private' stamp: 'pmm 1/4/2008 15:04'!
isBinary: aFilename
	^(self mimetypeFor: (aFilename copyAfterLast: $.)) isBinary! !

!WAFileLibrary class methodsFor: 'private' stamp: 'pmm 10/5/2006 18:37'!
isBinaryAt: aPath
	^self isBinary: (SeasidePlatformSupport localNameOf: aPath)! !

!WAFileLibrary class methodsFor: 'private' stamp: 'pmm 4/7/2007 00:58'!
methodCategory
	"the method category for uploaded files"
	^#uploaded! !

!WAFileLibrary class methodsFor: 'accessing' stamp: 'pmm 1/4/2008 15:03'!
mimetypeFor: aString
	^ (self mimetypes at: aString ifAbsent: [ self defaultMimeType ]) toMimeType! !

!WAFileLibrary class methodsFor: 'accessing' stamp: 'pmm 4/20/2006 20:51'!
mimetypes
	^ MimeTypes! !

!WAFileLibrary class methodsFor: 'convenience' stamp: 'pmm 2/13/2007 18:03'!
register
	"no longer needed left in so that code can still be loaded since it is sent in class side initialize methods"! !

!WAFileLibrary class methodsFor: 'accessing' stamp: 'pmm 3/21/2008 17:20'!
renderListing
	^self default renderListing! !

!WAFileLibrary class methodsFor: 'convenience' stamp: 'pmm 2/16/2007 16:01'!
unregister
	"no longer used"! !

!WAFileLibrary class methodsFor: 'convenience' stamp: 'pmm 2/16/2007 16:05'!
urlOf: aSymbol
	^self new urlOf: aSymbol! !

!WAFileLibrary methodsFor: 'actions' stamp: 'lr 10/28/2007 14:42'!
addFile: aFile
	"adds a file to the receiver

	aFile an instance of of WAFile"
	| contents |
	aFile isNil ifTrue: [ ^self "in case no file was selected for uploading" ].

	contents := (self class isBinary: aFile fileName)
		ifTrue: [ aFile contents ]
		ifFalse: [ SeasidePlatformSupport convertToSmalltalkNewlines: aFile contents ].
	self class addFileNamed: aFile fileName contents: contents! !

!WAFileLibrary methodsFor: 'private' stamp: 'lr 8/30/2008 16:22'!
asFilename: aSelector 
	| dotIndex extension |
	dotIndex := self lastUpperCaseIndexIn: aSelector.
	dotIndex = 0 ifTrue: 
		[ "convert Symbol to String"
		^ aSelector seasideString ].
	extension := (aSelector last: aSelector size - dotIndex + 1) asLowercase.
	^ (aSelector first: dotIndex - 1) , '.' , extension! !

!WAFileLibrary methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
asSelector: aFilename
	^ self class asSelector: aFilename! !

!WAFileLibrary methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
compileBinary: aString selector: aSymbol
	^self class compileBinary: aString selector: aSymbol! !

!WAFileLibrary methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
compileText: aString selector: aSymbol
	self class compileText: aString selector: aSymbol! !

!WAFileLibrary methodsFor: 'private' stamp: 'pmm 2/22/2007 07:21'!
fileSelectors
	^ (self class selectors
		select: [ :each | self isFileSelector: each ])
		removeAllFoundIn: self nonFileSelectors;
		yourself! !

!WAFileLibrary methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
isFileSelector: aSymbol
	^ aSymbol isUnary and: [ (self lastUpperCaseIndexIn: aSymbol) > 1 ]! !

!WAFileLibrary methodsFor: 'private' stamp: 'lr 2/18/2007 12:28'!
lastUpperCaseIndexIn: aString
	^ aString findLast: [ :each | each isUppercase ]! !

!WAFileLibrary methodsFor: 'accessing' stamp: 'mb 2/23/2007 10:18'!
mimetypeForFile: aFilename
	^self class mimetypeFor: (aFilename copyAfterLast: $.)! !

!WAFileLibrary methodsFor: 'private' stamp: 'pmm 2/22/2007 07:17'!
nonFileSelectors
	^#(
		nonFileSelectors
		selectorsToInclude
	)! !

!WAFileLibrary methodsFor: 'actions' stamp: 'pmm 4/21/2006 23:57'!
removeFile: aFilename
	SeasidePlatformSupport
		removeSelector: (self asSelector: aFilename)
		from: self class! !

!WAFileLibrary methodsFor: 'actions' stamp: 'lr 10/28/2007 14:42'!
renameFile: oldName to: newName
	| contents file |
	(self asSelector: oldName) = (self asSelector: newName)
		ifTrue: [ ^ nil ].
	contents := self perform: (self asSelector: oldName).
	file := WAFile new contents: contents.
	file fileName: newName.
	self addFile: file.
	self removeFile: oldName! !

!WAFileLibrary methodsFor: 'rendering' stamp: 'pmm 3/24/2008 17:50'!
renderListing
	| title |
	title := 'Index of ', self name.
	^WARenderCanvas builder
		rootBlock: [ :html | html title: title ];
		renderResponse: [ :html |
			html heading level: 1; with: title.
			html table: [
				html tableRow: [
					html tableHeading: 'Name'.
					html tableHeading: 'Size'.
					html tableHeading: 'Description' ].
				self fileSelectors do: [ :each |
					html tableRow: [
						html tableData: [
							html anchor
								url: (self urlOf: each);
								with: (self asFilename: each) ].
						html tableData: (self perform: each) size.
						html tableData: (self mimetypeForFile: (self asFilename: each)) ] ] ] ]! !

!WAFileLibrary methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
selectorsToInclude
	"The files represented by the selectors this method returns will be automatically added to the html <head> if the receiver is added to the respective Seaside application.

	This makes only sense for CSS and JS files"
	^ #()! !

!WAFileLibrary methodsFor: 'processing' stamp: 'lr 4/9/2007 11:06'!
updateRoot: aHtmlRoot
	"Only override if you want to automatically include new types of resources. The default implementation knows how to reference CSS, JS and FavIcons into aHtmlRoot."

	self selectorsToInclude do: [ :each |
		(each endsWith: #Js)
			ifTrue: [ aHtmlRoot javascript url: (self urlOf: each) ].
		(each endsWith: #Ico)
			ifTrue: [ aHtmlRoot link beShortcutIcon; url: (self urlOf: each) ].
		(each endsWith: #Css)
			ifTrue: [ aHtmlRoot stylesheet url: (self urlOf: each) ] ]! !

WAFileLibrary subclass: #WAStandardFiles
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Libraries'!

!WAStandardFiles commentStamp: 'lr 6/5/2007 19:29' prior: 0!
A collection of standard scripts, styles, and images. They are needed for the configuration application and some basic look-and-feel in Seaside. The icons are from the Tango Desktop Project (tango.freedesktop.org), they are licensed under the Creative Commons Attribution Share-Alike license.!

!WAStandardFiles methodsFor: 'accessing-scripts' stamp: 'pmm 2/13/2007 19:16'!
externalAnchorsJs
	^ '// See http://www.sitepoint.com/article/standards-compliant-world
function externalLinks() {
	if (!!document.getElementsByTagName) return;
	var anchors = document.getElementsByTagName("a");
	for (var i=0; i<anchors.length; i++) {
	var anchor = anchors[i];
	if (anchor.getAttribute("href") && anchor.getAttribute("rel") == "external")
		anchor.target = "_blank";
	}
}'! !

!WAStandardFiles methodsFor: 'accessing-styles' stamp: 'lr 10/28/2007 14:42'!
kalseyTabsCss
	"this is from http://kalsey.com/tools/csstabs/ - would also be nice to do http://www.alistapart.com/articles/slidingdoors/"
	^ '
.kalsey .navigation-options {
	border-bottom : 1px solid #ccc;
	margin : 0;
	padding-bottom : 19px;
	padding-left : 10px;
}

.kalsey .navigation-options ul, .kalsey .navigation-options li	{
	display : inline;
	list-style-type : none;
	margin : 0;
	padding : 0;
}


.kalsey .navigation-options a:link, .kalsey .navigation-options a:visited	{
	background : #E8EBF0;
	border : 1px solid #ccc;
	color : #666;
	float : left;
	font-size : small;
	font-weight : normal;
	line-height : 14px;
	margin-right : 8px;
	padding : 2px 10px 2px 10px;
	text-decoration : none;
}

.kalsey .navigation-options a:link.active, .kalsey .navigation-options a:visited.active	{
	background : #fff;
	border-bottom : 1px solid #fff;
	color : #000;
}

.kalsey .navigation-options ul a:hover	{
	color : #f00;
}

.kalsey .navigation-options .option-selected a {
	background : #fff;
	border-bottom : 1px solid #fff;
	color : #000;
}

.kalsey .navigation-content {
	background : #fff;
	border : 1px solid #ccc;
	border-top : none;
	clear : both;
	margin : 0px;
	padding : 15px;
	line-height: 1.1;  /* IE6 CSS workaround - http://www.dracos.co.uk/web/css/ie6floatbug/ */
}
'! !

!WAStandardFiles methodsFor: 'accessing-scripts' stamp: 'lr 10/28/2007 14:42'!
miscJs
	^ '
	function swapDisplay(a, b) {
		var tmp = document.getElementById(a).style.display;
		document.getElementById(a).style.display = document.getElementById(b).style.display;
		document.getElementById(b).style.display = tmp;
	}

	function submitFormTriggeringCallback(formName, callbackKey, value) {
		if (value)
			{
				var ele = document.createElement("input");
				ele.type = "hidden";
				ele.name = callbackKey;
				ele.value = value;
				document.forms[formName].appendChild(ele)
			}
		submitForm(formName)
	}

	function submitForm(formName) {
		document.forms[formName].submit();
	}

	function chooseOther(select, hiddenId, p) {
		value = prompt(p);
		document.getElementById(hiddenId).value = value;
		select.options[select.options.length-1].text = value;
	}

	function enableChoice(enableID, disableID) {
		document.getElementById(enableID).disabled = false;
		document.getElementById(disableID).disabled = true;
	}

	function setFocus(elementId) {
		document.getElementById(elementId).focus();
	}

	function setSelection(elementId, start, stop) {
		var input = document.getElementById(elementId);
		input.focus();
		/* When stop parameter not supplied, all field is selected */
		if (!!start) start = 1;
		if (!!stop) stop = input.value.length + 1;
		if (typeof document.selection !!= "undefined") {
	    		/* Place selection in MS-IE */
	    		var range = document.selection.createRange();
	     	range.moveStart("character", start - 1);
	     	range.moveEnd("character", stop - start);
	 		range.select();
	  	} else if (typeof input.selectionStart !!= "undefined") {
		  	/* Place selection in Gecko browsers */
	    		input.selectionStart = start - 1;
	    		input.selectionEnd = stop - 1;
	  	} else {
	  		/* Other browsers, please feel free to implement */
			alert("unknown browser");
		}
	}

'! !

!WAStandardFiles methodsFor: 'accessing' stamp: 'MAD 8/29/2008 16:43'!
selectorsToInclude
	^#(
		windowCss

		kalseyTabsCss
		externalAnchorsJs
		miscJs
		shortcutsJs
	)! !

!WAStandardFiles methodsFor: 'accessing-scripts' stamp: 'lr 10/28/2007 14:42'!
shortcutsJs
	^ '

	var shortcutKeys = [];
	var shortcutElements = [];

	function resetShortcuts() {
		shortcutKeys = [];
		shortcutElements = [];
	}

	function addShortcut(shortcut, elementID) {
		var elem = document.getElementById(elementID);
		if ((elem.tagName == "INPUT" & (elem.type == "submit" || elem.type == "checkbox" || elem.type == "radio")) || elem.tagName == "A")
			{
			shortcutKeys[shortcutKeys.length] = shortcut;
			shortcutElements[shortcutElements.length] = elem;
			}
		else alert("Attempt to assign a shortcut (" + shortcut + ") to something that is not clickable");
	}

	function onKeyDown(event) {
		var keyname = "";
		var element;
		var nav;
		if (navigator.userAgent.indexOf("Safari") > 0)
			nav = "Safari";
		else if (navigator.product == "Gecko")
			nav = "Gecko";
		else
			nav = "IE";
		// cope with MS-IE
		if (event == null) event = window.event;
		if (event) {
			if (event.ctrlKey) keyname = keyname + "Ctrl-";
			if (event.altKey) keyname = keyname + "Alt-";
			if (event.metaKey) keyname = keyname + "Meta-";
			// cope with Netscape
			var keyCode = event.which;
			if (keyCode == null) keyCode = event.keyCode;
			if (keyCode == null) keyCode = event.charCode;
			if (keyCode !!= 0) {
				var character = String.fromCharCode(keyCode);
				character = character.toLowerCase();
				if (event.shiftKey) character = character.toUpperCase();
				// cope with special keys, designated with some logical names
				if (keyCode == 27) character = "Esc";
				if (keyCode == 8) character = "Backspace";
				if (keyCode == 9) character = "Tab";
				if (keyCode == 13) character = "Return";
				if (keyCode == 37) character = "Left";
				if (keyCode == 38) character = "Up";
				if (keyCode == 39) character = "Right";
				if (keyCode == 40) character = "Down";
				// cope with func-keys (some keys not intercepted for MS-IE)
				if ((keyCode >= 112) & (keyCode <= 123)) character = "F" + (keyCode - 112 + 1);
				for ( var x = 1 ; x <= shortcutKeys.length ; x++ ) {
					if (shortcutKeys[x-1] == keyname+character) {
						// alert("key=" + keyCode + " " + keyname + character);
						element = shortcutElements[x-1];
						if (element.tagName == "A" & nav !!= "IE") {
							if (element.onclick)
								element.onclick.call();
							else
								/* This does not work for anchor in IE */
								location.href = element.href;
						} else  {
							element.click();
						}
					}
				}
				return false;
			}
		}
	}

'! !

!WAStandardFiles methodsFor: 'processing' stamp: 'lr 10/28/2007 14:42'!
updateRoot: aHtmlRoot
	super updateRoot: aHtmlRoot.
	aHtmlRoot bodyAttributes
		at: 'onkeydown'
		put: 'onKeyDown(event)'! !

!WAStandardFiles methodsFor: 'accessing-styles' stamp: 'MAD 8/29/2008 19:38'!
windowCss
	^ '.window {
	border: 1px solid #aaa;
}
.window .window-titlebar {
	color: #444;
	padding: 5px;
	overflow: hidden;
	background-color: #eee;
	border-bottom: 1px solid #aaa;
	font: 10pt Verdana, Arial, Helvetica, sans-serif;
}
.window .window-titlebar .window-title {
	float: left;
	font-weight: bold;
	padding-left: 20px;
}
.window .window-titlebar .window-close {
	float: right;
}
.window .window-titlebar .window-close a {
	color: #444;
	text-decoration: none;
}
.window .window-titlebar .window-close a:hover {
	color: #111;
}
.window .window-content {
	clear: both;
	padding: 2px;
}'! !

!WALibrary class methodsFor: 'instance-creation' stamp: 'pmm 4/6/2007 13:27'!
default
	^ default ifNil: [ default := self new ]! !

!WALibrary class methodsFor: 'actions' stamp: 'pmm 8/14/2007 07:21'!
deployFiles
	^self default deployFiles! !

!WALibrary class methodsFor: 'accessing' stamp: 'pmm 7/21/2007 23:19'!
documentAt: aFilename ifAbsent: aBlock
	^self default
		documentAt: aFilename
		ifAbsent: aBlock! !

!WALibrary class methodsFor: 'testing' stamp: 'pmm 7/20/2007 06:56'!
handlesFolder: aSymbol
	^self name = aSymbol! !

!WALibrary methodsFor: 'accessing' stamp: 'mb 2/23/2007 10:25'!
asFilename: aFilename
	self subclassResponsibility! !

!WALibrary methodsFor: 'accessing' stamp: 'mb 2/23/2007 10:25'!
asSelector: aFilename
	self subclassResponsibility! !

!WALibrary methodsFor: 'actions' stamp: 'pmm 8/14/2007 19:34'!
deployFiles
	"Write to disk the files that the receiver use to serve as methods.
	The files are stored in a subfolder named like the classname of the receiver in a subfolder of Smalltalk image folder."
	SeasidePlatformSupport ensureExistenceOfFolder: self name.
	self fileSelectors do: [ :each |
		SeasidePlatformSupport
			write: (self perform: each)
			toFile: (self asFilename: each)
			inFolder: self name ]! !

!WALibrary methodsFor: 'accessing' stamp: 'akuhn 8/30/2008 15:57'!
documentAt: aFilename ifAbsent: aBlock
	| selector |
	selector := self asSelector: aFilename.
	^(self fileSelectors includes: selector)
		ifTrue: [ WAResponse
			document: (self documentForFile: aFilename)
			mimeType: (self mimetypeForFile: aFilename);
			cacheForMinutes: 30;
			yourself ]
		ifFalse: [ aBlock value ]! !

!WALibrary methodsFor: 'accessing' stamp: 'mb 2/23/2007 10:17'!
documentForFile: aFilename
	^self perform: (self asSelector: aFilename)! !

!WALibrary methodsFor: 'accessing' stamp: 'mb 2/23/2007 10:25'!
fileSelectors
	self subclassResponsibility! !

!WALibrary methodsFor: 'accessing' stamp: 'mb 2/23/2007 10:20'!
filenames
	^ self fileSelectors collect: [ :each | self asFilename: each ]! !

!WALibrary methodsFor: 'accessing' stamp: 'mb 2/23/2007 10:24'!
mimetypeForFile: aFilename
	self subclassResponsibility! !

!WALibrary methodsFor: 'accessing' stamp: 'mb 2/23/2007 10:21'!
name
	^ self class name! !

!WALibrary methodsFor: 'processing' stamp: 'mb 2/23/2007 10:29'!
updateRoot: anHtmlRoot! !

!WALibrary methodsFor: 'accessing' stamp: 'mb 2/22/2007 16:03'!
urlForFile: aFilename
	^ self urlOf: (self asSelector: aFilename)! !

!WALibrary methodsFor: 'accessing' stamp: 'mb 2/22/2007 16:03'!
urlOf: aSymbol
	^ self urlOf: aSymbol using: WAFileHandler default! !

!WALibrary methodsFor: 'accessing' stamp: 'mb 2/22/2007 16:03'!
urlOf: aSymbol using: aHandler
	^ aHandler baseUrl
		addToPath: self className;
		addToPath: (self asFilename: aSymbol);
		yourself! !

Object subclass: #WALocale
	instanceVariableNames: 'language country'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

WALocale class
	instanceVariableNames: 'iso2Languages iso3Languages iso2Countries iso3Countries'!

!WALocale commentStamp: 'pmm 6/1/2008 11:58' prior: 0!
A WALocale definces a users langauge and country.

Instance Variables
	country:		<String>
	language:		<String>

country
	- either an ISO 2 or ISO 3 country code

language
	- either an ISO 2 or ISO 3 language code
!

WALocale class
	instanceVariableNames: 'iso2Languages iso3Languages iso2Countries iso3Countries'!

!WALocale class methodsFor: 'accessing' stamp: ''!
countryList
	^#(('AF' 'AFG' 'AFGHANISTAN') ('AL' 'ALB' 'ALBANIA') ('DZ' 'DZA' 'ALGERIA') ('AS' 'ASM' 'AMERICAN SAMOA') ('AD' 'AND' 'ANDORRA') ('AO' 'AGO' 'ANGOLA') ('AI' 'AIA' 'ANGUILLA') ('AQ' 'ATA' 'ANTARCTICA') ('AG' 'ATG' 'ANTIGUA AND BARBUDA') ('AR' 'ARG' 'ARGENTINA') ('AM' 'ARM' 'ARMENIA') ('AW' 'ABW' 'ARUBA') ('AU' 'AUS' 'AUSTRALIA') ('AT' 'AUT' 'AUSTRIA') ('AZ' 'AZE' 'AZERBAIJAN') ('BS' 'BHS' 'BAHAMAS') ('BH' 'BHR' 'BAHRAIN') ('BD' 'BGD' 'BANGLADESH') ('BB' 'BRB' 'BARBADOS') ('BY' 'BLR' 'BELARUS') ('BE' 'BEL' 'BELGIUM') ('BZ' 'BLZ' 'BELIZE') ('BJ' 'BEN' 'BENIN') ('BM' 'BMU' 'BERMUDA') ('BT' 'BTN' 'BHUTAN') ('BO' 'BOL' 'BOLIVIA') ('BA' 'BIH' 'BOSNIA AND HERZEGOWINA') ('BW' 'BWA' 'BOTSWANA') ('BV' 'BVT' 'BOUVET ISLAND') ('BR' 'BRA' 'BRAZIL') ('IO' 'IOT' 'BRITISH INDIAN OCEAN TERRITORY') ('BN' 'BRN' 'BRUNEI DARUSSALAM') ('BG' 'BGR' 'BULGARIA') ('BF' 'BFA' 'BURKINA FASO') ('BI' 'BDI' 'BURUNDI') ('KH' 'KHM' 'CAMBODIA') ('CM' 'CMR' 'CAMEROON') ('CA' 'CAN' 'CANADA') ('CV' 'CPV' 'CAPE VERDE') ('KY' 'CYM' 'CAYMAN ISLANDS') ('CF' 'CAF' 'CENTRAL AFRICAN REPUBLIC') ('TD' 'TCD' 'CHAD') ('CL' 'CHL' 'CHILE') ('CN' 'CHN' 'CHINA') ('CX' 'CXR' 'CHRISTMAS ISLAND') ('CC' 'CCK' 'COCOS (KEELING) ISLANDS') ('CO' 'COL' 'COLOMBIA') ('KM' 'COM' 'COMOROS') ('CG' 'COG' 'CONGO') ('CK' 'COK' 'COOK ISLANDS') ('CR' 'CRI' 'COSTA RICA') ('CI' 'CIV' 'COTE D''IVOIRE') ('HR' 'HRV' 'CROATIA (local name: Hrvatska)') ('CU' 'CUB' 'CUBA') ('CY' 'CYP' 'CYPRUS') ('CZ' 'CZE' 'CZECH REPUBLIC') ('DK' 'DNK' 'DENMARK') ('DJ' 'DJI' 'DJIBOUTI') ('DM' 'DMA' 'DOMINICA') ('DO' 'DOM' 'DOMINICAN REPUBLIC') ('TP' 'TMP' 'EAST TIMOR') ('EC' 'ECU' 'ECUADOR') ('EG' 'EGY' 'EGYPT') ('SV' 'SLV' 'EL SALVADOR') ('GQ' 'GNQ' 'EQUATORIAL GUINEA') ('ER' '   ' 'ERITREA') ('EE' 'EST' 'ESTONIA') ('ET' 'ETH' 'ETHIOPIA') ('FK' 'FLK' 'FALKLAND ISLANDS (MALVINAS)') ('FO' 'FRO' 'FAROE ISLANDS') ('FJ' 'FJI' 'FIJI') ('FI' 'FIN' 'FINLAND') ('FR' 'FRA' 'FRANCE') ('FX' 'FXX' 'FRANCE, METROPOLITAN') ('GF' 'GUF' 'FRENCH GUIANA') ('PF' 'PYF' 'FRENCH POLYNESIA') ('TF' 'ATF' 'FRENCH SOUTHERN TERRITORIES') ('GA' 'GAB' 'GABON') ('GM' 'GMB' 'GAMBIA') ('GE' 'GEO' 'GEORGIA') ('DE' 'DEU' 'GERMANY') ('GH' 'GHA' 'GHANA') ('GI' 'GIB' 'GIBRALTAR') ('GR' 'GRC' 'GREECE') ('GL' 'GRL' 'GREENLAND') ('GD' 'GRD' 'GRENADA') ('GP' 'GLP' 'GUADELOUPE') ('GU' 'GUM' 'GUAM') ('GT' 'GTM' 'GUATEMALA') ('GN' 'GIN' 'GUINEA') ('GW' 'GNB' 'GUINEA-BISSAU') ('GY' 'GUY' 'GUYANA') ('HT' 'HTI' 'HAITI') ('HM' 'HMD' 'HEARD AND MC DONALD ISLANDS') ('VA' 'VAT' 'HOLY SEE (VATICAN CITY STATE)') ('HN' 'HND' 'HONDURAS') ('HK' 'HKG' 'HONG KONG') ('HU' 'HUN' 'HUNGARY') ('IS' 'ISL' 'ICELAND') ('IN' 'IND' 'INDIA') ('ID' 'IDN' 'INDONESIA') ('IR' 'IRN' 'IRAN (ISLAMIC REPUBLIC OF)') ('IQ' 'IRQ' 'IRAQ') ('IE' 'IRL' 'IRELAND') ('IL' 'ISR' 'ISRAEL') ('IT' 'ITA' 'ITALY') ('JM' 'JAM' 'JAMAICA') ('JP' 'JPN' 'JAPAN') ('JO' 'JOR' 'JORDAN') ('KZ' 'KAZ' 'KAZAKHSTAN') ('KE' 'KEN' 'KENYA') ('KI' 'KIR' 'KIRIBATI') ('KP' 'PRK' 'KOREA, DEMOCRATIC PEOPLE''S REPUBLIC OF') ('KR' 'KOR' 'KOREA, REPUBLIC OF') ('KW' 'KWT' 'KUWAIT') ('KG' 'KGZ' 'KYRGYZSTAN') ('LA' 'LAO' 'LAO PEOPLE''S DEMOCRATIC REPUBLIC') ('LV' 'LVA' 'LATVIA') ('LB' 'LBN' 'LEBANON') ('LS' 'LSO' 'LESOTHO') ('LR' 'LBR' 'LIBERIA') ('LY' 'LBY' 'LIBYAN ARAB JAMAHIRIYA') ('LI' 'LIE' 'LIECHTENSTEIN') ('LT' 'LTU' 'LITHUANIA') ('LU' 'LUX' 'LUXEMBOURG') ('MO' 'MAC' 'MACAU') ('MK' 'MKD' 'MACEDONIA, THE FORMER YUGOSLAV REPUBLIC OF') ('MG' 'MDG' 'MADAGASCAR') ('MW' 'MWI' 'MALAWI') ('MY' 'MYS' 'MALAYSIA') ('MV' 'MDV' 'MALDIVES') ('ML' 'MLI' 'MALI') ('MT' 'MLT' 'MALTA') ('MH' 'MHL' 'MARSHALL ISLANDS') ('MQ' 'MTQ' 'MARTINIQUE') ('MR' 'MRT' 'MAURITANIA') ('MU' 'MUS' 'MAURITIUS') ('YT' 'MYT' 'MAYOTTE') ('MX' 'MEX' 'MEXICO') ('FM' 'FSM' 'MICRONESIA, FEDERATED STATES OF') ('MD' 'MDA' 'MOLDOVA, REPUBLIC OF') ('MC' 'MCO' 'MONACO') ('MN' 'MNG' 'MONGOLIA') ('MS' 'MSR' 'MONTSERRAT') ('MA' 'MAR' 'MOROCCO') ('MZ' 'MOZ' 'MOZAMBIQUE') ('MM' 'MMR' 'MYANMAR') ('NA' 'NAM' 'NAMIBIA') ('NR' 'NRU' 'NAURU') ('NP' 'NPL' 'NEPAL') ('NL' 'NLD' 'NETHERLANDS') ('AN' 'ANT' 'NETHERLANDS ANTILLES') ('NC' 'NCL' 'NEW CALEDONIA') ('NZ' 'NZL' 'NEW ZEALAND') ('NI' 'NIC' 'NICARAGUA') ('NE' 'NER' 'NIGER') ('NG' 'NGA' 'NIGERIA') ('NU' 'NIU' 'NIUE') ('NF' 'NFK' 'NORFOLK ISLAND') ('MP' 'MNP' 'NORTHERN MARIANA ISLANDS') ('NO' 'NOR' 'NORWAY') ('OM' 'OMN' 'OMAN') ('PK' 'PAK' 'PAKISTAN') ('PW' 'PLW' 'PALAU') ('PA' 'PAN' 'PANAMA') ('PG' 'PNG' 'PAPUA NEW GUINEA') ('PY' 'PRY' 'PARAGUAY') ('PE' 'PER' 'PERU') ('PH' 'PHL' 'PHILIPPINES') ('PN' 'PCN' 'PITCAIRN') ('PL' 'POL' 'POLAND') ('PT' 'PRT' 'PORTUGAL') ('PR' 'PRI' 'PUERTO RICO') ('QA' 'QAT' 'QATAR') ('RE' 'REU' 'REUNION') ('RO' 'ROM' 'ROMANIA') ('RU' 'RUS' 'RUSSIAN FEDERATION') ('RW' 'RWA' 'RWANDA') ('KN' 'KNA' 'SAINT KITTS AND NEVIS') ('LC' 'LCA' 'SAINT LUCIA') ('VC' 'VCT' 'SAINT VINCENT AND THE GRENADINES') ('WS' 'WSM' 'SAMOA') ('SM' 'SMR' 'SAN MARINO') ('ST' 'STP' 'SAO TOME AND PRINCIPE') ('SA' 'SAU' 'SAUDI ARABIA') ('SN' 'SEN' 'SENEGAL') ('SC' 'SYC' 'SEYCHELLES') ('SL' 'SLE' 'SIERRA LEONE') ('SG' 'SGP' 'SINGAPORE') ('SK' 'SVK' 'SLOVAKIA (Slovak Republic)') ('SI' 'SVN' 'SLOVENIA') ('SB' 'SLB' 'SOLOMON ISLANDS') ('SO' 'SOM' 'SOMALIA') ('ZA' 'ZAF' 'SOUTH AFRICA') ('GS' 'SGS' 'SOUTH GEORGIA AND THE SOUTH SANDWICH ISLANDS') ('ES' 'ESP' 'SPAIN') ('LK' 'LKA' 'SRI LANKA') ('SH' 'SHN' 'ST. HELENA') ('PM' 'SPM' 'ST. PIERRE AND MIQUELON') ('SD' 'SDN' 'SUDAN') ('SR' 'SUR' 'SURINAME') ('SJ' 'SJM' 'SVALBARD AND JAN MAYEN ISLANDS') ('SZ' 'SWZ' 'SWAZILAND') ('SE' 'SWE' 'SWEDEN') ('CH' 'CHE' 'SWITZERLAND') ('SY' 'SYR' 'SYRIAN ARAB REPUBLIC') ('TW' 'TWN' 'TAIWAN, PROVINCE OF CHINA') ('TJ' 'TJK' 'TAJIKISTAN') ('TZ' 'TZA' 'TANZANIA, UNITED REPUBLIC OF') ('TH' 'THA' 'THAILAND') ('TG' 'TGO' 'TOGO') ('TK' 'TKL' 'TOKELAU') ('TO' 'TON' 'TONGA') ('TT' 'TTO' 'TRINIDAD AND TOBAGO') ('TN' 'TUN' 'TUNISIA') ('TR' 'TUR' 'TURKEY') ('TM' 'TKM' 'TURKMENISTAN') ('TC' 'TCA' 'TURKS AND CAICOS ISLANDS') ('TV' 'TUV' 'TUVALU') ('UG' 'UGA' 'UGANDA') ('UA' 'UKR' 'UKRAINE') ('AE' 'ARE' 'UNITED ARAB EMIRATES') ('GB' 'GBR' 'UNITED KINGDOM') ('US' 'USA' 'UNITED STATES') ('UM' 'UMI' 'UNITED STATES MINOR OUTLYING ISLANDS') ('UY' 'URY' 'URUGUAY') ('UZ' 'UZB' 'UZBEKISTAN') ('VU' 'VUT' 'VANUATU') ('VE' 'VEN' 'VENEZUELA') ('VN' 'VNM' 'VIET NAM') ('VG' 'VGB' 'VIRGIN ISLANDS (BRITISH)') ('VI' 'VIR' 'VIRGIN ISLANDS (U.S.)') ('WF' 'WLF' 'WALLIS AND FUTUNA ISLANDS') ('EH' 'ESH' 'WESTERN SAHARA') ('YE' 'YEM' 'YEMEN') ('YU' 'YUG' 'YUGOSLAVIA') ('ZR' 'ZAR' 'ZAIRE') ('ZM' 'ZMB' 'ZAMBIA') ('ZW' 'ZWE' 'ZIMBABWE'))! !

!WALocale class methodsFor: 'instance creation' stamp: 'pmm 1/4/2008 14:47'!
fromString: aString
	| language country delimeter |
	delimeter := (aString includes: $_)
		ifTrue: [ $_ ]
		ifFalse: [ $- ].
	language := aString copyUpTo: delimeter.
	country := aString copyAfter: delimeter.
	country isEmpty ifTrue: [ country := nil ].
	^self
		language: language
		country: country! !

!WALocale class methodsFor: 'class initialization' stamp: 'pmm 3/16/2008 12:50'!
initialize
	self initializeLangaugeList.
	self initializeCountryList! !

!WALocale class methodsFor: 'class initialization' stamp: 'lr 3/29/2008 14:47'!
initializeCountryList
	iso2Countries := Dictionary new.
	iso3Countries := Dictionary new.
	self countryList do: [ :each |
		iso2Countries
			at: each first
			put: each third.
		iso3Countries
			at: each second
			put: each third ]! !

!WALocale class methodsFor: 'class initialization' stamp: 'pmm 3/16/2008 12:50'!
initializeLangaugeList
	iso2Languages := Dictionary new.
	iso3Languages := Dictionary new.
	
	self languageList do: [ :each |
		each size > 2
			ifTrue: [
				iso2Languages at: each first put: each third.
				iso3Languages at: each second put: each third ]
			ifFalse: [
				iso3Languages at: each first put: each second ] ]! !

!WALocale class methodsFor: 'accessing' stamp: 'pmm 1/4/2008 17:36'!
iso2Countries
	^iso2Countries! !

!WALocale class methodsFor: 'accessing' stamp: 'pmm 1/4/2008 17:04'!
iso2Languages
	^iso2Languages! !

!WALocale class methodsFor: 'accessing' stamp: 'lr 3/29/2008 14:50'!
iso3Countries
	^iso3Countries! !

!WALocale class methodsFor: 'accessing' stamp: 'pmm 1/4/2008 17:04'!
iso3Languages
	^iso3Languages! !

!WALocale class methodsFor: 'instance creation' stamp: 'pmm 11/20/2007 13:16'!
language: aLanguageString country: aCounryString
	^self new
		language: aLanguageString;
		country: aCounryString;
		yourself! !

!WALocale class methodsFor: 'accessing' stamp: ''!
languageList
	^#(('aa' 'aar' 'Afar') ('ab' 'abk' 'Abkhazian') ('ace' 'Achinese') ('ach' 'Acoli') ('ada' 'Adangme') ('ady' 'Adyghe; Adygei') ('afa' 'Afro-Asiatic (Other)') ('afh' 'Afrihili') ('af' 'afr' 'Afrikaans') ('ain' 'Ainu') ('ak' 'aka' 'Akan') ('akk' 'Akkadian') ('sq' 'alb' 'Albanian') ('ale' 'Aleut') ('alg' 'Algonquian languages') ('alt' 'Southern Altai') ('am' 'amh' 'Amharic') ('ang' 'English, Old (ca.450-1100)') ('anp' 'Angika') ('apa' 'Apache languages') ('ar' 'ara' 'Arabic') ('arc' 'Official Aramaic (700-300 BCE); Imperial Aramaic (700-300 BCE)') ('an' 'arg' 'Aragonese') ('hy' 'arm' 'Armenian') ('arn' 'Mapudungun; Mapuche') ('arp' 'Arapaho') ('art' 'Artificial (Other)') ('arw' 'Arawak') ('as' 'asm' 'Assamese') ('ast' 'Asturian; Bable; Leonese; Asturleonese') ('ath' 'Athapascan languages') ('aus' 'Australian languages') ('av' 'ava' 'Avaric') ('ae' 'ave' 'Avestan') ('awa' 'Awadhi') ('ay' 'aym' 'Aymara') ('az' 'aze' 'Azerbaijani') ('bad' 'Banda languages') ('bai' 'Bamileke languages') ('ba' 'bak' 'Bashkir') ('bal' 'Baluchi') ('bm' 'bam' 'Bambara') ('ban' 'Balinese') ('eu' 'baq' 'Basque') ('bas' 'Basa') ('bat' 'Baltic (Other)') ('bej' 'Beja; Bedawiyet') ('be' 'bel' 'Belarusian') ('bem' 'Bemba') ('bn' 'ben' 'Bengali') ('ber' 'Berber (Other)') ('bho' 'Bhojpuri') ('bh' 'bih' 'Bihari') ('bik' 'Bikol') ('bin' 'Bini; Edo') ('bi' 'bis' 'Bislama') ('bla' 'Siksika') ('bnt' 'Bantu (Other)') ('bs' 'bos' 'Bosnian') ('bra' 'Braj') ('br' 'bre' 'Breton') ('btk' 'Batak languages') ('bua' 'Buriat') ('bug' 'Buginese') ('bg' 'bul' 'Bulgarian') ('my' 'bur' 'Burmese') ('byn' 'Blin; Bilin') ('cad' 'Caddo') ('cai' 'Central American Indian (Other)') ('car' 'Galibi Carib') ('ca' 'cat' 'Catalan; Valencian') ('cau' 'Caucasian (Other)') ('ceb' 'Cebuano') ('cel' 'Celtic (Other)') ('ch' 'cha' 'Chamorro') ('chb' 'Chibcha') ('ce' 'che' 'Chechen') ('chg' 'Chagatai') ('zh' 'chi' 'Chinese') ('chk' 'Chuukese') ('chm' 'Mari') ('chn' 'Chinook jargon') ('cho' 'Choctaw') ('chp' 'Chipewyan; Dene Suline') ('chr' 'Cherokee') ('cu' 'chu' 'Church Slavic; Old Slavonic; Church Slavonic; Old Bulgarian; Old Church Slavonic') ('cv' 'chv' 'Chuvash') ('chy' 'Cheyenne') ('cmc' 'Chamic languages') ('cop' 'Coptic') ('kw' 'cor' 'Cornish') ('co' 'cos' 'Corsican') ('cpe' 'Creoles and pidgins, English based (Other)') ('cpf' 'Creoles and pidgins, French-based (Other)') ('cpp' 'Creoles and pidgins, Portuguese-based (Other)') ('cr' 'cre' 'Cree') ('crh' 'Crimean Tatar; Crimean Turkish') ('crp' 'Creoles and pidgins (Other)') ('csb' 'Kashubian') ('cus' 'Cushitic (Other)') ('cs' 'cze' 'Czech') ('dak' 'Dakota') ('da' 'dan' 'Danish') ('dar' 'Dargwa') ('day' 'Land Dayak languages') ('del' 'Delaware') ('den' 'Slave (Athapascan)') ('dgr' 'Dogrib') ('din' 'Dinka') ('dv' 'div' 'Divehi; Dhivehi; Maldivian') ('doi' 'Dogri') ('dra' 'Dravidian (Other)') ('dsb' 'Lower Sorbian') ('dua' 'Duala') ('dum' 'Dutch, Middle (ca.1050-1350)') ('nl' 'dut' 'Dutch; Flemish') ('dyu' 'Dyula') ('dz' 'dzo' 'Dzongkha') ('efi' 'Efik') ('egy' 'Egyptian (Ancient)') ('eka' 'Ekajuk') ('elx' 'Elamite') ('en' 'eng' 'English') ('enm' 'English, Middle (1100-1500)') ('eo' 'epo' 'Esperanto') ('et' 'est' 'Estonian') ('ee' 'ewe' 'Ewe') ('ewo' 'Ewondo') ('fan' 'Fang') ('fo' 'fao' 'Faroese') ('fat' 'Fanti') ('fj' 'fij' 'Fijian') ('fil' 'Filipino; Pilipino') ('fi' 'fin' 'Finnish') ('fiu' 'Finno-Ugrian (Other)') ('fon' 'Fon') ('fr' 'fre' 'French') ('frm' 'French, Middle (ca.1400-1600)') ('fro' 'French, Old (842-ca.1400)') ('frr' 'Northern Frisian') ('frs' 'Eastern Frisian') ('fy' 'fry' 'Western Frisian') ('ff' 'ful' 'Fulah') ('fur' 'Friulian') ('gaa' 'Ga') ('gay' 'Gayo') ('gba' 'Gbaya') ('gem' 'Germanic (Other)') ('ka' 'geo' 'Georgian') ('de' 'ger' 'German') ('gez' 'Geez') ('gil' 'Gilbertese') ('gd' 'gla' 'Gaelic; Scottish Gaelic') ('ga' 'gle' 'Irish') ('gl' 'glg' 'Galician') ('gv' 'glv' 'Manx') ('gmh' 'German, Middle High (ca.1050-1500)') ('goh' 'German, Old High (ca.750-1050)') ('gon' 'Gondi') ('gor' 'Gorontalo') ('got' 'Gothic') ('grb' 'Grebo') ('grc' 'Greek, Ancient (to 1453)') ('el' 'gre' 'Greek, Modern (1453-)') ('gn' 'grn' 'Guarani') ('gsw' 'Swiss German; Alemannic; Alsatian') ('gu' 'guj' 'Gujarati') ('gwi' 'Gwich''in') ('hai' 'Haida') ('ht' 'hat' 'Haitian; Haitian Creole') ('ha' 'hau' 'Hausa') ('haw' 'Hawaiian') ('he' 'heb' 'Hebrew') ('hz' 'her' 'Herero') ('hil' 'Hiligaynon') ('him' 'Himachali') ('hi' 'hin' 'Hindi') ('hit' 'Hittite') ('hmn' 'Hmong') ('ho' 'hmo' 'Hiri Motu') ('hsb' 'Upper Sorbian') ('hu' 'hun' 'Hungarian') ('hup' 'Hupa') ('iba' 'Iban') ('ig' 'ibo' 'Igbo') ('is' 'ice' 'Icelandic') ('io' 'ido' 'Ido') ('ii' 'iii' 'Sichuan Yi; Nuosu') ('ijo' 'Ijo languages') ('iu' 'iku' 'Inuktitut') ('ie' 'ile' 'Interlingue; Occidental') ('ilo' 'Iloko') ('ia' 'ina' 'Interlingua (International Auxiliary Language Association)') ('inc' 'Indic (Other)') ('id' 'ind' 'Indonesian') ('ine' 'Indo-European (Other)') ('inh' 'Ingush') ('ik' 'ipk' 'Inupiaq') ('ira' 'Iranian (Other)') ('iro' 'Iroquoian languages') ('it' 'ita' 'Italian') ('jv' 'jav' 'Javanese') ('jbo' 'Lojban') ('ja' 'jpn' 'Japanese') ('jpr' 'Judeo-Persian') ('jrb' 'Judeo-Arabic') ('kaa' 'Kara-Kalpak') ('kab' 'Kabyle') ('kac' 'Kachin; Jingpho') ('kl' 'kal' 'Kalaallisut; Greenlandic') ('kam' 'Kamba') ('kn' 'kan' 'Kannada') ('kar' 'Karen languages') ('ks' 'kas' 'Kashmiri') ('kr' 'kau' 'Kanuri') ('kaw' 'Kawi') ('kk' 'kaz' 'Kazakh') ('kbd' 'Kabardian') ('kha' 'Khasi') ('khi' 'Khoisan (Other)') ('km' 'khm' 'Central Khmer') ('kho' 'Khotanese') ('ki' 'kik' 'Kikuyu; Gikuyu') ('rw' 'kin' 'Kinyarwanda') ('ky' 'kir' 'Kirghiz; Kyrgyz') ('kmb' 'Kimbundu') ('kok' 'Konkani') ('kv' 'kom' 'Komi') ('kg' 'kon' 'Kongo') ('ko' 'kor' 'Korean') ('kos' 'Kosraean') ('kpe' 'Kpelle') ('krc' 'Karachay-Balkar') ('krl' 'Karelian') ('kro' 'Kru languages') ('kru' 'Kurukh') ('kj' 'kua' 'Kuanyama; Kwanyama') ('kum' 'Kumyk') ('ku' 'kur' 'Kurdish') ('kut' 'Kutenai') ('lad' 'Ladino') ('lah' 'Lahnda') ('lam' 'Lamba') ('lo' 'lao' 'Lao') ('la' 'lat' 'Latin') ('lv' 'lav' 'Latvian') ('lez' 'Lezghian') ('li' 'lim' 'Limburgan; Limburger; Limburgish') ('ln' 'lin' 'Lingala') ('lt' 'lit' 'Lithuanian') ('lol' 'Mongo') ('loz' 'Lozi') ('lb' 'ltz' 'Luxembourgish; Letzeburgesch') ('lua' 'Luba-Lulua') ('lu' 'lub' 'Luba-Katanga') ('lg' 'lug' 'Ganda') ('lui' 'Luiseno') ('lun' 'Lunda') ('luo' 'Luo (Kenya and Tanzania)') ('lus' 'Lushai') ('mk' 'mac' 'Macedonian') ('mad' 'Madurese') ('mag' 'Magahi') ('mh' 'mah' 'Marshallese') ('mai' 'Maithili') ('mak' 'Makasar') ('ml' 'mal' 'Malayalam') ('man' 'Mandingo') ('mi' 'mao' 'Maori') ('map' 'Austronesian (Other)') ('mr' 'mar' 'Marathi') ('mas' 'Masai') ('ms' 'may' 'Malay') ('mdf' 'Moksha') ('mdr' 'Mandar') ('men' 'Mende') ('mga' 'Irish, Middle (900-1200)') ('mic' 'Mi''kmaq; Micmac') ('min' 'Minangkabau') ('mis' 'Uncoded languages') ('mkh' 'Mon-Khmer (Other)') ('mg' 'mlg' 'Malagasy') ('mt' 'mlt' 'Maltese') ('mnc' 'Manchu') ('mni' 'Manipuri') ('mno' 'Manobo languages') ('moh' 'Mohawk') ('mo' 'mol' 'Moldavian') ('mn' 'mon' 'Mongolian') ('mos' 'Mossi') ('mul' 'Multiple languages') ('mun' 'Munda languages') ('mus' 'Creek') ('mwl' 'Mirandese') ('mwr' 'Marwari') ('myn' 'Mayan languages') ('myv' 'Erzya') ('nah' 'Nahuatl languages') ('nai' 'North American Indian') ('nap' 'Neapolitan') ('na' 'nau' 'Nauru') ('nv' 'nav' 'Navajo; Navaho') ('nr' 'nbl' 'Ndebele, South; South Ndebele') ('nd' 'nde' 'Ndebele, North; North Ndebele') ('ng' 'ndo' 'Ndonga') ('nds' 'Low German; Low Saxon; German, Low; Saxon, Low') ('ne' 'nep' 'Nepali') ('new' 'Nepal Bhasa; Newari') ('nia' 'Nias') ('nic' 'Niger-Kordofanian (Other)') ('niu' 'Niuean') ('nn' 'nno' 'Norwegian Nynorsk; Nynorsk, Norwegian') ('nb' 'nob' 'Bokml, Norwegian; Norwegian Bokml') ('nog' 'Nogai') ('non' 'Norse, Old') ('no' 'nor' 'Norwegian') ('nqo' 'N''Ko') ('nso' 'Pedi; Sepedi; Northern Sotho') ('nub' 'Nubian languages') ('nwc' 'Classical Newari; Old Newari; Classical Nepal Bhasa') ('ny' 'nya' 'Chichewa; Chewa; Nyanja') ('nym' 'Nyamwezi') ('nyn' 'Nyankole') ('nyo' 'Nyoro') ('nzi' 'Nzima') ('oc' 'oci' 'Occitan (post 1500); Provenal') ('oj' 'oji' 'Ojibwa') ('or' 'ori' 'Oriya') ('om' 'orm' 'Oromo') ('osa' 'Osage') ('os' 'oss' 'Ossetian; Ossetic') ('ota' 'Turkish, Ottoman (1500-1928)') ('oto' 'Otomian languages') ('paa' 'Papuan (Other)') ('pag' 'Pangasinan') ('pal' 'Pahlavi') ('pam' 'Pampanga; Kapampangan') ('pa' 'pan' 'Panjabi; Punjabi') ('pap' 'Papiamento') ('pau' 'Palauan') ('peo' 'Persian, Old (ca.600-400 B.C.)') ('fa' 'per' 'Persian') ('phi' 'Philippine (Other)') ('phn' 'Phoenician') ('pi' 'pli' 'Pali') ('pl' 'pol' 'Polish') ('pon' 'Pohnpeian') ('pt' 'por' 'Portuguese') ('pra' 'Prakrit languages') ('pro' 'Provenal, Old (to 1500)') ('ps' 'pus' 'Pushto; Pashto') ('qaa-qtz' 'Reserved for local use') ('qu' 'que' 'Quechua') ('raj' 'Rajasthani') ('rap' 'Rapanui') ('rar' 'Rarotongan; Cook Islands Maori') ('roa' 'Romance (Other)') ('rm' 'roh' 'Romansh') ('rom' 'Romany') ('ro' 'rum' 'Romanian') ('rn' 'run' 'Rundi') ('rup' 'Aromanian; Arumanian; Macedo-Romanian') ('ru' 'rus' 'Russian') ('sad' 'Sandawe') ('sg' 'sag' 'Sango') ('sah' 'Yakut') ('sai' 'South American Indian (Other)') ('sal' 'Salishan languages') ('sam' 'Samaritan Aramaic') ('sa' 'san' 'Sanskrit') ('sas' 'Sasak') ('sat' 'Santali') ('sr' 'scc' 'Serbian') ('scn' 'Sicilian') ('sco' 'Scots') ('hr' 'scr' 'Croatian') ('sel' 'Selkup') ('sem' 'Semitic (Other)') ('sga' 'Irish, Old (to 900)') ('sgn' 'Sign Languages') ('shn' 'Shan') ('sid' 'Sidamo') ('si' 'sin' 'Sinhala; Sinhalese') ('sio' 'Siouan languages') ('sit' 'Sino-Tibetan (Other)') ('sla' 'Slavic (Other)') ('sk' 'slo' 'Slovak') ('sl' 'slv' 'Slovenian') ('sma' 'Southern Sami') ('se' 'sme' 'Northern Sami') ('smi' 'Sami languages (Other)') ('smj' 'Lule Sami') ('smn' 'Inari Sami') ('sm' 'smo' 'Samoan') ('sms' 'Skolt Sami') ('sn' 'sna' 'Shona') ('sd' 'snd' 'Sindhi') ('snk' 'Soninke') ('sog' 'Sogdian') ('so' 'som' 'Somali') ('son' 'Songhai languages') ('st' 'sot' 'Sotho, Southern') ('es' 'spa' 'Spanish; Castilian') ('sc' 'srd' 'Sardinian') ('srn' 'Sranan Tongo') ('srr' 'Serer') ('ssa' 'Nilo-Saharan (Other)') ('ss' 'ssw' 'Swati') ('suk' 'Sukuma') ('su' 'sun' 'Sundanese') ('sus' 'Susu') ('sux' 'Sumerian') ('sw' 'swa' 'Swahili') ('sv' 'swe' 'Swedish') ('syc' 'Classical Syriac') ('syr' 'Syriac') ('ty' 'tah' 'Tahitian') ('tai' 'Tai (Other)') ('ta' 'tam' 'Tamil') ('tt' 'tat' 'Tatar') ('te' 'tel' 'Telugu') ('tem' 'Timne') ('ter' 'Tereno') ('tet' 'Tetum') ('tg' 'tgk' 'Tajik') ('tl' 'tgl' 'Tagalog') ('th' 'tha' 'Thai') ('bo' 'tib' 'Tibetan') ('tig' 'Tigre') ('ti' 'tir' 'Tigrinya') ('tiv' 'Tiv') ('tkl' 'Tokelau') ('tlh' 'Klingon; tlhIngan-Hol') ('tli' 'Tlingit') ('tmh' 'Tamashek') ('tog' 'Tonga (Nyasa)') ('to' 'ton' 'Tonga (Tonga Islands)') ('tpi' 'Tok Pisin') ('tsi' 'Tsimshian') ('tn' 'tsn' 'Tswana') ('ts' 'tso' 'Tsonga') ('tk' 'tuk' 'Turkmen') ('tum' 'Tumbuka') ('tup' 'Tupi languages') ('tr' 'tur' 'Turkish') ('tut' 'Altaic (Other)') ('tvl' 'Tuvalu') ('tw' 'twi' 'Twi') ('tyv' 'Tuvinian') ('udm' 'Udmurt') ('uga' 'Ugaritic') ('ug' 'uig' 'Uighur; Uyghur') ('uk' 'ukr' 'Ukrainian') ('umb' 'Umbundu') ('und' 'Undetermined') ('ur' 'urd' 'Urdu') ('uz' 'uzb' 'Uzbek') ('vai' 'Vai') ('ve' 'ven' 'Venda') ('vi' 'vie' 'Vietnamese') ('vo' 'vol' 'Volapk') ('vot' 'Votic') ('wak' 'Wakashan languages') ('wal' 'Walamo') ('war' 'Waray') ('was' 'Washo') ('cy' 'wel' 'Welsh') ('wen' 'Sorbian languages') ('wa' 'wln' 'Walloon') ('wo' 'wol' 'Wolof') ('xal' 'Kalmyk; Oirat') ('xh' 'xho' 'Xhosa') ('yao' 'Yao') ('yap' 'Yapese') ('yi' 'yid' 'Yiddish') ('yo' 'yor' 'Yoruba') ('ypk' 'Yupik languages') ('zap' 'Zapotec') ('zbl' 'Blissymbols; Blissymbolics; Bliss') ('zen' 'Zenaga') ('za' 'zha' 'Zhuang; Chuang') ('znd' 'Zande languages') ('zu' 'zul' 'Zulu') ('zun' 'Zuni') ('zxx' 'No linguistic content') ('zza' 'Zaza; Dimili; Dimli; Kirdki; Kirmanjki; Zazaki'))! !

!WALocale methodsFor: 'accessing' stamp: 'pmm 11/20/2007 13:10'!
country
	^ country! !

!WALocale methodsFor: 'accessing' stamp: 'pmm 11/20/2007 13:10'!
country: aString
	country := aString! !

!WALocale methodsFor: 'accessing' stamp: 'pmm 5/31/2008 23:49'!
countryName
	"answers the country name in english and all capitals"
	^self country size = 2
		ifTrue: [ self class iso2Countries at: self country ]
		ifFalse: [ self class iso3Countries at: self country ]! !

!WALocale methodsFor: 'accessing' stamp: 'pmm 11/20/2007 13:10'!
language
	^ language! !

!WALocale methodsFor: 'accessing' stamp: 'pmm 11/20/2007 13:11'!
language: aString
	language := aString! !

!WALocale methodsFor: 'accessing' stamp: 'pmm 5/31/2008 23:50'!
languageName
	"answers the language name in english and all capitals"
	^self language size = 2
		ifTrue: [ self class iso2Languages at: self language ]
		ifFalse: [ self class iso3Languages at: self language ]! !

!WALocale methodsFor: 'printing' stamp: 'lr 8/30/2008 16:22'!
printOn: aStream 
	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self seasideString;
		nextPut: $)! !

!WALocale methodsFor: 'converting' stamp: 'lr 8/30/2008 16:22'!
seasideString
	^ String streamContents: 
		[ :stream | 
		stream nextPutAll: self language.
		self country isNil ifFalse: 
			[ stream
				nextPut: $-;
				nextPutAll: self country ] ]! !

Object subclass: #WAMain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Session'!

!WAMain commentStamp: 'rew 10/19/2007 10:49' prior: 0!
WAMain subclasses are used to initialize applications when a new session is started.

Subclasses must implement the following messages:
	start:
		Does the initializing 
!

!WAMain methodsFor: 'accessing' stamp: 'jf 7/16/2008 08:39'!
application
	^ WACurrentRequestContext application! !

!WAMain methodsFor: 'processing' stamp: 'lr 10/28/2007 14:42'!
start: aRequest
	"The main entry point into a session."

	self subclassResponsibility! !

WAMain subclass: #WARenderLoopMain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RenderLoop'!

!WARenderLoopMain commentStamp: 'rew 10/19/2007 10:50' prior: 0!
When a new session on a WAApplication is started WARenderLoopMain initializes the application, that is it:
 
	creates the top level component of the application, 
	informs each component(WAPresenter) of the application that the session started (via WAPresenter>>initialRequest:)
	starts a WARenderLoop to handle the request
!

WARenderLoopMain subclass: #WAAuthMain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RenderLoop'!

!WAAuthMain methodsFor: 'creational' stamp: 'jf 7/22/2008 11:38'!
createRoot
	^ super createRoot
		addDecoration: (WABasicAuthentication new authenticator: self application);
		yourself! !

!WARenderLoopMain methodsFor: 'processing' stamp: 'lr 4/20/2007 15:10'!
call: aComponent
	^ self renderLoopClass new call: aComponent! !

!WARenderLoopMain methodsFor: 'creational' stamp: 'lr 5/12/2007 11:39'!
createRoot
	^ self rootClass new! !

!WARenderLoopMain methodsFor: 'accessing' stamp: 'lr 4/20/2007 15:10'!
renderLoopClass
	^ WARenderLoop! !

!WARenderLoopMain methodsFor: 'accessing' stamp: 'jf 7/29/2008 14:34'!
rootClass
	^ self application rootClass! !

!WARenderLoopMain methodsFor: 'processing' stamp: 'lr 4/20/2007 19:41'!
start: aRequest
	| root |
	root := self createRoot.
	root visiblePresentersDo: [ :each | each initialRequest: aRequest ].
	(self renderLoopClass new root: root) run! !

Object subclass: #WAMimeDocument
	instanceVariableNames: 'contentType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAMimeDocument commentStamp: 'pmm 4/15/2008 21:00' prior: 0!
WAMimeDocument is the abstract base class for mime documents. It is intened as a very basic, mime documents. Implementations are free to use more advance, native implentations as long as they confirm to the protocol.

Instance Variables
	contentType:		<WAMimeType>

mimeType
	- the mime type of this document
!

WAMimeDocument subclass: #WACollectionMimeDocument
	instanceVariableNames: 'content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WACollectionMimeDocument commentStamp: 'pmm 4/15/2008 20:57' prior: 0!
A WACollectionMimeDocument is a mime document that is based on a collection.

Instance Variables
	content:		<Collection>

content
	- is the content either as a Collection of Characters or bytes
!

!WACollectionMimeDocument class methodsFor: 'instance creation' stamp: 'pmm 4/16/2008 07:12'!
contentType: aMimeType content: aCollection
	^self new initializeWithContentType: aMimeType content: aCollection! !

!WACollectionMimeDocument methodsFor: 'converting' stamp: 'pmm 4/15/2008 21:08'!
asMIMEDocumentType: aMimeType
	aMimeType = contentType ifTrue: [ ^self ].
	^self class contentType: aMimeType content: content! !

!WACollectionMimeDocument methodsFor: 'accessing' stamp: 'pmm 4/15/2008 21:11'!
content
	^content! !

!WACollectionMimeDocument methodsFor: 'accessing' stamp: 'pmm 4/15/2008 21:11'!
contentStream
	^content readStream! !

!WACollectionMimeDocument methodsFor: 'initialize-release' stamp: 'pmm 4/16/2008 07:12'!
initializeWithContentType: aMimeType content: aCollection
	contentType := aMimeType.
	content := aCollection! !

!WAMimeDocument methodsFor: 'converting' stamp: 'pmm 4/15/2008 21:10'!
asMIMEDocument
	^self! !

!WAMimeDocument methodsFor: 'converting' stamp: 'pmm 4/15/2008 21:10'!
asMIMEDocumentType: aMimeType
	self subclassResponsibility! !

!WAMimeDocument methodsFor: 'accessing' stamp: 'pmm 4/15/2008 21:14'!
content
	"returns the contents of the receiver as a Collection of Characters or bytes"
	self subclassResponsibility! !

!WAMimeDocument methodsFor: 'accessing' stamp: 'pmm 4/15/2008 21:14'!
contentStream
	"returns the contents of receiver as a ReadStream"
	self subclassResponsibility! !

!WAMimeDocument methodsFor: 'accessing' stamp: 'pmm 4/15/2008 21:15'!
contentType
	"returns the mime type of this document, an istance of the mime type of this document"
	^contentType! !

WAMimeDocument subclass: #WAStreamMimeDocument
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAStreamMimeDocument commentStamp: 'pmm 4/15/2008 20:58' prior: 0!
A WAStreamMimeDocument is a mime document that is based on a stream.

Instance Variables
	stream:		<ReadStream>

stream
	- the stream containing the contents of the document
!

!WAStreamMimeDocument class methodsFor: 'instance creation' stamp: 'pmm 4/16/2008 07:14'!
contentType: aMimeType contentStream: aStream
	^self new initializeWithContentType: aMimeType contentStream: aStream! !

!WAStreamMimeDocument methodsFor: 'converting' stamp: 'pmm 4/15/2008 21:16'!
asMIMEDocumentType: aMimeType
	aMimeType = contentType ifTrue: [ ^self ].
	^self class contentType: aMimeType contentStream: stream! !

!WAStreamMimeDocument methodsFor: 'accessing' stamp: 'pmm 4/15/2008 21:12'!
content
	^stream contents! !

!WAStreamMimeDocument methodsFor: 'accessing' stamp: 'pmm 4/15/2008 21:12'!
contentStream
	^stream! !

!WAStreamMimeDocument methodsFor: 'initialize-release' stamp: 'pmm 4/16/2008 07:14'!
initializeWithContentType: aMimeType contentStream: aStream
	contentType := aMimeType.
	stream := aStream! !

Object subclass: #WAMimeType
	instanceVariableNames: 'main sub parameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAMimeType commentStamp: 'pmm 1/4/2008 14:44' prior: 0!
A WAMimeType abstracts a Internet media type, it is a two-part identifier for file formats on the Internet.

Instance Variables
	main:		<String>
	parameters:		<WASmallDictionary>
	sub:		<String>

main
	- the main type

parameters
	- a lazily initialized dictionary of optional parameters

sub
	- the subtype
!

!WAMimeType class methodsFor: 'instance creation' stamp: 'YM 8/29/2008 16:04'!
fromString: aString
	| main endOfSub sub parts parameters |
	main  := aString copyUpTo: $/.
	endOfSub := aString indexOf: $;.
	endOfSub := endOfSub = 0
		ifTrue: [ aString size ]
		ifFalse: [ endOfSub - 1 ].
	sub := aString copyFrom: main size + 2 to: endOfSub.
	endOfSub = aString size ifTrue: [
		^self main: main sub: sub ].
	parts := (aString copyFrom: endOfSub + 1 to: aString size) findTokens: ';'.
	parameters := WASmallDictionary new.
	parts do: [ :each | 
		parameters
			at: (each copyUpTo: $=) trimBoth
			put: (each copyAfter: $=) trimBoth ].
	^self main: main sub: sub parameters: parameters! !

!WAMimeType class methodsFor: 'instance creation' stamp: 'pmm 11/20/2007 10:58'!
main: aMainString sub: aSubString
	^self new
		main: aMainString;
		sub: aSubString;
		yourself! !

!WAMimeType class methodsFor: 'instance creation' stamp: 'pmm 11/20/2007 10:58'!
main: aMainString sub: aSubString parameters: aDictionary
	^(self main: aMainString sub: aSubString)
		parameters: aDictionary;
		yourself! !

!WAMimeType methodsFor: 'comparing' stamp: 'pmm 1/4/2008 15:08'!
= other
	^(other isKindOf: WAMimeType)
		and: [ self main = other main
		and: [ self sub = other sub ] ]! !

!WAMimeType methodsFor: 'parameters' stamp: 'pmm 4/6/2008 15:26'!
charset
	^self parameters at: 'charset'! !

!WAMimeType methodsFor: 'parameters' stamp: 'pmm 11/21/2007 15:17'!
charset: aString
	self parameters at: 'charset' put: aString! !

!WAMimeType methodsFor: 'comparing' stamp: 'pmm 1/4/2008 15:14'!
hash
	^self main hash bitXor: self sub hash! !

!WAMimeType methodsFor: 'testing' stamp: 'pmm 11/21/2007 14:30'!
isBinary
	| subTypes |
	self main = 'text' ifTrue: [ ^false ].
	self main = 'application' ifFalse: [ ^true ].
	subTypes := self sub findTokens: '+'.
	^ subTypes noneSatisfy: [ :each | 
		#('x-javascript' 'xml') includes: each ]! !

!WAMimeType methodsFor: 'testing' stamp: 'pmm 1/4/2008 14:40'!
isNonStandard
	"tests if the receiver is a non-standard mime type that is not registered with IANA"
	^(self main beginsWith: 'x-')
		or: [ (self main beginsWith: 'X-')
		or: [ (self sub beginsWith: 'x-')
		or: [ self sub beginsWith: 'X-' ] ] ]! !

!WAMimeType methodsFor: 'testing' stamp: 'pmm 1/4/2008 14:39'!
isVendorSpecific
	"tests if the receiver is a vendor specific mimetype"
	^self sub beginsWith: 'vnd.'! !

!WAMimeType methodsFor: 'accessing' stamp: 'pmm 11/20/2007 10:54'!
main
	^ main! !

!WAMimeType methodsFor: 'accessing' stamp: 'pmm 11/20/2007 10:57'!
main: aString
	main := aString! !

!WAMimeType methodsFor: 'testing' stamp: 'pmm 11/21/2007 15:12'!
matches: aMimeType
	"aMimeType is the pattern to match, it is a normal WAMimeType instance where main or sub can be wildcards"
	^(aMimeType main = '*'
		or: [ aMimeType main = self main ])
		and: [
			aMimeType sub = '*'
				or: [ aMimeType sub = self sub ] ]! !

!WAMimeType methodsFor: 'parameters' stamp: 'pmm 11/21/2007 15:14'!
parameterAt: aKey put: aValue
	self parameters at: aKey put: aValue! !

!WAMimeType methodsFor: 'accessing' stamp: 'pmm 11/20/2007 10:57'!
parameters
	parameters isNil ifTrue: [
		parameters := WASmallDictionary new ].
	^ parameters! !

!WAMimeType methodsFor: 'accessing' stamp: 'pmm 11/20/2007 10:54'!
parameters: aDictionary
	parameters := aDictionary! !

!WAMimeType methodsFor: 'printing' stamp: 'lr 8/30/2008 16:22'!
printOn: aStream 
	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self seasideString;
		nextPut: $)! !

!WAMimeType methodsFor: 'converting' stamp: 'lr 8/30/2008 16:22'!
seasideString
	^ String streamContents: 
		[ :stream | 
		stream
			nextPutAll: self main;
			nextPut: $/;
			nextPutAll: self sub.
		parameters isNil ifFalse: 
			[ parameters keysAndValuesDo: 
				[ :key :value | 
				stream
					nextPut: $;;
					nextPutAll: key;
					nextPut: $=;
					nextPutAll: value ] ] ]! !

!WAMimeType methodsFor: 'accessing' stamp: 'pmm 11/20/2007 10:54'!
sub
	^ sub! !

!WAMimeType methodsFor: 'accessing' stamp: 'pmm 11/20/2007 10:55'!
sub: aString
	sub := aString! !

!WAMimeType methodsFor: 'converting' stamp: 'pmm 11/21/2007 20:18'!
toMimeType
	^ self! !

Object subclass: #WAOpeningConditionalComment
	instanceVariableNames: 'condition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WAOpeningConditionalComment commentStamp: 'pmm 1/28/2008 07:06' prior: 0!
Opens a WAConditionalComment and encodes the condition.!

!WAOpeningConditionalComment class methodsFor: 'instance creation' stamp: 'pmm 10/11/2006 17:38'!
condition: aString
	^self new
		condition: aString;
		yourself! !

!WAOpeningConditionalComment methodsFor: 'accessing' stamp: 'lr 3/27/2007 11:36'!
condition
	^ condition! !

!WAOpeningConditionalComment methodsFor: 'accessing' stamp: 'pmm 10/11/2006 17:31'!
condition: aString
	condition := aString! !

!WAOpeningConditionalComment methodsFor: 'printing' stamp: 'pmm 11/25/2007 21:53'!
encodeOn: aDocument
	aDocument
		nextPutAll: '<!!--[';
		nextPutAll: self condition;
		nextPutAll: ']>'! !

WAOpeningConditionalComment subclass: #WAOpeningRevealedConditionalComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WAOpeningRevealedConditionalComment commentStamp: 'pmm 1/28/2008 07:07' prior: 0!
Opens a WARevealedConditionalComment and encodes the condition.!

!WAOpeningRevealedConditionalComment methodsFor: 'printing' stamp: 'pmm 11/25/2007 21:54'!
encodeOn: aDocument
	aDocument
		nextPutAll: '<!!--[';
		nextPutAll: self condition;
		nextPutAll: ']><!!-->'! !

Object subclass: #WAPresenter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Component'!

WAPresenter subclass: #WAComponent
	instanceVariableNames: 'decoration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Component'!

!WAComponent commentStamp: 'pmm 8/27/2007 12:55' prior: 0!
I am a class representing a graphical element of a seaside application. A component has state (instance variables, that might be backtracked using #states), behavior decorations, children and an appearance that is specified in #renderContentOn:. A component might chose to display another component with #call:.

Child Components:
It is common for a component to display instances of other components while rendering itself.  It does this by passing them into the #render: method of WACanvas.  For example, this #renderContentOn: method simply renders a heading and then displays a counter component 
immediately below it:

	renderContentOn: html
		html heading level3; with: 'My Counter'.
		html render: myCounter.

It's important that you use #render:, rather than directly calling the #renderContentOn: method of the subcomponent. The following is *not* correct:

	renderContentOn: html
		html heading level3; with: 'My Counter'.
		myCounter renderContentOn: html.   "DON'T DO THIS".

These subcomponents are usually instance variables of the component that is "embedding" them.  They are commonly created as part of the components #initialize method:

	initialize
		myCounter := WACounter new.

They may also be stored in a collection. One fairly common pattern is to keep a lazily initialized dictionary of subcomponents that match a collection of model items. For example, if you wanted a BudgetItemRow subcomponent for each member of budgetItems, you might do something like this:

	initialize
		budgetRows := Dictionary new.

	rowForItem: anItem
		^budgetRows at: anItem ifAbsentPut: [ BudgetItemRow item: anItem ].

	renderContentOn: html
		self budgetItems
			do: [ :each | html render: (self rowForItem: each) ]
			separatedBy: [ html horizontalLine ].

Each parent component *must* implement a #children method that returns a collection of all of the subcomponents that it might display on the next render. For the above two examples, #children might look like this:

	children
		^Array with: myCounter

or this:

	children
		^self budgetItems collect: [ :each | self rowForItem: each ].
		
Call/Answer:
If a subcomponent makes a #call: to another component, that component will appear in place of the subcomponent.  In the first example, if myCounter made a #call: to DateSelector, that DateSelector would appear in the context of the counter's parent, with the 'My Counter' heading 
above it.

Since a subcomponent has not been #call:'d, in general #answer: is a no-op.  However, the parent may attach an #onAnswer: block to the subcomponent to be notified if it sends #answer:. This allows one component to be used both from #call: and through embedding. For example:

	initialize
		dateSelector := WADateSelector new 
			onAnswer: [ :date | self dateChosen: date ].
			
Visibility:
A component is visible if
- it is the root component of an application
- a child of of a visible component (returned by #children) that has not been #call:'d
- passed as an argument to #call: on a visible component!

WAComponent subclass: #WAAlphabeticBatchedList
	instanceVariableNames: 'items currentPage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Widgets'!

!WAAlphabeticBatchedList commentStamp: 'rew 1/23/2008 21:10' prior: 0!
WAAlphabeticBatchedList organizes a collection of items into pages for display. A page contains all items whose string representation (item displayString) starts with the same character. WAAlphabeticBatchedList only displays the navigation (alphabet with links) for the list. Your code needs to display the current page.

Use WAAlphabeticBatchedList>>items: to set the collections of items.
Use WAAlphabeticBatchedList>>batch to get the items to display on the current page

See WABatchTest for example of usage.
Select "Batch" tab of the Functional Seaside Test Suite to run an example  (http://127.0.0.1:xxxx/seaside/tests/alltests)

Instance Variables:
	currentPage	<Character>	the character of the curent page
	items	<(Collection of: (Object ))> collection of the items managed by WAAlphabeticBatchedList. Collection is sorted before items are displayed.
!

!WAAlphabeticBatchedList methodsFor: 'accessing-calculated' stamp: 'avi 12/18/2004 18:26'!
allPages
	^ $A to: $Z! !

!WAAlphabeticBatchedList methodsFor: 'accessing-calculated' stamp: 'lr 8/30/2008 16:22'!
batch
	^ items select: [ :each | each seasideString asUppercase first = self currentPage ]! !

!WAAlphabeticBatchedList methodsFor: 'accessing' stamp: 'avi 12/18/2004 18:20'!
currentPage
	^ currentPage ifNil: [currentPage := self validPages first]! !

!WAAlphabeticBatchedList methodsFor: 'accessing' stamp: 'avi 12/18/2004 18:16'!
currentPage: aCharacter
	currentPage := aCharacter! !

!WAAlphabeticBatchedList methodsFor: 'testing' stamp: 'avi 12/18/2004 18:21'!
isOnFirstPage
	^ self validPages first = self currentPage! !

!WAAlphabeticBatchedList methodsFor: 'testing' stamp: 'avi 12/18/2004 18:21'!
isOnLastPage
	^ self validPages last = self currentPage! !

!WAAlphabeticBatchedList methodsFor: 'accessing' stamp: 'avi 12/18/2004 18:13'!
items
	^ items! !

!WAAlphabeticBatchedList methodsFor: 'accessing' stamp: 'avi 12/18/2004 18:20'!
items: aCollection
	items := aCollection! !

!WAAlphabeticBatchedList methodsFor: 'actions' stamp: 'avi 12/18/2004 18:19'!
nextPage
	self isOnLastPage ifFalse: [currentPage := self validPages after: currentPage]! !

!WAAlphabeticBatchedList methodsFor: 'actions' stamp: 'lr 10/28/2007 14:42'!
previousPage
	self isOnFirstPage ifFalse: [currentPage := self validPages before: currentPage]! !

!WAAlphabeticBatchedList methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderContentOn: html
	items isEmpty ifFalse: [
		html div
			id: 'batch';
			with: [
				self renderPreviousOn: html.
				self renderPagesOn: html.
				self renderNextOn: html ] ]! !

!WAAlphabeticBatchedList methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderNextOn: html
	html space.
	self isOnLastPage
		ifFalse: [ html anchor callback: [ self nextPage ]; with: '>>' ]
		ifTrue: [ html text: '>>' ]! !

!WAAlphabeticBatchedList methodsFor: 'rendering' stamp: 'pmm 10/11/2006 19:15'!
renderPagesOn: html
	self allPages
		do: [ :char |
			currentPage = char
				ifFalse: [
					(self validPages includes: char)
						ifTrue: [ html anchor callback: [self currentPage: char]; with: char]
						ifFalse: [ html text: char ] ]
				ifTrue: [ html strong: char ] ]
		separatedBy: [ html space ]! !

!WAAlphabeticBatchedList methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderPreviousOn: html
	self isOnFirstPage
		ifFalse: [ html anchor callback: [ self previousPage ]; with: '<<' ]
		ifTrue: [ html text: '<<' ].
	html space! !

!WAAlphabeticBatchedList methodsFor: 'accessing' stamp: 'lr 4/15/2007 19:55'!
states
	^ Array with: self! !

!WAAlphabeticBatchedList methodsFor: 'accessing-calculated' stamp: 'lr 8/30/2008 16:22'!
validPages
	^ (items collect: [ :each | each seasideString asUppercase first ]) asSet asSortedCollection! !

WAComponent subclass: #WABatchSelection
	instanceVariableNames: 'batcher linkSelector textSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Dialogs'!

!WABatchSelection commentStamp: 'rew 9/24/2007 20:22' prior: 0!
WABatchSelection displays a list of objects. The list is show N (currently 8) items per page, with links to navigate to other pages if needed. Objects in the list must implement one method that returns text description of the item and one method that returns a name or label used as the link users click to select the item. The text description is displayed below the link.

Example
	items := OrderedCollection new.
	1 to: 20 do: [:each | items add: (Contact new name: each; phoneNumber: '54321';yourself)].
	selection := WABatchSelection items: items link: #name text: #phoneNumber.
	result := self call: selection.

	where the Contact class has methodsinstance vars "phoneNumber" and "name", with
	setter & getter methods.

Instance Variables:
	batcher	<WABatchedList>	description of batcher
	linkSelector	<Symbol>	method sent to items in list for link text
	textSelector	<Symbol>	method sent to items in list for text description

!

!WABatchSelection class methodsFor: 'instance-creation' stamp: 'pmm 4/19/2006 17:39'!
items: aCollection link: linkSelector text: textSelector
	^ self new
		items: aCollection;
		linkSelector: linkSelector;
		textSelector: textSelector;
		yourself! !

!WABatchSelection methodsFor: 'accessing' stamp: 'rjl 8/4/2006 11:35'!
batchSize
    ^batcher batchSize! !

!WABatchSelection methodsFor: 'accessing' stamp: 'rjl 8/4/2006 11:34'!
batchSize: aSize
    batcher batchSize: aSize! !

!WABatchSelection methodsFor: 'accessing' stamp: 'avi 2/10/2004 20:43'!
children
	^ Array with: batcher! !

!WABatchSelection methodsFor: 'commands' stamp: 'avi 12/9/2003 13:17'!
choose: anItem
	self answer: anItem! !

!WABatchSelection methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
items: aCollection
	batcher := WABatchedList new
		items: aCollection;
		batchSize: 8;
		yourself! !

!WABatchSelection methodsFor: 'accessing' stamp: 'avi 12/9/2003 13:22'!
linkSelector: aSymbol
	linkSelector := aSymbol! !

!WABatchSelection methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderContentOn: html
	html unorderedList: [
		batcher batch do: [ :each |
			html anchor
				callback: [ self choose: each ];
				with: (each perform: linkSelector).
			html break.
			html text: (each perform: textSelector).
			html paragraph ] ].
	html div
		style: 'text-align: center';
		with: batcher! !

!WABatchSelection methodsFor: 'accessing' stamp: 'avi 12/9/2003 13:22'!
textSelector: aSymbol
	textSelector := aSymbol! !

WAComponent subclass: #WABatchedList
	instanceVariableNames: 'items batchSize currentPage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Widgets'!

!WABatchedList commentStamp: 'rew 1/23/2008 21:10' prior: 0!
WABatchedList helps display a collection of items across multiple pages. WABatchedList organizes a collection into pages (or batches) of batchSize items each and renders navigation links for a user to moved between pages. WABatchedList>>batch returns the items to display in the current page or batch. Your code has to display the items.

See WABatchSelection for example of usage.

Instance Variables:
	batchSize	<Integer>	number of items to display on a single page
	currentPage	<Integer>	 index of current page, starts a 1
	items	<SequenceableCollection of Objects>	objects organized into pages for display

!

!WABatchedList class methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
example
	^self new
		items: (1 to: 100);
		yourself! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'rjl 8/9/2006 14:30'!
batch
	^ self items copyFrom: self startIndex to: self endIndex! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:12'!
batchSize
	^ batchSize! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:09'!
batchSize: aNumber
	batchSize := aNumber! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:12'!
currentPage
	^ currentPage! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:12'!
currentPage: aNumber
	currentPage := aNumber! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'rjl 8/9/2006 14:30'!
endIndex
	^ self currentPage * self batchSize min: self items size! !

!WABatchedList methodsFor: 'initialization' stamp: 'lr 4/15/2007 19:55'!
initialize
	super initialize.
	self batchSize: 10.
	self currentPage: 1! !

!WABatchedList methodsFor: 'testing' stamp: 'rjl 8/9/2006 14:32'!
isOnFirstPage
	^ self currentPage = 1! !

!WABatchedList methodsFor: 'testing' stamp: 'rjl 8/9/2006 14:32'!
isOnLastPage
	^ self currentPage = self maxPages! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:12'!
items
	^ items! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 22:57'!
items: aCollection
	items := aCollection! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'rjl 8/9/2006 14:30'!
maxPages
	^ (self items size / self batchSize) ceiling! !

!WABatchedList methodsFor: 'actions' stamp: 'rjl 8/9/2006 14:31'!
nextPage
	self isOnLastPage ifFalse: [self currentPage: self currentPage + 1]! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'lr 9/3/2003 10:44'!
pageRange
	^ self pageRangeStart to: self pageRangeEnd! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'lr 9/3/2003 10:50'!
pageRangeEnd
	^ self maxPages min: self currentPage + 9! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'lr 9/3/2003 10:51'!
pageRangeStart
	^ 1 max: self currentPage - 9! !

!WABatchedList methodsFor: 'actions' stamp: 'rjl 8/9/2006 14:31'!
previousPage
	self isOnFirstPage ifFalse: [self currentPage: self currentPage - 1]! !

!WABatchedList methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderContentOn: html
	self maxPages > 0 ifTrue: [
		html div
			id: 'batch';
			with: [
				self renderPreviousOn: html.
				self renderPagesOn: html.
				self renderNextOn: html ] ]! !

!WABatchedList methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderNextOn: html
	html space.
	self isOnLastPage
		ifFalse: [ html anchor callback: [ self nextPage ]; with: '>>' ]
		ifTrue: [ html text: '>>' ]! !

!WABatchedList methodsFor: 'rendering' stamp: 'al 9/7/2006 17:07'!
renderPagesOn: html
	self pageRange
		do: [ :index |
			self currentPage = index
				ifFalse: [html anchor callback: [self currentPage: index]; with: index]
				ifTrue: [html strong: index ] ]
		separatedBy: [ html space ]! !

!WABatchedList methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderPreviousOn: html
	self isOnFirstPage
		ifFalse: [ html anchor callback: [ self previousPage ]; with: '<<' ]
		ifTrue: [ html text: '<<' ].
	html space! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'rjl 8/9/2006 14:30'!
startIndex
	^ (self currentPage - 1) * self batchSize + 1! !

!WABatchedList methodsFor: 'accessing' stamp: 'lr 4/15/2007 19:55'!
states
	^ Array with: self! !

!WAComponent class methodsFor: 'testing' stamp: 'lr 10/28/2007 14:42'!
canBeRoot
	"When returning true, the component can be registered as a standalone application from the config interface."

	^ false! !

!WAComponent class methodsFor: 'accessing' stamp: 'lr 2/12/2007 23:15'!
description
	^ self name! !

!WAComponent class methodsFor: 'accessing' stamp: 'pmm 5/24/2007 10:42'!
headerForExampleBrowser
	^self name = self description
		ifTrue: [ self name ]
		ifFalse: [ self description , ' (' , self name , ')' ]! !

!WAComponent class methodsFor: 'registration' stamp: 'jf 7/29/2008 14:33'!
registerAsApplication: aString
	"Use this to programatically register a component as an appliction."
	
	| application |
	application := WAApplication register: aString.
	application preferenceAt: #rootClass put: self.
	^ application! !

!WAComponent class methodsFor: 'registration' stamp: 'jf 7/24/2008 19:34'!
registerAsAuthenticatedApplication: aString 
	"Like #registerAsApplication: but addtionally adds password protection. You will be prompted for a susername and password."
	| application user password |
	application := self registerAsApplication: aString.
	application configuration addParent: WAAuthConfiguration instance.
	user := SeasidePlatformSupport request: 'Please choose a username for\the application ' withCRs , aString printString.
	password := SeasidePlatformSupport request: 'Please enter a password for ' , aString printString.
	application 
		preferenceAt: #login
		put: user.
	application 
		preferenceAt: #passwordHash
		put: (SeasidePlatformSupport secureHashFor: password).
	^ application! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 5/19/2004 14:18'!
activeComponent
	self visiblePresentersDo: [:ea | ea isDecoration ifFalse: [^ ea]]! !

!WAComponent methodsFor: 'decorations' stamp: 'avi 6/2/2004 22:16'!
addDecoration: newDecoration
	| prev dec |
	prev := nil.
	dec := self decoration.
	[dec ~~ self and: [self decoration: dec shouldWrap: newDecoration]] whileTrue:
		[prev := dec.
		dec := dec owner].
	newDecoration owner: dec.
	prev
		ifNil: [self decoration: newDecoration]
		ifNotNil: [prev owner: newDecoration].
	^ newDecoration! !

!WAComponent methodsFor: 'convenience' stamp: 'pmm 5/9/2007 11:36'!
addMessage: aString
	"adds a decoration that renders a level 3 heading with <aString> around the receiver
	returns this decoration so don't forget #yourself"
	^self addDecoration: (WAMessageDecoration new message: aString)! !

!WAComponent methodsFor: 'iterating' stamp: 'avi 10/19/2004 15:55'!
allDecorationsDo: aBlock
	| ea |
	ea := self decoration.
	[ea notNil and: [ea ~~ self]] whileTrue:
		[aBlock value: ea.
		ea := ea owner]! !

!WAComponent methodsFor: 'call/answer' stamp: 'avi 3/27/2004 00:55'!
answer
	self answer: self! !

!WAComponent methodsFor: 'call/answer' stamp: 'lr 2/27/2008 15:41'!
answer: anObject
	"Give back control to the component from which the receiver was called from. When returning, a component can additionally return anObject to the caller."

	self decorationChainDo: [ :each | each handleAnswer: anObject ]! !

!WAComponent methodsFor: 'convenience' stamp: 'ac 3/22/2006 15:04'!
asComponent
	^ self! !

!WAComponent methodsFor: 'decorations' stamp: 'lr 10/28/2007 14:42'!
authenticateWith: anAuthenticator during: aBlock
	^ self decorateWith: (WABasicAuthentication new authenticator: anAuthenticator) during: aBlock! !

!WAComponent methodsFor: 'call/answer' stamp: 'lr 3/29/2008 14:20'!
call: aComponent 
	"Pass control from the receiver to aComponent. The receiver will be temporarily replaced with aComponent. Code can return from here later on by sending #answer: to aComponent."

	^ WAContinuation currentDo: [ :cc | 
		self 
			show: aComponent
			onAnswer: cc.
		WARenderNotification raiseSignal ]! !

!WAComponent methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
children
	"This method is really important. It should return a collection of all subcomponents of the current component that will be rendered in #renderContentOn:. Components that are displayed using #call: are *not* children.

	If the contents returned by this method change over time make sure to return them in #states as well, otherwise the back button will fail."

	^ #()! !

!WAComponent methodsFor: 'iterating' stamp: 'avi 6/8/2004 00:57'!
childrenDo: aBlock
	self children do: [:ea | ea ifNotNil: [aBlock value: ea]]! !

!WAComponent methodsFor: 'convenience' stamp: 'pmm 5/9/2007 11:49'!
chooseFrom: aCollection
	"Choose an item from the given aCollection. Answer the selected item."
	^ self chooseFrom: aCollection caption: ''! !

!WAComponent methodsFor: 'convenience' stamp: 'pmm 5/9/2007 11:49'!
chooseFrom: aCollection caption: aString
	"Choose an item from the given aCollection with caption aString. Answer the selected item."
	^ self call: ((WAChoiceDialog new options: aCollection)
		addMessage: aString;
		yourself)! !

!WAComponent methodsFor: 'convenience' stamp: 'lr 10/28/2007 14:42'!
confirm: aString
	"Display a yes/no dialog with caption queryString. Answer true if the
	response is yes, false if no. This is a modal question -- the user must
	respond yes or no."

	^ self call: (WAYesOrNoDialog new
		addMessage: aString;
		yourself)! !

!WAComponent methodsFor: 'decorations' stamp: 'avi 3/27/2004 19:53'!
decorateWith: aDecoration during: aBlock
	| val |
	self addDecoration: aDecoration.
	val := aBlock value.
	self removeDecoration: aDecoration.
	^ val! !

!WAComponent methodsFor: 'accessing' stamp: 'lr 4/15/2007 18:48'!
decoration
	^ decoration contents! !

!WAComponent methodsFor: 'accessing' stamp: 'avi 9/22/2004 13:59'!
decoration: aDecoration
	decoration contents: aDecoration! !

!WAComponent methodsFor: 'decorations' stamp: 'avi 3/28/2004 20:49'!
decoration: oldDecoration shouldWrap: newDecoration
	^ (oldDecoration isGlobal and: [newDecoration isGlobal not])
		or: [oldDecoration isDelegation and: [newDecoration isLocal]]! !

!WAComponent methodsFor: 'decorations' stamp: 'avi 4/22/2004 14:50'!
decorationChainDo: aBlock
	aBlock value: self decoration! !

!WAComponent methodsFor: 'accessing' stamp: 'avi 10/19/2004 15:57'!
delegations
	| delegations |
	delegations := OrderedCollection new.
	self allDecorationsDo: [:ea | ea isDelegation ifTrue: [delegations add: ea]].
	^ delegations! !

!WAComponent methodsFor: 'call/answer' stamp: 'avi 6/8/2004 01:13'!
handleAnswer: anObject
	^ false! !

!WAComponent methodsFor: 'accessing' stamp: 'avi 10/19/2004 15:56'!
home
	self delegations do: [:ea | self removeDecoration: ea]! !

!WAComponent methodsFor: 'convenience' stamp: 'lr 10/28/2007 14:42'!
inform: aString
	"Display a dialog with aString to the user until he clicks 'OK'"
	self call: (WAFormDialog new
		addMessage: aString;
		yourself)! !

!WAComponent methodsFor: 'initialize-release' stamp: 'pmm 4/9/2007 13:36'!
initialize
	super initialize.
	self initializeDecoration! !

!WAComponent methodsFor: 'initialize-release' stamp: 'lr 9/5/2007 11:44'!
initializeDecoration
	decoration := WAValueHolder with: self! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 3/27/2004 00:56'!
isolate: aBlock
	|txn val |
	txn := WATransaction new.
	val := self decorateWith: txn during: aBlock.
	txn close.
	^ val! !

!WAComponent methodsFor: 'iterating' stamp: 'avi 6/8/2004 00:59'!
nextPresentersDo: aBlock
	self childrenDo: [:ea | ea decorationChainDo: aBlock]! !

!WAComponent methodsFor: 'call/answer' stamp: 'lr 10/28/2007 14:42'!
onAnswer: aBlock
	"Adds an answer handler aBlock to the receiver."

	^ self addDecoration: (WAAnswerHandler new block: aBlock)! !

!WAComponent methodsFor: 'decorations' stamp: 'lr 10/28/2007 14:42'!
removeDecoration: aDecoration
	| dec |
	dec := self decoration.
	dec = aDecoration ifTrue:
		[self decoration: dec owner.
		^ self].

	[dec notNil] whileTrue:
		[dec owner = aDecoration
			ifTrue: [dec owner: aDecoration owner.  ^ self]
			ifFalse: [dec := dec owner]]! !

!WAComponent methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderOn: aRenderer
	"Do not override this methods on your component, override instead #renderContentOn: and in addition to not invoke directly renderContentOn: on subcomponent in such method but use instead html render: subcomponent."

	self decorationChainDo: [ :each | each renderWithContext: aRenderer context ]! !

!WAComponent methodsFor: 'convenience' stamp: 'pmm 5/9/2007 11:51'!
request: aString
	"Display an input dialog whose question is queryString and answer the string the user accepts."
	^ self request: aString default: ''! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 3/27/2004 00:56'!
request: aString default: initialString
	^ self request: aString label: nil default: initialString! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 3/27/2004 00:56'!
request: requestString label: labelString
	^ self request: requestString label: labelString default: ''! !

!WAComponent methodsFor: 'convenience' stamp: 'pmm 5/9/2007 11:38'!
request: requestString label: labelString default: initialString
	^ self call: (WAInputDialog new
		label: labelString;
		default: initialString;
		addMessage: requestString;
		yourself)! !

!WAComponent methodsFor: 'call/answer' stamp: 'lr 10/28/2007 14:42'!
show: aComponent
	"Pass control from the receiver to aComponent. The receiver will be temporarily replaced with aComponent. As opposed to #call: sending this message does not block and immediately returns."

	self
		show: aComponent
		onAnswer: [ :value | ]! !

!WAComponent methodsFor: 'call/answer' stamp: 'lr 10/28/2007 14:42'!
show: aComponent onAnswer: aBlock
	"Pass control from the receiver to aComponent. The receiver will be temporarily replaced with aComponent. When #answer: is sent to aComponent, aBlock is evaluated. This can be used for continuation passing style programmation of a control flow. #show:onAnswer: does not block."

	self
		show: aComponent
		onAnswer: aBlock
		delegation: (WADelegation new
			delegate: aComponent;
			yourself)! !

!WAComponent methodsFor: 'call/answer' stamp: 'lr 10/28/2007 14:42'!
show: aComponent onAnswer: aBlock delegation: aDelegation
	| event |
	event := nil.
	event := aComponent onAnswer: [ :value |
		aDelegation remove.
		event remove.
		aBlock value: value ].
	self addDecoration: aDelegation! !

!WAComponent methodsFor: 'updating' stamp: 'lr 4/20/2007 20:18'!
updateStates: aSnapshot
	super updateStates: aSnapshot.
	aSnapshot register: decoration! !

!WAComponent methodsFor: 'convenience' stamp: 'cds 7/25/2005 10:24'!
validateWith: aBlock
	^self addDecoration: (WAValidationDecoration new validateWith: aBlock)! !

!WAComponent methodsFor: 'iterating' stamp: 'avi 6/8/2004 00:58'!
visiblePresentersDo: aBlock
	self decorationChainDo: [:ea | ea withNextPresentersDo: aBlock]! !

WAComponent subclass: #WADateSelector
	instanceVariableNames: 'day month year startYear endYear'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Widgets'!

!WADateSelector commentStamp: 'rew 1/23/2008 21:10' prior: 0!
WADateSelector displays dropdown menus (html select) allowing a user to delect a date within a range. "startYear" and "endYear" define the range of selectable dates. Date displayed in month, day, year format. WADateSelector>>date returns date user selected as a Date object.

See WADateSelectorTest for sample of usage.
Select "Date Selector" tab of the Functional Seaside Test Suite to run an example  (http://127.0.0.1:xxxx/seaside/tests/alltests)

Instance Variables:
	day	<Integer 1-31> selected day
	endYear	<Integer>	end of range of dates user is allowed to select, not required to use 4 digits
	month	<Integer 1-12>	selected month
	startYear	<Integer>	 start of range of dates user is allowed to select, not required to use 4 digits
	year	<Integer>	selected year

!

!WADateSelector methodsFor: 'accessing' stamp: 'pmm 10/22/2006 08:02'!
date
	(self privateIsValidDay: day monthNumber: month year: year)
		ifFalse: [self error: 'Invalid date'].
	^ self dateClass year: year month: month day: day! !

!WADateSelector methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
date: aDate
	day := aDate dayOfMonth.
	month := aDate monthIndex.
	year := aDate year! !

!WADateSelector methodsFor: 'private' stamp: 'pmm 10/22/2006 07:59'!
dateClass
	^ Date! !

!WADateSelector methodsFor: 'testing' stamp: 'ab 2/17/2003 13:53'!
dateIsValid
	[self date] on: Error do: [:e | ^ false].
	^ true! !

!WADateSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:01'!
day
	^day! !

!WADateSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:01'!
day: anObject
	^day := anObject! !

!WADateSelector methodsFor: 'accessing' stamp: 'ac 11/25/2003 12:06'!
days
	^ 1 to: 31! !

!WADateSelector methodsFor: 'accessing' stamp: 'JF 8/14/2003 14:44'!
endYear
	^ endYear! !

!WADateSelector methodsFor: 'accessing' stamp: 'JF 8/14/2003 14:41'!
endYear: anInteger
	endYear := anInteger! !

!WADateSelector methodsFor: 'initialize-release' stamp: 'lr 10/28/2007 14:42'!
initialize
	super initialize.
	startYear := Date today year - 1.
	endYear := Date today year + 5.
	self date: self dateClass today! !

!WADateSelector methodsFor: 'accessing' stamp: 'ac 11/25/2003 12:34'!
labelForDay: aNumber
	^ aNumber! !

!WADateSelector methodsFor: 'accessing' stamp: 'ac 11/25/2003 12:33'!
labelForMonth: aNumber
	^ Date nameOfMonth: aNumber! !

!WADateSelector methodsFor: 'accessing' stamp: 'ac 11/25/2003 12:34'!
labelForYear: aNumber
	^ aNumber! !

!WADateSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:01'!
month
	^month! !

!WADateSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:01'!
month: anObject
	^month := anObject! !

!WADateSelector methodsFor: 'accessing' stamp: 'ac 11/25/2003 12:06'!
months
	^ 1 to: 12! !

!WADateSelector methodsFor: 'private' stamp: 'dkh 3/10/2008 10:50'!
privateIsValidDay: theDay monthNumber: theMonth year: theYear
	| daysInMonth |
	(theMonth between: 1 and: 12) ifFalse: [^false].
	daysInMonth := Date daysInMonthNumber: theMonth forYear: theYear.
	^(theDay between: 1 and: daysInMonth)! !

!WADateSelector methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderContentOn: html
	html select
		list: self months;
		on: #month of: self;
		labels: [ :each | self labelForMonth: each ].

	html select
		list: self days;
		on: #day of: self;
		labels: [ :each | self labelForDay: each ].

	html select
		list: self yearRange;
		on: #year of: self;
		labels: [ :each | self labelForYear: each ].

	self dateIsValid ifFalse: [self renderValidationErrorOn: html]! !

!WADateSelector methodsFor: 'rendering' stamp: 'pmm 10/11/2006 18:00'!
renderValidationErrorOn: html
	html span
		class: 'error';
		with: 'invalid date'! !

!WADateSelector methodsFor: 'accessing' stamp: 'JF 8/14/2003 14:44'!
startYear
	^ startYear! !

!WADateSelector methodsFor: 'accessing' stamp: 'JF 8/14/2003 14:40'!
startYear: anInteger
	startYear := anInteger! !

!WADateSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:02'!
year
	^year! !

!WADateSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:02'!
year: anObject
	^year := anObject! !

!WADateSelector methodsFor: 'accessing' stamp: 'JF 8/14/2003 14:43'!
yearRange
	^ self startYear to: self endYear! !

WAComponent subclass: #WADateTable
	instanceVariableNames: 'rows startDate endDate datesCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Widgets'!

!WADateTable commentStamp: 'rew 1/23/2008 21:11' prior: 0!
WADateTable renders a table containing dates from startDate to endDate. The table contains one column for each date from startDate to endDate. The top row of the table groups columns by month and labels each month (January 2008). The second row contains the date of each month (1-31) in the date range. The table also contains "rows size" rows. The first column of these rows contains the contents of the instance variable "rows". Rest of the cells are empty.

Basically this is an abstract superclass for WASelectionDateTable

Instance Variables:
	datesCache	<(SequenceableCollection of: Date>	contains a date object for each date in the range startDate-endDate
	endDate	<Date>	end date of the range displayed in the table
	rows	<SequenceableCollection>	labels of the rows
	startDate	<Date>	start date of the range displayed in the table

!

!WADateTable methodsFor: 'enumerating' stamp: 'lr 10/28/2007 14:42'!
datesDo: aBlock separatedBy: monthlyBlock
	| month |
	month := datesCache first monthIndex.
	datesCache do: [ :date |
		date monthIndex = month ifFalse: [month := date monthIndex. monthlyBlock value].
		aBlock value: date ].
	monthlyBlock value! !

!WADateTable methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
endDate: aDate
	endDate := aDate.
	self updateDatesCache! !

!WADateTable methodsFor: 'enumerating' stamp: 'pmm 5/16/2007 17:50'!
monthsAndLengthsDo: aTwoArgumentBlock
	| count last |
	count := 0.
	last := nil.
	self
		datesDo: [ :each |
			count := count + 1.
			last := each ]
		separatedBy: [
			aTwoArgumentBlock value: last month value: count.
			count := 0 ]! !

!WADateTable methodsFor: 'rendering' stamp: 'ab 2/17/2003 16:59'!
renderCellForDate: aDate row: anObject index: aNumber on: html
	html tableData: [html space]! !

!WADateTable methodsFor: 'rendering' stamp: 'pmm 2/23/2008 18:25'!
renderContentOn: html
	html table
		class: 'DateTable';
		border: 1;
		with: [
			html tableRow: [
				self renderMonthHeadingsOn: html ].
			html tableRow: [
				self renderDayHeadingsOn: html ].
			rows keysAndValuesDo: [ :index :each | 
				html tableRow: [
					self
						renderRow: each
						index: index
						on: html ] ] ]! !

!WADateTable methodsFor: 'rendering' stamp: 'pmm 10/11/2006 19:19'!
renderDayHeadingsOn: html
	self renderHeadingSpacerOn: html.
	self
		datesDo: [:date |
			html tableHeading
				class: 'DayHeading';
				with: date dayOfMonth ]
		separatedBy: [ self renderHeadingSpacerOn: html ]! !

!WADateTable methodsFor: 'rendering' stamp: 'pmm 10/11/2006 19:20'!
renderHeadingForRow: anObject on: html
	html tableHeading
		class: 'RowHeading';
		with: anObject! !

!WADateTable methodsFor: 'rendering' stamp: 'pmm 12/18/2007 20:35'!
renderHeadingSpacerOn: html
	html tableData: ''! !

!WADateTable methodsFor: 'rendering' stamp: 'pmm 10/11/2006 19:21'!
renderMonthHeadingsOn: html
	self monthsAndLengthsDo: [ :month :length |
		self renderHeadingSpacerOn: html.
		html tableHeading
			colSpan: length;
			class: 'MonthHeading';
			with: [
				html text: month name.
				html space.
				html text: month year ] ]! !

!WADateTable methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderRow: anObject index: aNumber on: html
	self renderHeadingForRow: anObject on: html.
	self
		datesDo: [ :date | self renderCellForDate: date row: anObject index: aNumber on: html]
		separatedBy: [ self renderHeadingSpacerOn: html ]! !

!WADateTable methodsFor: 'accessing' stamp: 'ab 2/17/2003 14:11'!
rows: aCollection
	rows := aCollection! !

!WADateTable methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
startDate: aDate
	startDate := aDate.
	self updateDatesCache! !

!WADateTable methodsFor: 'actions' stamp: 'lr 10/28/2007 14:42'!
updateDatesCache
	| date |
	(startDate isNil or: [endDate isNil]) ifTrue: [^ self].

	datesCache := OrderedCollection new.
	date := startDate.
	[date > endDate] whileFalse:
		[datesCache add: date.
		date := date next]! !

WADateTable subclass: #WASelectionDateTable
	instanceVariableNames: 'cellBlock dateSelectionStart dateSelectionEnd rowSelectionStart rowSelectionEnd'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Widgets'!

!WASelectionDateTable commentStamp: 'rew 1/23/2008 21:13' prior: 0!
WASelectionDateTable renders a table containing dates and rows. A user can select a continuous block of cells in the table.  The table contains one column for each date from startDate to endDate. The top row of the table groups columns by month and labels each month (January 2008). The second row contains the date of each month  (1-30) in the date range. The table also contains "rows size" rows. The first column of these rows contains the contents of the instance variable "rows". Rest of the cells contents are given by "cellBlock". 

Instance Variables:
	cellBlock	<BlockClosure [:rowIndex :date | ]>	returns text for the cell in row "rowIndex" and column for "date"
	dateSelectionEnd	<Date>	last selected date
	dateSelectionStart	<Date>	first selected date
	rowSelectionEnd	<Integer>	index of last selected row
	rowSelectionStart	<Integer>	index of first selected row

!

!WASelectionDateTable methodsFor: 'selecting' stamp: 'ab 2/17/2003 17:23'!
clearSelection
	dateSelectionStart := dateSelectionEnd := rowSelectionStart := rowSelectionEnd := nil! !

!WASelectionDateTable methodsFor: 'private' stamp: 'ab 2/17/2003 17:19'!
colorForDate: aDate rowIndex: aNumber
	^ (self hasSelection
		and: [self selectionContainsDate: aDate rowIndex: aNumber])
			ifTrue: ['lightgrey']
			ifFalse: ['white']! !

!WASelectionDateTable methodsFor: 'accessing' stamp: 'ab 2/17/2003 19:56'!
endDate: aDate
	self clearSelection.
	super endDate: aDate! !

!WASelectionDateTable methodsFor: 'private' stamp: 'ab 2/17/2003 17:22'!
endDateSelection
	^ dateSelectionStart ifNotNil: [dateSelectionStart max: dateSelectionEnd]! !

!WASelectionDateTable methodsFor: 'private' stamp: 'ab 2/17/2003 19:40'!
endRow
	^ rowSelectionStart max: rowSelectionEnd! !

!WASelectionDateTable methodsFor: 'private' stamp: 'ab 2/17/2003 17:27'!
endRowSelection
	^ rowSelectionStart ifNotNil: [rows at: (rowSelectionStart max: rowSelectionEnd)]! !

!WASelectionDateTable methodsFor: 'testing' stamp: 'ab 2/17/2003 17:02'!
hasSelection
	^ dateSelectionStart notNil! !

!WASelectionDateTable methodsFor: 'rendering' stamp: 'pmm 10/11/2006 19:27'!
renderCellForDate: aDate row: anObject index: aNumber on: html
	| text |
	html tableData
		style: 'background-color: ', (self colorForDate: aDate rowIndex: aNumber);
		align: 'center';
		with: [
			text := cellBlock value: anObject value: aDate.
			html anchor callback: [self selectDate: aDate rowIndex: aNumber]; with: text ]! !

!WASelectionDateTable methodsFor: 'accessing' stamp: 'ab 2/17/2003 19:56'!
rows: aCollection
	self clearSelection.
	super rows: aCollection! !

!WASelectionDateTable methodsFor: 'private' stamp: 'ab 2/17/2003 16:48'!
rowsAndDatesDisplay: aBlock
	cellBlock := aBlock! !

!WASelectionDateTable methodsFor: 'editor access' stamp: 'lr 10/28/2007 14:42'!
selectAll
	dateSelectionStart := startDate.
	dateSelectionEnd := endDate.
	rowSelectionStart := 1.
	rowSelectionEnd := rows size! !

!WASelectionDateTable methodsFor: 'private' stamp: 'ab 2/17/2003 17:05'!
selectDate: aDate rowIndex: rowIndex
	self hasSelection
		ifFalse: [dateSelectionStart := dateSelectionEnd := aDate. rowSelectionStart := rowSelectionEnd := rowIndex]
		ifTrue: [dateSelectionEnd := aDate. rowSelectionEnd := rowIndex]! !

!WASelectionDateTable methodsFor: 'private' stamp: 'ab 2/17/2003 19:40'!
selectedRows
	^ rows copyFrom: self startRow to: self endRow! !

!WASelectionDateTable methodsFor: 'private' stamp: 'ab 2/17/2003 17:18'!
selectionContainsDate: aDate rowIndex: aNumber
	^ ((aDate between: dateSelectionStart and: dateSelectionEnd) or: [aDate between: dateSelectionEnd and: dateSelectionStart])
		and: [(aNumber between: rowSelectionStart and: rowSelectionEnd) or: [aNumber between: rowSelectionEnd and: rowSelectionStart]]! !

!WASelectionDateTable methodsFor: 'accessing' stamp: 'ab 2/17/2003 19:56'!
startDate: aDate
	self clearSelection.
	super startDate: aDate! !

!WASelectionDateTable methodsFor: 'private' stamp: 'ab 2/17/2003 17:22'!
startDateSelection
	^ dateSelectionStart ifNotNil: [dateSelectionStart min: dateSelectionEnd]! !

!WASelectionDateTable methodsFor: 'private' stamp: 'ab 2/17/2003 19:40'!
startRow
	^ rowSelectionStart min: rowSelectionEnd! !

!WASelectionDateTable methodsFor: 'private' stamp: 'ab 2/17/2003 17:27'!
startRowSelection
	^ rowSelectionStart ifNotNil: [rows at: (rowSelectionStart min: rowSelectionEnd)]! !

!WASelectionDateTable methodsFor: 'rendering' stamp: 'ab 2/17/2003 22:43'!
style
	^ 'td a {text-decoration: none}'! !

WAComponent subclass: #WADateTimeSelector
	instanceVariableNames: 'dateSelector timeSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Widgets'!

!WADateTimeSelector commentStamp: 'rew 1/23/2008 21:11' prior: 0!
WADateTimeSelector allows the user to select a date and time in a given range dropdown menus (html select). Actual work done by WADateSelector and WATimeSelector. Date range is default range of WADateSelector.

See WADateSelectorTest for sample of usage.
Select "Date Selector" tab of the Functional Seaside Test Suite to run an example  (http://127.0.0.1:xxxx/seaside/tests/alltests)

Instance Variables:
	dateSelector	<WADateSelector>	presents date selection to user
	timeSelector	<WATimeSelector>	presents time selection to user

!

!WADateTimeSelector methodsFor: 'accessing' stamp: 'jlr 4/5/2006 00:19'!
children

	^ Array with: dateSelector with: timeSelector! !

!WADateTimeSelector methodsFor: 'accessing' stamp: 'jlr 4/5/2006 00:22'!
dateAndTime

	^ DateAndTime date: dateSelector date time: timeSelector time! !

!WADateTimeSelector methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
dateAndTime: anObject

	dateSelector date: anObject asDate.
	timeSelector time: anObject asTime! !

!WADateTimeSelector methodsFor: 'initialize-release' stamp: 'lr 10/28/2007 14:42'!
initialize
	super initialize.
	dateSelector := WADateSelector new.
	timeSelector := WATimeSelector new! !

!WADateTimeSelector methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderContentOn: html

	html span: dateSelector.
	html span: [html strong: ' : '].
	html span: timeSelector! !

WAComponent subclass: #WAFormDialog
	instanceVariableNames: 'validationError form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Dialogs'!

!WAFormDialog commentStamp: 'rew 9/24/2007 20:23' prior: 0!
WAFormDialog is an empty html form. Used in WAComponent>>inform: to create a dialog component that displays text and an "Ok" button to close the component. See subclasses for sample usage & more functionality.

Instance Variables:
	form	<WAFormDecoration> Decorator that generates form tags
	validationError	<String>	Text descriping invalid data entered by user. Displayed when not nil. Set to nil when user submits form.
!

WAFormDialog subclass: #WAChoiceDialog
	instanceVariableNames: 'options selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Dialogs'!

!WAChoiceDialog commentStamp: 'pmm 9/25/2007 20:24' prior: 0!
WAChoiceDialog produces a form with select tag (dropdown menu) on a collection of options and "Ok" and "Cancel" buttons. Options can be any object. Returns actual object selected or nil if user select "Cancel". WAChoiceDialog is used to implement the chooseFrom:caption: convenience method in WAComponent.

	| selection |
	selection := WAChoiceDialog options: #('Smalltalk' 'Perl' 'Python' 'Ruby' 9).
	result := self call: selection.
	self inform: result printString

Instance Variables:
	options	<Collection of Objects> objects in list
	selection	<Object>	object selected by user or nil if user cancels

!

!WAChoiceDialog class methodsFor: 'examples' stamp: 'lr 1/7/2007 17:59'!
example
	^ self options: #('Smalltalk' 'Perl' 'Python' 'Ruby')! !

!WAChoiceDialog class methodsFor: 'instance-creation' stamp: 'avi 3/21/2004 00:59'!
options: aCollection
	^ self new options: aCollection! !

!WAChoiceDialog methodsFor: 'accessing' stamp: 'avi 3/21/2004 01:00'!
buttons
	^ #(ok cancel)! !

!WAChoiceDialog methodsFor: 'actions' stamp: 'avi 3/21/2004 01:00'!
cancel
	self answer: nil! !

!WAChoiceDialog methodsFor: 'actions' stamp: 'avi 3/21/2004 01:00'!
ok
	self answer: selection! !

!WAChoiceDialog methodsFor: 'accessing' stamp: 'avi 3/21/2004 00:59'!
options
	^ options! !

!WAChoiceDialog methodsFor: 'accessing' stamp: 'avi 3/21/2004 00:59'!
options: aCollection
	options := aCollection! !

!WAChoiceDialog methodsFor: 'rendering' stamp: 'pmm 4/27/2007 00:18'!
renderContentOn: html
	html select
		list: options;
		selected: selection;
		callback: [ :value | selection := value ]! !

!WAFormDialog methodsFor: 'actions' stamp: 'avi 3/16/2004 13:45'!
addForm
	form := WAFormDecoration new buttons: self buttons.
	self addDecoration: form! !

!WAFormDialog methodsFor: 'testing' stamp: 'avi 3/16/2004 14:05'!
addFormByDefault
	^ true! !

!WAFormDialog methodsFor: 'accessing' stamp: 'avi 3/12/2004 16:37'!
buttons
	^ #(ok)! !

!WAFormDialog methodsFor: 'accessing' stamp: 'mb 4/4/2006 13:41'!
defaultButton
	^self buttons first! !

!WAFormDialog methodsFor: 'accessing' stamp: 'avi 3/12/2004 20:41'!
divClass
	^ self class name! !

!WAFormDialog methodsFor: 'initialization' stamp: 'pmm 11/2/2005 22:51'!
initialize
	super initialize.
	self addFormByDefault ifTrue: [self addForm]! !

!WAFormDialog methodsFor: 'testing' stamp: 'avi 3/12/2004 16:35'!
isValid
	^ validationError isNil! !

!WAFormDialog methodsFor: 'accessing' stamp: 'avi 3/12/2004 16:35'!
model
	^ self! !

!WAFormDialog methodsFor: 'actions' stamp: 'avi 3/12/2004 16:37'!
ok
	self answer! !

!WAFormDialog methodsFor: 'actions' stamp: 'avi 3/27/2004 16:59'!
removeForm
	form ifNotNil: [self removeDecoration: form]! !

!WAFormDialog methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderContentOn: html
	html hiddenInput callback: [ validationError := nil ].
	validationError
		ifNotNil: [ self renderValidationError: validationError on: html ].
	html div
		class: self divClass;
		with: [ self renderDialogOn: html ]! !

!WAFormDialog methodsFor: 'rendering' stamp: 'avi 3/12/2004 20:37'!
renderDialogOn: html! !

!WAFormDialog methodsFor: 'rendering' stamp: 'lr 1/7/2007 17:55'!
renderSpacerRowOn: html
	html div class: 'dialog-spacer'; with: [ html space ]! !

!WAFormDialog methodsFor: 'rendering' stamp: 'lr 1/7/2007 17:56'!
renderValidationError: aString on: html
	html span class: 'dialog-validation'; with: aString! !

!WAFormDialog methodsFor: 'validation' stamp: 'avi 3/12/2004 16:35'!
validationError: aString
	validationError := aString! !

WAFormDialog subclass: #WALabelledFormDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Dialogs'!

!WALabelledFormDialog commentStamp: 'rew 9/24/2007 20:24' prior: 0!
WALabelledFormDialog is an abstract class for generating html forms. Given a data model WALabelledFormDialog displays a label and input field for each instance variable of interest. User supplied data is placed in the data model.

Subclasses need to implment the methods labelForSelector:, model, and rows. The "model" method just returns the object whose fields we wish to populate with date. The "rows" method returns a collections of symbols. One symbol for each row of data in the dialog. The symbol is used generate the accessor methods for the data in the model. The method "labelForSelector:" returns the labels for each row and each submit button in the form.

A standard text input field is used for each row of data. To use other html widgets for input for = a datum implement the method renderXXXOn: where XXX is the symbol for the row. See "renderNameOn:" in example below.

The default form has one button "Ok". Override the "buttons" method to change the text or number of submit buttons on the form. Override the "defaultButton" method to indicate which button is the default. For each button in the form the subclass needs a method with the same name as the button, which is called when the user clicks that button. See example below.

LabelledFormDialogExample subclass of WALabelledFormDialog instance methods
	initialize
		super initialize.
		contact := Contact new. "contact is an inst var"
		self addMessage: 'Please enter the followning information'.

	model
		^ contact

	ok
		self answer: contact

	cancel
		self answer

	rows
		^ #(name phoneNumber)

	buttons
		#(ok cancel)

	labelForSelector: aSymbol
		aSymbol == #name ifTrue: [^'Your Name'].
		aSymbol == #phoneNumber ifTrue: [^'Phone Number'].
		aSymbol == #ok ifTrue: [^'Ok'].
		aSymbol == #cancel ifTrue: [^'Cancel'].
		^ super labelForSelector: aSymbol

	renderNameOn: html 
		"Show how to specily special input instead of using simple text field."
		(html select)
				list: #('Roger' 'Pete');
				selected: 'Roger';
				callback: [:v | contact name: v]

Contact Class used above has instance variables name, phoneNumber with standard getter and setter methods
!

!WALabelledFormDialog methodsFor: 'rendering' stamp: 'al 9/7/2006 16:08'!
renderDefaultFieldForSelector: aSymbol on: html
	html textInput
		on: aSymbol of: self model! !

!WALabelledFormDialog methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderDialogOn: html
	self rows do:
		[:ea |
		ea = #-
			ifTrue: [self renderSpacerRowOn: html]
			ifFalse: [self renderRowForSelector: ea on: html]]! !

!WALabelledFormDialog methodsFor: 'rendering' stamp: 'avi 3/12/2004 21:06'!
renderFieldForSelector: aSymbol on: html
	| renderSelector |
	renderSelector := self renderingSelectorFor: aSymbol.
	(self respondsTo: renderSelector)
		ifTrue: [self perform: renderSelector with: html]
		ifFalse: [self renderDefaultFieldForSelector: aSymbol on: html]! !

!WALabelledFormDialog methodsFor: 'rendering' stamp: 'avi 3/12/2004 20:41'!
renderLabelForSelector: aSymbol on: html
	html text: (self labelForSelector: aSymbol)! !

!WALabelledFormDialog methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderRowForSelector: aSymbol on: html
	html div
		id: 'dialog-row-' , aSymbol;
		class: 'dialog-row';
		with: [
			html span
				class: 'dialog-form-label';
				with: [self renderLabelForSelector: aSymbol on: html].
			html span
				class: 'dialog-form-field';
				with: [self renderFieldForSelector: aSymbol on: html]]! !

!WALabelledFormDialog methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderTableRowsOn: html
	self rows do:
		[:ea |
		ea = #-
			ifTrue: [self renderSpacerRowOn: html]
			ifFalse: [self renderRowForSelector: ea on: html]]! !

!WALabelledFormDialog methodsFor: 'rendering' stamp: 'avi 3/12/2004 20:37'!
renderingSelectorFor: aSymbol
	^ ('render', aSymbol capitalized, 'On:') asSymbol! !

!WALabelledFormDialog methodsFor: 'accessing' stamp: 'avi 3/10/2004 18:00'!
rows
	^ #()! !

!WALabelledFormDialog methodsFor: 'accessing' stamp: 'avi 3/16/2004 16:29'!
style
	^ '
.dialog-row {
	clear: both;
	/*set position: relative to handle the ie disappearing text bug*/
	position: relative;
	margin-top: 3px;
}

.dialog-form-label {
	width: 100px;
	float: left;
	text-align: right;
	padding: 2px 6px;
	margin-right: 4px;
	margin-top: 2px;
}

.dialog-form-field {
	text-align: left;
	padding: 2px;
	margin-top: 2px;
	float: left;
}

.dialog-buttons {
	clear: both;
	padding: 10px;
	text-align: center
}

.dialog-spacer {
	clear: both;
	height: 10px;
}
	'! !

WAFormDialog subclass: #WAYesOrNoDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Dialogs'!

!WAYesOrNoDialog commentStamp: 'rew 9/24/2007 20:25' prior: 0!
WAYesOrNoDialog displays a yes/no dialog. Returns boolean indicating user selection. See WAComponent>>confirm: for sample usage and easy way to use WAYesOrNoDialog.!

!WAYesOrNoDialog methodsFor: 'accessing' stamp: 'avi 3/13/2004 21:40'!
buttons
	^ #(yes no)! !

!WAYesOrNoDialog methodsFor: 'accessing' stamp: 'avi 3/13/2004 21:40'!
no
	self answer: false! !

!WAYesOrNoDialog methodsFor: 'accessing' stamp: 'avi 3/13/2004 21:40'!
yes
	self answer: true! !

WAComponent subclass: #WAInputDialog
	instanceVariableNames: 'label value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Dialogs'!

!WAInputDialog commentStamp: 'rew 9/24/2007 20:24' prior: 0!
WAInputDialog generates a simple form with a text input field and a submit button. The instance variable "value" is used for initial value of the text field and hold the text entered by user. WAInputDialog answers with text entered by user (value of "value"). See WAComponent>>request:label:default: for sample use and easy way to use WAInputDialog.

Instance Variables:
	label	<String>	label of submit button
	value	<Object | String>	
!

!WAInputDialog methodsFor: 'accessing' stamp: 'pmm 9/12/2006 18:32'!
default: aString
	value := aString! !

!WAInputDialog methodsFor: 'accessing' stamp: 'pmm 9/12/2006 18:34'!
label
	^label ifNil: [ label := 'OK' ]! !

!WAInputDialog methodsFor: 'accessing' stamp: 'pmm 9/12/2006 18:32'!
label: aString
	label := aString! !

!WAInputDialog methodsFor: 'rendering' stamp: 'lr 1/7/2007 18:02'!
renderContentOn: html
	html form
		defaultAction: [ self answer: value ];
		with: [
			html textInput on: #value of: self.
			html space.
			html submitButton
				callback: [ self answer: value ];
				text: self label ]! !

!WAInputDialog methodsFor: 'accessing' stamp: 'pmm 9/12/2006 18:34'!
value
	^value! !

!WAInputDialog methodsFor: 'accessing' stamp: 'pmm 9/12/2006 18:34'!
value: aString
	value := aString! !

WAComponent subclass: #WAMiniCalendar
	instanceVariableNames: 'monthIndex year date canSelectBlock selectBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Widgets'!

!WAMiniCalendar commentStamp: '<historical>' prior: 0!
WAMiniCalendar renders a monthly calendar. Users can navigate by month, year, or select a year and a month. Users can select a date in the calendar. Set canSelectBlock to control which dates a user can select. Use selectBlock to perform an action when a user selects a date. WAMiniCalendar>>date returns the selected date.

Select "Mini Calendar" tab of the Functional Seaside Test Suite to run an example  (http://127.0.0.1:xxxx/seaside/tests/alltests)

Instance Variables:
	canSelectBlock		<BlockClosure with date argument>	return true if date argument should be rendered with a link, ie user can select that date
	date		<WAValueHolder on a date>	Selected date
	monthIndex		<WAValueHolder on an Integer>	Currently displayed month
	year		<WAValueHolder on an Integer>	Currently displayed year
	selectBlock		<BlockClosure with date argument> called when user selects a date

!

!WAMiniCalendar class methodsFor: 'testing' stamp: 'dc 12/28/2005 14:20'!
canBeRoot
	^ true! !

!WAMiniCalendar class methodsFor: 'accessing' stamp: 'lr 11/29/2004 16:37'!
example
	^self new! !

!WAMiniCalendar methodsFor: 'testing' stamp: 'lr 12/28/2006 22:37'!
canSelect: aDate
	^ canSelectBlock value: aDate! !

!WAMiniCalendar methodsFor: 'accessing' stamp: 'avi 10/23/2003 15:16'!
canSelectBlock: aBlock
	canSelectBlock := aBlock! !

!WAMiniCalendar methodsFor: 'accessing-delegated' stamp: 'avi 10/23/2003 15:25'!
date
	^ date contents! !

!WAMiniCalendar methodsFor: 'accessing-delegated' stamp: 'dkh 2/29/2008 09:32'!
date: aDate 
	date contents: aDate.
	monthIndex contents: aDate monthIndex.
	year contents: aDate year! !

!WAMiniCalendar methodsFor: 'initialization' stamp: 'dkh 2/29/2008 09:32'!
initialize
	super initialize.
	monthIndex := WAValueHolder with: Date today monthIndex.
	year := WAValueHolder with: Date today year.
	date := WAValueHolder new.
	canSelectBlock := [:value | true].
	selectBlock := [:value | self answer: value]! !

!WAMiniCalendar methodsFor: 'private' stamp: 'lr 8/30/2008 16:22'!
monthHeading
	^ self monthName , ' ' , self year seasideString! !

!WAMiniCalendar methodsFor: 'accessing-delegated' stamp: 'dkh 2/29/2008 09:34'!
monthIndex
	^ monthIndex contents! !

!WAMiniCalendar methodsFor: 'accessing-delegated' stamp: 'dkh 2/29/2008 09:34'!
monthIndex: anInteger 
	monthIndex contents: anInteger! !

!WAMiniCalendar methodsFor: 'private' stamp: 'dkh 2/29/2008 09:34'!
monthName
	^ Date nameOfMonth: self monthIndex! !

!WAMiniCalendar methodsFor: 'localization' stamp: 'dkh 2/29/2008 09:34'!
monthNames
	^ (1 to: 12)
		collect: [:each | Date nameOfMonth: each]! !

!WAMiniCalendar methodsFor: 'action' stamp: 'obi 3/23/2008 10:34'!
nextMonth
	self monthIndex = 12
		ifTrue: [ self monthIndex: 1; year: self year + 1]
		ifFalse: [ self monthIndex: self monthIndex + 1 ]! !

!WAMiniCalendar methodsFor: 'action' stamp: 'obi 3/23/2008 10:34'!
previousMonth
	self monthIndex = 1
		ifTrue: [ self monthIndex: 12; year: self year - 1]
		ifFalse: [ self monthIndex: self monthIndex - 1 ]
! !

!WAMiniCalendar methodsFor: 'rendering' stamp: 'dkh 2/29/2008 09:36'!
renderCellForDate: aDate on: html
	html tableData: 
		[(aDate monthIndex = self monthIndex and: [ aDate year = self year ])
			ifTrue: 
			[html span
				class: (self date = aDate ifTrue: ['calendarArchiveDate']);
				with: [(self canSelect: aDate) 
					ifTrue: 
						[html anchor
							callback: [self select: aDate];
							with: aDate dayOfMonth]
					ifFalse: [html text: aDate dayOfMonth]]]]! !

!WAMiniCalendar methodsFor: 'rendering' stamp: 'dkh 2/29/2008 09:36'!
renderContentOn: html
	html div
		class: 'calendar';
		with: 
			[html span
				class: 'calendarCaption';
				with: [self renderMonthHeadingOn: html].
			html table: 
				[html tableRow
					class: 'calendarTitle';
					with: [self weekDays do: [:each | html tableData: each]].
						self weeksDo: [:week | self renderRowForWeek: week on: html]].
			self renderMonthNavigationOn: html.
			html
				space;
				space.
			self renderYearNavigationOn: html]! !

!WAMiniCalendar methodsFor: 'rendering' stamp: 'dkh 2/29/2008 09:36'!
renderMonthHeadingOn: html
	html form: 
		[html select
			list: (1 to: 12);
			on: #monthIndex of: self;
			labels: [:index | Date nameOfMonth: index].
		html textInput
			maxLength: 4;
			on: #year of: self.
		html submitButton text: 'Refresh']! !

!WAMiniCalendar methodsFor: 'rendering' stamp: 'obi 3/23/2008 10:34'!
renderMonthNavigationOn: html
	| tab |
	tab := #(12 1 2 3 4 5 6 7 8 9 10 11 12 1).
	html span
		class: 'calendarPrevious';
		with: 
			[html anchor
				callback: [self previousMonth];
				with: ((self monthNames at: (tab at: self monthIndex)) first: 3)].
	html space.
	html span
		class: 'calendarNext';
		with: 
			[html anchor
				callback: [self nextMonth];
				with: ((self monthNames at: (tab at: self monthIndex + 2)) first: 3)].! !

!WAMiniCalendar methodsFor: 'rendering' stamp: 'dkh 2/29/2008 09:37'!
renderRowForWeek: initialDay on: html
	html 
		tableRow: [0 to: 6 do: [:each |
			self renderCellForDate: (initialDay addDays: each) on: html]]! !

!WAMiniCalendar methodsFor: 'rendering' stamp: 'dkh 2/29/2008 09:37'!
renderYearNavigationOn: html
	html span
		class: 'calendarPrevious';
		with: 
			[html anchor
				callback: [self year: self year - 1];
				with: self year - 1].
	html space.
	html span
		class: 'calendarNext';
		with: 
			[html anchor
				callback: [self year: self year + 1];
				with: self year + 1]! !

!WAMiniCalendar methodsFor: 'action' stamp: 'lr 12/28/2006 22:38'!
select: aDate
	self date: aDate.
	selectBlock value: aDate! !

!WAMiniCalendar methodsFor: 'accessing' stamp: 'avi 10/23/2003 17:39'!
selectBlock: aBlock
	selectBlock := aBlock! !

!WAMiniCalendar methodsFor: 'accessing' stamp: 'dkh 2/29/2008 09:37'!
states
	^Array with: date with: monthIndex with: year! !

!WAMiniCalendar methodsFor: 'private' stamp: 'lr 12/28/2006 22:42'!
weekDays
	^ (1 to: 7) collect: [ :i | (Date nameOfDay: i) first: 3 ]! !

!WAMiniCalendar methodsFor: 'private' stamp: 'dkh 2/29/2008 09:49'!
weeksDo: aBlock
	| day nextMonth |
	day := Date newDay: 1 monthNumber: self monthIndex year: self year.
	day := day subtractDays: day dayOfWeek.
	nextMonth := (self monthIndex \\ 12) + 1.
	[ day monthIndex = nextMonth ] whileFalse: [
		aBlock value: day.
		day := day addDays: 7 ]! !

!WAMiniCalendar methodsFor: 'accessing-delegated' stamp: 'dkh 2/29/2008 09:38'!
year
	^year contents! !

!WAMiniCalendar methodsFor: 'accessing-delegated' stamp: 'dkh 2/29/2008 09:38'!
year: anIntegerOrString
	year contents: ([anIntegerOrString asInteger] on: Error do: [:error | 1900])! !

WAComponent subclass: #WANavigation
	instanceVariableNames: 'selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Frames'!

!WANavigation methodsFor: 'initialize' stamp: 'lr 9/5/2007 11:20'!
initialize
	super initialize.
	selection := WAValueHolder new! !

!WANavigation methodsFor: 'query' stamp: 'lr 8/30/2008 16:22'!
labelForOption: anObject 
	^ anObject seasideString! !

!WANavigation methodsFor: 'initialize' stamp: 'avi 3/15/2004 16:27'!
options
	^ #()! !

!WANavigation methodsFor: 'rendering' stamp: 'lr 6/6/2007 17:49'!
renderContentOn: html
	html div class: 'kalsey'; with: [
		html div
			class: 'navigation-options';
			with: [ self renderOptionsOn: html ].
		html div
			class: 'navigation-content';
			with: [ self renderSelectionOn: html ] ]! !

!WANavigation methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderOptionsOn: html
	html unorderedList
		list: self options;
		selected: self selection;
		callback: [ :value | self select: value ];
		labels: [ :each | self labelForOption: each ]! !

!WANavigation methodsFor: 'rendering' stamp: 'avi 3/15/2004 16:13'!
renderSelectionOn: html! !

!WANavigation methodsFor: 'selection' stamp: 'lr 6/6/2007 17:54'!
select: anObject
	selection contents: anObject.
	self selectionChanged! !

!WANavigation methodsFor: 'selection' stamp: 'avi 3/15/2004 16:28'!
selection
	^ selection contents! !

!WANavigation methodsFor: 'selection' stamp: 'lr 10/28/2007 14:42'!
selectionChanged! !

!WANavigation methodsFor: 'selection' stamp: 'lr 4/15/2007 19:57'!
states
	^ Array with: selection! !

WANavigation subclass: #WASimpleNavigation
	instanceVariableNames: 'components'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Frames'!

!WASimpleNavigation commentStamp: 'lr 11/29/2004 16:30' prior: 0!
I'm a simple tab panel, that can be styled with stylesheets. New tabs can be added using #add:label:!

!WASimpleNavigation methodsFor: 'behavior' stamp: 'avi 3/15/2004 19:24'!
add: aComponent label: aString
	components add: aString -> aComponent! !

!WASimpleNavigation methodsFor: 'accessing' stamp: 'lr 6/6/2007 17:53'!
children
	^ Array with: self selectedComponent! !

!WASimpleNavigation methodsFor: 'initialize' stamp: 'avi 3/15/2004 19:25'!
initialize
	super initialize.
	components := OrderedCollection new! !

!WASimpleNavigation methodsFor: 'accessing' stamp: 'lr 11/29/2004 16:28'!
labels
	"Return the tabs labels"

	^ self options! !

!WASimpleNavigation methodsFor: 'accessing' stamp: 'lr 6/6/2007 17:53'!
options
	^ components collect: [ :each | each key ]! !

!WASimpleNavigation methodsFor: 'rendering' stamp: 'sd 11/28/2004 21:15'!
renderSelectionOn: html
	html render: self selectedComponent! !

!WASimpleNavigation methodsFor: 'accessing' stamp: 'lr 6/6/2007 17:53'!
selectedComponent
	^ (components detect: [ :each | each key = self selection ] ifNone: [ ^ nil ]) value! !

WAComponent subclass: #WANavigationBar
	instanceVariableNames: 'actionsSelector owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Widgets'!

!WANavigationBar commentStamp: 'rew 2/14/2008 10:17' prior: 0!
WANavigationBar provides navigation links for a component, the WANavigationBar's owner. WANavigationBar is vertical in that all items in the bar are rendered in a column. WANavigationBar's owner typically is a top level component that renders a number of children components, including the WANavigationBar. When a user selects an item in the WANavigationBar a message is sent to the owner, so it can change.

The owner component needs to implement the method indicated by the instance variable "actionsSelector", the default value is "actions". This method returns a collections of symbols. The symbols become the list of items in the navigation bar. The first letter of the symbol is capitalized when displayed. If the symbol represents a 0-argument method it is rendered as a link. When the user clicks on the link the original symbol is send as a message to the owner component. If the symbol represents a 1-argument method it is rendered as a label followed by a text input box. The user has to know that they hit enter after filling the text box.

Instance Variables:
	actionsSelector	<ByteSymbol>	Symbol sent to owner to get a list of items to be listed in the navigation bar. Default value is "actions".
	owner	<WAComponent>	This is the navigation bar for the component "owner".!

!WANavigationBar methodsFor: 'accessing' stamp: 'ab 5/30/2003 00:15'!
actions
	^ self target perform: actionsSelector! !

!WANavigationBar methodsFor: 'accessing' stamp: 'ab 5/30/2003 00:15'!
actionsSelector: aSymbol
	actionsSelector := aSymbol! !

!WANavigationBar methodsFor: 'initialize-release' stamp: 'mb 4/23/2006 15:27'!
initialize
	super initialize.
	actionsSelector := #actions! !

!WANavigationBar methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
owner: anObject
	owner := anObject! !

!WANavigationBar methodsFor: 'rendering' stamp: 'pmm 10/11/2006 18:32'!
renderContentOn: html
	self actions do: [ :symbol |
		symbol numArgs = 0
			ifTrue: [ self renderLink: symbol on: html ]
			ifFalse: [ self renderInput: symbol on: html ] ]! !

!WANavigationBar methodsFor: 'rendering' stamp: 'pmm 10/11/2006 18:34'!
renderInput: aSymbol on: html
	html form: [
		html strong: aSymbol capitalized.
		html space.
		html textInput
			callback: [ :value |
				self target perform: aSymbol with: value ] ]! !

!WANavigationBar methodsFor: 'rendering' stamp: 'pmm 10/11/2006 18:34'!
renderLink: aSymbol on: html
	html anchor
		on: aSymbol of: self target.
	html break! !

!WANavigationBar methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:31'!
target
	^ owner activeComponent! !

WAComponent subclass: #WAPath
	instanceVariableNames: 'stack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Widgets'!

!WAPath commentStamp: 'rew 1/23/2008 21:12' prior: 0!
WAPath represents a path navigation (breadcrumbs) for a web page and displays standard breadcrumbs(xxx >> yyy >> zzz). WAPath maintains a stack of associations, one for each "location" or "page" in the path. The association key is the text that is displayed in the breadcrimb. The association value is an object of your choosing, which your code uses to restore that "page". 

To add to the path use the method WAPath>>pushSegment: anObject name: 'lulu'. The name: arguement is the association key, the segment: argument is the association value.

The method WAPath>>currentSegment returns object associated with the current "page". Your code is not notified when the user clicks on a link in the WAPath object. So when you render a page call WAPath>>currentSegment to get the current object, and generate the page accordingly.

See WAInspector for example use.

Use WATrail to handle breadcrumbs for sequences of call: and answers:.

Instance Variables:
	stack	<Array of associations(String->Object) > History of the page. Keys -> display string, values -> object used in helping generating page.

!

!WAPath class methodsFor: 'example' stamp: 'lr 10/28/2007 14:42'!
example
	^self new
		pushSegment: 123 name: 'xxx';
		pushSegment: 456 name: 'yyy';
		pushSegment: 789 name: 'zzz';
		yourself! !

!WAPath methodsFor: 'behavior' stamp: 'lr 10/28/2007 14:42'!
choose: anAssociation
	"Install a new stack of navigation from the old one and the specified association."

	| newStack |
	newStack := Array new writeStream.
	stack do:
		[:ea |
		newStack nextPut: ea.
		ea == anAssociation
			ifTrue: [stack := newStack contents. ^ self]]! !

!WAPath methodsFor: 'accessing' stamp: 'ab 5/31/2003 15:06'!
currentSegment
	^ stack isEmpty
		ifTrue: [nil]
		ifFalse: [stack last value]! !

!WAPath methodsFor: 'initialize' stamp: 'lr 4/15/2007 19:55'!
initialize
	super initialize.
	stack := #()! !

!WAPath methodsFor: 'behavior' stamp: 'ab 5/31/2003 15:06'!
pushSegment: anObject name: aString
	stack := stack, (Array with: aString -> anObject)! !

!WAPath methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderContentOn: html

	stack isEmpty ifTrue: [^ self].

	html div
		id: 'path';
		with: [
		stack allButLast do:
			[:assoc |
			html anchor callback: [self choose: assoc]; with: assoc key.
			html text: ' >> '].

		html strong: stack last key]! !

!WAPath methodsFor: 'accessing' stamp: 'lr 4/15/2007 19:56'!
states
	^ Array with: self! !

WAComponent subclass: #WASelection
	instanceVariableNames: 'items labelBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Dialogs'!

!WASelection commentStamp: 'rew 9/24/2007 20:25' prior: 0!
WASelection creates a selectable list. Items can be any object. If optional labelBlock is not given the string versions of the items are displayed to user, otherwise labelBlock is used to generate the text to display for each item. Returns the item selected by user, (not the index nor the text shown the user). 

	| selection |
	selection := WASelection new.
	selection items: #(1 'cat' 'rat').
	selection 
		labelBlock: [:item | item = 1 ifTrue: ['First'] ifFalse: [item asUppercase]].
	result := self call: selection.
	self inform: result printString

Instance Variables:
	items	<Array of Objects> 	
	labelBlock	<One arg Block>	

!

!WASelection methodsFor: 'initialization' stamp: 'lr 8/30/2008 16:22'!
initialize
	super initialize.
	items := #().
	labelBlock := [ :each | each seasideString ]! !

!WASelection methodsFor: 'accessing' stamp: 'lr 1/7/2007 18:04'!
items
	^ items! !

!WASelection methodsFor: 'accessing' stamp: 'avi 7/5/2004 20:24'!
items: aCollection
	items := aCollection! !

!WASelection methodsFor: 'accessing' stamp: 'lr 1/7/2007 18:06'!
labelBlock
	^ labelBlock! !

!WASelection methodsFor: 'accessing' stamp: 'avi 7/5/2004 20:24'!
labelBlock: aBlock
	labelBlock := aBlock! !

!WASelection methodsFor: 'rendering' stamp: 'lr 1/7/2007 18:05'!
renderContentOn: html
	html unorderedList
		list: self items;
		labels: self labelBlock;
		callback: [ :value | self answer: value ]! !

WAComponent subclass: #WATableReport
	instanceVariableNames: 'sortColumn isReversed columns rowPeriod rowColors rows'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Widgets'!

!WATableReport commentStamp: 'rew 2/14/2008 10:16' prior: 0!
WATableReport presents tabular data. A WATableReport contains a collections of objects, one per row, and a collection of WAReportColumns. The WAReportColumn objects are configured to produce the text for the table cell based on the each row object. Each column has a header and an optional column sum. The table can be sorted on a column by clicking its header, unless the column handles rendering on the canvas itself. A table can be given a set of html colors (rowColors), used to colors the rows to aid in viewing. 

For more information see:
	Example - WATableReportTestm (initialization code below)
	WATableReport Tutorial - http://www.cdshaffer.com/david/Seaside/WATableReport/index.html

Instance Variables:
	columns	<Collection of WAReportColumn>	Each WAReportColumn produces the text for each table cell in a column  
	isReversed	<Boolean>	true if the current sort column is to be sorted in reverse order
	rowColors	<Collection of String/Symbol>	Each element is a string for an html color, which is used as a background color for table rows
	rowPeriod	<Integer>	Each color in rowColors is used for rowPeriod consectutive rows before using the next row color.
	rows	<Collection of Object>	Each element of the collection provides the data for a row in the table.
	sortColumn	<WAValueHolder on WAReportColumn>	Column used to sort the the table rows

Example:
	WATableReport new
		rows: WAComponent allSubclasses asArray;
		columns: (OrderedCollection new
			add: (WAReportColumn
				selector: #fullName title: 'Name'
				onClick: [ :each | self inform: each description ]);
			add: ((WAReportColumn
				selector: #canBeRoot title: 'Can Be Root')
				sortBlock: [ :a :b | a ]);
			add: (WAReportColumn
				renderBlock: [ :each :html | html emphasis: each description ]
				title: 'Description');
			yourself);
		rowColors: #(lightblue lightyellow);
		rowPeriod: 1;
		yourself!

!WATableReport methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
chooseRow: aRow column: aColumn
	aColumn chooseRow: aRow! !

!WATableReport methodsFor: 'private' stamp: 'lr 7/12/2007 20:28'!
colorForRowNumber: aNumber
	^ rowColors at: ((aNumber - 1 // rowPeriod) \\ rowColors size) + 1 ifAbsent: ['white']! !

!WATableReport methodsFor: 'accessing' stamp: 'ab 10/26/2002 22:29'!
columns: anArray
	columns := anArray! !

!WATableReport methodsFor: 'initialize' stamp: 'rew 1/25/2008 20:38'!
initialize
	super initialize.
	isReversed := false.
	rows := #().
	columns := #().
	sortColumn := WAValueHolder new.
	rowColors := #('white' 'lightyellow').
	rowPeriod := 3! !

!WATableReport methodsFor: 'testing' stamp: 'AC 1/31/2003 11:24'!
isReversed
	^ isReversed! !

!WATableReport methodsFor: 'rendering' stamp: 'pmm 3/24/2008 16:39'!
renderColumn: aColumn row: aRow on: html
	| text |
	aColumn canRender ifTrue: [
		^html tableData
			class: aColumn cssClass;
			with: [
				aColumn renderValue: aRow on: html ] ].
	text := aColumn textForRow: aRow.
	text isEmpty ifTrue: [ text := ' ' ].
	html tableData
		class: aColumn cssClass;
		with: [
			aColumn canChoose
				ifFalse: [ html text: text ]
				ifTrue: [
					html anchor
						callback: [ self chooseRow: aRow column: aColumn ];
						with: text ] ]! !

!WATableReport methodsFor: 'rendering' stamp: 'lr 11/16/2006 18:17'!
renderContentOn: html
	html table: [
		self renderTableHeaderOn: html.
		self renderRowsOn: html.
		self renderTableFooterOn: html ]! !

!WATableReport methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderFooterForColumn: aColumn on: html
	html tableHeading: (aColumn totalForRows: rows)! !

!WATableReport methodsFor: 'rendering' stamp: 'lr 11/16/2006 16:46'!
renderHeaderForColumn: aColumn on: html
	html tableHeading:  [
		aColumn canSort
			ifTrue: [
				html anchor
					callback: [self sortColumn: aColumn];
					with: aColumn title]
			ifFalse: [ html text: aColumn title ] ]! !

!WATableReport methodsFor: 'rendering' stamp: 'pmm 9/30/2006 20:48'!
renderRowNumber: index item: row on: html
	html tableRow
		style: 'background-color: ' , (self colorForRowNumber: index);
		with: [
			columns do: [ :each |
				self renderColumn: each row: row on: html ] ]! !

!WATableReport methodsFor: 'rendering' stamp: 'pmm 2/23/2008 18:29'!
renderRowsOn: html 
	self rows keysAndValuesDo: [ :index :row | 
		self 
			renderRowNumber: index
			item: row
			on: html ]! !

!WATableReport methodsFor: 'rendering' stamp: 'pmm 9/30/2006 20:38'!
renderTableFooterOn: html
	html tableRow: [
		columns do: [ :each |
			self renderFooterForColumn: each on: html] ]! !

!WATableReport methodsFor: 'rendering' stamp: 'pmm 9/30/2006 20:39'!
renderTableHeaderOn: html
	html tableRow: [
			columns do: [ :each |
				self renderHeaderForColumn: each on: html] ]! !

!WATableReport methodsFor: 'state variables' stamp: 'DataCurator 04/24/2007 14:10'!
reverse

	isReversed := isReversed not! !

!WATableReport methodsFor: 'accessing' stamp: 'ab 10/26/2002 22:04'!
rowColors: colorArray
	rowColors := colorArray! !

!WATableReport methodsFor: 'accessing' stamp: 'ab 10/26/2002 22:04'!
rowPeriod: aNumber
	rowPeriod := aNumber! !

!WATableReport methodsFor: 'accessing' stamp: 'AC 1/31/2003 11:46'!
rows
	| r |
	self sortColumn ifNil: [^ rows].
	r := self sortColumn sortRows: rows.
	^ self isReversed ifTrue: [r reversed] ifFalse: [r]! !

!WATableReport methodsFor: 'accessing' stamp: 'rew 1/25/2008 20:34'!
rows: anArray
	rows := anArray! !

!WATableReport methodsFor: 'state variables' stamp: 'ab 1/16/2003 17:47'!
sortColumn
	^ sortColumn contents! !

!WATableReport methodsFor: 'state variables' stamp: 'lr 10/28/2007 14:42'!
sortColumn: anObject
	isReversed := anObject = self sortColumn and: [isReversed not ].
	sortColumn contents: anObject! !

!WATableReport methodsFor: 'accessing' stamp: 'lr 4/15/2007 18:51'!
states
	^ Array with: sortColumn! !

WAComponent subclass: #WATask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Component'!

!WATask commentStamp: 'pmm 6/30/2007 19:02' prior: 0!
I am a subclass of WAComponent, specialized for defining workflow.  The difference between a task and a component is the following:

Both of them are reusable, embeddable, callable pieces of user interface. A component has state (instance variables), behavior (it may change its state, and it may also choose to display other components with #call:), and appearance (it renders HTML). A Task has only the first two - it doesn't render any HTML directly, but only through the components it calls. This is useful when what you want to encapsulate/embed/call is purely a process (show this component, then this one, then this one).

The key method for WATask is #go - as soon as a task is displayed, this method will get invoked, and will presumably #call: other components.

In terms of implementation, you can think of a WATask in the following way: it is a component which renders two things:
- a link whose callback invokes the #go method
- a header that immediately redirects to the URL of that link

Subclasses must not implement #renderContentOn:

An example can be found in WAConvenienceTest.
!

!WATask methodsFor: 'decorations' stamp: 'avi 3/28/2004 20:50'!
decoration: oldDecoration shouldWrap: newDecoration
	^ (oldDecoration isGlobal and: [newDecoration isGlobal not])
		or: [oldDecoration isLocal and: [newDecoration isDelegation]]! !

!WATask methodsFor: 'processing' stamp: 'jf 11/10/2003 16:13'!
go
	self subclassResponsibility! !

!WATask methodsFor: 'processing' stamp: 'lr 8/29/2008 18:46'!
nextPresentersDo: aBlock
	self activeComponent == self ifTrue: [
		[ self answer: self go ]
			on: WARenderNotification
			do: [ :err | ] ].
	super nextPresentersDo: aBlock! !

WAComponent subclass: #WATimeSelector
	instanceVariableNames: 'second hour minute startHour endHour'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Widgets'!

!WATimeSelector commentStamp: 'rew 1/23/2008 21:14' prior: 0!
WATimeSelector displays dropdown menus (html select) allowing a user to delect a time within a range. "startHour" and "endHour" define the range of selectable times. Time is displayed in 24 hour format. WATimeSelector>>time returns time user selected as a Time object.

See WADateSelectorTest for sample of usage.
Select "Date Selector" tab of the Functional Seaside Test Suite to run an example  (http://127.0.0.1:xxxx/seaside/tests/alltests)

Instance Variables:
	endHour	<Integer 0-23>	end of time interval for selectable times
	hour	<Integer 0-23>	selected hour
	minute	<Integer 0-59>	selected minute
	second	<Integer 0-59>	selected second
	startHour	<Integer 0-23>	start of time interval for selectable times
!

!WATimeSelector methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
date: aDate
	second := aDate dayOfMonth.
	hour := aDate monthIndex.
	minute := aDate year! !

!WATimeSelector methodsFor: 'accessing' stamp: 'jlr 4/4/2006 23:37'!
days
	^ 1 to: 31! !

!WATimeSelector methodsFor: 'accessing' stamp: 'jlr 4/4/2006 23:48'!
endHour
	^endHour! !

!WATimeSelector methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
endHour: anInteger
	endHour := anInteger! !

!WATimeSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:10'!
hour
	^hour! !

!WATimeSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:10'!
hour: anObject
	^hour := anObject! !

!WATimeSelector methodsFor: 'initialize-release' stamp: 'mb 5/6/2006 16:10'!
initialize
	super initialize.
	startHour := 0.
	endHour := 23.
	self time: Time midnight! !

!WATimeSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:10'!
minute
	^minute! !

!WATimeSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:10'!
minute: anObject
	^minute := anObject! !

!WATimeSelector methodsFor: 'private' stamp: 'lr 2/12/2008 08:10'!
privateIsValidSecond: theSecond hourNumber: theHour minuteNumber: theMinute

	^ (theHour between: 0 and: 23)
		and: [ (theMinute between: 0 and: 59)
		and: [ theSecond between: 0 and: 59 ] ]! !

!WATimeSelector methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderContentOn: html
	html select
		list: (0 to: 23);
		on: #hour of: self.
	html  select
		list: (0 to: 59);
		on: #minute of: self.
	html  select
		list: (0 to: 59);
		on: #second of: self.

	self timeIsValid ifFalse: [self renderValidationErrorOn: html]! !

!WATimeSelector methodsFor: 'rendering' stamp: 'pmm 10/11/2006 18:23'!
renderValidationErrorOn: html
	html span
		class: 'error';
		with: 'invalid time'! !

!WATimeSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:10'!
second
	^second! !

!WATimeSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:10'!
second: anObject
	^second := anObject! !

!WATimeSelector methodsFor: 'accessing' stamp: 'jlr 4/4/2006 23:48'!
startHour
	^startHour! !

!WATimeSelector methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
startHour: anInteger
	startHour := anInteger! !

!WATimeSelector methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
time
	(self
		privateIsValidSecond: second
		hourNumber: hour
		minuteNumber: minute) ifFalse: [self error: 'Invalid time'].
	^self timeClass
		hour: hour
		minute: minute
		second: second! !

!WATimeSelector methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
time: aTime
	second := aTime second.
	hour := aTime hour.
	minute := aTime minute! !

!WATimeSelector methodsFor: 'private' stamp: 'pmm 10/22/2006 07:22'!
timeClass
	^Time! !

!WATimeSelector methodsFor: 'testing' stamp: 'jlr 4/4/2006 23:46'!
timeIsValid
	[self time] on: Error do: [:e | ^ false].
	^ true! !

WAComponent subclass: #WATrail
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Widgets'!

!WATrail commentStamp: 'rew 1/25/2008 20:49' prior: 0!
WATrail implements breadcrumbs for pages generated using a sequence of WAComponent>>call: methods. Each component in the call sequence that is to appear in the breadcrumb must implement the method "trailName", which returns the text displayed in the breadcrumb. 

Instantiate (WATrail on: rootComponent) an WATrail object on the first component (root) of the breadcrumb. When the root component, or subsequent component, transfers control via "self call:" the WATrail object is automatically updated and will display the correct call sequence in the breadcrumb. When a user clicks on a link in the breadcrumb the call sequence is automatically updated.

The breadcrumb is placed in a div with class "trail" and each crumb is separated with the character '>', which is inside a span of class "separator" to aid in using CSS to format the breadcrumbs.

Instance Variables:
	root	<WAComponent>	first component in the breadcrumb and in the call sequence.

!

!WATrail class methodsFor: 'instance creation' stamp: 'ab 8/26/2003 15:27'!
on: anObject
	^ self new root: anObject! !

!WATrail methodsFor: 'rendering' stamp: 'rew 1/25/2008 20:51'!
renderContentOn: html
	| last selected |
	last := nil.
	html div
		class: 'trail';
		with: [
			root visiblePresentersDo: [ :each |
				(each isDecoration and: [each isDelegation]) ifTrue: [
					(each component respondsTo: #trailName) ifTrue: [
						last := each.
						html anchor
							callback: [ each remove ];
							with: each component trailName.
					
						html span
							class: 'separator';
							with: self separator. ] ] ] .
			selected := last ifNil: [ root ] ifNotNil: [ last delegate ].
			(selected respondsTo: #trailName) ifTrue: [
				html text: selected trailName ]]! !

!WATrail methodsFor: 'accessing' stamp: 'ab 8/26/2003 15:27'!
root: anObject
	root := anObject! !

!WATrail methodsFor: 'accessing' stamp: 'rew 1/25/2008 20:50'!
separator
	
	^' > '! !

WAComponent subclass: #WATree
	instanceVariableNames: 'root selected expanded childrenBlock labelBlock canSelectBlock selectBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Widgets'!

!WATree commentStamp: 'rew 1/23/2008 21:14' prior: 0!
WATree implements a tree menu, which supports nesting, collapsing and expanding. Prefixes items with "+/-" to indicate items that can be expanded/collapsed.

See class methods for simple example.


Instance Variables:
	canSelectBlock	<BlockClosure [:nodeInTree | ]>	returns true if user can select the argument of the block, if true node is an anchor
	childrenBlock	<BlockClosure [:nodeInTree | ]>	returns children (or subnodes) of the given node in the tree, sent to all nodes
	expanded	<IdentitySet>	Collection of all nodes that are currently expanded
	labelBlock	<[:nodeInTree | ]> returns text to display for given node
	root	<Object>	root or top level node in tree, childrenBlock is used to determine roots subnodes
	selectBlock	<BlockClosure [:selectedNode | ]>	called when an node is selected, put a callback to your code here
	selected	<Object>	currently selected node


!

!WATree class methodsFor: 'examples' stamp: 'lr 8/30/2008 16:22'!
exampleObjectExplorer
	^ self new
		root: 'dispatcher' -> WADispatcher default;
		labelBlock: [ :assoc | assoc key seasideString , ': ' , assoc value printString ];
		childrenBlock: [ :assoc | assoc value inspectorFields ];
		yourself! !

!WATree class methodsFor: 'instance-creation' stamp: 'lr 3/27/2006 11:08'!
root: anObject
	^ self new
		root: anObject;
		yourself! !

!WATree class methodsFor: 'instance-creation' stamp: 'lr 3/27/2006 11:09'!
root: anObject path: anArray
	^ (self root: anObject)
		expandAll: anArray;
		selected: anArray last;
		yourself! !

!WATree methodsFor: 'testing' stamp: 'lr 10/28/2007 14:42'!
canSelect: aNode
	^self selectBlock notNil
		and: [ self canSelectBlock isNil
			or: [ self canSelectBlock value: aNode ] ]! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 12:11'!
canSelectBlock
	^canSelectBlock! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 3/7/2005 17:40'!
canSelectBlock: aBlock
	canSelectBlock := aBlock! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 11:19'!
childrenBlock
	^childrenBlock! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 11:20'!
childrenBlock: aBlock
	childrenBlock := aBlock! !

!WATree methodsFor: 'accessing-nodes' stamp: 'lr 3/27/2006 09:12'!
childrenOf: aNode
	| children |
	children := self childrenBlock value: aNode.
	^ children ifNil: [ Array new ]! !

!WATree methodsFor: 'actions' stamp: 'lr 10/28/2007 14:42'!
collapse: aNode
	expanded remove: aNode! !

!WATree methodsFor: 'actions' stamp: 'lr 10/28/2007 14:42'!
expand: aNode
	expanded add: aNode! !

!WATree methodsFor: 'actions' stamp: 'lr 10/28/2007 14:42'!
expandAll: aCollection
	expanded addAll: aCollection! !

!WATree methodsFor: 'testing' stamp: 'lr 10/28/2007 14:42'!
hasChildren: aNode
	^(self childrenOf: aNode)
		isEmpty not! !

!WATree methodsFor: 'initialization' stamp: 'lr 8/30/2008 16:22'!
initialize
	super initialize.
	expanded := IdentitySet new.
	self selectBlock: [ :node | self answer: node ].
	self childrenBlock: [ :node | Array new ].
	self labelBlock: [ :node | node seasideString ]! !

!WATree methodsFor: 'testing' stamp: 'lr 10/28/2007 14:42'!
isExpanded: aNode
	^expanded includes: aNode! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 11:19'!
labelBlock
	^labelBlock! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 11:20'!
labelBlock: aBlock
	labelBlock := aBlock! !

!WATree methodsFor: 'accessing-nodes' stamp: 'lr 10/28/2007 14:42'!
labelOf: aNode
	^self labelBlock value: aNode! !

!WATree methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderContentOn: html
	self renderTreeOn: html! !

!WATree methodsFor: 'rendering-nodes' stamp: 'pmm 9/22/2006 23:27'!
renderNode: aNode on: html
	html listItem: [
		self renderNodeButton: aNode on: html.
		self renderNodeLabel: aNode on: html.
		self renderNodeChildren: aNode on: html ]! !

!WATree methodsFor: 'rendering-nodes' stamp: 'lr 10/28/2007 14:42'!
renderNodeButton: aNode on: html
	| isExpanded |
	html span
		class: 'button';
		with: [
			(self hasChildren: aNode) ifTrue: [
				isExpanded := self isExpanded: aNode.
				self
					renderNodeButtonLink: aNode
					action: (MessageSend
						receiver: self
						selector: (isExpanded
							ifTrue: [ #collapse: ]
							ifFalse: [ #expand: ])
						argument: aNode)
					text: (isExpanded
						ifTrue: [ '-' ]
						ifFalse: [ '+' ])
					on: html ] ]! !

!WATree methodsFor: 'rendering-nodes' stamp: 'pmm 9/22/2006 23:24'!
renderNodeButtonLink: aNode action: aBlock text: anObject on: html
	html anchor callback: aBlock; with: anObject! !

!WATree methodsFor: 'rendering-nodes' stamp: 'lr 10/28/2007 14:42'!
renderNodeChildren: aNode on: html
	| children |
	children := self childrenOf: aNode.
	children isEmpty ifFalse: [
		(self isExpanded: aNode) ifTrue: [
			html unorderedList: [
				children do: [ :each |
					self renderNode: each on: html ] ] ] ]! !

!WATree methodsFor: 'rendering-nodes' stamp: 'lr 10/28/2007 14:42'!
renderNodeLabel: aNode on: html
	| label |
	html span
		class: 'label';
		class: (self selected == aNode
			ifTrue: [ 'active' ]
			ifFalse: [ 'inactive' ]);
		with: [
			label := self labelOf: aNode.
			(self canSelect: aNode)
				ifFalse: [ html render: label ]
				ifTrue: [
					self
						renderNodeLabelLink: aNode
						action: (MessageSend
							receiver: self
							selector: #select:
							argument: aNode)
						text: label on: html ] ]! !

!WATree methodsFor: 'rendering-nodes' stamp: 'pmm 9/22/2006 23:28'!
renderNodeLabelLink: aNode action: aBlock text: anObject on: html
	html anchor callback: aBlock; with: anObject! !

!WATree methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderTreeOn: html
	html unorderedList: [ self renderNode: self root on: html ]! !

!WATree methodsFor: 'accessing' stamp: 'lr 2/19/2005 11:18'!
root
	^root! !

!WATree methodsFor: 'accessing' stamp: 'lr 2/19/2005 11:18'!
root: aNode
	root := aNode! !

!WATree methodsFor: 'actions' stamp: 'lr 3/25/2008 22:13'!
select: aNode 
	(self canSelect: aNode) ifFalse: [ ^ self ].
	self selected: aNode.
	self selectBlock isNil ifFalse: [ self selectBlock value: aNode ]! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 11:21'!
selectBlock
	^selectBlock! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 11:21'!
selectBlock: aBlock
	selectBlock := aBlock! !

!WATree methodsFor: 'accessing' stamp: 'lr 2/19/2005 11:19'!
selected
	^selected! !

!WATree methodsFor: 'accessing' stamp: 'lr 2/19/2005 11:19'!
selected: aNode
	selected := aNode! !

!WATree methodsFor: 'accessing' stamp: 'lr 4/15/2007 19:56'!
states
	^ Array with: expanded! !

WAPresenter subclass: #WADecoration
	instanceVariableNames: 'next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Component'!

!WADecoration commentStamp: '<historical>' prior: 0!
I am an abstract decoration around instances of WAComponent. I can be added to aComponent by calling #addDecoration: and I change the basic behaviour or look of a component. There are several methods that can be overriden to archive this:

- #renderContentOn: to emit xhtml around the decorated component. Call #renderOwnerOn: to let the owner emit its output.

- #processChildCallbacks: to intercept the callback processing of the owner.

- #handleAnswer: to intercept the answer processing.!

WADecoration subclass: #WAAnswerHandler
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Component'!

!WAAnswerHandler methodsFor: 'accessing' stamp: 'avi 6/2/2004 21:59'!
block: aBlock
	block := aBlock! !

!WAAnswerHandler methodsFor: 'processing' stamp: 'jf 7/22/2008 13:19'!
handleAnswer: anObject continueWith: aBlock
	block valueWithPossibleArgument: anObject! !

WADecoration subclass: #WABasicAuthentication
	instanceVariableNames: 'authenticator realm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Decorations'!

!WABasicAuthentication commentStamp: 'rew 9/24/2007 20:28' prior: 0!
WABasicAuthentication password protects its component using the standard Http basic authentication, which passes usernames & passwords in clear text. You must set the authenticator, which validates usernames and passwords.

Seaside has a number of ways to authenticate a user: WAComponent>>registerAsAuthenticatedApplication:, WAAuthMain, WAAuthConfiguration. One can also use a task or a session to authenticate. These methods can be used to authenicate a session or application rather than a single component.

Instance Variables:
	authenticator	<Authenticator>	Any object that implements the method verifyPassword:forUser:
	realm	<String>	An http realm is a string used to identify a set of pages that are convered by the same login

!

!WABasicAuthentication methodsFor: 'accessing' stamp: 'avi 2/2/2004 13:03'!
authenticator: anAuthenticator
	authenticator := anAuthenticator! !

!WABasicAuthentication methodsFor: 'testing' stamp: 'avi 3/28/2004 20:51'!
isGlobal
	^ true! !

!WABasicAuthentication methodsFor: 'processing' stamp: 'lr 4/9/2008 10:45'!
processChildCallbacks: aStream
	(self verifyRequest: self requestContext request)
		ifTrue: [ super processChildCallbacks: aStream ]
		ifFalse: [ self respondWithChallenge ]! !

!WABasicAuthentication methodsFor: 'accessing' stamp: 'jf 8/5/2008 09:28'!
realm
	^ realm ifNil: [self session application baseUrl pathString]! !

!WABasicAuthentication methodsFor: 'accessing' stamp: 'avi 2/5/2004 13:52'!
realm: aString
	realm := aString! !

!WABasicAuthentication methodsFor: 'processing' stamp: 'pmm 7/14/2008 20:27'!
respondWithChallenge
	self requestContext returnResponse: (WAResponse basicAuthWithRealm: self realm)! !

!WABasicAuthentication methodsFor: 'processing' stamp: 'lr 4/9/2008 10:44'!
updateRoot: aStream
	(self verifyRequest: self requestContext request)
		ifTrue: [ super updateRoot: aStream ]
		ifFalse: [ self respondWithChallenge ]! !

!WABasicAuthentication methodsFor: 'processing' stamp: 'lr 8/20/2007 23:41'!
verifyRequest: aRequest
	^ authenticator verifyPassword: aRequest password forUser: aRequest user! !

!WADecoration methodsFor: 'convenience' stamp: 'lr 10/28/2007 14:42'!
asComponent
	^ self component! !

!WADecoration methodsFor: 'rendering' stamp: 'jf 8/29/2008 21:48'!
canHaveHalo
	^ false! !

!WADecoration methodsFor: 'accessing' stamp: 'avi 3/27/2004 22:13'!
component
	^ self owner isDecoration
		ifTrue: [self owner component]
		ifFalse: [self owner]! !

!WADecoration methodsFor: 'call/answer' stamp: 'avi 6/22/2004 11:02'!
handleAnswer: anObject
	(self owner handleAnswer: anObject) ifFalse:
		[self handleAnswer: anObject continueWith: [^ false]].
	^ true! !

!WADecoration methodsFor: 'processing' stamp: 'avi 6/22/2004 11:03'!
handleAnswer: anObject continueWith: aBlock
	aBlock value! !

!WADecoration methodsFor: 'initialization' stamp: 'lr 9/5/2007 11:21'!
initialize
	super initialize.
	next := WAValueHolder new! !

!WADecoration methodsFor: 'testing' stamp: 'avi 3/27/2004 19:55'!
isDecoration
	^ true! !

!WADecoration methodsFor: 'testing' stamp: 'avi 3/27/2004 22:23'!
isDelegation
	^ false! !

!WADecoration methodsFor: 'testing' stamp: 'avi 3/28/2004 20:48'!
isGlobal
	^ false! !

!WADecoration methodsFor: 'testing' stamp: 'avi 3/28/2004 20:49'!
isLocal
	^ (self isGlobal or: [self isDelegation]) not! !

!WADecoration methodsFor: 'iterating' stamp: 'avi 6/8/2004 12:43'!
nextPresentersDo: aBlock
	aBlock value: self owner! !

!WADecoration methodsFor: 'accessing' stamp: 'lr 4/15/2007 18:49'!
owner
	^ next contents! !

!WADecoration methodsFor: 'accessing' stamp: 'lr 4/15/2007 18:49'!
owner: aPresenter
	next contents: aPresenter! !

!WADecoration methodsFor: 'actions' stamp: 'avi 3/29/2004 16:10'!
remove
	self component removeDecoration: self! !

!WADecoration methodsFor: 'rendering' stamp: 'lr 2/12/2008 08:10'!
renderOwnerOn: html
	self owner isNil
		ifFalse: [ self owner renderWithContext: html context ]! !

!WADecoration methodsFor: 'updating' stamp: 'lr 4/20/2007 20:18'!
updateStates: aSnapshot
	super updateStates: aSnapshot.
	aSnapshot register: next! !

WADecoration subclass: #WADelayedAnswerDecoration
	instanceVariableNames: 'delay'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Widgets'!

!WADelayedAnswerDecoration commentStamp: 'rew 1/23/2008 21:11' prior: 0!
WADelayedAnswerDecoration adds a delay in displaying a component. 

See WADelayTest for sample usage.
Select 'Delay" tab of the Functional Seaside Test Suite to run an example  (http://127.0.0.1:xxxx/seaside/tests/alltests)

Instance Variables:
	delay	<Integer>	delay length in seconds 

!

!WADelayedAnswerDecoration methodsFor: 'accessing' stamp: 'lr 5/23/2007 19:58'!
delay
	^ delay ifNil: [ 1 ]! !

!WADelayedAnswerDecoration methodsFor: 'accessing' stamp: 'avi 3/27/2005 20:34'!
delay: aNumber
	delay := aNumber! !

!WADelayedAnswerDecoration methodsFor: 'path' stamp: 'lr 8/30/2008 16:22'!
updateRoot: aRoot 
	| callbacks url |
	super updateRoot: aRoot.
	callbacks := WACallbackRegistry 
		context: aRoot context
		owner: self.
	url := aRoot context actionUrl withParameter: (callbacks registerActionCallback: [ self component answer ]).
	aRoot meta 
		redirectAfter: self delay
		to: url seasideString! !

WADecoration subclass: #WADelegation
	instanceVariableNames: 'delegate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Component'!

!WADelegation methodsFor: 'accessing' stamp: 'avi 3/12/2004 20:18'!
delegate
	^ delegate! !

!WADelegation methodsFor: 'accessing' stamp: 'avi 3/12/2004 20:18'!
delegate: aComponent
	delegate := aComponent! !

!WADelegation methodsFor: 'testing' stamp: 'avi 3/27/2004 22:26'!
isDelegation
	^ true! !

!WADelegation methodsFor: 'iterating' stamp: 'avi 4/22/2004 14:51'!
nextPresentersDo: aBlock
	delegate decorationChainDo: aBlock! !

WADecoration subclass: #WAFormDecoration
	instanceVariableNames: 'buttons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Decorations'!

!WAFormDecoration commentStamp: 'rew 9/13/2007 21:21' prior: 0!
A WAFormDecoration places its component inside an html form tag. The buttons inst var must be set. The component that a WAFormDecoration decorates must implement the method "defaultButton", which returns the string/symbol of the default button (one selected by default) of the form. Don't place any decorators between WAFormDecoration and its component otherwise "defaultButton" method fails. For each string/symbol in the buttons inst var the decorated component must implement a method of the same name, which is called when the button is selected.

Instance Variables
	buttons:		<Collection of strings or symbols>

buttons
	- list of strings or symbols, each string/symbol is the label (first letter capitalized) for a button and the name of the callback method on component when button is pressed, 
!

!WAFormDecoration methodsFor: 'accessing' stamp: 'avi 3/16/2004 13:36'!
buttons
	^ buttons! !

!WAFormDecoration methodsFor: 'accessing' stamp: 'avi 3/16/2004 13:34'!
buttons: selectorArray
	buttons := selectorArray! !

!WAFormDecoration methodsFor: 'actions' stamp: 'lr 12/1/2007 08:18'!
defaultAction
	self component perform: self component defaultButton! !

!WAFormDecoration methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderButtonForSelector: aSymbol on: html
	html submitButton on: aSymbol of: self component! !

!WAFormDecoration methodsFor: 'rendering' stamp: 'lr 9/25/2007 23:29'!
renderButtonsOn: html
	html div class: 'dialog-buttons'; with: [
		self buttons do: [ :each |
			html  span
				class: 'dialog-button-' , each;
				with: [ self renderButtonForSelector: each on: html ] ] ]! !

!WAFormDecoration methodsFor: 'rendering' stamp: 'al 9/7/2006 15:50'!
renderContentOn: html
	html form
		defaultAction: [ self defaultAction ];
		with: [
			self renderOwnerOn: html.
			self renderButtonsOn: html ]! !

WADecoration subclass: #WAMessageDecoration
	instanceVariableNames: 'message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Decorations'!

!WAMessageDecoration commentStamp: 'rew 9/13/2007 16:57' prior: 0!
I add a string message on top of the WAComponent I decorate. For example if change WACounter>>initialize as below the text "Counter Example" will appear on above the counter when rendered.

WACounter>>initialize
	super initialize.
	self count: 0.
	self addMessage: 'Counter Example'	"added line"

!

!WAMessageDecoration methodsFor: 'accessing' stamp: 'avi 3/12/2004 00:43'!
message: aString
	message := aString! !

!WAMessageDecoration methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderContentOn: html
	html heading level3; with: message.
	self renderOwnerOn: html! !

WADecoration subclass: #WASessionProtector
	instanceVariableNames: 'remoteAddress'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Decorations'!

!WASessionProtector commentStamp: 'pmm 7/7/2008 06:55' prior: 0!
I bind a session to an IP address.

The problem I solve is when you navigate from a Seaside "page" to a different page then this page will have enough information to hijack your old session. This can happen for example with blogs that display the referer.

I don't work for users that have the same IP. This is the case if they are NATed (universities, companies, ...), behind load balanced proxies or mobile. I can be circumvened if the application is not behind an Apache proxy.

An alternative to solve the same problem is to use a session cookie.

Usage:
In your root component class implement

initialize
	super initialize.
	self addDecoration: WASessionProtector new!

!WASessionProtector methodsFor: 'testing' stamp: 'lr 1/3/2008 13:15'!
isGlobal
	^ true! !

!WASessionProtector methodsFor: 'forwarding' stamp: 'lr 4/9/2008 10:41'!
processChildCallbacks: aStream
	(self verifyRequest: self requestContext request)
		ifTrue: [ super processChildCallbacks: aStream ]
		ifFalse: [ self respondNotVerified ]! !

!WASessionProtector methodsFor: 'accessing' stamp: 'pmm 5/11/2008 22:32'!
remoteAddressFromRequest: aRequest
	^aRequest
		headerAt: 'x-forwarded-for'
		ifAbsent: [ aRequest remoteAddress ]! !

!WASessionProtector methodsFor: 'forwarding' stamp: 'pmm 8/26/2007 14:26'!
renderContentOn: html
	self renderOwnerOn: html! !

!WASessionProtector methodsFor: 'forwarding' stamp: 'jf 8/5/2008 09:15'!
respondNotVerified
	self session redirectTo: self session application baseUrl! !

!WASessionProtector methodsFor: 'accessing' stamp: 'lr 4/9/2008 10:41'!
storedRemoteAddress
	^ remoteAddress ifNil: [ remoteAddress := self remoteAddressFromRequest: self requestContext request ]! !

!WASessionProtector methodsFor: 'forwarding' stamp: 'lr 4/9/2008 10:40'!
updateRoot: html
	super updateRoot: html.
	(self verifyRequest: self requestContext request)
		ifFalse: [ self respondNotVerified ]! !

!WASessionProtector methodsFor: 'testing' stamp: 'lr 8/31/2004 19:31'!
verifyRequest: aRequest
	^(self remoteAddressFromRequest: aRequest) = self storedRemoteAddress! !

WADecoration subclass: #WATransaction
	instanceVariableNames: 'active'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Decorations'!

!WATransaction commentStamp: 'pmm 9/25/2007 20:27' prior: 0!
WATransaction ensures that the component it decorates is not repeated once the "transaction" is completed. For example once a user has submitted an order you don't want them to use the web browser's back button to accidentally resubmit the order. WATransaction does not support rollbacks.

Normally you will not use this class directly. Instead use WAComponent>>isolate: in a task.

Instance Variables:
	active	<Boolean>	false indicates the transaction is over.
!

!WATransaction methodsFor: 'open/close' stamp: 'ab 1/15/2003 21:55'!
close
	active := false! !

!WATransaction methodsFor: 'initialization' stamp: 'mb 4/23/2006 18:36'!
initialize
	super initialize.
	active := true! !

!WATransaction methodsFor: 'testing' stamp: 'avi 3/28/2004 20:51'!
isGlobal
	^ true! !

!WATransaction methodsFor: 'forwarding' stamp: 'lr 8/17/2007 10:01'!
processChildCallbacks: aStream
	^ active
		ifTrue: [ super processChildCallbacks: aStream ]
		ifFalse: [ self session pageExpired ]! !

!WATransaction methodsFor: 'rendering' stamp: 'avi 9/8/2004 12:18'!
renderContentOn: html
	active
		ifTrue: [ self renderOwnerOn: html ]
		ifFalse: [ self session pageExpired ]! !

WADecoration subclass: #WAValidationDecoration
	instanceVariableNames: 'message validationBlock exceptionClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Decorations'!

!WAValidationDecoration commentStamp: 'rew 9/13/2007 22:16' prior: 0!
A WAValidationDecoration validates its component form data when the component returns using "answer" or "answer:". A WAValidationDecoration can be added to component via the method "validateWith:" as below.

	SampleLoginComponent>>intialize
		form := WAFormDecoration new buttons: self buttons.
		self addDecoration: form.
		self validateWith: [:answerArgOrSelf | answerArgOrSelf validate].
		self addMessage: 'Please enter the following information'.

If component returns via "answer:" the answer: argument is passed to the validate block. If the component returns using "answer" the sender of "answer" is passed to the validate block.

Instance Variables
	exceptionClass:		<Notification>
	message:		<String>
	validationBlock:		<one arg block>

exceptionClass
	- Type of notication that is raised by validation code when validation fails. Default value is WAValidationNotification

message
	- String message displayed on validation failure. Obtained from the notification

validationBlock
	- One arg block, 
!

!WAValidationDecoration methodsFor: 'accessing' stamp: 'cds 6/3/2006 22:40'!
exceptionClass
	^exceptionClass ifNil: [exceptionClass := WAValidationNotification]! !

!WAValidationDecoration methodsFor: 'accessing' stamp: 'cds 7/25/2005 10:19'!
exceptionClass: aClass
	exceptionClass := aClass! !

!WAValidationDecoration methodsFor: 'call/answer' stamp: 'pmm 11/2/2005 23:04'!
handleAnswer: anObject
	^(super handleAnswer: anObject)
		or: [(self validate: anObject) not]! !

!WAValidationDecoration methodsFor: 'request processing' stamp: 'avi 6/22/2004 11:03'!
handleAnswer: anObject continueWith: aBlock
	(self validate: anObject) ifTrue: [aBlock value]! !

!WAValidationDecoration methodsFor: 'initialization' stamp: 'lr 9/5/2007 11:21'!
initialize
	super initialize.
	message := WAValueHolder new! !

!WAValidationDecoration methodsFor: 'rendering' stamp: 'lr 2/12/2008 08:10'!
renderContentOn: html
	message contents isNil ifFalse: [
		html div
			class: 'validation-error';
			with: message contents ].
	self renderOwnerOn: html! !

!WAValidationDecoration methodsFor: 'accessing' stamp: 'lr 4/15/2007 19:58'!
states
	^ Array with: message! !

!WAValidationDecoration methodsFor: 'request processing' stamp: 'pmm 11/1/2007 21:33'!
validate: anObject
	[ validationBlock value: anObject.
	message contents: nil.
	^ true ]
		on: self exceptionClass
		do: [ :exception | message contents: exception messageText ].
	^ false! !

!WAValidationDecoration methodsFor: 'convenience' stamp: 'avi 12/10/2003 12:49'!
validateWith: aBlock
	validationBlock := aBlock! !

WADecoration subclass: #WAWindowDecoration
	instanceVariableNames: 'title cssClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Decorations'!

!WAWindowDecoration commentStamp: 'pmm 10/3/2007 21:11' prior: 0!
WAWindowDecoration adds a simple title and close button in a bordered area at the top of the page. When closed button is selected nil is "answer"ed. Useful for a quick & dirty dialog window. Used by WAPlugin and SCTestRunner.

Instance Variables:
	cssClass	<String>	String added to "window-title " to generate cssClass for the title
	title	<String>	title of page
!

!WAWindowDecoration class methodsFor: 'instance creation' stamp: 'pmm 10/3/2007 21:12'!
title: aTitle
	^self new
		title: aTitle;
		yourself! !

!WAWindowDecoration methodsFor: 'accessing' stamp: 'lr 5/28/2007 17:52'!
cssClass: aString
	cssClass := aString! !

!WAWindowDecoration methodsFor: 'testing' stamp: 'avi 3/28/2004 20:52'!
isGlobal
	^ true! !

!WAWindowDecoration methodsFor: 'rendering' stamp: 'pmm 10/3/2007 21:12'!
renderCloseButtonOn: html
	html anchor
		title: 'Close';
		callback: [ self component answer: nil ];
		with: [ html html: '&times;' ]! !

!WAWindowDecoration methodsFor: 'rendering' stamp: 'lr 5/28/2007 17:56'!
renderContentOn: html
	html div class: 'window'; with: [
		html div class: 'window-titlebar'; with: [
			html div class: 'window-title'; class: cssClass; with: title.
			html div class: 'window-close'; with: [ self renderCloseButtonOn: html ] ].
		html div class: 'window-content'; with: [ self renderOwnerOn: html ] ]! !

!WAWindowDecoration methodsFor: 'accessing' stamp: 'ab 6/15/2003 12:51'!
title: aString
	title := aString! !

!WAPresenter class methodsFor: 'instance creation' stamp: 'avi 4/13/2004 20:14'!
new
	^ self basicNew initialize! !

!WAPresenter methodsFor: 'accessing-context' stamp: 'lr 4/9/2008 10:42'!
application
	"Answer the current application."

	^ self requestContext application! !

!WAPresenter methodsFor: 'rendering' stamp: 'jf 8/29/2008 21:47'!
canHaveHalo
	^ SeasidePlatformSupport haloClass notNil! !

!WAPresenter methodsFor: 'call/answer' stamp: 'lr 10/28/2007 14:42'!
handleAnswer: anObject
	self subclassResponsibility! !

!WAPresenter methodsFor: 'request processing' stamp: 'lr 10/28/2007 14:42'!
initialRequest: aRequest
	"When a new session is started, all visible presenters (components or tasks) receive this message with the request as argument.

	A common usage for this is to initialize their state depending on the URL of the request. This is one building block for bookmarkable URL. The other is updateUrl: where you can manipulate the anchor urls generated by Seaside.

	You can not use #call: in here. Consider using a WATask instead and sending #call: in #go.

	See WABrowser for examples."! !

!WAPresenter methodsFor: 'initialization' stamp: 'ab 2/13/2003 01:10'!
initialize! !

!WAPresenter methodsFor: 'decoration' stamp: 'avi 3/27/2004 19:55'!
isDecoration
	^ false! !

!WAPresenter methodsFor: 'tree' stamp: 'lr 10/28/2007 14:42'!
nextPresentersDo: aBlock
	self subclassResponsibility! !

!WAPresenter methodsFor: 'request processing' stamp: 'lr 10/28/2007 14:42'!
processCallbackStream: aCallbackStream
	aCallbackStream processCallbacksWithOwner: self.
	self processChildCallbacks: aCallbackStream.
	aCallbackStream processCallbacksWithOwner: self! !

!WAPresenter methodsFor: 'request processing' stamp: 'avi 6/8/2004 00:54'!
processChildCallbacks: aStream
	self nextPresentersDo: [:ea | ea processCallbackStream: aStream]! !

!WAPresenter methodsFor: 'rendering' stamp: 'pmm 3/29/2008 11:56'!
renderContentOn: html
	self nextPresentersDo: [ :each |
		each renderWithContext: html context]! !

!WAPresenter methodsFor: 'rendering' stamp: 'jf 8/29/2008 21:48'!
renderWithContext: aRenderingContext
	| html callbacks |
	callbacks := aRenderingContext callbacksFor: self.
	html := self rendererClass context: aRenderingContext callbacks: callbacks.
	(aRenderingContext isDebugMode and: [ self canHaveHalo ])
		ifTrue: [ (SeasidePlatformSupport haloClass for: self) renderContentOn: html ]
		ifFalse: [ self renderContentOn: html ].
	html flush! !

!WAPresenter methodsFor: 'rendering' stamp: 'pmm 4/7/2007 01:16'!
rendererClass
	"Override this method if you want a custom renderer."
	^ WARenderCanvas! !

!WAPresenter methodsFor: 'accessing-context' stamp: 'lr 4/9/2008 10:53'!
requestContext
	"Answer the current request context."

	^ WACurrentRequestContext value! !

!WAPresenter methodsFor: 'rendering' stamp: 'pmm 4/7/2007 17:16'!
script
	"The same as #style except that it is for JavaScript. This is rarely used, consider using WAFileLibrary or exernal files instead."
	^ nil! !

!WAPresenter methodsFor: 'accessing-context' stamp: 'lr 4/9/2008 10:41'!
session
	"Answer the current session."

	^ self requestContext session! !

!WAPresenter methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
states
	"Answer a collection of states that should be backtracked."

	^ #()! !

!WAPresenter methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
style
	"Returns a CSS stylesheet associated with this component. This stylesheet will be added to <head> section of the html document so it will be global and not scoped.

	This is done for all visible components (see class comment of WAComponent for what visible means).

	Nice for demos but consider using WAFileLibrary or exernal files instead."

	^ nil! !

!WAPresenter methodsFor: 'updating' stamp: 'lr 2/12/2008 08:12'!
updateRoot: anHtmlRoot
	"This method allows you customize the <head> section of an HTML document. The API is very similar to the 'Canvas API' for rendering in the <body> section (where you 'draw' in #renderContentOn:).

	anHtmlRoot is an instance of WAHtmlRoot

	Whenever you override this method don't forget to send super"

	self script isNil ifFalse: [ anHtmlRoot addScript: self script ].
	self style isNil ifFalse: [ anHtmlRoot addStyle: self style ]! !

!WAPresenter methodsFor: 'updating' stamp: 'lr 10/28/2007 14:42'!
updateStates: aSnapshot
	"This method allows to register objects for backtracking. Don't forget to send super in all cases."

	self states do: [ :each | aSnapshot register: each ]! !

!WAPresenter methodsFor: 'updating' stamp: 'lr 10/28/2007 14:42'!
updateUrl: aUrl! !

!WAPresenter methodsFor: 'tree' stamp: 'avi 3/27/2004 20:59'!
withNextPresentersDo: aBlock
	aBlock value: self.
	self nextPresentersDo: [:ea | ea withNextPresentersDo: aBlock]! !

Object subclass: #WAProcessMonitor
	instanceVariableNames: 'mutex process semaphore value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Utilities'!

!WAProcessMonitor commentStamp: 'rew 10/19/2007 10:49' prior: 0!
WAProcessMonitor executes a block in a new process. Ensures that only one such block is executed at a time. See method critical:ifError:

Instance Variables:
	mutex	<Semaphore>	Used to sure that only one block is executed at a time
	process	<Process>	New process used to execute block
	semaphore	<Semaphore>	Used to signal when process is done

!

!WAProcessMonitor class methodsFor: 'instance creation' stamp: 'pmm 4/18/2006 20:17'!
new
	^ self basicNew initialize! !

!WAProcessMonitor methodsFor: 'mutual exclusion' stamp: 'lr 3/3/2008 22:06'!
critical: aBlock ifError: anErrorBlock
	"Evaluate aBlock as a mutual exclusive block within a new processes and wait for the process to finish. Evaluate anErrorBlock in case of a problem. Answer the result of evaluating the blocks. Note, that the semaphore and value needs to be an instance-variable, otherwise continuations might screw up your session."

	mutex critical: [
		value := nil.
		semaphore := SeasidePlatformSupport semaphoreClass new.
		process := [
			[ value := aBlock on: Error do: anErrorBlock ]
				ensure: [ semaphore signal ] ] newProcess.
		process resume.
		semaphore wait.
		process := nil ].
	^ value! !

!WAProcessMonitor methodsFor: 'initialization' stamp: 'lr 3/3/2008 22:06'!
initialize
	mutex := SeasidePlatformSupport semaphoreClass forMutualExclusion! !

!WAProcessMonitor methodsFor: 'controlling' stamp: 'lr 3/3/2008 10:51'!
terminate
	process isNil ifFalse: [ process terminate ]! !

Object subclass: #WAQualifiedValue
	instanceVariableNames: 'value quality'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAQualifiedValue commentStamp: 'pmm 1/4/2008 14:45' prior: 0!
A WAQualifiedValue is an Object with an assigned quality value.

Instance Variables
	quality:		<Float>
	value:		<Object>

quality
	- between 0.0 and 1.0 or Float infinity if no value is given

value
	- the qualified object!

WAQualifiedValue subclass: #WAAccept
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAAccept commentStamp: 'pmm 5/31/2008 23:46' prior: 0!
A WAAccept is a WAQualifiedValue with a value that is an instance of WAMimeType. It represents how much a user agent preferes a certain mime type.!

!WAAccept class methodsFor: 'private' stamp: 'pmm 11/21/2007 21:56'!
valueClass
	^WAMimeType! !

WAQualifiedValue subclass: #WAAcceptLanguage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAAcceptLanguage commentStamp: 'pmm 5/31/2008 23:47' prior: 0!
A WAAcceptLanguage is a WAQualifiedValue with a value that is an instance of WALocale. It represents how much a user agent preferes a certain locale.!

!WAAcceptLanguage class methodsFor: 'private' stamp: 'pmm 11/21/2007 21:59'!
valueClass
	^WALocale! !

!WAQualifiedValue class methodsFor: 'instance creation' stamp: 'YM 8/29/2008 16:04'!
fromString: aString
	^Array streamContents: [ :stream |
		| values |
		values := aString findTokens: ','.
		values do: [ :each |
			| value quality |
			(each includes: $;)
				ifTrue: [
					value := self valueClass fromString: (each copyUpTo: $;) trimBoth.
					quality := Float readFrom: ((each copyAfter: $;) copyAfter: $=) readStream ]
				ifFalse: [
					value := self valueClass fromString: each trimBoth.
					quality := Float infinity ].
			stream nextPut: (self value: value quality: quality) ] ]! !

!WAQualifiedValue class methodsFor: 'instance creation' stamp: 'pmm 11/21/2007 21:54'!
value: anObject quality: aFloat
	^self new
		value: anObject;
		quality: aFloat;
		yourself! !

!WAQualifiedValue class methodsFor: 'private' stamp: 'pmm 11/21/2007 21:51'!
valueClass
	self subclassResponsibility! !

!WAQualifiedValue methodsFor: 'accessing' stamp: 'pmm 11/21/2007 21:47'!
quality
	^ quality! !

!WAQualifiedValue methodsFor: 'accessing' stamp: 'pmm 11/21/2007 21:48'!
quality: aFloat
	quality := aFloat! !

!WAQualifiedValue methodsFor: 'accessing' stamp: 'pmm 11/21/2007 21:48'!
value
	^ value! !

!WAQualifiedValue methodsFor: 'accessing' stamp: 'pmm 11/21/2007 21:47'!
value: anObject
	value := anObject! !

Object subclass: #WARadioGroup
	instanceVariableNames: 'canvas key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Canvas'!

!WARadioGroup commentStamp: 'pmm 6/1/2008 00:47' prior: 0!
A WARadioGroup is a container for several related radio buttons. It must be used to create radio buttons.

Example:
| group |
group := html radioGroup.
group radioButton
	selected: aBoolean;
	callback: [ self someThing ].
!

!WARadioGroup class methodsFor: 'accessing' stamp: 'ac 7/6/2005 11:30'!
canvas: aRenderCanvas
	^ self basicNew initializeWithCanvas: aRenderCanvas! !

!WARadioGroup methodsFor: 'initialize-release' stamp: 'lr 10/28/2007 14:42'!
initializeWithCanvas: aRenderCanvas
	canvas := aRenderCanvas.
	key := aRenderCanvas callbacks registerDispatchCallback! !

!WARadioGroup methodsFor: 'accessing' stamp: 'ac 7/6/2005 11:32'!
key
	^ key! !

!WARadioGroup methodsFor: 'public api' stamp: 'ac 7/6/2005 11:31'!
radioButton
	^ canvas radioButton group: self! !

Object subclass: #WARedirectHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandler'!

!WARedirectHandler methodsFor: 'actions' stamp: 'lr 8/30/2008 16:22'!
redirectPageExpiredTo: aUrl 
	^ (WAResponse 
		refreshWithMessage: 'That page has expired.'
		location: aUrl seasideString
		delay: 3)
		gone;
		yourself! !

!WARedirectHandler methodsFor: 'actions' stamp: 'lr 8/30/2008 16:22'!
redirectTo: aUrl 
	^ WAResponse redirectTo: aUrl seasideString! !

Object subclass: #WARenderLoop
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RenderLoop'!

!WARenderLoop methodsFor: 'accessing-conveniance' stamp: 'lr 4/9/2008 09:38'!
application
	"Answer the application to which this entry point is associated."
	^ WACurrentRequestContext application! !

!WARenderLoop methodsFor: 'processing' stamp: 'lr 3/29/2008 14:20'!
call: aComponent 
	^ WAContinuation currentDo: [ :cc | 
		aComponent onAnswer: cc.
		self root: aComponent.
		self run ]! !

!WARenderLoop methodsFor: 'accessing-properties' stamp: 'lr 8/17/2007 09:56'!
renderContinuationClass
	^ self application preferenceAt: #renderContinuationClass! !

!WARenderLoop methodsFor: 'accessing' stamp: 'lr 4/20/2007 15:12'!
root
	^ root! !

!WARenderLoop methodsFor: 'accessing' stamp: 'lr 1/3/2008 13:29'!
root: aComponent
	root := aComponent.
	self application decorationClasses
		do: [ :each | root addDecoration: each new ]! !

!WARenderLoop methodsFor: 'processing' stamp: 'lr 8/17/2007 09:54'!
run
	(self renderContinuationClass root: self root) run! !

Object subclass: #WARenderingContext
	instanceVariableNames: 'session actionUrl count callbacks document mode properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

!WARenderingContext class methodsFor: 'instance creation' stamp: 'avi 3/25/2004 02:21'!
new
	^ self basicNew initialize! !

!WARenderingContext methodsFor: 'accessing' stamp: 'lr 4/9/2008 09:38'!
absoluteUrlForResource: aString 
	| url |
	(aString isNil or: [ aString includesSubString: '://' ]) ifTrue: [ ^ aString ].
	url := WACurrentRequestContext application resourceBaseUrl.
	url ifNil: [ ^ aString ].
	^ url , aString! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ab 2/13/2003 01:25'!
actionUrl
	"Answer the value of actionUrl"

	^ actionUrl! !

!WARenderingContext methodsFor: 'accessing' stamp: 'avi 11/7/2005 13:13'!
actionUrl: anObject
	actionUrl := anObject! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'avi 6/8/2004 00:42'!
advanceKey
	| key |
	key := self nextKey.
	self increaseKey.
	^ key! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'lr 4/19/2006 08:05'!
callbackAt: aString
	^ callbacks at: aString ifAbsent: [ ]! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'avi 6/8/2004 02:01'!
callbackStreamForRequest: aRequest
	^ WACallbackStream callbacks: callbacks request: aRequest! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'avi 6/7/2004 22:17'!
callbacksFor: anObject
	^ WACallbackRegistry context: self owner: anObject! !

!WARenderingContext methodsFor: 'modes' stamp: 'avi 3/13/2004 22:19'!
clearMode
	mode := nil! !

!WARenderingContext methodsFor: 'accessing' stamp: 'lr 3/27/2006 10:42'!
count
	^ count! !

!WARenderingContext methodsFor: 'accessing' stamp: 'lr 3/27/2006 10:42'!
count: anInteger
	count := anInteger! !

!WARenderingContext methodsFor: 'modes' stamp: 'avi 3/13/2004 22:19'!
debugMode
	mode := #debug! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ab 2/13/2003 01:25'!
document
	"Answer the value of document"

	^ document! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ab 2/13/2003 01:25'!
document: anObject
	"Set the value of document"

	document := anObject! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'mb 11/27/2005 19:22'!
increaseKey
	count contents: count contents + 1! !

!WARenderingContext methodsFor: 'initialize-release' stamp: 'lr 9/5/2007 11:47'!
initialize
	count := WAValueHolder with: 1.
	callbacks := Dictionary new! !

!WARenderingContext methodsFor: 'modes' stamp: 'avi 3/13/2004 22:20'!
isDebugMode
	^ mode = #debug! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'lr 8/30/2008 16:22'!
nextKey
	^ count contents seasideString! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ac 2/18/2006 17:33'!
properties
	^ properties ifNil: [properties := Dictionary new]! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ac 2/18/2006 17:33'!
propertyAt: key ifAbsent: aBlock
	^ self properties at: key ifAbsent: aBlock! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ac 2/18/2006 17:33'!
propertyAt: key put: value
	^ self properties at: key put: value! !

!WARenderingContext methodsFor: 'documents' stamp: 'jf 7/14/2008 17:51'!
registry
	^ WACurrentRequestContext application! !

!WARenderingContext methodsFor: 'initialize-release' stamp: 'lr 4/20/2007 19:57'!
release
	super release.
	document := nil! !

!WARenderingContext methodsFor: 'accessing' stamp: 'lr 4/10/2007 10:06'!
session
	^ session! !

!WARenderingContext methodsFor: 'accessing' stamp: 'lr 4/10/2007 10:06'!
session: aSession
	session := aSession! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'lr 10/28/2007 14:42'!
storeCallback: aCallback
	| key |
	key := self advanceKey.
	callbacks at: (aCallback convertKey: key) put: aCallback.
	^ key! !

!WARenderingContext methodsFor: 'documents' stamp: 'lr 10/28/2007 14:42'!
urlForDocument: anObject
	^ self urlForDocument: anObject mimeType: nil! !

!WARenderingContext methodsFor: 'documents' stamp: 'avi 5/22/2004 18:02'!
urlForDocument: anObject mimeType: mimeString
	^ self urlForDocument: anObject mimeType: mimeString fileName: nil! !

!WARenderingContext methodsFor: 'documents' stamp: 'pmm 3/29/2008 22:49'!
urlForDocument: anObject mimeType: mimeType fileName: fileName
	^self registry
		urlForRequestHandler:
			(WADocumentHandler
				document: anObject
				mimeType: mimeType
				fileName: fileName)
		addHandlerField: true! !

Object subclass: #WAReportColumn
	instanceVariableNames: 'clickBlock formatBlock hasTotal title sortBlock valueBlock cssClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Components-Widgets'!

!WAReportColumn commentStamp: 'pmm 3/24/2008 16:44' prior: 0!
WAReportColumn displays a column, one cell at a time, of a WAReportTable. Columns can be sorted, have a title, can have a total, and its element can be links. The valueBlock obtains the output (an object) to display for each row from the row's object.  The formatBlock is used to convert the valueBlock output to a string. If you need html markup to display the result, use the two argument form of valueBlock. However, columns with two argument valueBlock can not be sorted. See class methods for shortcut methods for setting the value block. 

For more information see:
	WATableReport

Instance Variables:
	clickBlock	<BlockClosure [:rowObject | ]>	When clickBlock is set items in column will be anchors. clickBlock is called with the selected object when anchor is clicked on. Typically clickBlock calls a component which generates a new page.
	formatBlock	<BlockClosure [:object | ]>	Should convert the result of the one-argument valueBlock to the string to be displayed. If formatBlock is nil then  "displayString" is sent to the result of valueBlock for the display string for this column.  
	hasTotal	<Boolean>	If true the column will display the sum of all elements in the column, sum is displayed in the last row.
	sortBlock	<BlockClosure [:a :b | ]>	Used to sort the element in the column. Arguments are the value from the one argument valueBlock
	title	<String>	Column header 
	valueBlock	<BlockClosure [:rowObject | ] or [:rowObject :aWARenderCanvas |] >	
		[:rowObject | ] this form results in an object that is to be displayed in a column cell, argument is the object for a given row (see WATableReport)
		[:rowObject :aWARenderCanvas |] this form is to render the value for a column cell from rowObject directly on aWRenderCanvas
cssClass
	title <String> CSS class
	the CSS class assigned to the <td>-tag in this column 

!

!WAReportColumn class methodsFor: 'instance creation' stamp: 'pmm 4/18/2006 20:17'!
new
	^ self basicNew initialize! !

!WAReportColumn class methodsFor: 'instance creation' stamp: 'mb 5/30/2006 12:13'!
renderBlock: aBlock title: aString
	^ self new
		title: aString;
		valueBlock: aBlock;
		yourself! !

!WAReportColumn class methodsFor: 'instance creation' stamp: 'ab 10/26/2002 22:26'!
selector: aSymbol
	^ self selector: aSymbol title: aSymbol capitalized! !

!WAReportColumn class methodsFor: 'instance creation' stamp: 'ab 10/26/2002 22:26'!
selector: aSymbol title: aString
	^ self selector: aSymbol title: aString onClick: nil! !

!WAReportColumn class methodsFor: 'instance creation' stamp: 'pmm 4/19/2006 17:42'!
selector: aSymbol title: aString onClick: aBlock
	^ self new
		title: aString;
		selector: aSymbol;
		clickBlock: aBlock;
		yourself! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 10/27/2002 00:05'!
canChoose
	^ clickBlock notNil! !

!WAReportColumn methodsFor: 'rendering' stamp: 'mb 5/30/2006 11:49'!
canRender
	^valueBlock numArgs > 1! !

!WAReportColumn methodsFor: 'public' stamp: 'lr 10/28/2007 14:42'!
canSort
	^self canRender not and: [sortBlock notNil]! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 1/16/2003 16:06'!
chooseRow: row
	^ clickBlock value: row! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/28/2002 14:02'!
clickBlock: aBlock
	clickBlock := aBlock! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 11/12/2002 14:03'!
columnClickBlock: aBlock
	self clickBlock: [:r | aBlock value: (self valueForRow: r)]! !

!WAReportColumn methodsFor: 'accessing' stamp: 'pmm 3/24/2008 16:39'!
cssClass
	^ cssClass! !

!WAReportColumn methodsFor: 'accessing' stamp: 'pmm 3/24/2008 16:41'!
cssClass: aString
	cssClass := aString! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:50'!
formatBlock: anObject
	formatBlock := anObject! !

!WAReportColumn methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
hasTotal: aBoolean
	hasTotal := aBoolean! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:52'!
index: aNumber
	valueBlock := [:row | row at: aNumber]! !

!WAReportColumn methodsFor: 'initialize-release' stamp: 'lr 8/30/2008 16:22'!
initialize
	formatBlock := [ :x | x seasideString ].
	sortBlock := [ :a :b | a <= b ].
	valueBlock := [ :row | nil ].
	clickBlock := nil.
	title := 'Untitled'.
	hasTotal := false! !

!WAReportColumn methodsFor: 'rendering' stamp: 'mb 5/30/2006 11:47'!
renderValue: anObject on: html
	valueBlock value: anObject value: html! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:52'!
selector: aSymbol
	valueBlock := [:row | row perform: aSymbol]! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:50'!
sortBlock: anObject
	sortBlock := anObject! !

!WAReportColumn methodsFor: 'public' stamp: 'avi 9/18/2003 16:43'!
sortRows: anArray
	|assocs|
	assocs := anArray collect: [:ea | ea -> (self valueForRow: ea)].
	assocs := assocs asSortedCollection: [:a :b | sortBlock value: a value value: b value].
	^ assocs collect: [:ea | ea key]! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 10/26/2002 21:51'!
textForRow: row
	^ formatBlock value: (self valueForRow: row)! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 10/26/2002 21:50'!
title
	^title! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:50'!
title: aString
	title := aString! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 11/12/2002 14:31'!
totalForRows: aCollection
	^ hasTotal
		ifFalse: ['']
		ifTrue: [formatBlock value: (aCollection detectSum: [:r | self valueForRow: r])]! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:50'!
valueBlock: aBlock
	valueBlock := aBlock! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 10/26/2002 21:51'!
valueForRow: row
	^ valueBlock value: row! !

Object subclass: #WARequest
	instanceVariableNames: 'url fields headers cookies method nativeRequest responseStream remoteAddress'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WARequest commentStamp: 'pmm 5/11/2008 22:14' prior: 0!
I am a server independent http request object. Instance of me can be aquired through WASession >> #currentRequest.

Instance Variables
	url:				<String>
	fields:			<Dictionary<String, Object>>
	headers:		<Dictionary<String, String>>
	nativeRequest:	<Object>
	cookies:			<Collection<WARequestCookie>>
	method:			<String>
	remoteAddress:	<String>

url
	- The request path without the query string. For example if the client requested 'http://www.google.com/search?q=seaside' then the contents of url would be '/search'.

headers
	- The header of the HTTP request. This is a Dictionary mapping lowercase strings to other strings.
	
fields
	- The HTTP request parameters. These are the GET and POST parameters in combined into a single dictionary. In general this is a dictionary mapping Strings to Strings. In the case of multivalued paramters or parameters specified in both GET and POST it maps Strings to a Collection of Strings.
	
cookies
	- The collection of cookies (instance of WARequestCookie) the client sent. Note not all clients support all fields. E.g. you might send a path but the client might not return it. Note there can be several cookies with the same key but a different domain or path. See the #cookiesAt: method.
	
nativeRequest
	- The underlying request object of the web server (Kom, Swazoo, OpenTalk, FastCGI, ...). Accessing this makes your code unportable.
	
method
	- the HTTP method, should be upper case. In general only 'GET' and 'POST' are encountered in Seaside. SqueakSource also supports 'PUT'.
	
remoteAddress
	- the IP address of the client. If the server is behind a reverse proxy then this is '127.0.0.1'. This could in theory also be an IPv6 address.!

!WARequest class methodsFor: 'instance-creation' stamp: 'pmm 5/11/2008 22:03'!
blankRequest
	^ self
		method: 'GET'
		url: ''
		headers: Dictionary new
		fields: Dictionary new
		cookies: Array new
		remoteAddress: '' ! !

!WARequest class methodsFor: 'instance-creation' stamp: 'pmm 5/11/2008 22:02'!
method: methodString url: urlString headers: headerDictionary fields: fieldDictionary cookies: cookieCollection remoteAddress: addressString
	^ self new
		setMethod: methodString
		url: urlString
		headers: headerDictionary
		fields: fieldDictionary
		cookies: cookieCollection
		remoteAddress: addressString! !

!WARequest class methodsFor: 'instance-creation' stamp: 'pmm 5/11/2008 22:04'!
method: methodString url: urlString headers: headerDictionary fields: fieldDictionary cookies: cookieCollection remoteAddress: addressString nativeRequest: anObject
	^ (self method: methodString url: urlString headers: headerDictionary fields: fieldDictionary cookies: cookieCollection remoteAddress: addressString)
		nativeRequest: anObject;
		yourself! !

!WARequest methodsFor: 'accessing-headers' stamp: 'pmm 10/12/2006 06:26'!
accept
	^ self headerAt: 'accept'! !

!WARequest methodsFor: 'accessing-headers' stamp: 'pmm 10/12/2006 06:28'!
acceptCharset
	^ self headerAt: 'accept-charset'! !

!WARequest methodsFor: 'accessing-headers' stamp: 'pmm 10/12/2006 06:27'!
acceptEncoding
	^ self headerAt: 'accept-encoding'! !

!WARequest methodsFor: 'accessing-headers' stamp: 'pmm 10/12/2006 06:27'!
acceptLanguage
	^ self headerAt: 'accept-language'! !

!WARequest methodsFor: 'accessing' stamp: 'ab 7/3/2002 13:37'!
at: key
	^ fields at: key! !

!WARequest methodsFor: 'accessing' stamp: 'JF 5/16/2003 09:40'!
at: key ifAbsent: aBlock
	^ fields at: key ifAbsent: aBlock! !

!WARequest methodsFor: 'accessing' stamp: 'ac 11/12/2005 00:46'!
at: key ifPresent: aBlock
	^ fields at: key ifPresent: aBlock! !

!WARequest methodsFor: 'private' stamp: 'pmm 4/22/2008 07:32'!
authorization
	"Answer the basic authorization string from the request. This is the username and the password separated by a colon."
	
	| authorization |
	authorization := self headerAt: 'authorization'.
	^ authorization isNil ifFalse: [ self decodeAuthorization: authorization ]! !

!WARequest methodsFor: 'accessing-cookies' stamp: 'pmm 3/25/2008 18:59'!
cookieAt: aKey
	"returns the first found cookie with the given key
	there might be several cookies with the name key but different paths, in this case use
	#cookiesAt:"
	^ cookies ifNotNil: [
		cookies
			detect: [ :each | each key = aKey ]
			ifNone: [ nil ] ]! !

!WARequest methodsFor: 'accessing-cookies' stamp: 'pmm 3/22/2008 15:23'!
cookies
	^ cookies ifNil: [ #() ]! !

!WARequest methodsFor: 'accessing-cookies' stamp: 'pmm 3/25/2008 19:00'!
cookiesAt: aKey
	"returns all the cookies with the given key"
	
	^ cookies ifNotNil: [
		cookies
			select: [ :each | each key = aKey ] ]! !

!WARequest methodsFor: 'private' stamp: 'avi 9/21/2003 18:28'!
decodeAuthorization: aString
	^ SeasidePlatformSupport base64Decode: (aString findTokens: ' ') last! !

!WARequest methodsFor: 'accessing' stamp: 'ab 7/3/2002 12:51'!
fields
	^ fields! !

!WARequest methodsFor: 'accessing' stamp: 'JF 11/18/2002 16:18'!
headerAt: aKey
	^ self headerAt: aKey ifAbsent: []! !

!WARequest methodsFor: 'accessing' stamp: 'JF 11/18/2002 16:18'!
headerAt: aKey ifAbsent: aBlock
	^ headers at: aKey ifAbsent: aBlock! !

!WARequest methodsFor: 'accessing' stamp: 'JF 11/18/2002 16:16'!
headers
	^ headers! !

!WARequest methodsFor: 'accessing-headers' stamp: 'pmm 10/29/2006 07:28'!
host
	^ self headerAt: 'host'! !

!WARequest methodsFor: 'testing' stamp: 'mb 3/31/2006 09:41'!
includesKey: key
	^ fields includesKey: key! !

!WARequest methodsFor: 'testing' stamp: 'avi 3/22/2004 12:58'!
isGet
	^ self method asUppercase = 'GET'! !

!WARequest methodsFor: 'testing' stamp: 'lr 7/3/2006 09:25'!
isXmlHttpRequest
	^ (self headerAt: 'x-requested-with') = 'XMLHttpRequest'! !

!WARequest methodsFor: 'accessing' stamp: 'ab 8/26/2003 19:33'!
method
	^ method! !

!WARequest methodsFor: 'accessing' stamp: 'avi 4/28/2004 13:43'!
nativeRequest
	^ nativeRequest! !

!WARequest methodsFor: 'accessing' stamp: 'avi 4/28/2004 13:43'!
nativeRequest: aRequest
	nativeRequest := aRequest! !

!WARequest methodsFor: 'accessing' stamp: 'lr 2/12/2008 08:09'!
password
	"Answer the password from basic authentication."
	
	| authorization |
	^ (authorization := self authorization) isNil
		ifFalse: [ authorization copyAfter: $: ]! !

!WARequest methodsFor: 'printing' stamp: 'lr 4/20/2007 19:12'!
printOn: aStream
	super printOn: aStream.
	aStream space; nextPutAll: self method.
	aStream space; nextPutAll: self url! !

!WARequest methodsFor: 'accessing-headers' stamp: 'ac 6/17/2006 16:28'!
referer
	^ self headerAt: 'referer'! !

!WARequest methodsFor: 'accessing' stamp: 'pmm 5/11/2008 22:00'!
remoteAddress
	"answer the IP address of the client (String)"
	^ remoteAddress! !

!WARequest methodsFor: 'accessing' stamp: 'avi 1/6/2006 13:23'!
responseStream
	^ responseStream! !

!WARequest methodsFor: 'accessing' stamp: 'avi 1/6/2006 13:23'!
responseStream: aStream
	responseStream := aStream! !

!WARequest methodsFor: 'private' stamp: 'pmm 5/11/2008 22:02'!
setMethod: methodString url: urlString headers: headerDictionary fields: fieldDictionary cookies: cookieCollection remoteAddress: addressString
	method := methodString.
	url := urlString.
	headers := headerDictionary.
	fields := fieldDictionary.
	cookies := cookieCollection.
	remoteAddress := addressString! !

!WARequest methodsFor: 'accessing' stamp: 'ab 5/26/2003 00:54'!
url
	^ url! !

!WARequest methodsFor: 'accessing' stamp: 'lr 2/12/2008 08:09'!
user
	"Answer the username from basic authentication."
	
	| authorization |
	^ (authorization := self authorization) isNil
		ifFalse: [ authorization copyUpTo: $: ]! !

!WARequest methodsFor: 'accessing-headers' stamp: 'pmm 10/12/2006 06:26'!
userAgent
	^ self headerAt: 'user-agent'! !

Object subclass: #WARequestContext
	instanceVariableNames: 'server handlers request response properties subscribers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Contexts'!

!WARequestContext commentStamp: 'lr 4/9/2008 09:44' prior: 0!
WARequestContext encapsulates all the knowledge that shuld be available while processing a single request. It does not matter if this is a request to a static file, a normal Seaside request, an AJAX request or a long Comet request.

The request context is valid only during the request that caused it. It should not be stored. Neither within instance variables, nor within the execution stack so that it might be captured by a continuation. In both cases this might lead to memory leaks.!

!WARequestContext class methodsFor: 'instance creation' stamp: 'pmm 3/29/2008 14:13'!
new
	^self basicNew initialize! !

!WARequestContext class methodsFor: 'convenience' stamp: 'lr 4/9/2008 09:38'!
pushRequestHandler: aRequestHandler while: aBlock 
	^ WACurrentRequestContext value 
		pushRequestHandler: aRequestHandler
		while: aBlock! !

!WARequestContext class methodsFor: 'convenience' stamp: 'lr 4/9/2008 09:38'!
response: aResponse 
	^ WACurrentRequestContext value response: aResponse! !

!WARequestContext class methodsFor: 'instance creation' stamp: 'pmm 3/29/2008 14:59'!
server: aServerApater request: aRequest
	^self new
		server: aServerApater;
		request: aRequest;
		yourself! !

!WARequestContext methodsFor: 'accessing-scripts' stamp: 'lr 4/2/2008 11:57'!
addLoadScript: aString
	^ self loadScripts addLast: aString! !

!WARequestContext methodsFor: 'accessing-dynamic' stamp: 'jf 7/16/2008 10:49'!
application
	"Answer the current application or nil."

	^ handlers 
		detect: [ :each | each isApplication ]
		ifNone: [ nil ]! !

!WARequestContext methodsFor: 'accessing' stamp: 'pmm 5/10/2008 22:02'!
codec
	"returns the WACodec instance used by the current server"
	^self server codec! !

!WARequestContext methodsFor: 'accessing-dynamic' stamp: 'lr 4/9/2008 10:17'!
handler
	"Answer the current request handler or nil."

	^ self handlers isEmpty ifFalse: [ self handlers first ]! !

!WARequestContext methodsFor: 'accessing' stamp: 'lr 4/9/2008 09:47'!
handlers
	"Answer an ordered collection of request handlers that have been processed. The list of handlers is in reverse orders, so that the last processed handler is first in the list."

	^ handlers! !

!WARequestContext methodsFor: 'initialization' stamp: 'lr 4/9/2008 10:15'!
initialize
	handlers := OrderedCollection new! !

!WARequestContext methodsFor: 'testing' stamp: 'pmm 5/9/2008 19:33'!
isEncoded
	"returns true if the server is encoded
	the server is encoded if multi byte input characters are mapped to one instance of Character"
	^self server isEncoded! !

!WARequestContext methodsFor: 'accessing-scripts' stamp: 'lr 5/31/2008 23:34'!
loadScripts
	^ self properties at: #loadScripts ifAbsentPut: [ OrderedCollection new ]! !

!WARequestContext methodsFor: 'initialization' stamp: 'lr 4/9/2008 10:17'!
newCookie
	"Creates a new cookie. Tries to put as many restrictions on it as possible and make stealing it has hard a possible. Some of these restrictions might be to severe for your application, you can always loosen them."
	| cookie baseUrl |
	baseUrl := self handler baseUrl.
	cookie := WACookie new
		path: baseUrl pathString;
		httpOnly: true;
		yourself.
	baseUrl hostname isNil ifFalse: [ cookie domain: baseUrl hostname ].
	baseUrl scheme = 'https' ifTrue: [ cookie secure: true ].
	(baseUrl port notNil and: [ baseUrl hostname notNil ]) ifTrue: [ cookie port: baseUrl port ].
	^ cookie! !

!WARequestContext methodsFor: 'events' stamp: 'lr 3/29/2008 22:10'!
on: anEventClass do: aValuable
	"Evaluate aValuable, when an event of aClass is triggered."

	subscribers ifNil: [ subscribers := WASmallDictionary new ].
	(subscribers at: anEventClass ifAbsentPut: [ OrderedCollection new ])
		add: aValuable.
	^ aValuable! !

!WARequestContext methodsFor: 'events' stamp: 'lr 3/29/2008 22:11'!
on: anEventClass send: aSelector to: anObject
	"Send the message aSelector to anObject, when an event of aClass is triggered."

	^ self on: anEventClass do: (MessageSend receiver: anObject selector: aSelector)! !

!WARequestContext methodsFor: 'events' stamp: 'lr 3/29/2008 22:12'!
onRespond: aValuable
	self on: WAResponseEvent do: aValuable! !

!WARequestContext methodsFor: 'accessing' stamp: 'lr 4/9/2008 10:15'!
properties
	"Answer a dictionary of custom request related properties."

	^ properties ifNil: [ properties := WASmallDictionary new ]! !

!WARequestContext methodsFor: 'initialization' stamp: 'lr 4/9/2008 09:44'!
pushRequestHandler: aRequestHandler while: aBlock 
	handlers addFirst: aRequestHandler.
	^ aBlock ensure: [ handlers removeFirst ]! !

!WARequestContext methodsFor: 'accessing-scripts' stamp: 'lr 5/31/2008 23:40'!
rememberLoadScripts: aBlock
	| result scripts |
	scripts := self loadScripts.
	self properties removeKey: #loadScripts.
	result := aBlock value.
	self properties at: #loadScripts put: scripts.
	^ result! !

!WARequestContext methodsFor: 'accessing' stamp: 'lr 4/9/2008 09:48'!
request
	"Answer the current request object."
	
	^ request! !

!WARequestContext methodsFor: 'initialization' stamp: 'pmm 3/29/2008 14:59'!
request: aRequest
	request := aRequest! !

!WARequestContext methodsFor: 'accessing' stamp: 'lr 4/9/2008 09:48'!
response
	"Answer the current response object."
	
	^ response! !

!WARequestContext methodsFor: 'initialization' stamp: 'pmm 3/29/2008 15:25'!
response: aResponse
	response := aResponse! !

!WARequestContext methodsFor: 'responding' stamp: 'lr 4/5/2008 18:00'!
returnResponse: aResponse
	| event |
	"That should be improved, it should also check if the response is not already out on the socket.
	response isNil 
		ifFalse: [ self error: 'Invalid state exception.' ]."
	self trigger: (event := WAResponseEvent on: aResponse).
	WAReturnResponse new
		response: event response;
		raiseSignal! !

!WARequestContext methodsFor: 'accessing' stamp: 'lr 4/9/2008 09:48'!
server
	"Answer the server handing this request."

	^ server! !

!WARequestContext methodsFor: 'initialization' stamp: 'pmm 3/29/2008 14:16'!
server: aServerApater
	server := aServerApater! !

!WARequestContext methodsFor: 'accessing-dynamic' stamp: 'jf 7/25/2008 20:34'!
session
	"Answer the current session or nil."

	^ handlers 
		detect: [ :each | each isSession ]
		ifNone: [ nil ]! !

!WARequestContext methodsFor: 'initialization' stamp: 'lr 3/29/2008 17:08'!
setRequest: aRequest
	request := aRequest! !

!WARequestContext methodsFor: 'initialization' stamp: 'lr 3/29/2008 17:08'!
setResponse: aResponse
	response := aResponse! !

!WARequestContext methodsFor: 'initialization' stamp: 'lr 3/29/2008 17:08'!
setServer: aServerApater
	server := aServerApater! !

!WARequestContext methodsFor: 'events' stamp: 'lr 4/9/2008 10:15'!
trigger: anEvent
	"Pass anEvent to all subscribers of anEvent class."
	
	subscribers ifNil: [ ^ anEvent ].
	subscribers keysAndValuesDo: [ :class :actions |
		(anEvent isKindOf: class)
			ifTrue: [ actions do: [ :action | action value: anEvent ] ] ].
	^ anEvent! !

!WARequestContext methodsFor: 'testing' stamp: 'pmm 5/9/2008 19:37'!
usesSmalltalkEncoding
	"returns true if the Strings provided by the server are guaranteed to be in the native encoding of the Smalltalk image
	returns false if the Characters in Strings provided by the server are only bytes"
	^self server usesSmalltalkEncoding! !

Object subclass: #WARequestCookie
	instanceVariableNames: 'key path domain ports value version'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WARequestCookie commentStamp: 'pmm 6/1/2008 00:04' prior: 0!
A WARequestCookie is the cookie the user agent sent to the server.

Instance Variables
	domain:		<String>
	key:		<String>
	path:		<String>
	ports:		<Collection<Integer>>
	value:		<String>
	version:		<Integer>

domain
	- xxxxx

key
	- xxxxx

path
	- xxxxx

ports
	- xxxxx

value
	- xxxxx

version
	- the version of the cookie specification supported, currently only 1 is known
!

WARequestCookie subclass: #WACookie
	instanceVariableNames: 'expiry secure discard comment commentUrl httpOnly maxAge'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WACookie commentStamp: 'pmm 6/1/2008 00:01' prior: 0!
I represent a cookie, a piece of information that is stored on the client and read and writable by the server. I am basically a key/value pair of strings.
You can never trust information in a cookie, the client is free to edit it.
I model only a part of the full cookie specification.

Browser support:
http://www.mnot.net/blog/2006/10/27/cookie_fun

Netscape spec
http://wp.netscape.com/newsref/std/cookie_spec.html

Cookie spec
http://tools.ietf.org/html/rfc2109

Cookie 2 spec
http://tools.ietf.org/html/rfc2965

HttpOnly
http://msdn2.microsoft.com/en-us/library/ms533046.aspx
https://bugzilla.mozilla.org/show_bug.cgi?id=178993

Compared to WARequestCookie I represent the information that is sent to the user agent.!

!WACookie class methodsFor: 'convenience' stamp: 'pmm 3/22/2008 11:00'!
combine: aCollectionOfCookies using: aOneArgumentBlock
	"combines several cookies into one HTTP header line
	aOneArgumentBlock takes a cookie as an argument and returns a string,
	it is supposed to send one of #oldNetscapeString #rfc2109String #rfc2965String to the argument"
	^String streamContents: [ :stream |
		aCollectionOfCookies
			do: [ :each |
				stream nextPutAll: (aOneArgumentBlock value: each) ]
			separatedBy: [ stream nextPutAll: ', ' ] ]! !

!WACookie class methodsFor: 'instance creation' stamp: 'pmm 2/19/2008 07:07'!
new
	"C++ pattern 753: overload the new operator"
	^self basicNew initialize! !

!WACookie methodsFor: 'accessing' stamp: 'pmm 2/20/2008 06:34'!
comment
	^ comment! !

!WACookie methodsFor: 'accessing' stamp: 'pmm 2/20/2008 06:34'!
comment: aString
	comment := aString! !

!WACookie methodsFor: 'accessing' stamp: 'pmm 2/20/2008 06:34'!
commentUrl
	^ commentUrl! !

!WACookie methodsFor: 'accessing' stamp: 'pmm 2/20/2008 06:35'!
commentUrl: aUrl
	commentUrl := aUrl! !

!WACookie methodsFor: 'accessing' stamp: 'pmm 2/20/2008 06:34'!
discard
	^ discard! !

!WACookie methodsFor: 'accessing' stamp: 'pmm 2/20/2008 06:34'!
discard: aBoolean
	discard := aBoolean! !

!WACookie methodsFor: 'api' stamp: 'pmm 3/22/2008 12:37'!
expireIn: aDuration
	"sets the lifetime of the receiver mesaured in a duration"
	self expiry: DateAndTime now + aDuration.
	self maxAge: aDuration asSeconds! !

!WACookie methodsFor: 'api' stamp: 'pmm 4/5/2008 15:44'!
expireInPast
	self maxAge: 0.
	self expiry: (DateAndTime now - (Duration days: 10 hours: 0 minutes: 0 seconds: 0)).! !

!WACookie methodsFor: 'api' stamp: 'pmm 3/22/2008 12:37'!
expireInSeconds: anInteger
	"sets the lifetime of the receiver mesaured in seconds"
	self expiry: (Duration days: 0 hours: 0 minutes: 0 seconds: anInteger).
	self maxAge: anInteger! !

!WACookie methodsFor: 'accessing' stamp: 'avi 5/18/2004 22:53'!
expiry
	^ expiry! !

!WACookie methodsFor: 'accessing' stamp: 'mb 9/22/2006 12:22'!
expiry: aDateTime
	expiry := aDateTime asUTC! !

!WACookie methodsFor: 'private' stamp: 'lr 8/30/2008 16:22'!
expiryString
	^ String streamContents: 
		[ :stream | 
		stream
			nextPutAll: (expiry dayOfWeekName first: 3);
			nextPutAll: ', ';
			nextPutAll: expiry dayOfMonth seasideString;
			nextPut: $-;
			nextPutAll: expiry monthName;
			nextPut: $-;
			nextPutAll: expiry year seasideString;
			space;
			nextPutAll: expiry hour24 seasideString;
			nextPut: $:;
			nextPutAll: expiry minute seasideString;
			nextPut: $:;
			nextPutAll: expiry second seasideString;
			nextPutAll: ' GMT' ]! !

!WACookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 22:39'!
httpOnly
	^ httpOnly! !

!WACookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 22:39'!
httpOnly: anObject
	httpOnly := anObject! !

!WACookie methodsFor: 'initialize-release' stamp: 'pmm 3/3/2008 20:41'!
initialize
	super initialize.
	self secure: false.
	self discard: false.
	self httpOnly: false.
	self version: 1! !

!WACookie methodsFor: 'accessing' stamp: 'pmm 3/22/2008 12:31'!
maxAge
	^ maxAge! !

!WACookie methodsFor: 'accessing' stamp: 'pmm 3/22/2008 12:32'!
maxAge: anInteger
	"Optional.  The Max-Age attribute defines the lifetime of the
	cookie, in seconds.  The delta-seconds value is a decimal non-
	negative integer.  After delta-seconds seconds elapse, the client
	should discard the cookie.  A value of zero means the cookie
	should be discarded immediately."
	maxAge := anInteger! !

!WACookie methodsFor: 'writing' stamp: 'pmm 4/5/2008 14:19'!
oldNetscapeString
	"Serializes the receiver accroding to the orginal Netscape spec.
	This has the broadest browser support but limited features.
	It can not be used with HTTP header combining.
	See class comment for a link to the spec."
	^String streamContents: [ :stream |
		self writeKeyValueQuoted: false on: stream.
		self writeExpiresOn: stream.
		self writePathQuoted: false on: stream.
		self writeDomainQuoted: false on: stream.
		self writeSecureOn: stream.
		self writeHttpOnlyOn: stream ]! !

!WACookie methodsFor: 'writing' stamp: 'pmm 4/5/2008 14:17'!
oldNetscapeStringWithoutKey
	"same as oldNetscapeString except that the key is not included, used for Kom hacks"
	^String streamContents: [ :stream |
		self value isNil ifFalse: [
			stream nextPutAll: self value ].
		self writeExpiresOn: stream.
		self writePathQuoted: false on: stream.
		self writeDomainQuoted: false on: stream.
		self writeSecureOn: stream.
		self writeHttpOnlyOn: stream ]! !

!WACookie methodsFor: 'writing' stamp: 'pmm 4/5/2008 14:20'!
rfc2109String
	"Serializes the receiver accroding to RFC 2109.
	Almost no browser support.
	It can be used with HTTP header combining.
	See class comment for a link to the spec."
	^String streamContents: [ :stream |
		self writeKeyValueQuoted: true on: stream.
		self writeCommentOn: stream.
		self writeMaxAgeOn: stream.
		self writePathQuoted: true on: stream.
		self writeDomainQuoted: true on: stream.
		self writeSecureOn: stream.
		self writeHttpOnlyOn: stream.
		self writeVersionOn: stream ]! !

!WACookie methodsFor: 'writing' stamp: 'pmm 4/5/2008 14:21'!
rfc2965String
	"Serializes the receiver accroding to RFC 2965.
	This has the most features but is only supported in Opera.
	It can be used together with other serialization forms.
	It can be used with HTTP header combining.
	See class comment for a link to the spec."
	^String streamContents: [ :stream |
		self writeKeyValueQuoted: true on: stream.
		self writeCommentOn: stream.
		self writeCommentUrlOn: stream.
		self writeMaxAgeOn: stream.
		self writePathQuoted: true on: stream.
		self writePortsOn: stream.
		self writeDomainQuoted: true on: stream.
		self writeSecureOn: stream.
		self writeHttpOnlyOn: stream.
		self writeDiscardOn: stream.
		self writeVersionOn: stream ]! !

!WACookie methodsFor: 'accessing' stamp: 'pmm 2/20/2008 06:33'!
secure
	^ secure! !

!WACookie methodsFor: 'accessing' stamp: 'pmm 2/20/2008 06:35'!
secure: aBoolean
	secure := aBoolean! !

!WACookie methodsFor: 'writing-private' stamp: 'pmm 2/25/2008 07:33'!
write: aString asQuotedStringOn: aStream

	aStream nextPut: $".
	aString do: [ :each |
		each = $" 
			ifTrue: [ aStream nextPutAll: '\"']
			ifFalse: [ aStream nextPut: each ] ].
	aStream nextPut: $"! !

!WACookie methodsFor: 'writing-private' stamp: 'pmm 3/3/2008 20:25'!
write: aString quoted: aBoolean on: aStream
	aBoolean
		ifTrue: [
			self
				write: aString
				asQuotedStringOn: aStream ]
		ifFalse: [ aStream nextPutAll: aString ]! !

!WACookie methodsFor: 'writing-private' stamp: 'pmm 3/3/2008 21:18'!
writeCommentOn: aStream
	self comment isNil ifTrue: [ ^self ].
	
	aStream nextPutAll: '; Comment='.
	self
		write: self comment
		asQuotedStringOn: aStream! !

!WACookie methodsFor: 'writing-private' stamp: 'lr 8/30/2008 16:22'!
writeCommentUrlOn: aStream 
	self commentUrl isNil ifTrue: [ ^ self ].
	aStream nextPutAll: '; CommentURL='.
	self 
		write: self commentUrl seasideString
		asQuotedStringOn: aStream! !

!WACookie methodsFor: 'writing-private' stamp: 'pmm 3/3/2008 20:32'!
writeDiscardOn: aStream
	(self discard notNil and: [ self discard ])
		ifTrue: [ aStream nextPutAll: '; Discard' ]! !

!WACookie methodsFor: 'writing-private' stamp: 'pmm 3/3/2008 21:02'!
writeDomainQuoted: aBoolean on: aStream
	domain isNil ifTrue: [ ^self ].

	aStream nextPutAll: '; domain='.
	self
		write: self domain
		quoted: aBoolean
		on: aStream! !

!WACookie methodsFor: 'writing-private' stamp: 'pmm 3/3/2008 20:22'!
writeExpiresOn: aStream
	expiry isNil ifTrue: [ ^self ].

	aStream
		nextPutAll: '; expires=';
		nextPutAll: self expiryString! !

!WACookie methodsFor: 'writing-private' stamp: 'pmm 3/3/2008 20:42'!
writeHttpOnlyOn: aStream
	self httpOnly
		ifTrue: [ aStream nextPutAll: '; HttpOnly' ]! !

!WACookie methodsFor: 'writing-private' stamp: 'pmm 3/3/2008 20:26'!
writeKeyValueQuoted: aBoolean on: aStream
	aStream nextPutAll: self key.
	aStream nextPut: $=.
	self
		write: (self value ifNil: [ '' ])
		quoted: aBoolean
		on: aStream! !

!WACookie methodsFor: 'writing-private' stamp: 'pmm 3/22/2008 12:39'!
writeMaxAgeOn: aStream
	maxAge isNil ifTrue: [ ^self ].
	
	aStream nextPutAll: '; Max-Age="'.
	aStream print: maxAge.
	aStream nextPut: $".! !

!WACookie methodsFor: 'writing' stamp: 'pmm 3/3/2008 20:50'!
writeOn: aStream
	aStream nextPutAll: self oldNetscapeString! !

!WACookie methodsFor: 'writing-private' stamp: 'pmm 3/3/2008 21:02'!
writePathQuoted: aBoolean on: aStream
	path isNil ifTrue: [ ^self ].

	aStream nextPutAll: '; path='.
	self
		write: self path
		quoted: aBoolean
		on: aStream! !

!WACookie methodsFor: 'writing-private' stamp: 'pmm 3/3/2008 21:24'!
writePortsOn: aStream
	ports isEmptyOrNil ifTrue: [ ^self ].
	
	aStream nextPutAll: '; Port="'.
	self ports
		do: [ :each | aStream print: each ]
		separatedBy: [ aStream nextPut: $, ].
	aStream nextPut: $".! !

!WACookie methodsFor: 'writing-private' stamp: 'pmm 3/3/2008 20:42'!
writeSecureOn: aStream
	self secure
		ifTrue: [ aStream nextPutAll: '; Secure' ]! !

!WACookie methodsFor: 'writing-private' stamp: 'pmm 3/3/2008 21:00'!
writeVersionOn: aStream
	aStream nextPutAll: '; Version='.
	aStream print: self version! !

!WARequestCookie class methodsFor: 'accessing' stamp: 'pmm 3/22/2008 13:55'!
actions
	^Dictionary new
		at: '$Domain' put: [ :cookie :value | cookie domain: value ];
		at: '$Path' put: [ :cookie :value | cookie path: value ];
		at: '$Port' put: [ :cookie :value | cookie initializePorts: value ];
		yourself! !

!WARequestCookie class methodsFor: 'instance creation' stamp: 'pmm 7/12/2008 07:54'!
fromString: aString
	"Creates an array of cookies from a HTTP Cookie: header value."
	| version tokens cookieLine current |
	cookieLine := aString.
	aString isEmptyOrNil ifTrue: [ ^#() ]. 
	tokens := cookieLine findTokens: $;.
	current := nil.
	^Array streamContents: [ :cookies |
		tokens do: [ :each |
			| key value action |
			key := self keyFrom: each.
			value := self valueFrom: each.
			key = '$Version'
				ifTrue: [ version := value asInteger ]
				ifFalse: [
					action := self actions
						at: key
						ifAbsent: [ nil ].
					action isNil
						ifTrue: [
							current := self key: key value: value.
							current version: version.
							cookies nextPut: current ]
						ifFalse: [ action value: current value: value ] ] ] ]! !

!WARequestCookie class methodsFor: 'instance creation' stamp: 'pmm 2/21/2008 21:30'!
key: keyString value: valueString
	^ self new
		key: keyString;
		value: valueString;
		yourself! !

!WARequestCookie class methodsFor: 'private' stamp: 'YM 8/29/2008 16:05'!
keyFrom: aString
	^(aString copyUpTo: $=) trimBoth! !

!WARequestCookie class methodsFor: 'private' stamp: 'YM 8/29/2008 16:04'!
trimBlanksAndQuotes: aString
	| trimmed |
	trimmed := aString trimBoth.
	^(trimmed size > 2
		and: [ trimmed first = $"
		and: [ trimmed last = $" ] ])
			ifTrue: [ trimmed copyFrom: 2 to: trimmed size - 1 ]
			ifFalse: [ trimmed ]! !

!WARequestCookie class methodsFor: 'private' stamp: 'pmm 2/24/2008 20:39'!
valueFrom: aString
	^(aString includes: $=)
		ifTrue: [ self trimBlanksAndQuotes: (aString copyAfter: $=) ]! !

!WARequestCookie methodsFor: 'comparing' stamp: 'pmm 3/22/2008 15:58'!
= other
	"cookies are identified by the triple name/domain/path"
	^ self species = other species
		and: [ self key = other key
		and: [ self domain = other domain
		and: [ self path = other path ] ] ]! !

!WARequestCookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 06:42'!
domain
	^ domain! !

!WARequestCookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 06:42'!
domain: aString
	domain := aString! !

!WARequestCookie methodsFor: 'comparing' stamp: 'pmm 3/22/2008 15:58'!
hash
	"see #="
	^(self key hash
		bitXor: self domain hash)
		bitXor: self path hash! !

!WARequestCookie methodsFor: 'initialize-release' stamp: 'pmm 3/22/2008 13:55'!
initializePorts: aString
	self ports: ((aString findTokens: $,) collect: [ :each | each asInteger ]).! !

!WARequestCookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 21:30'!
key
	^ key! !

!WARequestCookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 21:30'!
key: aString
	key := aString! !

!WARequestCookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 06:42'!
path
	^ path ifNil: ['/']! !

!WARequestCookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 06:42'!
path: aString
	path := aString! !

!WARequestCookie methodsFor: 'accessing' stamp: 'pmm 3/22/2008 20:09'!
port: anInteger
	self ports: (Array with: anInteger)! !

!WARequestCookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 06:43'!
ports
	^ ports! !

!WARequestCookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 06:43'!
ports: aCollection
	ports := aCollection! !

!WARequestCookie methodsFor: 'copying' stamp: 'pmm 4/5/2008 15:22'!
postCopy
	super postCopy.
	ports := ports copy! !

!WARequestCookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 21:31'!
value
	^ value! !

!WARequestCookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 21:31'!
value: aString
	value := aString! !

!WARequestCookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 22:36'!
version
	^ version! !

!WARequestCookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 22:36'!
version: anInteger
	version := anInteger! !

Object subclass: #WARequestHandler
	instanceVariableNames: 'parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandler'!

!WARequestHandler commentStamp: 'rew 10/19/2007 10:44' prior: 0!
WARequestHandler is an abstract class whose subclasses handle http requests. Most of the methods are either empty or return a default value. 

Subclasses must implement the following messages:
	handleRequest:	process the request

Instance Variables:
	parent	<WADispatcher | WAApplication | nil> What owns or manages the handler. WADispatchers manage WADispatchers & WAApplications, WAApplications own WASessions

!

WARequestHandler subclass: #WADocumentHandler
	instanceVariableNames: 'document mimeDocument mimeType fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandler'!

!WADocumentHandler commentStamp: 'pmm 10/20/2007 23:22' prior: 0!
WADocumentHandler handles requests for images, text documents and binary files (byte arrays). This class is not normally used directly. A number of WA*Tag classes implement document:mimeType:fileName: which use WADocumentHandler. Given a document document:mimeType:fileName: creates a WADocumentHandler on the document, registers the handler with a dispatcher, and adds the correct url in the tag for the document.

Instance Variables:
	document	<ByteArray | GIFImage | Image | String | WACachedDocument | any class that understands #asMIMEDocumentType:>	contents of the document
	fileName	<String>	file containing the document to be sent as an attachment, nil if no such file
	mimeDocument	<MIMEDocument>	MIMEDocument object representing this document and mimeType, generates stream used to write document for the response. 
	mimeType	<String>	standard HTTP mime type
!

!WADocumentHandler class methodsFor: 'instance-creation' stamp: 'avi 11/3/2003 12:23'!
document: anObject mimeType: mimeString fileName: fileString
	^ self basicNew initializeWithDocument: anObject mimeType: mimeString fileName: fileString! !

!WADocumentHandler methodsFor: 'comparing' stamp: 'lr 2/12/2007 19:38'!
= other
	^ other species = self species
		and: [ other document = self document
		and: [ other mimeType = self mimeType ] ]! !

!WADocumentHandler methodsFor: 'accessing' stamp: 'ab 2/12/2003 13:41'!
document
	^ document! !

!WADocumentHandler methodsFor: 'actions' stamp: 'ab 8/17/2003 12:43'!
handleRequest: aRequest
	^ self response! !

!WADocumentHandler methodsFor: 'comparing' stamp: 'ab 8/17/2003 12:42'!
hash
	^ self document hash bitXor: self mimeType hash! !

!WADocumentHandler methodsFor: 'initialization' stamp: 'lr 1/5/2008 13:58'!
initializeWithDocument: anObject mimeType: mimeString fileName: fileString
	document := anObject.
	mimeString isNil
		ifFalse: [ mimeType := mimeString toMimeType ].
	fileName := fileString! !

!WADocumentHandler methodsFor: 'accessing' stamp: 'lr 2/12/2007 19:37'!
mimeDocument
	^ mimeDocument ifNil: [ mimeDocument := document asMIMEDocumentType: mimeType ]! !

!WADocumentHandler methodsFor: 'accessing' stamp: 'ab 8/24/2003 18:48'!
mimeType
	^ mimeType! !

!WADocumentHandler methodsFor: 'accessing' stamp: 'pmm 11/21/2007 20:27'!
response
	| response |
	response := WAResponse new.
	response contents: self mimeDocument contentStream.
	response contentType: (mimeType ifNil: [ self mimeDocument contentType toMimeType ]).
	response cacheForever.
	fileName ifNotNil: [ response attachmentWithFileName: fileName ].
	^ response! !

WARequestHandler subclass: #WAEntryPoint
	instanceVariableNames: 'name configuration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandler'!

!WAEntryPoint commentStamp: 'rew 10/19/2007 10:45' prior: 0!
WAEntryPoint represents a named entry point to a request handler.

Given a seaside application URL, http://localhost:8008/seaside/tests/alltests, the path parts of the url are mapped to WARequestHandlers. "seaside" & "tests" map to WADispatchers, "alltests" maps to a WAApplication. These individual path parts are used as the names of the WARequestHandlers. WAEntryPoint is an abstract class that handles the name of WARequestHandlers. WAEntryPoint constructs the proper url path for this handler.

Instance Variables:
	name	<String>	the name or path part of this handler

!

WAEntryPoint subclass: #WADispatcher
	instanceVariableNames: 'entryPoints defaultName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandler'!

WADispatcher class
	instanceVariableNames: 'default'!

!WADispatcher commentStamp: 'rew 10/19/2007 10:46' prior: 0!
WADispatcher takes http requests and dispatches them to the correct handler (WAApplication, WAFileHandler, WANotFoundHandler, etc). 

WADispatcher class>>default is the top level dispatcher. When a Seaside application is registered as "foo" the application is added to the top level dispatcher. The application is added to the entryPoints of the dispatcher at the key "foo". If a Seaside application is registered as "bar/foo" then the application isadded to a  dispatcher's entryPoints at the key "foo". That dispatcher is in the top level dispatcher's  entryPoints at the key "bar". 
  
When a http request is received it is sent to WADispatcher class>>default to find the correct handler for the request. If a handler exists for the request is sent to that handler. Otherwise the request is sent to WANotFoundHandler.

The VW port maintains multiple copies of the tree of dispatchers rooted at WADispatcher class>>default. One copy is for each different URL that can reach Seaside (http://..../seaside/go/counter - normal, http://..../counter - SeasideShortPath, http://..../seaside/stream/counter - streaming). 

Instance Variables:
	defaultName	<String>
	entryPoints	<(Dictionary of: (WAApplication | WADispatcher | WAFileHandler))>	 the keys are strings, which are the names and URL path segments for the handler at that key
	lastUpdate	<TimeStamp>	Time the dispatcher was last changed
	version	<SmallInteger>	Each time the dispatcher is changed the version is increased by 1
!

WADispatcher class
	instanceVariableNames: 'default'!

!WADispatcher class methodsFor: 'accessing' stamp: 'lr 3/19/2007 21:06'!
default
	^ default ifNil: [ default := self named: SeasidePlatformSupport defaultDispatcherName ]! !

!WADispatcher class methodsFor: 'accessing' stamp: 'lr 2/10/2008 15:28'!
description
	^ 'Dispatcher'! !

!WADispatcher class methodsFor: 'initialization' stamp: 'lr 2/10/2008 20:01'!
resetAll
	"To have this todo list somewhere,
	May be used in the WADispatcher tests"
	
	default := nil.
	WAEntryPoint allSubclasses do: [ :each | each initialize ].
	WAComponent allSubclasses do: [ :each | each initialize ].! !

!WADispatcher methodsFor: 'accessing' stamp: 'lr 2/12/2007 20:07'!
defaultName
	^ defaultName! !

!WADispatcher methodsFor: 'accessing' stamp: 'lr 2/10/2008 17:45'!
defaultName: aString
	defaultName := aString! !

!WADispatcher methodsFor: 'accessing' stamp: 'lr 2/12/2007 21:44'!
entryPointAt: aString
	^ (aString findTokens: '/') inject: self into: [ :dispatcher :token | dispatcher entryPoints at: token ]! !

!WADispatcher methodsFor: 'accessing' stamp: 'ab 8/26/2003 21:35'!
entryPoints
	^ entryPoints! !

!WADispatcher methodsFor: 'processing' stamp: 'pmm 4/14/2008 06:56'!
handleRequest: aRequest
	^self pushSelfDuring: [
		(self handlerForRequest: aRequest)
			handleRequest: aRequest ]! !

!WADispatcher methodsFor: 'private' stamp: 'pmm 4/22/2008 22:34'!
handlerForRequest: aRequest
	| requestUrl baseUrl relativePath |
	requestUrl := WAUrl new parsePath: aRequest url; yourself.
	requestUrl path isEmpty ifTrue: [
		^self handlerOrNotFoundAt: self defaultName ].
	
	baseUrl := WAUrl new addAllToPath: self path; yourself.
	relativePath := baseUrl relativeTo: requestUrl.
	
	relativePath isEmpty ifTrue: [
		^self handlerOrNotFoundAt: self defaultName ].
		
	^ self handlerOrNotFoundAt: relativePath first! !

!WADispatcher methodsFor: 'private' stamp: 'jf 7/24/2008 23:14'!
handlerOrNotFoundAt: aString
	"returns the request handler registered under the given key
	if no handler exists for such a key a WANotFoundHandler is returned"
	^self entryPoints
		at: aString
		ifAbsent: [ self notFoundHandler ]! !

!WADispatcher methodsFor: 'initialization' stamp: 'lr 2/11/2008 21:13'!
initialize
	super initialize.
	entryPoints := Dictionary new! !

!WADispatcher methodsFor: 'testing' stamp: 'mb 5/26/2006 08:51'!
isDispatcher
	^ true! !

!WADispatcher methodsFor: 'testing' stamp: 'lr 2/12/2007 20:59'!
isRoot
	^ self parent isNil! !

!WADispatcher methodsFor: 'copying' stamp: 'mb 2/17/2007 01:31'!
postCopy
	super postCopy.
	entryPoints := entryPoints valuesCollect: [ :each | each copy setParent: self ]! !

!WADispatcher methodsFor: 'registration' stamp: 'lr 2/10/2008 17:44'!
register: anEntryPoint
	anEntryPoint name
		ifNil: [ self error: 'Unable to add unnamed entry point.' ].
	entryPoints
		at: anEntryPoint name
		put: (anEntryPoint setParent: self).
	^ anEntryPoint! !

!WADispatcher methodsFor: 'registration' stamp: 'lr 2/10/2008 17:44'!
unregister: anEntryPoint
	entryPoints removeKey: anEntryPoint name ifAbsent: [ ^ nil ].
	^ anEntryPoint unregistered! !

!WAEntryPoint class methodsFor: 'accessing' stamp: 'lr 2/12/2007 19:54'!
concreteSubclasses
	^ self allSubclasses reject: [ :each | each isAbstract ]! !

!WAEntryPoint class methodsFor: 'accessing' stamp: 'ab 8/27/2003 00:14'!
description
	^ nil! !

!WAEntryPoint class methodsFor: 'testing' stamp: 'ab 8/27/2003 00:14'!
isAbstract
	^ self description isNil! !

!WAEntryPoint class methodsFor: 'instance-creation' stamp: 'lr 2/12/2007 19:56'!
named: aString
	^ self new setName: aString! !

!WAEntryPoint class methodsFor: 'instance-creation' stamp: 'lr 2/10/2008 19:51'!
register: aString
	^ self register: aString in: WADispatcher default! !

!WAEntryPoint class methodsFor: 'instance-creation' stamp: 'lr 2/10/2008 19:51'!
register: aString in: aDispatcher
	| path dispatcher |
	path := aString findTokens: '/'.
	dispatcher := path allButLast
		inject: aDispatcher
		into: [ :result :each |
			result entryPoints 
				at: each
				ifAbsent: [ result register: (WADispatcher named: each) ] ].
	^ dispatcher register: (self named: path last)! !

!WAEntryPoint methodsFor: 'accessing' stamp: 'mb 2/18/2007 01:30'!
basePath
	^ self parent isNil
		ifTrue: [self name isEmpty
				ifTrue: ['']
				ifFalse: ['/' , self name]]
		ifFalse: [self parent basePath , '/' , self name]! !

!WAEntryPoint methodsFor: 'public' stamp: 'jf 7/31/2008 16:00'!
baseUrl
	| serverPath url |
	serverPath := self serverPath.

	url := (serverPath isNil and: [ parent notNil ])
			ifTrue: [ parent baseUrl ]
			ifFalse: [ WAUrl new ].
	serverPath isNil
		ifFalse: [ url addToPath: serverPath ]
		ifTrue: [ url addToPath: self name ].
		
	self serverProtocol isNil ifFalse: [ url scheme: self serverProtocol ].
	self serverHostname isNil ifFalse: [ url hostname: self serverHostname ].
	self serverPort isNil ifFalse: [ url port: self serverPort ].

	^ url! !

!WAEntryPoint methodsFor: 'preferences' stamp: 'lr 2/10/2008 18:33'!
configuration
	"Answer a default user configuration for the receiver."

	^ configuration ifNil: [ configuration := self defaultConfiguration ]! !

!WAEntryPoint methodsFor: 'configuration' stamp: 'jf 7/24/2008 23:24'!
defaultConfiguration
	^ WAUserConfiguration new
		addParent: WARequestHandlingConfiguration instance;
		yourself! !

!WAEntryPoint methodsFor: 'accessing' stamp: 'lr 2/12/2007 23:21'!
description
	^ self class description! !

!WAEntryPoint methodsFor: 'configuration' stamp: 'jf 8/5/2008 10:23'!
documentClass
	^ self preferenceAt: #documentClass! !

!WAEntryPoint methodsFor: 'public' stamp: 'jf 8/5/2008 11:25'!
expiredKeyHandler
	^ self expiredKeyHandlerClass new
		setParent: self;
		yourself! !

!WAEntryPoint methodsFor: 'configuration' stamp: 'jf 8/5/2008 11:24'!
expiredKeyHandlerClass
	^ self preferenceAt: #expiredKeyHandlerClass! !

!WAEntryPoint methodsFor: 'testing' stamp: 'mb 5/26/2006 08:50'!
isEntryPoint
	^ true! !

!WAEntryPoint methodsFor: 'testing' stamp: 'lr 2/10/2008 16:20'!
isRoot
	^ false! !

!WAEntryPoint methodsFor: 'accessing' stamp: 'lr 2/12/2007 19:50'!
name
	^ name! !

!WAEntryPoint methodsFor: 'public' stamp: 'jf 7/16/2008 09:37'!
newDocumentOn: aStream
	^ self documentClass new
		stream: aStream;
		yourself.! !

!WAEntryPoint methodsFor: 'public' stamp: 'jf 8/5/2008 11:50'!
notFoundHandler
	^ self notFoundHandlerClass new
		setParent: self;
		yourself! !

!WAEntryPoint methodsFor: 'configuration' stamp: 'jf 8/5/2008 11:50'!
notFoundHandlerClass
	^ self preferenceAt: #notFoundHandlerClass! !

!WAEntryPoint methodsFor: 'public' stamp: 'jf 7/24/2008 23:20'!
notFoundResponseFor: aRequest
	^ self notFoundHandler handleRequest: aRequest! !

!WAEntryPoint methodsFor: 'copying' stamp: 'lr 2/10/2008 17:40'!
postCopy
	super postCopy.
	configuration := configuration copy! !

!WAEntryPoint methodsFor: 'preferences' stamp: 'lr 2/10/2008 17:46'!
preferenceAt: aSymbol
	^ self configuration valueAt: aSymbol! !

!WAEntryPoint methodsFor: 'preferences' stamp: 'lr 2/10/2008 17:46'!
preferenceAt: aSymbol put: anObject
	^ self configuration valueAt: aSymbol put: anObject! !

!WAEntryPoint methodsFor: 'printing' stamp: 'lr 2/12/2007 21:48'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' named: '; print: self name! !

!WAEntryPoint methodsFor: 'public' stamp: 'jf 8/5/2008 10:52'!
redirectHandler
	^ self redirectHandlerClass new! !

!WAEntryPoint methodsFor: 'configuration' stamp: 'jf 8/5/2008 10:52'!
redirectHandlerClass
	^ self preferenceAt: #redirectHandlerClass! !

!WAEntryPoint methodsFor: 'public' stamp: 'jf 7/29/2008 14:20'!
redirectResponseFor: aUrl
	^ self redirectHandler redirectTo: aUrl! !

!WAEntryPoint methodsFor: 'configuration' stamp: 'jf 7/29/2008 12:11'!
serverHostname
	^ self preferenceAt: #serverHostname! !

!WAEntryPoint methodsFor: 'configuration' stamp: 'jf 7/29/2008 12:11'!
serverPath
	^ self preferenceAt: #serverPath! !

!WAEntryPoint methodsFor: 'configuration' stamp: 'jf 7/29/2008 12:11'!
serverPort
	^ self preferenceAt: #serverPort! !

!WAEntryPoint methodsFor: 'configuration' stamp: 'jf 7/29/2008 12:11'!
serverProtocol
	^ self preferenceAt: #serverProtocol! !

!WAEntryPoint methodsFor: 'initialization' stamp: 'lr 2/10/2008 17:44'!
setName: aString
	name := aString! !

WAEntryPoint subclass: #WAFileHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandler'!

WAFileHandler class
	instanceVariableNames: 'default'!

!WAFileHandler commentStamp: 'rew 10/19/2007 10:48' prior: 0!
Seaside serves static files using WALibrary subclasses. WAFileHandler handles all requests for WALibrary files (or methods) for all applications on the Seaside server. WAFileHandler is registered with the default WADispatcher automatically.!

WAFileHandler class
	instanceVariableNames: 'default'!

!WAFileHandler class methodsFor: 'accessing' stamp: 'lr 2/10/2008 19:59'!
default
	^ default! !

!WAFileHandler class methodsFor: 'accessing' stamp: 'lr 2/10/2008 15:28'!
description
	^ 'File Library'! !

!WAFileHandler class methodsFor: 'initialization' stamp: 'lr 2/10/2008 19:59'!
initialize
	default := self register: 'files'! !

!WAFileHandler methodsFor: 'processing' stamp: 'jf 7/24/2008 23:19'!
handleRequest: aRequest
	| path baseUrl requestUrl |
	baseUrl := WAUrl new addAllToPath: self path; yourself. 
	requestUrl := WAUrl new parsePath: aRequest url; yourself.
	path := baseUrl relativeTo: requestUrl.
	^ path isEmpty
		ifTrue: [ self renderListing ]
		ifFalse: [
			self
				responseAt: path
				ifAbsent: [ self notFoundResponseFor: aRequest ] ]! !

!WAFileHandler methodsFor: 'accessing' stamp: 'lr 2/18/2007 12:15'!
libraries
	^ self libraryRootClasses gather: [ :each | each allSubclasses ]! !

!WAFileHandler methodsFor: 'private' stamp: 'lr 2/18/2007 12:16'!
librariesDo: aOneArgumentBlock
	self libraryRootClasses do: [ :each | each allSubclassesDo: aOneArgumentBlock ]! !

!WAFileHandler methodsFor: 'accessing' stamp: 'pmm 7/20/2007 06:52'!
libraryAt: aSymbol ifAbsent: aBlock
	self librariesDo: [ :each |
		(each handlesFolder: aSymbol)
			ifTrue: [ ^ each ] ].
	^ aBlock value! !

!WAFileHandler methodsFor: 'private' stamp: 'pmm 7/20/2007 06:54'!
libraryRootClasses
	^ WALibrary subclasses! !

!WAFileHandler methodsFor: 'private' stamp: 'pmm 3/21/2008 18:14'!
renderListing
	| title |
	title := 'Index of ', self basePath.
	^WARenderCanvas builder
		rootBlock: [ :html | html title: title ];
		renderResponse: [ :html |
			html heading: title.
			html unorderedList: [
				self libraries do: [ :each |
					html listItem: [
						html anchor
							url: (each urlOf: '');
							with: each name ] ] ] ]! !

!WAFileHandler methodsFor: 'private' stamp: 'pmm 3/21/2008 17:33'!
responseAt: aPath ifAbsent: aBlock
	| libraryClass |
	libraryClass := self
		libraryAt: aPath first asSymbol
		ifAbsent: [ ^ aBlock value ].
	^aPath size > 1
		ifTrue: [
			libraryClass
				documentAt: aPath second
				ifAbsent: aBlock ]
		ifFalse: [  libraryClass renderListing  ]! !

WAEntryPoint subclass: #WARegistry
	instanceVariableNames: 'keysByHandler handlersByKey mutex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandler'!

!WARegistry commentStamp: 'jf 8/5/2008 11:13' prior: 0!
WARegistry maintains a set of handlers indexed by a key, (by default _s). WARegistry checks incoming request URLs for a key and looks for a matching active request handler. If one exists, the request is sent to the proper handler. If not the request is either a new request (in which case #handleDefaultRequest: is called) or a request to a now-inactive handler (in which case #handleExpiredRequest: is called). These two methods allow subclasses to properly handle these requests.

Subclasses must implement the following messages:
	handleDefaultRequest:
		Handle a request without a session key, ie a new request.

Instance Variables:
	handlersByKey	<Dictionary of <session key(string),WASession>>	provides easy access to the session for a session key
	keysByHandler	<Dictionary of <WASession, session key(string)>>	provides easy access to the session key of a session
	mutex	<Semaphore>	Used to insure keysByHandler & handlersByKey are updated atomically
!

WARegistry subclass: #WAApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Session'!

!WAApplication commentStamp: 'rew 10/19/2007 10:47' prior: 0!
WAApplication is the starting point for a Seaside application. When a WAComponent is registered as a top level component a WAApplication object is added to a WADispatcher. The dispatcher forwards all requests to the WAApplication, which in turn forwards them to the correct WASession object. WAApplication's parent class WARegistry maintains a list of all active sessions to the application. 

"configuration" contains a chain of WAConfituration classes that define attributes of the application. The attribute "rootComponent", for example, defines the top level WAComponent class for the application. The configuration chain includes WAUserConfiguration, WAGlobalConfiguration, WARenderLoopConfiguration and WASessionConfiguration. Other configurations can be added to the chain when the top level application is registered with a dispatcher. (See below)

"libraries" is a collection of WALibrary classes, which are used to serve css, javascript and images used by the application. These may be in methods or in files. Sometimes these libraries are replaced by static files served by Apache. See WAFileLibrary class comment for more information.

Registering an Application.
	An application can be registered with a dispatcher by using the Seaside configuration page or via code. Below MyComponent is a subclass of WAComponent. The following registers the component as an application, gives some values to attributes (or preferences) and adds a library and a configuration. 

MyComponent class>>initialize
	"self initialize"
	| application |
	application := self registerAsApplication: 'sample'.
	application preferenceAt: #sessionClass put: Glorp.WAGlorpSession.
	application addLibrary: SampleLibrary.
	application configuration addAncestor: GlorpConfiguration new.
	application preferenceAt: #glorpDatabasePlatform put: Glorp.PostgreSQLPlatform.
	application preferenceAt: #databaseServer put: '127.0.0.1'.
	application preferenceAt: #databaseConnectString put: 'glorptests'.

MyComponent>>someInstanceMethod
	"example of how to access attributes (preferences)"
	self session application preferenceAt: #glorpDatabasePlatform!

!WAApplication class methodsFor: 'accessing' stamp: 'lr 11/16/2006 18:38'!
description
	^ 'Application'! !

!WAApplication methodsFor: 'libraries' stamp: 'lr 11/18/2007 15:24'!
addLibrary: aLibraryClass
	self preferenceAt: #libraries put: (self libraries copyWith: aLibraryClass)! !

!WAApplication methodsFor: 'configuration' stamp: 'pmm 4/6/2008 15:11'!
charSet
	^ self preferenceAt: #charSet! !

!WAApplication methodsFor: 'configuration' stamp: 'pmm 4/6/2008 15:11'!
contentType
	^ (WAMimeType fromString: self mimeType)
		charset: self charSet;
		yourself! !

!WAApplication methodsFor: 'configuration' stamp: 'lr 1/3/2008 13:22'!
decorationClasses
	^ self preferenceAt: #decorationClasses! !

!WAApplication methodsFor: 'configuration' stamp: 'jf 7/24/2008 23:24'!
defaultConfiguration
	"WAApplicationConfiguration is actually required. WARenderLoopConfiguration is added by default because most users will use WASession and the Render Loop."
	^ super defaultConfiguration
		removeParent: WARequestHandlingConfiguration instance;
		addParent: WAApplicationConfiguration instance;
		addParent: WARenderLoopConfiguration instance;
		yourself! !

!WAApplication methodsFor: 'accessing' stamp: 'lr 8/30/2008 15:41'!
description
	^ [ self rootClass description ]
		on: WAAttributeNotFound
		do: [ :err | String new ]! !

!WAApplication methodsFor: 'request handling' stamp: 'lr 2/12/2007 20:47'!
handleDefaultRequest: aRequest
	^ (self sessionClass new setParent: self) handleRequest: aRequest! !

!WAApplication methodsFor: 'request handling' stamp: 'pmm 3/25/2008 19:57'!
handleRequest: aRequest
	| cookie |
	cookie := self sessionCookieFor: aRequest.
	cookie isNil ifFalse: [
		aRequest fields
			at: self handlerField
			ifAbsentPut: [ cookie value ] ].
	^ super handleRequest: aRequest! !

!WAApplication methodsFor: 'accessing' stamp: 'pmm 3/22/2008 15:13'!
handlerCookieName
	"returns the key of the session cookie"
	^ self handlerField! !

!WAApplication methodsFor: 'testing' stamp: 'mb 4/5/2006 20:26'!
isApplication
	^true! !

!WAApplication methodsFor: 'configuration' stamp: 'lr 2/10/2008 15:59'!
libraries
	^ self preferenceAt: #libraries! !

!WAApplication methodsFor: 'configuration' stamp: 'pmm 4/6/2008 15:11'!
mimeType
	^ self preferenceAt: #mimeType! !

!WAApplication methodsFor: 'libraries' stamp: 'lr 11/18/2007 15:25'!
removeLibrary: aLibraryClass
	self preferenceAt: #libraries put: (self libraries copyWithout: aLibraryClass)! !

!WAApplication methodsFor: 'configuration' stamp: 'lr 2/12/2007 22:02'!
resourceBaseUrl
	^ self preferenceAt: #resourceBaseUrl! !

!WAApplication methodsFor: 'configuration' stamp: 'jf 7/29/2008 14:31'!
rootClass
	^ self preferenceAt: #rootClass! !

!WAApplication methodsFor: 'deprecated' stamp: 'jf 7/29/2008 14:31'!
rootComponent
	self deprecatedApi: 'Use WAApplication>>rootClass'.
	^ self rootClass! !

!WAApplication methodsFor: 'configuration' stamp: 'lr 10/28/2007 14:42'!
sessionClass
	^ self preferenceAt: #sessionClass! !

!WAApplication methodsFor: 'private' stamp: 'pmm 5/16/2008 21:38'!
sessionCookieFor: aRequest
	"answers the session cookie or nil
	There can be several cookies with the correct key (_s). We try to find the one who has the most specific path."

	| candidates requestUrl |
	candidates := aRequest cookiesAt: self handlerCookieName.
	
	candidates isEmptyOrNil
		ifTrue: [ ^nil ].
	candidates size = 1 
		ifTrue: [ ^candidates first ].
		
	requestUrl := WAUrl new parsePath: aRequest url; yourself.
	candidates := candidates collect: [ :each |
		each -> ((WAUrl new parsePath: each path; yourself) relativeTo: requestUrl) ].
	
	candidates := candidates reject: [ :each |
		| path |
		path := each value.
		path notEmpty and: [ path first = '..' ] ].

	candidates isEmpty
		ifTrue: [  ^nil ].
		
	candidates size > 1
		ifTrue: [
			candidates sort: [ :a :b |
				 a value size <= b value size ] ].
	
	^candidates first key! !

!WAApplication methodsFor: 'request handling' stamp: 'lr 4/9/2007 10:51'!
updateRoot: anHtmlRoot
	self libraries do: [ :each | each default updateRoot: anHtmlRoot ]! !

!WAApplication methodsFor: 'request handling' stamp: 'lr 4/15/2007 16:21'!
updateUrl: anUrl! !

!WAApplication methodsFor: 'authentication' stamp: 'jf 7/19/2008 21:36'!
verifyPassword: password forUser: username
"This method is called by WAAuthMain to verify the username provided
in the HTTP request. The default implementation compares them against
the configuration values provided by WAAuthConfiguration. WAAuthMain
can also be used by itself if you implement this method in your
own Application subclass to do something different."

	| loginPref hashPref |
	loginPref := self preferenceAt: #login.
	hashPref := self preferenceAt: #passwordHash.
	
	loginPref ifNil: [self error: 'Login not defined. The default authentication method requires a WAAuthConfiguration'].
	hashPref ifNil: [self error: 'Password not defined. The default authentication method requires a WAAuthConfiguration'].
	
	(username isNil or: [password isNil or: [username isEmpty or: [password isEmpty]]])
		ifTrue: [^ false].
	
	^ (loginPref = username) and:
				[hashPref = (SeasidePlatformSupport secureHashFor: password)]! !

!WARegistry class methodsFor: 'initialization' stamp: 'lr 3/19/2007 15:34'!
clearAllHandlers
	self allSubInstancesDo: [ :each | each clearHandlers ]! !

!WARegistry methodsFor: 'public' stamp: 'pmm 7/5/2007 19:32'!
clearHandlers
	| handlers |
	self mutex critical: [
		handlers := handlersByKey.
		handlersByKey := SeasidePlatformSupport reducedConflictDictionary new.
		keysByHandler := SeasidePlatformSupport reducedConflictDictionary new ].
	handlers ifNotNil: [
		[ handlers do: [ :each | each unregistered ] ]
			fork ]! !

!WARegistry methodsFor: 'public' stamp: 'lr 2/12/2007 20:40'!
ensureKeyForHandler: anObject
	^ (self keyOrNilForHandler: anObject) ifNil: [ self registerRequestHandler: anObject ]! !

!WARegistry methodsFor: 'private' stamp: 'ab 5/18/2003 12:29'!
handleDefaultRequest: aRequest
	self subclassResponsibility! !

!WARegistry methodsFor: 'private' stamp: 'jf 8/5/2008 11:25'!
handleExpiredRequest: aRequest
	^ self expiredKeyHandler handleRequest: aRequest! !

!WARegistry methodsFor: 'private' stamp: 'mb 1/27/2006 15:52'!
handleKeyRequest: aRequest
	| key handler keyString |
	"Under some circumstances, HTTP fields are collections of values"
	key :=	[keyString := aRequest at: self handlerField.
			(keyString isKindOf: OrderedCollection) ifTrue: [keyString := keyString first].
			WAExternalID fromString: keyString] on: Error do: [:e | nil].
	handler := handlersByKey at: key ifAbsent: [nil].
	^ (handler notNil and: [handler isActive])
		ifTrue: [handler handleRequest: aRequest]
		ifFalse: [self handleExpiredRequest: aRequest]! !

!WARegistry methodsFor: 'public' stamp: 'pmm 3/29/2008 14:24'!
handleRequest: aRequest
	^ self pushSelfDuring: [
		(aRequest fields includesKey: self handlerField)
			ifTrue: [ self handleKeyRequest: aRequest ]
			ifFalse: [ self handleDefaultRequest: aRequest ] ]! !

!WARegistry methodsFor: 'private' stamp: 'avi 3/22/2004 13:04'!
handlerField
	^ '_s'! !

!WARegistry methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
initialize
	super initialize.
	self clearHandlers! !

!WARegistry methodsFor: 'private' stamp: 'pmm 2/13/2007 07:21'!
isSeasideField: aString
	^ aString notEmpty
		and: [ aString first = $_ ]! !

!WARegistry methodsFor: 'private' stamp: 'lr 2/12/2007 20:43'!
keyOrNilForHandler: anObject
	^ self mutex critical: [ keysByHandler at: anObject ifAbsent: [ nil ] ]! !

!WARegistry methodsFor: 'private' stamp: 'pmm 7/8/2007 16:45'!
mutex
	^ mutex ifNil: [ mutex := SeasidePlatformSupport semaphoreClass forMutualExclusion ]! !

!WARegistry methodsFor: 'copying' stamp: 'lr 2/10/2008 17:41'!
postCopy
	super postCopy.
	self clearHandlers.
	mutex := nil! !

!WARegistry methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
registerRequestHandler: anObject
	| key |
	key := WAExternalID new: 16.
	self shouldCollectHandlers
		ifTrue: [ self unregisterExpiredHandlers ].
	self mutex critical: [
		handlersByKey at: key put: anObject.
		keysByHandler at: anObject put: key ].
	^ key! !

!WARegistry methodsFor: 'private' stamp: 'lr 3/19/2007 19:32'!
shouldCollectHandlers
	^ handlersByKey size \\ 10 = 0! !

!WARegistry methodsFor: 'private' stamp: 'eam 11/7/2007 15:05'!
unregisterExpiredHandlers
	"Private - Unregisters the receiver expired handlers."

	| expired newHandlersByKey newKeysByHandler |
	expired := OrderedCollection new.
	newHandlersByKey := SeasidePlatformSupport reducedConflictDictionary new.
	newKeysByHandler := SeasidePlatformSupport reducedConflictDictionary new.
	self mutex critical: [
		handlersByKey keysAndValuesDo: [ :key :value |
			value isActive
				ifFalse: [ expired add: value ]
				ifTrue: [
					newHandlersByKey at: key put: value.
					newKeysByHandler at: value put: key ] ].
		handlersByKey := newHandlersByKey.
		keysByHandler := newKeysByHandler ].
	[ expired do: [ :each | each unregistered ] ]
		fork! !

!WARegistry methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
unregistered
	super unregistered.
	self clearHandlers! !

!WARegistry methodsFor: 'public' stamp: 'lr 8/30/2008 16:22'!
urlForRequestHandler: anObject addHandlerField: aBoolean 
	| key url |
	key := self ensureKeyForHandler: anObject.
	url := self baseUrl.
	aBoolean ifTrue: 
		[ url 
			addParameter: self handlerField
			value: key seasideString ].
	^ url! !

WARequestHandler subclass: #WAExpiredKeyHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandler'!

!WAExpiredKeyHandler methodsFor: 'processing' stamp: 'lr 8/30/2008 16:22'!
handleRequest: aRequest 
	| url |
	aRequest isXmlHttpRequest ifTrue: [ ^ WAResponse new forbidden ].
	url := WAUrl new.
	url addToPath: aRequest url.
	url takeServerParametersFromRequest: aRequest.
	aRequest isGet ifTrue: 
		[ aRequest fields keysAndValuesDo: 
			[ :key :value | 
			(url isSeasideField: key) ifFalse: 
				[ url 
					addParameter: key
					value: value ] ] ].
	^ WAResponse redirectTo: url seasideString! !

WAExpiredKeyHandler subclass: #WAExpiredSessionKeyHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Session'!

!WAExpiredSessionKeyHandler methodsFor: 'processing' stamp: 'jf 8/5/2008 11:38'!
handleRequest: aRequest
	| response sessionCookie |
	response := super handleRequest: aRequest.
	sessionCookie := (WACurrentRequestContext application sessionCookieFor: aRequest).
	sessionCookie isNil ifFalse: [ response deleteCookie: sessionCookie ].
	^ response! !

WARequestHandler subclass: #WAExpiringHandler
	instanceVariableNames: 'lastAccess expired timeout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandler'!

!WAExpiringHandler commentStamp: 'rew 10/19/2007 10:47' prior: 0!
WAExpiringHandler is an abstract class that times out when the time between requests is longer than the value of "timeout"

Subclasses must implement the following messages:
	incomingRequest:
		subclass handles the request in this method

Instance Variables:
	expired	<Boolean>	True if handler has times out
	lastAccess	<Time>	Time the handler was last accessed
	timeout	<Integer>	Length of time in seconds handler will timeout without a request
!

!WAExpiringHandler methodsFor: 'defaults' stamp: 'avi 1/23/2004 12:20'!
defaultTimeoutSeconds
	^ 600! !

!WAExpiringHandler methodsFor: 'actions' stamp: 'avi 1/23/2004 12:18'!
expire
	expired := true! !

!WAExpiringHandler methodsFor: 'testing' stamp: 'lr 2/12/2007 19:41'!
expired
	^ expired! !

!WAExpiringHandler methodsFor: 'processing' stamp: 'pmm 3/29/2008 14:26'!
handleRequest: aRequest
	lastAccess := Time totalSeconds.
	^self pushSelfDuring: [ self incomingRequest: aRequest ]! !

!WAExpiringHandler methodsFor: 'processing' stamp: 'lr 10/28/2007 14:42'!
incomingRequest: aRequest
	self subclassResponsibility! !

!WAExpiringHandler methodsFor: 'initialization' stamp: 'mb 4/23/2006 18:39'!
initialize
	super initialize.
	expired := false! !

!WAExpiringHandler methodsFor: 'testing' stamp: 'lr 2/12/2007 19:42'!
isActive
	^ self expired not and: [ self secondsSinceLastAccess < self timeoutSeconds ]! !

!WAExpiringHandler methodsFor: 'accessing' stamp: 'lr 2/27/2007 10:10'!
lastAccess
	^ lastAccess ifNil: [ lastAccess := Time totalSeconds ]! !

!WAExpiringHandler methodsFor: 'accessing' stamp: 'avi 1/23/2004 12:19'!
secondsSinceLastAccess
	^ Time totalSeconds - self lastAccess! !

!WAExpiringHandler methodsFor: 'accessing' stamp: 'lr 2/27/2007 10:10'!
timeoutSeconds
	^ timeout ifNil: [ timeout := self defaultTimeoutSeconds ]! !

!WAExpiringHandler methodsFor: 'accessing' stamp: 'avi 1/23/2004 12:20'!
timeoutSeconds: aNumber
	timeout := aNumber! !

WAExpiringHandler subclass: #WASession
	instanceVariableNames: 'continuations lastContinuation monitor jumpTo cookiesEnabled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Session'!

!WASession commentStamp: 'jf 7/22/2008 11:48' prior: 0!
I am a Seaside session. A new instance of me gets created when an user accesses an application for the first time and is persistent as long as the user is interacting with it.

This class is intended to be subclasses by applications that need global state, like a user. Custom state can be added by creating instance variables and storing it there. The session can be retrieved by #session if inside a component or task or by evaluating: WACurrentRequestContext session

If the session has not been used for #defaultTimeoutSeconds, it is garbage collected by the system. To manually expire a session call #expire.

A good way to clear all sessions is the following code:

WARegistry clearAllHandlers.
Smalltalk garbageCollect!

!WASession methodsFor: 'accessing' stamp: 'lr 4/15/2007 15:55'!
actionField
	^ '_k'! !

!WASession methodsFor: 'accessing' stamp: 'lr 8/20/2007 22:50'!
actionUrlForContinuation: aContinuation
	^ self actionUrlForKey: (continuations store: (lastContinuation := aContinuation))! !

!WASession methodsFor: 'accessing' stamp: 'lr 4/9/2008 10:48'!
actionUrlForKey: aString
	| url |
	url := self application
		urlForRequestHandler: self
		addHandlerField: self useSessionCookie not.
	url takeServerParametersFromRequest: self requestContext request.
	url addParameter: self actionField value: aString.
	jumpTo ifNotNil: [ url fragment: jumpTo ].
	^ url! !

!WASession methodsFor: 'deprecated' stamp: 'lr 4/9/2008 10:48'!
addLoadScript: aString
	self deprecatedApi: 'Use WAContext>>#addLoadScript:'.
	^ self requestContext addLoadScript: aString! !

!WASession methodsFor: 'accessing' stamp: 'lr 4/15/2007 15:55'!
application
	^ parent! !

!WASession methodsFor: 'accessing' stamp: 'lr 4/15/2007 15:55'!
baseUrl
	^ self parent baseUrl! !

!WASession methodsFor: 'private' stamp: 'lr 7/10/2007 19:34'!
checkCookiesField
	^ '_c'! !

!WASession methodsFor: 'scripts' stamp: 'lr 4/15/2007 15:55'!
clearJumpTo
	jumpTo := nil! !

!WASession methodsFor: 'responding' stamp: 'pmm 5/23/2007 23:50'!
closePopup
	^ self respond: [ :url |
		WAResponse new
			nextPutAll: '<html><script>';
			nextPutAll: 'self.close();';
			nextPutAll: 'self.opener.location=self.opener.location';
			nextPutAll: '</script></html>';
			yourself]! !

!WASession methodsFor: 'responding' stamp: 'lr 8/30/2008 16:22'!
closePopupAndContinue
	^ self respond: 
		[ :url | 
		WAResponse new
			nextPutAll: '<html><script>';
			nextPutAll: 'self.close();';
			nextPutAll: 'self.opener.location=';
			nextPutAll: url seasideString printString;
			nextPutAll: '</script></html>';
			yourself ]! !

!WASession methodsFor: 'responding' stamp: 'pmm 5/23/2007 23:50'!
closePopupWithoutReloadingOpener
	^ self respond: [ :url |
		WAResponse new
			nextPutAll: '<html><script>';
			nextPutAll: 'self.close();';
			nextPutAll: '</script></html>';
			yourself]! !

!WASession methodsFor: 'deprecated' stamp: 'pmm 7/23/2008 06:46'!
currentRequest
	"returns the current WARequest"
	self deprecatedApi: 'use WARequestContext >> #request directly'.
	^self requestContext request! !

!WASession methodsFor: 'expiring' stamp: 'jf 7/28/2008 17:11'!
defaultTimeoutSeconds
	^ self sessionExpirySeconds isNil
		ifFalse: [ self sessionExpirySeconds ]
		ifTrue: [ super defaultTimeoutSeconds ]! !

!WASession methodsFor: 'configuration' stamp: 'jf 7/28/2008 17:07'!
errorHandler
	^ self preferenceAt: #errorHandler! !

!WASession methodsFor: 'request handling' stamp: 'jf 8/5/2008 08:46'!
incomingRequest: aRequest 
	| context |
	((aRequest fields includesKey: 'terminate') and: [ self sessionAllowTermination ]) ifTrue: 
		[ monitor terminate.
		^ WAResponse new nextPutAll: 'Process terminated' ].
	context := self requestContext.
	^ monitor 
		critical: 
			[ WACurrentRequestContext 
				use: context
				during: [ self responseForRequest: aRequest ] ]
		ifError: 
			[ :error | 
			WACurrentRequestContext 
				use: context
				during: [ self errorHandler internalError: error ] ]! !

!WASession methodsFor: 'initializing' stamp: 'lr 7/10/2007 19:28'!
initialize
	super initialize.
	continuations := WALRUCache new.
	monitor := WAProcessMonitor new.
	cookiesEnabled := true! !

!WASession methodsFor: 'testing' stamp: 'jf 7/25/2008 20:33'!
isSession
	^ true! !

!WASession methodsFor: 'scripts' stamp: 'lr 4/15/2007 15:55'!
jumpToAnchor: aString
	jumpTo := aString! !

!WASession methodsFor: 'configuration' stamp: 'jf 7/28/2008 17:07'!
mainClass
	^ self preferenceAt: #mainClass! !

!WASession methodsFor: 'responding' stamp: 'lr 4/9/2008 10:48'!
newSessionUrl
	^ self baseUrl takeServerParametersFromRequest: self requestContext request! !

!WASession methodsFor: 'expiring' stamp: 'lr 10/11/2007 11:03'!
pageExpired
	((lastContinuation isKindOf: WASessionContinuation) and: [ lastContinuation states notNil ])
		ifTrue:  [ lastContinuation states restore ].
	self respond: [ :url |
		self application redirectHandler
			redirectPageExpiredTo: url ].
	WAPageExpired raiseSignal! !

!WASession methodsFor: 'responding' stamp: 'jf 7/25/2008 20:02'!
pageIntentionallyLeftBlank
	self requestContext returnResponse: WAResponse new! !

!WASession methodsFor: 'processing' stamp: 'lr 10/28/2007 14:42'!
performRequest: aRequest
	| key continuation |
	key := aRequest fields
		at: self actionField
		ifAbsent: [ ^ self start: aRequest ].
	((aRequest fields includesKey: self checkCookiesField)
		and: [ aRequest cookies isEmpty ])
			ifTrue: [ cookiesEnabled := false ].
	(key isKindOf: OrderedCollection)
		ifTrue: [ key := key first ].
	continuation := continuations
		at: key
		ifAbsent: [ ^ self unknownRequest: aRequest ].
	^ continuation value: aRequest! !

!WASession methodsFor: 'configuration' stamp: 'jf 7/28/2008 17:06'!
preferenceAt: aSymbol
	^ self application isNil ifFalse: [ self application preferenceAt: aSymbol ]! !

!WASession methodsFor: 'redirecting' stamp: 'lr 5/10/2007 22:20'!
redirect
	^ self respond: [ :url | self redirectResponseFor: url ]! !

!WASession methodsFor: 'redirecting' stamp: 'jf 7/24/2008 22:59'!
redirectResponseFor: aUrl
	^ self application redirectResponseFor: aUrl! !

!WASession methodsFor: 'redirecting' stamp: 'jf 7/25/2008 20:05'!
redirectTo: anUrl
	self requestContext returnResponse: (self redirectResponseFor: anUrl)! !

!WASession methodsFor: 'redirecting' stamp: 'lr 7/10/2007 19:38'!
redirectWithCookie: aCookie
	| response |
	self respond: [ :url |
		url addParameter: self checkCookiesField.
		response := self redirectResponseFor: url.
		response addCookie: aCookie.
		response ]! !

!WASession methodsFor: 'redirecting' stamp: 'lr 8/30/2008 16:22'!
redirectWithMessage: aString delay: aNumber 
	self respond: 
		[ :url | 
		WAResponse 
			refreshWithMessage: aString
			location: url seasideString
			delay: aNumber ]! !

!WASession methodsFor: 'responding' stamp: 'lr 3/29/2008 14:20'!
respond: aBlock 
	^ WAContinuation currentDo: [ :cc | self respond: aBlock onAnswer: cc ]! !

!WASession methodsFor: 'responding' stamp: 'jf 7/25/2008 20:04'!
respond: aBlock onAnswer: aContinuation
	| url response |
	url := self actionUrlForContinuation: aContinuation.
	response := aBlock value: url.
	self requestContext returnResponse: response! !

!WASession methodsFor: 'request handling' stamp: 'pmm 3/29/2008 22:51'!
responseForRequest: aRequest
	^ self withEscapeHandler: [
		self withErrorHandler: [
			self performRequest: aRequest ] ]! !

!WASession methodsFor: 'deprecated' stamp: 'jf 7/14/2008 17:06'!
returnResponse: aResponse
	self deprecatedApi: 'Use WARequestContext>>returnResponse: aResponse'.
	self requestContext returnResponse: aResponse! !

!WASession methodsFor: 'responding' stamp: 'lr 4/15/2007 15:55'!
script: aString
	self redirectWithMessage: '<script>', aString, '</script>' delay: 0! !

!WASession methodsFor: 'configuration' stamp: 'jf 8/5/2008 08:46'!
sessionAllowTermination
	^ self preferenceAt: #sessionAllowTermination! !

!WASession methodsFor: 'configuration' stamp: 'jf 7/28/2008 17:08'!
sessionContinuationCacheSize
	^ self preferenceAt: #sessionContinuationCacheSize! !

!WASession methodsFor: 'accessing' stamp: 'lr 8/30/2008 16:22'!
sessionCookie
	"creates a new session cookie"
	^ self requestContext newCookie
		key: self application handlerCookieName;
		value: (self application ensureKeyForHandler: self) seasideString;
		discard: true;
		comment: 'the Seaside Session Cookie';
		commentUrl: 'http://www.seaside.st/documentation/sessionCookie';
		yourself! !

!WASession methodsFor: 'configuration' stamp: 'jf 7/28/2008 17:10'!
sessionExpirySeconds
	^ self preferenceAt: #sessionExpirySeconds! !

!WASession methodsFor: 'initializing' stamp: 'jf 7/29/2008 14:58'!
setParent: aRequestHandler
	super setParent: aRequestHandler.
	continuations capacity: self sessionContinuationCacheSize.! !

!WASession methodsFor: 'processing' stamp: 'lr 10/28/2007 14:42'!
start: aRequest
	self useSessionCookie
		ifTrue: [ self redirectWithCookie: self sessionCookie ].
	^ self mainClass new start: aRequest! !

!WASession methodsFor: 'request handling' stamp: 'lr 4/15/2007 15:55'!
unknownRequest: aRequest
	self start: aRequest! !

!WASession methodsFor: 'private' stamp: 'lr 4/15/2007 15:55'!
unregistered
	super unregistered.
	self expire! !

!WASession methodsFor: 'updating' stamp: 'pmm 4/6/2008 15:16'!
updateRoot: anHtmlRoot
	self application updateRoot: anHtmlRoot.
	anHtmlRoot meta contentType: self application contentType.
	anHtmlRoot meta contentScriptType: 'text/javascript' toMimeType.
	anHtmlRoot htmlAttributes
		at: 'xmlns' put: 'http://www.w3.org/1999/xhtml';
		at: 'xml:lang' put: 'en';
		at: 'lang' put: 'en'.
	anHtmlRoot beXhtml10Strict.
	anHtmlRoot title: 'Seaside'! !

!WASession methodsFor: 'updating' stamp: 'lr 4/20/2007 20:14'!
updateStates: aSnapshot! !

!WASession methodsFor: 'updating' stamp: 'lr 4/15/2007 16:27'!
updateUrl: anUrl
	self application updateUrl: anUrl! !

!WASession methodsFor: 'configuration' stamp: 'jf 7/28/2008 17:09'!
useSessionCookie
	^ cookiesEnabled and: [ self preferenceAt: #useSessionCookie ]! !

!WASession methodsFor: 'request handling' stamp: 'lr 4/20/2007 14:53'!
withErrorHandler: aBlock
	^ [aBlock
		on: Error
		do: [:e | self errorHandler handleError: e. WAPageExpired raiseSignal]]
		on: Warning
		do: [:w | self errorHandler handleWarning: w. WAPageExpired raiseSignal]! !

!WASession methodsFor: 'request handling' stamp: 'lr 4/5/2008 17:53'!
withEscapeHandler: aBlock
	^ aBlock
		on: WAReturnResponse 
		do: [ :err | err response ]! !

WARequestHandler subclass: #WANotFoundHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandler'!

!WANotFoundHandler commentStamp: 'pmm 10/20/2007 23:18' prior: 0!
WANotFoundHandler handles requests whose urls don't map to a Seaside application.

!

!WANotFoundHandler methodsFor: 'actions' stamp: 'avi 5/18/2004 16:16'!
handleRequest: aRequest
	^ WAResponse notFound: aRequest url! !

!WARequestHandler class methodsFor: 'instance-creation' stamp: 'pmm 4/19/2006 18:00'!
new
	^ self basicNew initialize! !

!WARequestHandler methodsFor: 'accessing' stamp: 'lr 2/12/2007 19:33'!
description
	"Answer a descriptive text of the receiver."

	^ String new! !

!WARequestHandler methodsFor: 'processing' stamp: 'lr 10/28/2007 14:42'!
handleRequest: aRequest
	"Handle aRequest and answer a response."

	self subclassResponsibility! !

!WARequestHandler methodsFor: 'initialization' stamp: 'pmm 11/2/2005 23:17'!
initialize! !

!WARequestHandler methodsFor: 'testing' stamp: 'avi 7/23/2004 15:11'!
isActive
	^ true! !

!WARequestHandler methodsFor: 'testing' stamp: 'mb 5/26/2006 08:49'!
isApplication
	^ false! !

!WARequestHandler methodsFor: 'testing' stamp: 'mb 5/26/2006 08:49'!
isDispatcher
	^ false! !

!WARequestHandler methodsFor: 'testing' stamp: 'mb 5/26/2006 08:48'!
isEntryPoint
	^ false! !

!WARequestHandler methodsFor: 'testing' stamp: 'jf 7/25/2008 20:33'!
isSession
	^ false! !

!WARequestHandler methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
parent
	"Answer the parent request handler of the receiver."

	^ parent! !

!WARequestHandler methodsFor: 'accessing' stamp: 'lr 3/24/2008 14:18'!
path
	"Answer the path elements of the receiving request handler."
	
	^ self parent isNil
		ifTrue: [ OrderedCollection with: self name ]
		ifFalse: [ self parent path addLast: self name; yourself ]! !

!WARequestHandler methodsFor: 'copying' stamp: 'lr 2/16/2007 15:06'!
postCopy
	super postCopy.
	parent := nil! !

!WARequestHandler methodsFor: 'processing' stamp: 'lr 4/9/2008 09:37'!
pushSelfDuring: aBlock 
	^ WARequestContext 
		pushRequestHandler: self
		while: aBlock! !

!WARequestHandler methodsFor: 'accessing' stamp: 'lr 4/9/2008 10:53'!
requestContext
	"Answer the current request context."

	^ WACurrentRequestContext value! !

!WARequestHandler methodsFor: 'initialization' stamp: 'lr 2/12/2007 20:50'!
setParent: aRequestHandler
	parent := aRequestHandler! !

!WARequestHandler methodsFor: 'processing' stamp: 'lr 2/12/2007 21:12'!
unregistered! !

Object subclass: #WAResponse
	instanceVariableNames: 'contentType headers cookies status stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAResponse commentStamp: 'pmm 6/1/2008 00:11' prior: 0!
I am a server independent http response object. I am used in conjunction with WASession >> returnResponse:

Instance Variables
	contentType:	<WAMimeType>
	headers:		<Dictionary<String, Object>>
	cookies:			<Set<WACookie>>
	status:			<Integer>
	stream:			<Stream>
				
contentType
	- the content type of the body
				
headers
	- the HTTP headers to be sent to the client
				
cookies
	- the cookies to be sent to the client. Either a Set of cookies or an empty array.
	
status
	- the HTTP status code, the default is 200 (OK)
	
stream
	- a read stream on the contents of the body to be sent to the client !

!WAResponse class methodsFor: 'instance creation' stamp: 'avi 5/18/2004 16:14'!
basicAuthWithRealm: aString
	^ self new basicAuthenticationRealm: aString! !

!WAResponse class methodsFor: 'defaults' stamp: 'pmm 3/21/2008 17:26'!
defaultHttpVersion
	^'HTTP/1.1'! !

!WAResponse class methodsFor: 'defaults' stamp: 'pmm 3/1/2007 06:34'!
defaultValueForCharSet
	^'utf-8'! !

!WAResponse class methodsFor: 'defaults' stamp: 'pmm 11/21/2007 15:24'!
defaultValueForContentType
	^(WAMimeType fromString: self defaultValueForMimeType)
		charset: self defaultValueForCharSet;
		yourself! !

!WAResponse class methodsFor: 'defaults' stamp: 'pmm 3/1/2007 06:34'!
defaultValueForMimeType
	^'text/html'! !

!WAResponse class methodsFor: 'instance creation' stamp: 'akuhn 8/30/2008 15:37'!
document: anObject mimeType: mimeType
	| document |
	document := anObject asMIMEDocumentType: mimeType.
	^ self new
		contentType: (mimeType ifNil: [ document contentType toMimeType ]);
		nextPutAll: document content;
		yourself! !

!WAResponse class methodsFor: 'instance creation' stamp: 'avi 9/22/2004 21:02'!
document: anObject mimeType: mimeString fileName: fileString
	^ (self document: anObject mimeType: mimeString)
		attachmentWithFileName: fileString;
		yourself! !

!WAResponse class methodsFor: 'instance creation' stamp: 'pmm 6/29/2008 16:35'!
forbidden: locationString
	| response content |
	response := self new forbidden.
	content := WARenderCanvas builder
		fullDocument: true;
		rootBlock: [ :root |
			root title: 'Forbidden' ];
		render: [ :html |
			html heading level1; with: [
				html render: 'Error: you are forbidden to access "'.
				html render: locationString.
				html render: '"' ] ].
	response nextPutAll: content.
	^ response! !

!WAResponse class methodsFor: 'instance creation' stamp: 'pmm 11/1/2007 21:30'!
internalError: anError
	| response content |
	response := self new internalError.
	content := WARenderCanvas builder
		fullDocument: true;
		rootBlock: [ :root |
			root title: 'Internal Error' ];
		render: [ :html |
			html heading level1; with: 'Internal Error'.
			html heading level2; with: anError description.
			(SeasidePlatformSupport walkbackStringsFor: anError)
				do: [ :each | html text: each ]
				separatedBy: [ html break ] ].
	response nextPutAll: content.
	^ response! !

!WAResponse class methodsFor: 'instance creation' stamp: 'avi 5/18/2004 16:14'!
new
	^ self basicNew initialize! !

!WAResponse class methodsFor: 'instance creation' stamp: 'pmm 6/29/2008 16:36'!
notFound: locationString
	| response content |
	response := self new notFound.
	content := WARenderCanvas builder
		fullDocument: true;
		rootBlock: [ :root |
			root title: 'Not Found' ];
		render: [ :html |
			html heading level1; with: [
				html render: 'Error: "'.
				html render: locationString.
				html render: '" not found' ] ].
	response nextPutAll: content.
	^ response! !

!WAResponse class methodsFor: 'responding' stamp: 'avi 5/18/2004 16:15'!
redirectTo: locationString
	^ self new redirectTo: locationString! !

!WAResponse class methodsFor: 'instance creation' stamp: 'lr 10/28/2007 14:42'!
refreshWithMessage: aString location: locationString delay: aNumber
	| document |
	document := WARenderCanvas builder
		fullDocument: true;
		rootBlock: [ :root |
			root redirectTo: locationString delay: aNumber ];
		render: [ :html |
			html heading level1
				with: aString.
			html text: 'You are being redirected to '.
			html anchor
				url: locationString;
				with: locationString ].

	^ self new nextPutAll: document! !

!WAResponse methodsFor: 'accessing-cookies' stamp: 'lr 5/23/2007 11:40'!
addCookie: aCookie
	cookies ifNil: [ cookies := Set new ].
	cookies add: aCookie! !

!WAResponse methodsFor: 'convenience' stamp: 'pmm 4/19/2006 09:30'!
attachmentWithFileName: aString
	self headerAt: 'Content-Disposition' put: 'attachment; filename="', aString, '"'! !

!WAResponse methodsFor: 'status' stamp: 'avi 5/18/2004 14:25'!
authenticationFailed
	self status: 401! !

!WAResponse methodsFor: 'convenience' stamp: 'avi 5/18/2004 14:25'!
basicAuthenticationRealm: aString
	self headerAt: 'WWW-Authenticate' put: ('Basic realm="',aString,'"').
	self authenticationFailed! !

!WAResponse methodsFor: 'convenience' stamp: 'pmm 11/21/2007 15:22'!
beXML
	contentType sub = 'html' ifTrue: [
		contentType sub: 'xml' ]! !

!WAResponse methodsFor: 'convenience-caching' stamp: 'akuhn 8/30/2008 15:49'!
cacheForMinutes: anInteger
	| seconds |
	seconds := anInteger * 60.
	self headerAt: 'Cache-Control' put: 'max-age=', seconds printString. "HTTP 1.1"
	self removeHeaderAt: 'Pragma'. "Proxies"
	self removeHeaderAt: 'Expires'. "HTTP 1.0"
! !

!WAResponse methodsFor: 'convenience-caching' stamp: 'akuhn 8/30/2008 15:14'!
cacheForever
	self removeHeaderAt: 'Cache-Control'.
	self removeHeaderAt: 'Pragma'.
	self headerAt: 'Expires' put: self cacheForeverExpiresDate ! !

!WAResponse methodsFor: 'convenience-caching' stamp: 'akuhn 8/30/2008 15:15'!
cacheForeverExpiresDate
	^'Sat, 01 Jan 2095 13:00:00 GMT'! !

!WAResponse methodsFor: 'accessing' stamp: 'ab 7/3/2002 21:58'!
contentType
	^ contentType! !

!WAResponse methodsFor: 'accessing' stamp: 'pmm 11/21/2007 20:21'!
contentType: mimeTypeOrString
	contentType := mimeTypeOrString toMimeType! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 4/13/2004 21:21'!
contents
	^ stream reset! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 4/13/2004 21:21'!
contents: aStream
	stream := aStream! !

!WAResponse methodsFor: 'accessing-cookies' stamp: 'lr 5/23/2007 11:40'!
cookieAt: key put: value
	^ self addCookie: (WACookie key: key value: value)! !

!WAResponse methodsFor: 'accessing-cookies' stamp: 'lr 5/23/2007 11:40'!
cookies
	^ cookies ifNil: [ #() ]! !

!WAResponse methodsFor: 'accessing-cookies' stamp: 'lr 4/9/2008 10:17'!
deleteCookie: aCookie 
	"Delete the cookie in the browser.
	
	The spec sez:
	If a CGI script wishes to delete a cookie, it can do so by returning a cookie with the same name, and an expires time which is in the past. The path and name must match exactly in order for the expiring cookie to replace the valid cookie. This requirement makes it difficult for anyone but the originator of a cookie to delete a cookie.
	
	The trouble is:
	Browsers that follow the Netscape spec don't send path information"
	| cookie |
	cookie := (WACookie 
		key: aCookie key
		value: '')
		path: aCookie path;
		version: aCookie version;
		yourself.
	aCookie version isNil ifTrue: 
		[ "old Netscape cookie with no path information, assumbe baseUrl and cross fingers"
		cookie path: WACurrentRequestContext value handler baseUrl pathString ].
	cookie expireInPast.
	self addCookie: cookie! !

!WAResponse methodsFor: 'accessing-cookies' stamp: 'pmm 7/12/2008 07:51'!
deleteCookieAt: aKeyString
	"Delete the cookie in the browser. This method is quite unrelyable. Consider using #deleteCookie:"
	self deleteCookie: (WARequestCookie key: aKeyString value: '')! !

!WAResponse methodsFor: 'convenience-caching' stamp: 'akuhn 8/30/2008 15:14'!
doNotCache
	self headerAt: 'Expires' put: self doNotCacheExpiresDate. "HTTP 1.0"
	self headerAt: 'Cache-Control' put: 'no-cache, must-revalidate'. "HTTP 1.1"
	self headerAt: 'Pragma' put: 'no-cache' "Proxy Servers"! !

!WAResponse methodsFor: 'convenience-caching' stamp: 'akuhn 8/30/2008 15:15'!
doNotCacheExpiresDate
	^'Wed, 11 Jun 1980 11:00:00 GMT'.! !

!WAResponse methodsFor: 'convenience-caching' stamp: 'akuhn 8/30/2008 15:05'!
expiresDate
	^(self headerAt: 'Expires') value! !

!WAResponse methodsFor: 'status' stamp: 'avi 5/9/2005 13:14'!
forbidden
	self status: 403! !

!WAResponse methodsFor: 'status' stamp: 'pmm 12/31/2007 11:49'!
gone
	self status: 410! !

!WAResponse methodsFor: 'accessing-headers' stamp: 'pmm 11/10/2007 17:14'!
headerAt: aString
	^self headers
		detect: [ :each | each key = aString ]
		ifNone: [ nil ]! !

!WAResponse methodsFor: 'accessing-headers' stamp: 'pmm 11/10/2007 17:15'!
headerAt: aKeyString put: aValueObject
	self headers add: aKeyString -> aValueObject! !

!WAResponse methodsFor: 'accessing-headers' stamp: 'pmm 11/10/2007 17:24'!
headers
	headers isNil ifTrue: [
		headers := OrderedCollection new ].
	^headers! !

!WAResponse methodsFor: 'convenience' stamp: 'pmm 5/1/2007 09:42'!
httpVersion
	^self class defaultHttpVersion! !

!WAResponse methodsFor: 'initialize-release' stamp: 'lr 4/9/2008 09:38'!
initialize
	| application |
	stream := SeasidePlatformSupport readWriteStream.
	status := 200.
	application := WACurrentRequestContext application.
	contentType := application isNil 
		ifFalse: [ application contentType ]
		ifTrue: [ self class defaultValueForContentType ]! !

!WAResponse methodsFor: 'status' stamp: 'avi 5/18/2004 15:57'!
internalError
	self status: 500! !

!WAResponse methodsFor: 'streaming' stamp: 'ab 7/7/2003 11:12'!
nextPut: aCharacter
	stream nextPut: aCharacter asCharacter! !

!WAResponse methodsFor: 'streaming' stamp: 'ab 7/7/2003 11:12'!
nextPutAll: aString
	aString do: [:ea | self nextPut: ea]! !

!WAResponse methodsFor: 'status' stamp: 'avi 5/18/2004 14:25'!
notFound
	self status: 404! !

!WAResponse methodsFor: 'printing' stamp: 'lr 8/30/2008 16:22'!
printOn: aStream 
	super printOn: aStream.
	aStream
		space;
		nextPutAll: self status seasideString! !

!WAResponse methodsFor: 'status' stamp: 'avi 5/18/2004 14:26'!
redirect
	self status: 302! !

!WAResponse methodsFor: 'convenience' stamp: 'lr 10/28/2007 14:42'!
redirectTo: aString
	self headerAt: 'Location' put: aString.
	self redirect! !

!WAResponse methodsFor: 'initialize-release' stamp: 'tbn 7/20/2006 17:31'!
release
	stream := cookies := headers := nil.
	super release! !

!WAResponse methodsFor: 'accessing-headers' stamp: 'pmm 11/10/2007 17:21'!
removeHeaderAt: aString
	headers isNil ifTrue: [
		^self ].	

	headers := self headers reject: [ :each |
		each key = aString ]! !

!WAResponse methodsFor: 'streaming' stamp: 'lr 5/23/2007 11:13'!
space
	stream space! !

!WAResponse methodsFor: 'accessing' stamp: 'ab 7/3/2002 21:50'!
status
	^ status! !

!WAResponse methodsFor: 'accessing' stamp: 'lr 5/23/2007 12:04'!
status: aNumber
	status := aNumber! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 2/6/2004 15:28'!
stream
	^ stream! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 5/18/2004 14:28'!
stream: aStream
	stream := aStream! !

!WAResponse methodsFor: 'writing' stamp: 'lr 8/30/2008 16:22'!
writeHeadersOn: aStream 
	self headers associationsDo: 
		[ :assoc | 
		aStream
			nextPutAll: assoc key;
			nextPutAll: ': ';
			nextPutAll: assoc value seasideString.
		aStream crlf ].
	cookies ifNotNil: 
		[ cookies do: 
			[ :each | 
			aStream nextPutAll: 'Set-Cookie: '.
			each writeOn: aStream.
			aStream crlf ] ].
	aStream
		nextPutAll: 'Content-Type: ';
		nextPutAll: self contentType seasideString.
	aStream crlf! !

!WAResponse methodsFor: 'writing' stamp: 'avi 1/6/2006 12:52'!
writeOn: aStream
	self writeStatusOn: aStream.
	self writeHeadersOn: aStream.
	aStream crlf.
	aStream nextPutAll: stream contents! !

!WAResponse methodsFor: 'writing' stamp: 'lr 8/30/2008 16:22'!
writeStatusOn: aStream 
	aStream
		nextPutAll: self httpVersion;
		space;
		nextPutAll: self status seasideString;
		crlf! !

WAResponse subclass: #WAStreamResponse
	instanceVariableNames: 'writtenHeaders'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAStreamResponse commentStamp: 'pmm 6/1/2008 00:13' prior: 0!
A WAStreamResponse is a WAResponse that directly writes to the response stream. This can be used to implement HTTP response streaming.

Instance Variables
	writtenHeaders:		<Boolean>

writtenHeaders
	- whether the HTTP headers where alread written on the stream
!

!WAStreamResponse class methodsFor: 'instance-creation' stamp: 'lr 5/23/2007 10:35'!
on: aStream
	^ self new stream: aStream! !

!WAStreamResponse methodsFor: 'accessing' stamp: 'pmm 4/19/2006 17:32'!
hasWrittenHeaders
	^ writtenHeaders! !

!WAStreamResponse methodsFor: 'initialization' stamp: 'mb 9/22/2006 12:26'!
initialize
	super initialize.
	writtenHeaders := false! !

!WAStreamResponse methodsFor: 'accessing' stamp: 'avi 1/6/2006 13:31'!
stream
	self writeOn: stream.
	^ stream! !

!WAStreamResponse methodsFor: 'private' stamp: 'lr 3/25/2008 22:13'!
writeOn: aStream 
	self hasWrittenHeaders ifTrue: [ ^ self ].
	self writeStatusOn: aStream.
	self writeHeadersOn: aStream.
	aStream crlf.
	writtenHeaders := true! !

Object subclass: #WARoot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document'!

!WARoot commentStamp: 'pmm 6/1/2008 00:23' prior: 0!
A WARoot is the root node of a document.
!

WARoot subclass: #WAHtmlRoot
	instanceVariableNames: 'context docType htmlAttrs headAttrs bodyAttrs headElements title styles scripts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document'!

!WAHtmlRoot commentStamp: 'pmm 6/2/2008 19:31' prior: 0!
A WAHtmlRoot is the root element of an HTML Document (<html>).

Instance Variables
	bodyAttrs:		<WAHtmlAttributes>
	context:			<WARenderingContext>
	docType:		<String>
	headAttrs:		<WAHtmlAttributes>
	headElements:	<OrderedCollection<WAHtmlElement>>
	htmlAttrs:		<WAHtmlAttributes>
	scripts:			<Set<String>>
	styles:			<Set<String>>
	title:			<String>

bodyAttrs
	- the attributes of the <body> element

context
	- the context used to render the contents of the <body> element

docType
	- the document type

headAttrs
	- the attributes of the <head> element

headElements
	- the elements inside the <head> section

htmlAttrs
	- the attriebutes of the <html> element

scripts
	- contains the strings returned by WAPresenter >> #script

styles
	- contains the strings returned by WAPresenter >> #style

title
	- the title of the HTML document, the contents of the <title> element
!

!WAHtmlRoot class methodsFor: 'instance-creation' stamp: 'lr 3/27/2007 12:08'!
context: aRenderingContext
	^ self new setContext: aRenderingContext! !

!WAHtmlRoot methodsFor: 'private' stamp: 'lr 4/20/2007 16:24'!
absoluteUrlForResource: aString
	^ context absoluteUrlForResource: aString! !

!WAHtmlRoot methodsFor: 'adding' stamp: 'lr 10/28/2007 14:42'!
add: aHtmlElement
	"Add a HTML head element to the receiver."

	^ headElements add: aHtmlElement! !

!WAHtmlRoot methodsFor: 'adding' stamp: 'lr 6/2/2008 09:34'!
addScript: aString
	"Include the script aString into the receiver."

	scripts ifNil: [ scripts := Set new ].
	scripts add: aString! !

!WAHtmlRoot methodsFor: 'adding' stamp: 'lr 6/2/2008 09:34'!
addStyle: aString
	"Include the style-sheet aString into the receiver."

	styles ifNil: [ styles := Set new ].
	styles add: aString! !

!WAHtmlRoot methodsFor: 'elements' stamp: 'lr 4/9/2007 10:30'!
base
	^ self add: (WABaseElement root: self)! !

!WAHtmlRoot methodsFor: 'doctype' stamp: 'lr 4/9/2007 10:44'!
beXhtml10Strict
	self docType: '<!!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">'! !

!WAHtmlRoot methodsFor: 'doctype' stamp: 'lr 4/9/2007 10:45'!
beXhtml10Transitional
	self docType: '<!!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">'! !

!WAHtmlRoot methodsFor: 'doctype' stamp: 'lr 4/9/2007 10:45'!
beXhtml11
	self docType: '<!!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">'! !

!WAHtmlRoot methodsFor: 'accessing-attributes' stamp: 'lr 3/27/2007 12:07'!
bodyAttributes
	^ bodyAttrs ifNil: [ bodyAttrs := WAHtmlAttributes new ]! !

!WAHtmlRoot methodsFor: 'writing' stamp: 'lr 3/27/2007 13:18'!
close: aDocument
	self writeFootOn: aDocument! !

!WAHtmlRoot methodsFor: 'convenience' stamp: 'lr 3/27/2007 13:14'!
contentBase: urlString
	self base url: urlString! !

!WAHtmlRoot methodsFor: 'accessing' stamp: 'avi 3/27/2005 20:29'!
context
	^ context! !

!WAHtmlRoot methodsFor: 'doctype' stamp: 'lr 3/27/2007 12:11'!
docType
	^ docType! !

!WAHtmlRoot methodsFor: 'doctype' stamp: 'lr 10/28/2007 14:42'!
docType: aString
	"Set the document-type of the receiver. The table at http://www.w3.org/TR/2002/NOTE-xhtml-media-types-20020430/ summarizes the recommendation to content authors for labeling their XHTML documents:

Media type				XHTML 1.0 (HTML compatible)	XHTML 1.0 (other)	XHTML Basic / 1.1	XHTML+MathML
text/html				MAY							SHOULD NOT			SHOULD NOT			SHOULD NOT
application/xhtml+xml	SHOULD							SHOULD				SHOULD				SHOULD
application/xml			MAY							MAY				MAY				MAY
text/xml					MAY							MAY				MAY				MAY"

	docType := aString! !

!WAHtmlRoot methodsFor: 'accessing-attributes' stamp: 'lr 3/27/2007 12:07'!
headAttributes
	^ headAttrs ifNil: [ headAttrs := WAHtmlAttributes new ]! !

!WAHtmlRoot methodsFor: 'accessing-attributes' stamp: 'lr 3/27/2007 12:07'!
htmlAttributes
	^ htmlAttrs ifNil: [ htmlAttrs := WAHtmlAttributes new ]! !

!WAHtmlRoot methodsFor: 'elements' stamp: 'lr 10/28/2007 14:42'!
if
	^ WAConditionalComment root: self! !

!WAHtmlRoot methodsFor: 'initialization' stamp: 'lr 3/27/2007 12:09'!
initialize
	headElements := OrderedCollection new.
	title := docType := String new! !

!WAHtmlRoot methodsFor: 'elements' stamp: 'pmm 4/6/2007 14:18'!
javascript
	^ self script beJavascript; yourself! !

!WAHtmlRoot methodsFor: 'elements' stamp: 'lr 10/28/2007 14:42'!
link
	^ self add: (WALinkElement root: self)! !

!WAHtmlRoot methodsFor: 'elements' stamp: 'lr 4/9/2007 10:30'!
meta
	^ self add: (WAMetaElement root: self)! !

!WAHtmlRoot methodsFor: 'writing' stamp: 'lr 3/27/2007 13:17'!
open: aDocument
	self writeHeadOn: aDocument! !

!WAHtmlRoot methodsFor: 'convenience' stamp: 'lr 4/9/2007 10:43'!
redirectTo: aLocationString delay: aNumber
	self meta redirectAfter: aNumber to: aLocationString! !

!WAHtmlRoot methodsFor: 'elements' stamp: 'pmm 11/25/2007 21:57'!
revealedIf
	^ WARevealedConditionalComment root: self! !

!WAHtmlRoot methodsFor: 'elements' stamp: 'lr 10/28/2007 14:42'!
script
	^ self add: (WAScriptElement root: self)! !

!WAHtmlRoot methodsFor: 'initialization' stamp: 'lr 3/27/2007 12:08'!
setContext: aRenderingContext
	context := aRenderingContext! !

!WAHtmlRoot methodsFor: 'elements' stamp: 'lr 3/24/2008 18:06'!
stylesheet
	^ self link beStylesheet; beCss; yourself! !

!WAHtmlRoot methodsFor: 'accessing-properties' stamp: 'lr 3/27/2007 12:11'!
title
	^ title! !

!WAHtmlRoot methodsFor: 'accessing-properties' stamp: 'lr 3/27/2007 12:11'!
title: aString
	title := aString! !

!WAHtmlRoot methodsFor: 'writing' stamp: 'lr 4/9/2007 10:40'!
writeElementsOn: aDocument
	aDocument openTag: 'title'; nextPutAll: title; closeTag: 'title'.
	headElements do: [ :each | aDocument print: each ]! !

!WAHtmlRoot methodsFor: 'writing' stamp: 'lr 3/27/2007 13:20'!
writeFootOn: aDocument
	aDocument closeTag: 'body'.
	aDocument closeTag: 'html'! !

!WAHtmlRoot methodsFor: 'writing' stamp: 'lr 5/16/2007 21:53'!
writeHeadOn: aDocument
	aDocument nextPutAll: docType.
	aDocument openTag: 'html' attributes: htmlAttrs.
	aDocument openTag: 'head' attributes: headAttrs.
	self writeElementsOn: aDocument.
	self writeStylesOn: aDocument.
	self writeScriptsOn: aDocument.
	aDocument closeTag: 'head'.
	aDocument openTag: 'body' attributes: bodyAttrs! !

!WAHtmlRoot methodsFor: 'writing' stamp: 'pmm 4/6/2007 14:18'!
writeScriptsOn: aDocument
	scripts ifNil: [ ^ self ].
	scripts do: [ :each |
		aDocument print: ((WAScriptElement root: self)
			beJavascript;
			document: each;
			yourself) ]! !

!WAHtmlRoot methodsFor: 'writing' stamp: 'pmm 4/6/2007 14:18'!
writeStylesOn: aDocument
	styles ifNil: [ ^ self ].
	styles do: [ :each |
		aDocument print: ((WALinkElement root: self)
			beStylesheet; beCss;
			document: each;
			yourself) ]! !

!WARoot class methodsFor: 'instance creation' stamp: 'avi 6/19/2004 18:05'!
new
	^ self basicNew initialize! !

!WARoot methodsFor: 'writing' stamp: 'lr 3/27/2007 13:30'!
close: aDocument! !

!WARoot methodsFor: 'writing' stamp: 'lr 3/27/2007 13:30'!
open: aDocument! !

Object subclass: #WAServer
	instanceVariableNames: 'codec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAServer commentStamp: 'pmm 6/1/2008 00:14' prior: 0!
A WAServer is the abstract base class for all servers. Actual servers do not have to subclass it but have to support the protocol:
 - #codec
 - #usesSmalltalkEncoding

Instance Variables
	codec:		<WACodec>

codec
	- the codec used for response conversion from characters to bytes!

!WAServer methodsFor: 'accessing' stamp: 'pmm 5/11/2008 08:11'!
codec
	^ codec! !

!WAServer methodsFor: 'accessing' stamp: 'pmm 5/11/2008 08:12'!
codec: aCodec
	codec := aCodec! !

!WAServer methodsFor: 'testing' stamp: 'pmm 5/11/2008 08:12'!
usesSmalltalkEncoding
	"see WARequestContext >> #usesSmalltalkEncoding"
	^self codec usesSmalltalkEncoding! !

Object subclass: #WASessionContinuation
	instanceVariableNames: 'root states'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RenderLoop'!

!WASessionContinuation commentStamp: 'lr 6/2/2008 09:19' prior: 0!
I represent a continuation as part of the flow of pages within a session. I am not a real continuation (as compared to those used in #call: and #answer:), I only represent a specific point in the session. I reference the root component and a memory snapshot of backtracked objects.!

WASessionContinuation subclass: #WARedirectContinuation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RenderLoop'!

!WARedirectContinuation commentStamp: 'lr 6/2/2008 09:22' prior: 0!
I redirect to a WARenderContinuation. I am necessary to avoid the execution of anchor and form callbacks, when the back-button is used.!

!WARedirectContinuation methodsFor: 'processing' stamp: 'lr 8/17/2007 09:54'!
handleRequest: aRequest
	self newRenderContinuation run! !

!WARedirectContinuation methodsFor: 'processing' stamp: 'lr 8/30/2008 16:22'!
run
	self respond: [ :response | response redirectTo: self url seasideString ]! !

WASessionContinuation subclass: #WARenderContinuation
	instanceVariableNames: 'renderContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RenderLoop'!

!WARenderContinuation commentStamp: 'lr 6/2/2008 09:21' prior: 0!
I am used to trigger the rendering of the component-tree. After processing the callbacks of the page I rendered, I am followed by a WARedirectContinuation.!

!WARenderContinuation methodsFor: 'private' stamp: 'lr 8/30/2008 16:22'!
componentsNotFound: aCollection 
	WAComponentsNotFoundError raiseSignal: 'Components not found while processing callbacks: ' , aCollection seasideString! !

!WARenderContinuation methodsFor: 'processing' stamp: 'lr 4/9/2008 10:52'!
handleRequest: aRequest 
	aRequest isXmlHttpRequest ifTrue: [ self requestContext onRespond: [ :r | states snapshot ] ].
	self withNotificationHandler: [ self processCallbacks: aRequest ].
	((self shouldRedirect: aRequest) 
		ifTrue: [ self newRedirectContinuation ]
		ifFalse: [ self newRenderContinuation ]) run! !

!WARenderContinuation methodsFor: 'creational' stamp: 'lr 4/20/2007 19:36'!
newContext
	^ WARenderingContext new
		session: self session;
		actionUrl: self url;
		yourself! !

!WARenderContinuation methodsFor: 'creational' stamp: 'lr 3/29/2008 22:20'!
newHtmlRoot
	| htmlRoot |
	htmlRoot := WAHtmlRoot context: renderContext.
	htmlRoot bodyAttributes at: 'onload' append: 'onLoad()' separator: ';'.
	self updateRoot: htmlRoot.
	^ htmlRoot! !

!WARenderContinuation methodsFor: 'private' stamp: 'lr 3/29/2008 22:15'!
processCallbacks: aRequest 
	| lastPosition callbackStream |
	lastPosition := nil.
	callbackStream := renderContext callbackStreamForRequest: aRequest.
	[ callbackStream position = lastPosition ] whileFalse: 
		[ lastPosition := callbackStream position.
		self root decorationChainDo: [ :each | each processCallbackStream: callbackStream ] ].
	callbackStream atEnd ifFalse: [ self unprocessedCallbacks: callbackStream upToEnd ]! !

!WARenderContinuation methodsFor: 'private' stamp: 'jf 7/16/2008 09:41'!
processRendering: aResponse 
	| document htmlRoot |
	document := self application newDocumentOn: aResponse stream.
	renderContext document: document.
	htmlRoot := self newHtmlRoot.
	document open: htmlRoot.
	self root decorationChainDo: [ :each | each renderWithContext: renderContext ].
	self writeOnLoadOn: document.
	document close: htmlRoot.
	renderContext release! !

!WARenderContinuation methodsFor: 'actions' stamp: 'lr 3/29/2008 22:15'!
render
	self session clearJumpTo.
	renderContext := self newContext.
	self respond: [ :response | self processRendering: response ]! !

!WARenderContinuation methodsFor: 'processing' stamp: 'lr 4/20/2007 19:41'!
run
	self withNotificationHandler: [ self render ]! !

!WARenderContinuation methodsFor: 'testing' stamp: 'lr 4/16/2007 21:06'!
shouldRedirect: aRequest
	^ aRequest isGet not or: [ (aRequest fields includesKey: '_n') not ]! !

!WARenderContinuation methodsFor: 'private' stamp: 'pmm 5/29/2007 16:34'!
unprocessedCallbacks: aCollection
	| owners |
	owners := (aCollection collect: [ :each | each owner ]) asSet asArray.
	self componentsNotFound: owners! !

!WARenderContinuation methodsFor: 'private' stamp: 'lr 4/18/2007 00:04'!
withNotificationHandler: aBlock
	^ aBlock on: WARenderNotification , WAPageExpired do: [ :n | ]! !

!WARenderContinuation methodsFor: 'private' stamp: 'lr 8/30/2008 16:22'!
writeOnLoadOn: aDocument 
	| attributes |
	attributes := WAHtmlAttributes new.
	attributes 
		at: 'type'
		put: 'text/javascript'.
	aDocument 
		openTag: 'script'
		attributes: attributes
		closed: false.
	aDocument nextPutAll: '/*<!![CDATA[*/function onLoad(){'.
	self requestContext loadScripts 
		do: [ :each | aDocument nextPutAll: each seasideString ]
		separatedBy: [ aDocument nextPutAll: ';' ].
	aDocument nextPutAll: '}/*]]>*/'.
	aDocument closeTag: 'script'! !

!WASessionContinuation class methodsFor: 'instance-creation' stamp: 'lr 4/20/2007 20:17'!
root: aComponent
	^ self new initializeWithRoot: aComponent! !

!WASessionContinuation methodsFor: 'accessing' stamp: 'lr 4/9/2008 10:53'!
application
	"Answer the application to which this handler is associated."

	^ self requestContext application! !

!WASessionContinuation methodsFor: 'processing' stamp: 'lr 4/20/2007 19:34'!
handleRequest: aRequest
	self subclassResponsibility! !

!WASessionContinuation methodsFor: 'initialization' stamp: 'lr 4/20/2007 20:17'!
initializeWithRoot: aComponent
	root := aComponent! !

!WASessionContinuation methodsFor: 'creational' stamp: 'lr 10/28/2007 14:42'!
newRedirectContinuation
	"Answer a new redirect handler."

	^ (self application preferenceAt: #redirectContinuationClass) root: self root! !

!WASessionContinuation methodsFor: 'creational' stamp: 'lr 10/28/2007 14:42'!
newRenderContinuation
	"Answer a new render continuation."

	^ (self application preferenceAt: #renderContinuationClass) root: self root! !

!WASessionContinuation methodsFor: 'creational' stamp: 'lr 10/28/2007 14:42'!
newResponse
	"Answer a new response object and assign the current request stream."

	| stream response |
	stream := self request responseStream.
	response := stream isNil
		ifTrue: [ WAResponse new ]
		ifFalse: [ WAStreamResponse on: stream ].
	^ response doNotCache! !

!WASessionContinuation methodsFor: 'creational' stamp: 'lr 5/10/2007 22:26'!
newStates
	^ WASnapshot new! !

!WASessionContinuation methodsFor: 'accessing' stamp: 'lr 4/9/2008 10:52'!
request
	"Answer the current request object."

	^ self requestContext request! !

!WASessionContinuation methodsFor: 'accessing' stamp: 'lr 4/9/2008 10:53'!
requestContext
	"Answer the current request context."

	^ WACurrentRequestContext value! !

!WASessionContinuation methodsFor: 'processing' stamp: 'jf 7/16/2008 10:00'!
respond: aBlock 
	| response context |
	states := self newStates.
	response := self newResponse.
	context := self requestContext.
	context response: response.
	context onRespond: [ :value | self updateStates: states ].
	aBlock value: response.
	context returnResponse: response! !

!WASessionContinuation methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
root
	"Answer the root component instance. Usually this component is instantiated with the first reuqest."

	^ root! !

!WASessionContinuation methodsFor: 'processing' stamp: 'lr 4/20/2007 19:46'!
run
	self subclassResponsibility! !

!WASessionContinuation methodsFor: 'accessing' stamp: 'lr 4/9/2008 10:52'!
session
	"Answer the session to which this handler is associated."
	^ self requestContext session! !

!WASessionContinuation methodsFor: 'accessing' stamp: 'lr 8/20/2007 22:59'!
states
	^ states! !

!WASessionContinuation methodsFor: 'updating' stamp: 'lr 4/17/2007 22:50'!
updateRoot: aHtmlRoot
	self session updateRoot: aHtmlRoot.
	self root visiblePresentersDo: [ :each | each updateRoot: aHtmlRoot ]! !

!WASessionContinuation methodsFor: 'updating' stamp: 'lr 10/28/2007 14:42'!
updateStates: aSnapshot
	self session updateStates: aSnapshot.
	self root visiblePresentersDo: [ :each |
		(each isDecoration and: [ each isDelegation ])
			ifTrue: [ each component updateStates: aSnapshot ].
		each updateStates: aSnapshot ]! !

!WASessionContinuation methodsFor: 'updating' stamp: 'lr 4/17/2007 22:50'!
updateUrl: anUrl
	self session updateUrl: anUrl.
	self root visiblePresentersDo: [ :each | each updateUrl: anUrl ]! !

!WASessionContinuation methodsFor: 'accessing' stamp: 'lr 4/17/2007 22:20'!
url
	| url |
	url := self session actionUrlForContinuation: self.
	self updateUrl: url.
	^ url! !

!WASessionContinuation methodsFor: 'evaluating' stamp: 'lr 5/31/2008 16:16'!
value: aRequest
	"Resume processing of aRequest. To ensure valid application state restore all registered states."

	states ifNotNil: [ states restore ].
	self handleRequest: aRequest! !

Object subclass: #WASmallDictionary
	instanceVariableNames: 'size keys values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Utilities'!

!WASmallDictionary commentStamp: 'lr 7/12/2007 13:15' prior: 0!
I am an implementation of a dictionary. Compared to other dictionaries I am very efficient for small sizes, speed- and space-wise. I also remember the order in which elements are added, some of my users might depend on that. My implementation features some ideas from the RefactoringBrowser.!

WASmallDictionary subclass: #WAHtmlAttributes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document'!

!WAHtmlAttributes commentStamp: 'lr 7/12/2007 13:30' prior: 0!
I represent the attributes of a XHTML tag. Compared to my superclass I ignore requests to add a nil-values. I also don't throw an exception when accessing a key that doesn't exist, but instead return nil.!

!WAHtmlAttributes methodsFor: 'convenience' stamp: 'lr 10/28/2007 14:42'!
addClass: aString
	"Add an additional CSS class aString to the receiver."

	self at: 'class' append: aString separator: ' '! !

!WAHtmlAttributes methodsFor: 'convenience' stamp: 'pmm 3/9/2008 11:21'!
addMedia: aString
	"Add an additional intended destination medium aString to the receiver."

	self at: 'media' append: aString separator: ', '! !

!WAHtmlAttributes methodsFor: 'convenience' stamp: 'lr 10/28/2007 14:42'!
addStyle: aString
	"Add an additional CSS style definition aString to the receiver."

	self at: 'style' append: aString separator: ';'! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: 'lr 7/9/2007 07:46'!
at: aKey append: aValue
	"Append aValue to the attribute aKey. If already present, concatenate it with a space. Ignore the request if aValue is nil."

	^ self at: aKey append: aValue separator: ' '! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: 'lr 8/30/2008 16:22'!
at: aKey append: aValue separator: aString 
	"Append aValue to the attribute aKey. If already present, concatenate it with aString. Ignore the request if aValue is nil."
	aValue ifNil: [ ^ self at: aKey ].
	^ self 
		at: aKey
		put: (String streamContents: 
			[ :stream | 
			self 
				at: aKey
				ifPresent: 
					[ :value | 
					stream nextPutAll: value seasideString.
					stream nextPutAll: aString ].
			stream nextPutAll: aValue seasideString ])! !

!WAHtmlAttributes methodsFor: 'encoding' stamp: 'lr 10/28/2007 14:42'!
encodeOn: aDocument
	"Encode the receivers attribute onto aDocument. Note that this implementation reqires those two checks for true and false exactly the way they are here, to reliable encode boolean attributes in an XHTML compliant way."

	self keysAndValuesDo: [ :key :value |
		value == false ifFalse: [
			aDocument nextPut: $ ; nextPutAll: key; nextPutAll: '="'.
			value == true
				ifTrue: [ aDocument nextPutAll: key ]
				ifFalse: [ aDocument print: value ].
			aDocument nextPut: $" ] ]! !

!WAHtmlAttributes methodsFor: 'private' stamp: 'lr 7/12/2007 13:21'!
errorKeyNotFound
	^ nil! !

!WAHtmlAttributes methodsFor: 'private' stamp: 'lr 7/12/2007 13:23'!
privateAt: aKey put: aValue
	aValue ifNil: [ ^ nil ].
	^ super privateAt: aKey put: aValue! !

!WASmallDictionary class methodsFor: 'instance-creation' stamp: 'lr 1/24/2008 12:34'!
new
	^ self new: 3! !

!WASmallDictionary class methodsFor: 'instance-creation' stamp: 'lr 1/24/2008 12:34'!
new: anInteger
	^ self basicNew initialize: anInteger! !

!WASmallDictionary methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
associations
	"Answer a Collection containing the receiver's associations."

	| result |
	result := WriteStream on: (Array new: self size).
	self associationsDo: [ :assoc | result nextPut: assoc ].
	^ result contents! !

!WASmallDictionary methodsFor: 'enumerating' stamp: 'lr 8/20/2007 13:45'!
associationsDo: aBlock
	self keysAndValuesDo: [ :key :value | aBlock value: key -> value ]! !

!WASmallDictionary methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
at: aKey
	"Answer the value associated with aKey. Raise an exception, if no such key is defined."

	^ self at: aKey ifAbsent: [ self errorKeyNotFound ]! !

!WASmallDictionary methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
at: aKey ifAbsent: aBlock
	"Answer the value associated with aKey. Evaluate aBlock, if no such key is defined."

	| index |
	index := self findIndexFor: aKey.
	^ index = 0
		ifFalse: [ values at: index ]
		ifTrue: [ aBlock value ]! !

!WASmallDictionary methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
at: aKey ifAbsentPut: aBlock
	"Answer the value associated with aKey. Evaluate aBlock, if no such key is defined and store the return value."

	| index |
	index := self findIndexFor: aKey.
	^ index = 0
		ifFalse: [ values at: index ]
		ifTrue: [ self privateAt: aKey put: aBlock value ]! !

!WASmallDictionary methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
at: aKey ifPresent: aBlock
	"Lookup aKey in the receiver. If it is present, answer the value of evaluating the given block with the value associated with the key. Otherwise, answer nil."

	| index |
	index := self findIndexFor: aKey.
	^ index = 0 ifFalse: [ aBlock value: (values at: index) ]! !

!WASmallDictionary methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
at: aKey put: aValue
	"Set the value of aKey to be aValue."

	| index |
	index := self findIndexFor: aKey.
	^ index = 0
		ifFalse: [ values at: index put: aValue ]
		ifTrue: [ self privateAt: aKey put: aValue ]! !

!WASmallDictionary methodsFor: 'private' stamp: 'lr 7/12/2007 13:18'!
errorKeyNotFound
	self error: 'Key not found'! !

!WASmallDictionary methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
findIndexFor: aKey
	1 to: size do: [ :index |
		(keys at: index) = aKey
			ifTrue: [ ^ index ] ].
	^ 0! !

!WASmallDictionary methodsFor: 'private' stamp: 'lr 6/6/2007 19:12'!
grow
	| newKeys newValues |
	newKeys := Array new: 2 * size.
	newValues := Array new: 2 * size.
	1 to: size do: [ :index |
		newKeys at: index put: (keys at: index).
		newValues at: index put: (values at: index) ].
	keys := newKeys.
	values := newValues! !

!WASmallDictionary methodsFor: 'testing' stamp: 'lr 10/28/2007 14:42'!
includesKey: aKey
	"Answer whether the receiver has a key equal to aKey."

	^ (self findIndexFor: aKey) ~= 0! !

!WASmallDictionary methodsFor: 'initialization' stamp: 'lr 1/24/2008 12:34'!
initialize: anInteger
	size := 0.
	keys := Array new: anInteger.
	values := Array new: anInteger! !

!WASmallDictionary methodsFor: 'testing' stamp: 'lr 7/9/2007 08:13'!
isEmpty
	^ size = 0! !

!WASmallDictionary methodsFor: 'enumerating' stamp: 'lr 7/9/2007 10:37'!
keys
	^ keys copyFrom: 1 to: size! !

!WASmallDictionary methodsFor: 'enumerating' stamp: 'lr 6/7/2007 08:04'!
keysAndValuesDo: aBlock
	1 to: size do: [ :index | aBlock value: (keys at: index) value: (values at: index) ]! !

!WASmallDictionary methodsFor: 'enumerating' stamp: 'lr 8/17/2007 11:52'!
keysDo: aBlock
	1 to: size do: [ :each | aBlock value: (keys at: each) ]! !

!WASmallDictionary methodsFor: 'copying' stamp: 'lr 7/9/2007 07:50'!
postCopy
	super postCopy.
	keys := keys copy.
	values := values copy! !

!WASmallDictionary methodsFor: 'private' stamp: 'lr 6/6/2007 19:28'!
privateAt: aKey put: aValue
	size = keys size ifTrue: [ self grow ].
	keys at: (size := size + 1) put: aKey.
	^ values at: size put: aValue! !

!WASmallDictionary methodsFor: 'accessing' stamp: 'lr 7/12/2007 13:18'!
removeKey: aKey
	"Remove aKey from the receiver, raise an exception if the element is missing."

	^ self removeKey: aKey ifAbsent: [ self errorKeyNotFound ]! !

!WASmallDictionary methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
removeKey: aKey ifAbsent: aBlock
	"Remove aKey from the receiver, evaluate aBlock if the element is missing."

	| index value |
	index := self findIndexFor: aKey.
	index = 0 ifTrue: [ ^ aBlock value ].
	value := values at: index.
	index to: size - 1 do: [ :i |
		keys at: i put: (keys at: i + 1).
		values at: i put: (values at: i + 1) ].
	keys at: size put: nil.
	values at: size put: nil.
	size := size - 1.
	^ value! !

!WASmallDictionary methodsFor: 'accessing' stamp: 'lr 7/9/2007 10:38'!
size
	^ size! !

!WASmallDictionary methodsFor: 'enumerating' stamp: 'lr 7/9/2007 10:38'!
values
	^ values copyFrom: 1 to: size! !

!WASmallDictionary methodsFor: 'enumerating' stamp: 'lr 8/17/2007 11:52'!
valuesDo: aBlock
	1 to: size do: [ :index | aBlock value: (values at: index) ]! !

Object subclass: #WASnapshot
	instanceVariableNames: 'objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RenderLoop'!

!WASnapshot commentStamp: 'lr 6/2/2008 09:24' prior: 0!
I represent a memory snapshot of objects. Objects can be registered by sending the message #register:. All object snapshots are updated by sending #snapshot and restored by sending #restore. To have specific snpshot and restore actions for particular classes override #snapshotCopy and #restoreFromSnapshot: in your classes.!

!WASnapshot class methodsFor: 'instance creation' stamp: 'lr 5/31/2008 16:15'!
new
	^ self basicNew initialize! !

!WASnapshot methodsFor: 'initialize-release' stamp: 'lr 5/31/2008 16:53'!
initialize
	objects := IdentityDictionary new! !

!WASnapshot methodsFor: 'registry' stamp: 'lr 6/2/2008 09:28'!
register: anObject
	"Register anObject for backtracking."

	anObject ifNotNil: [ objects at: anObject put: anObject snapshotCopy ]! !

!WASnapshot methodsFor: 'actions' stamp: 'lr 5/31/2008 16:28'!
restore
	"Restore all the backtracked states."

	objects keysAndValuesDo: [ :key :value | key restoreFromSnapshot: value ]! !

!WASnapshot methodsFor: 'actions' stamp: 'lr 5/31/2008 16:29'!
snapshot
	"Snapshot all the states that have been registered for backtracking overriding existing snapshots."

	objects associationsDo: [ :assoc | assoc value: assoc key snapshotCopy ]! !

Object subclass: #WAUrl
	instanceVariableNames: 'scheme username password hostname port path parameters fragment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAUrl commentStamp: 'lr 3/26/2008 14:20' prior: 0!
I represent all portions of an URL as described by the RFC 1738. I include scheme, username, password, hostname, port, path, parameters, and fragment.

Instance Variables
	scheme:			<String> or nil
	username:		<String> or nil
	password:		<String> or nil
	hostname:		<String> or nil
	port:			<Integer> or nil
	path:			<OrderedCollection> or nil
	parameters:		<Dictionary>
	fragment:		<String> or nil!

!WAUrl class methodsFor: 'parsing' stamp: 'lr 3/26/2008 20:55'!
absolute: aString
	"Parse aString as an absolute URL."

	^ self basicNew initializeFromString: aString! !

!WAUrl class methodsFor: 'parsing' stamp: 'lr 3/26/2008 21:00'!
absolute: aString relative: aRelativeString
	"Take absolute URL aString and combine it with a relative path aRelativeString."

	^ (self absolute: aString) parsePath: aRelativeString! !

!WAUrl class methodsFor: 'instance-creation' stamp: 'lr 3/26/2008 21:00'!
new
	^ self basicNew initialize! !

!WAUrl methodsFor: 'comparing' stamp: 'lr 2/12/2008 11:09'!
= anUrl
	^ self class = anUrl class and: [ self printString = anUrl printString ]! !

!WAUrl methodsFor: 'adding' stamp: 'pmm 4/21/2008 20:42'!
addAllToPath: aCollectionOfStrings
	"convenice method to add a collection of strings to the path"
	aCollectionOfStrings do: [ :each |
		self addToPath: each ]! !

!WAUrl methodsFor: 'adding' stamp: 'lr 10/28/2007 14:42'!
addParameter: aString
	self addParameter: aString value: nil! !

!WAUrl methodsFor: 'adding' stamp: 'lr 3/27/2008 08:30'!
addParameter: keyString value: valueString
	keyString isEmpty 
		ifFalse: [ self parameters at: keyString put: valueString ]! !

!WAUrl methodsFor: 'adding' stamp: 'pmm 4/21/2008 20:43'!
addToPath: aString
	"Adds the argument as a path element. If the argument contains $/ it is split into multiple elements"
	self path addAll: (aString findTokens: '/')! !

!WAUrl methodsFor: 'private' stamp: 'lr 3/26/2008 15:14'!
decode: aString
	| input output char |
	input := aString readStream.
	output := WriteStream on: (String new: aString size).
	[ input atEnd ] whileFalse: [
		char := input next.
		output nextPut: (char = $+
			ifTrue: [ Character space ]
			ifFalse: [
				char = $%
					ifTrue: [
						Character value: input next asUppercase digitValue * 16
							+ input next asUppercase digitValue ]
					ifFalse: [ char ] ]) ].
	^ output contents! !

!WAUrl methodsFor: 'encoding' stamp: 'lr 8/20/2007 21:13'!
encodeFragmentOn: aDocument
	fragment ifNil: [ ^ self ].
	aDocument nextPut: $#.
	aDocument urlEncoder nextPutAll: fragment! !

!WAUrl methodsFor: 'encoding' stamp: 'lr 9/4/2007 15:32'!
encodeOn: aDocument
	self encodeOn: aDocument usingHtmlEntities: true! !

!WAUrl methodsFor: 'encoding' stamp: 'lr 10/28/2007 14:42'!
encodeOn: aDocument usingHtmlEntities: aBoolean
	self encodeServerOn: aDocument.
	self encodePathOn: aDocument.
	self
		encodeParametersOn: aDocument
		usingHtmlEntities: aBoolean.
	self encodeFragmentOn: aDocument! !

!WAUrl methodsFor: 'encoding' stamp: 'lr 8/30/2008 16:22'!
encodeParametersOn: aDocument usingHtmlEntities: aBoolean 
	| first |
	first := true.
	parameters ifNil: [ ^ self ].
	parameters keysAndValuesDo: 
		[ :key :value | 
		aDocument nextPutAll: (first 
				ifTrue: 
					[ first := false.
					'?' ]
				ifFalse: 
					[ aBoolean 
						ifTrue: [ '&amp;' ]
						ifFalse: [ '&' ] ]).
		aDocument urlEncoder nextPutAll: key.
		value ifNotNil: 
			[ aDocument nextPut: $=.
			aDocument urlEncoder nextPutAll: value seasideString ] ]! !

!WAUrl methodsFor: 'encoding' stamp: 'lr 3/26/2008 21:05'!
encodePathOn: aDocument
	aDocument nextPut: $/.
	path ifNil: [ ^ self ].
	path
		do: [ :each | aDocument urlEncoder nextPutAll: each ]
		separatedBy: [ aDocument nextPut: $/ ]! !

!WAUrl methodsFor: 'encoding' stamp: 'lr 10/28/2007 14:42'!
encodeServerOn: aDocument
	hostname ifNil: [ ^ self ].
	aDocument nextPutAll: scheme; nextPutAll: '://'.
	username notNil ifTrue: [
		aDocument urlEncoder nextPutAll: username.
		password notNil ifTrue: [
			aDocument nextPut: $:.
			aDocument urlEncoder nextPutAll: password ].
		aDocument nextPut: $@ ].
	aDocument urlEncoder nextPutAll: hostname.
	port notNil ifTrue: [
		((scheme = 'http' and: [ port = 80 ])
			or: [ scheme = 'https' and: [ port = 443 ] ])
			ifFalse: [ aDocument nextPut: $:; print: port ] ]! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
fragment
	"Answer the fragment part of the URL."

	^ fragment! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 8/17/2007 20:18'!
fragment: aString
	fragment := aString! !

!WAUrl methodsFor: 'comparing' stamp: 'lr 2/12/2008 11:09'!
hash
	^ self hostname hash bitXor: self path hash! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
hostname
	"Answer the host part of the URL."

	^ hostname! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 3/29/2008 10:14'!
hostname: aString
	hostname := aString isNil
		ifFalse: [ aString asLowercase ]! !

!WAUrl methodsFor: 'initialization' stamp: 'lr 3/26/2008 21:03'!
initialize
	scheme := 'http'! !

!WAUrl methodsFor: 'initialization' stamp: 'lr 3/28/2008 23:00'!
initializeFromString: aString
	| string index |
	self initialize.
	string := aString.
	index := string indexOf: $#.
	index > 0 ifTrue: [
		self parseFragment: (string copyFrom: index + 1 to: string size).
		string := string copyFrom: 1 to: index - 1 ].
	index := string indexOf: $?.
	index > 0 ifTrue: [
		self parseParameters: (string copyFrom: index + 1 to: string size).
		string := string copyFrom: 1 to: index - 1 ].
	index := string indexOfSubCollection: '://'.
	index > 0 ifTrue: [ 
		self scheme: (string copyFrom: 1 to: index - 1).
		string := string copyFrom: index + 3 to: string size.
		index := string indexOf: $/.
		index > 0
			ifFalse: [ 
				self parseHost: string.
				string := '' ]
			ifTrue: [
				self parseHost: (string copyFrom: 1 to: index - 1).
				string := string copyFrom: index + 1 to: string size ] ].
	self parsePath: string! !

!WAUrl methodsFor: 'private' stamp: 'lr 8/17/2007 22:49'!
isSeasideField: aString
	^ aString notEmpty
		and: [ aString first = $_
		or: [ aString allSatisfy: [ :each | each isDigit ] ] ]! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 3/26/2008 21:04'!
parameters
	"Answer a dictionary with the query parameters."

	^ parameters ifNil: [ parameters := WASmallDictionary new ]! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 8/17/2007 20:19'!
parameters: aDictionary
	parameters := aDictionary! !

!WAUrl methodsFor: 'parsing' stamp: 'lr 3/28/2008 23:02'!
parseFragment: aString
	aString isEmpty ifTrue: [ ^ self ].
	self fragment: (self decode: aString)! !

!WAUrl methodsFor: 'parsing' stamp: 'pmm 5/31/2008 13:48'!
parseHost: aString
	| string temp index |
	aString isEmpty 
		ifTrue: [ ^ self ].
	string := aString.
	index := string indexOf: $@.
	index > 1 ifTrue: [
		temp := string copyFrom: 1 to: index - 1.
		string := string copyFrom: index + 1 to: string size.
		index := temp indexOf: $:.
		index > 0 
			ifFalse: [ self username: (self decode: temp) ]
			ifTrue: [
				self username: (self decode: (temp copyFrom: 1 to: index - 1)).
				self password: (self decode: (temp copyFrom: index + 1 to: temp size)) ] ].
	index := string lastIndexOf: $:.
	index > 0 ifTrue: [
		temp := string copyFrom: index + 1 to: string size.
		string := string copyFrom: 1 to: index - 1.
		self port: ((temp notEmpty and: [ temp allSatisfy: [ :each | each isDigit ] ])
			ifTrue: [ temp asInteger ]) ].
	self hostname: (self decode: string)! !

!WAUrl methodsFor: 'parsing' stamp: 'lr 3/27/2008 08:30'!
parseParameters: aString
	| input string index |
	input := aString readStream.
	[ input atEnd ] whileFalse: [
		string := input upTo: $&.
		index := string indexOf: $=.
		index > 0
			ifFalse: [ self addParameter: (self decode: string) ]
			ifTrue: [
				self
					addParameter: (self decode: (string copyFrom: 1 to: index - 1))
					value: (self decode: (string copyFrom: index + 1 to: string size)) ] ]! !

!WAUrl methodsFor: 'parsing' stamp: 'lr 3/26/2008 22:13'!
parsePath: aString
	| input part |
	input := aString readStream.
	input peek = $/ 
		ifTrue: [ path := nil ].
	[ input atEnd ] whileFalse: [
		part := input upTo: $/.
		part isEmpty ifFalse: [
			part = '..'
				ifTrue: [ self path isEmpty ifFalse: [ self path removeLast ] ]
				ifFalse: [ part = '.' ifFalse: [ self path addLast: (self decode: part) ] ] ] ]! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
password
	"Answer the password part of the URL."

	^ password! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 8/17/2007 20:21'!
password: aString
	password := aString! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
path
	"Answer the path part of the URL."

	^ path ifNil: [ path := OrderedCollection new ]! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
path: aCollection
	"Set the path part of the URL to aCollection."

	path := aCollection! !

!WAUrl methodsFor: 'converting' stamp: 'lr 3/26/2008 21:27'!
pathString
	"Answer the path converted to a string."

	| document |
	^ String streamContents: [ :stream | 
		document := WAHtmlStreamDocument new.
		document stream: stream.
		self encodePathOn: document ]! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 8/17/2007 20:22'!
port
	"Answer the port number part of the URL."

	^ port! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 8/17/2007 20:22'!
port: aNumber
	port := aNumber! !

!WAUrl methodsFor: 'copying' stamp: 'lr 3/28/2008 23:07'!
postCopy
	super postCopy.
	path := path copy.
	parameters := parameters copy! !

!WAUrl methodsFor: 'printing' stamp: 'lr 9/4/2007 15:37'!
printOn: aStream
	| document |
	document := WAHtmlStreamDocument new.
	document stream: aStream.
	self encodeOn: document usingHtmlEntities: false! !

!WAUrl methodsFor: 'converting' stamp: 'lr 3/27/2008 07:47'!
relativeTo: anUrl
	"Answer a path element collection relative from the receiver to anUrl."
	
	| currentPath argumentPath resultingPath |
	currentPath := self path copy.
	argumentPath := anUrl path copy.
	[ currentPath notEmpty and: [ argumentPath notEmpty and: [ currentPath first = argumentPath first ] ] ] whileTrue: [
		currentPath removeFirst.
		argumentPath removeFirst ].
	resultingPath := OrderedCollection new.
	currentPath size 
		timesRepeat: [ resultingPath add: '..' ].
	resultingPath addAll: argumentPath.
	^ resultingPath! !

!WAUrl methodsFor: 'private' stamp: 'lr 8/17/2007 20:54'!
removeParameters
	parameters := nil! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
scheme
	"Answer the URL's scheme."

	^ scheme! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 8/30/2008 16:22'!
scheme: aString 
	"Set the URL scheme as a string. As some Seaside 2.7 and older uses Symbols here, we transform it to a string. This will be removed in future versions."
	scheme := aString seasideString asLowercase! !

!WAUrl methodsFor: 'converting' stamp: 'lr 8/30/2008 16:22'!
seasideString
	^ String streamContents: [ :stream | self printOn: stream ]! !

!WAUrl methodsFor: 'private' stamp: 'pmm 4/26/2008 12:11'!
takeServerParametersFromRequest: aRequest
	"Takes the hostname on URL from the given request unless already set.."
	
	self hostname isNil
		ifFalse: [ ^ self ].
	self parseHost: (aRequest 
		headerAt: 'host'
		ifAbsent: [ ^ self ])! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
username
	"Answer the username part of the URL."

	^ username! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 8/17/2007 20:38'!
username: aString
	username := aString! !

!WAUrl methodsFor: 'copying' stamp: 'avi 3/22/2004 00:52'!
with: pathString
	^ self copy
		addToPath: pathString;
		yourself! !

!WAUrl methodsFor: 'copying' stamp: 'pmm 6/21/2007 20:45'!
withParameter: aString
	^ self copy
		addParameter: aString;
		yourself! !

!WAUrl methodsFor: 'copying' stamp: 'avi 3/22/2004 00:51'!
withParameter: aString value: valueString
	^ self copy
		addParameter: aString value: valueString;
		yourself! !

!WAUrl methodsFor: 'copying' stamp: 'pmm 6/21/2007 20:57'!
withoutParameters
	^self copy
		removeParameters;
		yourself! !

Object subclass: #WAValueHolder
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Utilities'!

!WAValueHolder commentStamp: 'pmm 9/5/2007 19:01' prior: 0!
I wrap a single object. I am like value holder except that I am portable and don't include the Model cruft in Squeak.!

!WAValueHolder class methodsFor: 'instance-creation' stamp: 'lr 9/5/2007 11:40'!
with: anObject
	^ self new contents: anObject! !

!WAValueHolder methodsFor: 'accessing' stamp: 'lr 4/16/2007 00:11'!
contents
	^ contents! !

!WAValueHolder methodsFor: 'accessing' stamp: 'lr 4/16/2007 00:11'!
contents: anObject
	contents := anObject! !

!WAValueHolder methodsFor: 'printing' stamp: 'lr 4/20/2007 20:46'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' contents: '; print: self contents! !

!ByteArray methodsFor: '*Seaside-Core' stamp: 'pmm 1/22/2008 22:05'!
asMIMEDocument
	^self asMIMEDocumentType: 'application/octet-stream' toMimeType! !

!ByteArray methodsFor: '*Seaside-Core' stamp: 'pmm 8/29/2008 18:22'!
asMIMEDocumentType: mimeType
	^WACollectionMimeDocument
		contentType: mimeType toMimeType
		content: self! !

!ByteArray methodsFor: '*Seaside-Core' stamp: 'mb 9/22/2006 12:17'!
renderOn: aRenderer
	aRenderer text: self! !

ByteArray variableByteSubclass: #WAExternalID
	instanceVariableNames: ''
	classVariableNames: 'Generator GeneratorMutex GeneratorSpace'
	poolDictionaries: ''
	category: 'Seaside-Core-Utilities'!

!WAExternalID commentStamp: 'pmm 4/22/2007 12:55' prior: 0!
I am a session or conticuation key.!

!WAExternalID class methodsFor: 'private' stamp: 'ab 5/28/2003 23:34'!
defaultSize
	^ 8! !

!WAExternalID class methodsFor: 'instance-creation' stamp: 'pmm 2/23/2008 18:25'!
fromString: aString
	| id |
	id := self new: aString size.
	aString keysAndValuesDo: [ :index :each |
		id at: index put: each asInteger ].
	^ id! !

!WAExternalID class methodsFor: 'initialization' stamp: 'lr 1/17/2008 11:43'!
initialize
	self startUp.
	SeasidePlatformSupport addToStartUpList: self.
	GeneratorSpace := ($a to: $z) , ($A to: $Z) , ($0 to: $9) , (Array with: $_ with: $-)
		collect: [ :each | each asInteger ].
	GeneratorMutex := SeasidePlatformSupport semaphoreClass forMutualExclusion! !

!WAExternalID class methodsFor: 'instance-creation' stamp: 'ab 5/28/2003 23:53'!
new
	^ self new: self defaultSize! !

!WAExternalID class methodsFor: 'instance-creation' stamp: 'pmm 11/2/2005 23:19'!
new: aNumber
	^ (self basicNew: aNumber) initialize! !

!WAExternalID class methodsFor: 'initialization' stamp: 'lr 1/17/2008 11:42'!
startUp
	Generator := SeasidePlatformSupport randomClass new! !

!WAExternalID methodsFor: 'private' stamp: 'lr 1/17/2008 11:35'!
initialize
	GeneratorMutex critical: [
		1 to: self size do: [ :index |
			self at: index put: (GeneratorSpace atRandom: Generator) ] ]! !

!WAExternalID methodsFor: 'private' stamp: 'lr 1/17/2008 11:36'!
printOn: aStream
	self do: [ :each | aStream nextPut: (Character value: each) ]! !

!UndefinedObject methodsFor: '*Seaside-Core' stamp: 'lr 3/27/2007 10:40'!
encodeOn: aDocument! !

!UndefinedObject methodsFor: '*Seaside-Core' stamp: 'lr 10/28/2007 14:42'!
renderOn: html! !

!Dictionary methodsFor: '*Seaside-Core' stamp: 'ab 10/1/2002 13:48'!
inspectorFields
	^ self! !

!Dictionary methodsFor: '*Seaside-Core' stamp: 'lr 2/16/2007 15:11'!
valuesCollect: aBlock
	| result |
	result := self species new: self size.
	self keysAndValuesDo: [ :key :value |
		result at: key put: (aBlock value: value) ].
	^ result! !

!Exception methodsFor: '*Seaside-Core' stamp: 'pmm 6/1/2008 00:55'!
possibleCauses
	"Used by WAWalkback to render a list of what might have caused the receiver to be signaled.
	answers a collection of strings"
	^ #()! !

!MessageNotUnderstood methodsFor: '*Seaside-Core' stamp: 'pmm 7/7/2007 18:25'!
possibleCauses
	| causes |
	self receiver isNil ifFalse: [
		^ #('you sent a message this type of object doesn''t understand' )].
	causes := #(
		'the receiver of the message is nil'
		'a class extension hasn''t been loaded correctly'
		'you sent the wrong message' ) asOrderedCollection.
	self message selector = #contents ifTrue: [
		causes addFirst: 'you forgot to send "super initialize" in a initialize method of a component or task' ].
	^causes! !

Error subclass: #WAAttributeNotFound
	instanceVariableNames: 'key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WAAttributeNotFound methodsFor: 'accessing' stamp: 'jf 8/26/2008 14:17'!
key
	^ key! !

!WAAttributeNotFound methodsFor: 'accessing' stamp: 'jf 8/26/2008 14:17'!
key: aSymbol
	key := aSymbol! !

Error subclass: #WAComponentsNotFoundError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Exceptions'!

!WAComponentsNotFoundError commentStamp: 'pmm 6/1/2008 00:53' prior: 0!
A WAComponentsNotFoundError is an exception that is raised when for a callback now owning component could be found. See #possibleCauses for examples when this can happen.!

!WAComponentsNotFoundError methodsFor: 'accessing' stamp: 'pmm 7/11/2007 22:19'!
possibleCauses
	^#(
		'you do not implement #children correctly'
		'you do not backtrack #children correctly'
		'you do not implement #states correctly'
	)! !
WASharedConfiguration initialize!
WAHtmlEncoder initialize!
WAUrlEncoder initialize!
WAFileLibrary initialize!
WALocale initialize!
WAFileHandler initialize!
WAExternalID initialize!
